#ifndef N_AI_H
#define N_AI_H
//------------------------------------------------------------------------------
/**
    @class nAI

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_FSM_H
#include "enkiduo/nfsm.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAI
#include "kernel/ndefdllclass.h"
#include "physics/nphysics.h"
//------------------------------------------------------------------------------
class nAI : public nFSM
{
public:
    /// constructor
    nAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual float MoveTowards( const vector3& tar, float dtime );
    virtual float Move3D( const vector3& tar, float dtime );
    var pos;
    var rot;
    var vel;
    var rvel;
    var thrust;
    var rc_distAngleCoef;
    var rc_angleToTorque;
    var rc_rvelToTorque;
    var rc_angleToForce;
    nPhysics* physics;

    float dh;
    float lf, lr, lu;
};
//------------------------------------------------------------------------------
#endif

