#ifndef N_CONTROLLER_H
#define N_CONTROLLER_H
//------------------------------------------------------------------------------
/**
  @class nController

  @brief controllers form the root of the ai tree

  each controller should response to input from the user, to create/destroy child behaviors accordingly.

  (C)	2004	Chris Miles
 */
#ifndef N_FSMQUEUE_H
#include "enkiduo/nfsmqueue.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nController
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nController : public nFSMQueue
{
public:
    /// constructor
    nController();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nController();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void Tick( float time, float dtime );
    virtual void Display( nGfxServer* gfx );
    virtual void Message( nMessage* message );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nString entname;
    struct Path {
        bool used;
        n3DNode* node;
        vector3 start;
        vector3 end;
    };
    nArray<Path*> paths;
};
//------------------------------------------------------------------------------
#endif

