#ifndef N_MISSLEAI_H
#define N_MISSLEAI_H
//------------------------------------------------------------------------------
/**
    @class nMissleAI

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nMissleAI
#include "kernel/ndefdllclass.h"
#include "physics/nphysics.h"
#include "enkiduo/nopenalserver.h"

class nSoundEmitter;
//------------------------------------------------------------------------------
class nMissleAI : public nAI
{
    enum states  {
        Inactive,
        Drop,
        Dumb,
        Seek,
        Explode,
    };
public:
    /// constructor
    nMissleAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nMissleAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    var target;
    var targetPos;
    float startTime;
    var dropTime;
    var flyTime;
    var thrust;
    var attachedTo;

    var detonationRange;
    nDynAutoRef<nSoundEmitter> emitter;

    var damage;
    var impulse;
    var weaponlevel;
    var effectradius;
    float lastDistance;
};
//------------------------------------------------------------------------------
#endif

