#ifndef N_THREATALLOCATOR_H
#define N_THREATALLOCATOR_H
//------------------------------------------------------------------------------
/**
        @class nThreatAllocator

        @brief allocates defenses in the strike game

        reads in all of the threats / targets / enemy starting location and determines how to place them
        a numbero f parameter allows for this play to be tuned -> so the ga can play the game essentially.

        so how do we do this allocation...
        we determine what we have..and where the enemy is coming from..

        for alpha -> place threats on valuable targets


        (C)	2004	Chris Miles
    */
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

class nDefensabilityIM;
class nThreatRedundanceIM;
class nThreatViabilityIM;
class nInfluenceMap;
#undef N_DEFINES
#define N_DEFINES nThreatAllocator
#include "kernel/ndefdllclass.h"

    //------------------------------------------------------------------------------
    class nThreatAllocator : public nAI
    {
    public:
        /// constructor
        nThreatAllocator();
        virtual void Initialize();
        virtual void InitVars();
        /// destructor
        virtual ~nThreatAllocator();
        /// persistency
        virtual bool SaveCmds(nPersistServer* persistServer);

        virtual bool FindBiggestThreat	( nEnt*& threat, float& range );
        virtual void UnallocateThreats();
        virtual void Allocate		( nEnt* threat, vector2 location );
        
        virtual void CalcDefensability	( float range );	//sum (target.value * closeness (target, myrange))
        virtual void CalcThreatRedundance	( float range );	//sum (closeness (threat, myrange + threat.range))
        virtual void CalcExtendedCoverage	( float range );	//sum (closeness (threat, myrange + threat.range))
        virtual void CalcPopupViability	( float range );	//sum (myrange, extendedCoverage)
        virtual void Tick( float time, float dtime );
        /// pointer to nKernelServer
        static nKernelServer* kernelServer;
        virtual void PlaceThreats();
    protected:
        virtual void FindStartPos();
        vector3 startPos;
        bool startPosFound;
        var offset;
        nDynAutoRef<nInfluenceMap> 
            defensability,
            threatRedundance,
            threatViability,
            extendedCoverage,
            popupViability,
            closeness,
            formwall;
};
//------------------------------------------------------------------------------
#endif

