#ifndef N_ALTLIMIT_H
#define N_ALTLIMIT_H
//------------------------------------------------------------------------------
/**
    @class nAltLimit

    @brief Constrains an entity within a range of altitudes

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAltLimit
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"

//------------------------------------------------------------------------------
class nAltLimit : public nAspect
{
public:
    /// constructor
    nAltLimit();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAltLimit();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var pos;
    var vel;
    var minalt;
    var maxalt;
    nAutoRef<nMap> map;
};
//------------------------------------------------------------------------------
#endif

