#ifndef N_HARDPOINTATTACH_H
#define N_HARDPOINTATTACH_H
//------------------------------------------------------------------------------
/**
    @class nHardPointAttach

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nHardPointAttach
#include "kernel/ndefdllclass.h"
#include "aspect/nhardpoint.h"

//------------------------------------------------------------------------------
class nHardPointAttach : public nAspect
{
public:
    /// constructor
    nHardPointAttach();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nHardPointAttach();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void AttachTo( nEnt* e );
    virtual void AttachTo( const char* s ){
        this->AttachTo( (nEnt*)kernelServer->Lookup(s));
    }
    virtual void UnAttach(){
        if( hp.isvalid() ){
            hp->UnAttach();
            hp.invalidate();
        }
        else
            n_printf("%s trying to unattach, but no hp\n", fn);

    }
protected:
    nRef<nHardPoint> hp;
    var pos;
    var rot;
    var vel;
    var rvel;
    var rotLocal;
    var mother;
};
//------------------------------------------------------------------------------
#endif

