#ifndef N_SIDE_H
#define N_SIDE_H
//------------------------------------------------------------------------------
/**
    @class nSide

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nSide
#include "kernel/ndefdllclass.h"

class nSide;
typedef nArray<nSide*> SideArray;
//-----------------------------------------------------------------------------//
#include "enkiduo/enum.h"
static Enum RELATIONSHIPS; 
defineEnum( RELATIONSHIPS, VOID    );
defineEnum( RELATIONSHIPS, PLAYER  );
defineEnum( RELATIONSHIPS, FRIEND  );
defineEnum( RELATIONSHIPS, NEUTRAL );
defineEnum( RELATIONSHIPS, HOSTILE );
defineEnum( RELATIONSHIPS, LORD    );
defineEnum( RELATIONSHIPS, VASSAL  );

/*enum PLAYER_RELATIONSHIP {
    VOID,
    PLAYER,
    FRIEND,
    NEUTRAL,
    HOSTILE,
    LORD,
    VASSAL,
};
//-----------------------------------------------------------------------------//
static const char* playerRelationshipStrings[] = {
    "VOID",
    "PLAYER",
    "FRIEND",
    "NEUTRAL",
    "HOSTILE",
    "LORD",
    "VASSAL"
};
static int playerRelationshipNum = 7;
*/
//------------------------------------------------------------------------------
class nTextDisplayer;
class nEventServer;
class nSide : public nAspect
{
public:
    /// constructor
    nSide();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nSide();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void AddUnit( nEnt* e );
    virtual void RemoveUnit( nEnt* e );
    virtual void SetRelationship( const char* side, const char* relationship);
    virtual int GetRelationship( const char* side );
    virtual const EntArray* GetUnits()		                                        { return &units; }
    virtual const EntArray* GetRelatedUnits( int relationship );                                                         
    virtual const SideArray* GetRelatedSides( int relationship )                                                        { return &relations[relationship].sides; }
    virtual void PlayerRelationshipsChanged( const char* msg );
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void Display( nGfxServer* gfx );
    virtual void AddResource( const char* name );
protected:
    EntArray units;
    
    struct Relation {
        SideArray sides;
        EntArray units;
    };
    nArray<Relation> relations;

    struct Resource {
        nString name;
        var amount;
        float amount0;
        var damount;
        nDynAutoRef<nTextDisplayer> tdName;
        nDynAutoRef<nTextDisplayer> td;
        nDynAutoRef<nTextDisplayer> tdDelta;
    };
    nArray<Resource> resources;

    var playerSide;
    float time;
    float dtimesum;
    var playerRelationship;
    nAutoRef<nEventServer>              ref_eventServer;
};
//------------------------------------------------------------------------------
#endif

