#ifndef N_STATS_H
#define N_STATS_H
//------------------------------------------------------------------------------
/**
    @class nStats

    @brief updates variables based on level variables -- allowing upgrading of things
    any variable ending in "level" will be checked against the stats library to see what other variables it effects
    if it finds any to change it changes them
    not sure how to work out priority system here---hmmmm

    (C)	2005	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nStats
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nStats : public nAspect
{
public:
    /// constructor
    nStats();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nStats();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void CheckVars();
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    ////////////////////////////////////////////////////////////////////////////////
    ///information about vars being read from - level vars
    ////////////////////////////////////////////////////////////////////////////////
    struct InVar {
        var* v;
        InVar(): v(0) { }
    };
    ////////////////////////////////////////////////////////////////////////////////
    ///information about vars being written too 
    ////////////////////////////////////////////////////////////////////////////////
    struct OutVar {
        var* v;
        int priority;
        OutVar(): v(0), priority(0){}
    };
    nArray<InVar> invars;
    nArray<OutVar> outvars;
    nRoot* varRoot;		///root of the var tree
    nRoot* lastChecked;		///tracks the last vraiable checked - too see when new ones are added --- we should rechec
};
//------------------------------------------------------------------------------
#endif

