#ifndef __WIN32__
#ifndef NARRAYOPS_H
#define NARRAYOPS_H    
#include "util/narray.h"
/****************************************************************************************************
  named variable class - takes the place of an int/char whatever but
  outputs its name when couted
 ****************************************************************************************************/
/*
template <class T>
struct nv{
    T t;
    string name;
    nv(string name, T& t):name(name),t(t){}
    nv(string name):name(name){}
    const nv& operator = (T & rhs ) { this->t = rhs; }
    operator T&()  { return t; }
    T& operator *() { return t; }
};
template <class T>
ostream& operator << ( ostream& stream, const nv<T> nv ) {
    stream << nv.name << ":" << nv.t;
    return stream;
}*/
/****************************************************************************************************
  allows cout << vector
 ****************************************************************************************************/
/*
template <class T>
ostream& operator << ( ostream& stream, const nArray<T> v ) {
    stream << "[";
    for ( vector<T>::const_iterator viter = v.begin(); viter != v.end();
            viter++ ) {
        if( viter != v.begin() )
            stream << ", ";
        stream << *viter;
    }
    stream << "]";
    return stream;
}
*/
/****************************************************************************************************
  when coutting a vector full of chars - do not include ,'s
 ****************************************************************************************************/
/*
ostream& operator << ( ostream& stream, const vector<char> v ) {
    stream << "[";
    for ( vector<char>::const_iterator viter = v.begin(); viter !=
            v.end(); viter++ )
        stream << *viter;
    stream << "]";
    return stream;
}
*/
/****************************************************************************************************
  allows the outputting of multidimensional vectors with endlines after eachs
 ****************************************************************************************************/
/*
template <class T>
ostream & operator << ( ostream& stream, const vector<vector<T> > v ) {
    for ( vector<vector<T> >::const_iterator viter = v.begin(); viter !=
            v.end(); viter++ ) {
        stream << *viter;
        stream << endl;
    }
    return stream;
}
*/
/****************************************************************************************************
  these funcs are freaking sweet
  initialize a n dimensional vector
  @param v - the vector to initalize
  @param e - the initialization value
  @param ... the dimensions of the array
 ****************************************************************************************************/
//init( puzzle, '*', 2, numrows, numcols );
template <class T>
void init( nArray<nArray<T> >& v, T e, ... ) {
    va_list args;
    va_start(args,e);
    int d = va_arg( args, int );
    v.SetFixedSize( d );
    //v = nArray<nArray <T> >(d);
    for( int i = 0; i < d; i++ )
        init_sub( v[i], e, args );
    va_end(args);
}
/****************************************************************************************************
  used by init to initialize nArray of dimensions > 2
  @param v - the nArray to initalize
  @param e - the initialization value
  @param args dimensions for the remaining part of the array
  needed because you cannot call child ... functions with an unknown
  number of args
 ****************************************************************************************************/
template <class T>
void init_sub( nArray<nArray<T> >& v, T e, va_list args ) {
    int d = va_arg( args, int );
    v.SetFixedSize( d );
    //v = nArray<nArray <T> >(d);
    for( int i = 0; i < d; i++ )
        init_sub( v[i], e, args );
}
/****************************************************************************************************
  initializes the last dimension
  @param v - the nArray to initalize
  @param e - the initialization value
  @param args dimensions for this part of the array
 ****************************************************************************************************/
template <class T>
void init_sub( nArray<T>& v, T e, va_list args) {
    int d = va_arg( args, int );
    //v = nArray<T>(d);
    v.SetFixedSize(d);
    for( int i = 0; i < d; i ++ )
        v[i] = e;
}

/****************************************************************************************************
  initialize a single dimension nArray
  @param v - the nArray to initalize
  @param e - the initialization value
  @param ... the dimensions of the array
 ****************************************************************************************************/
template <class T>
void init( nArray<T>& v, T e, ... ) {
    va_list args;
    va_start(args,e);
    int d = va_arg( args, int );
    va_end(args);
    //v = nArray<T>(d);
    v.SetFixedSize(d);
    for( int i = 0; i < d; i ++ )
        v[i] = e;
}
#endif /* NARRAYOPS_H */
#endif /* __WIN#@__ */
