#ifndef N_ASPECT_H
#define N_ASPECT_H
//------------------------------------------------------------------------------
/**
    @class nAspect

    @brief Super class for entity attribute classes.

    Contains convenience functions for accessing nEnvs attached to parent Ent.

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAspect
#include "kernel/ndefdllclass.h"
#include "enkiduo/var.h"
#include "enkiduo/myvar.h"


//------------------------------------------------------------------------------
class nAspect : public nThing
{
public:
    /// constructor
    nAspect();
    virtual void Initialize();
    //ran on first trigger step
    virtual void InitVars();
    /// destructor
    virtual ~nAspect();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Message( nMessage* m );
    virtual void Tick( float time, float dtime );
    virtual bool BlockDeath( bool ){ return false; }
    virtual bool Select() { return true; }         ///pulled when the entity is selected
    virtual bool DeSelect() { return true; }         ///pulled when the entity is selected
    virtual int ReleasePriority(){ return 10; }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    nEnt* GetEnt(){ return ent; }
protected:
    nEnt* ent;
    //nDynAutoRef<nEnt> side;
    //var side;
    bool varsInitialized;
};
//------------------------------------------------------------------------------
typedef nArray<nAspect> AspectArray;
#endif

