#ifndef N_CATEGORYSERVER_H
#define N_CATEGORYSERVER_H
//------------------------------------------------------------------------------
/**
    @class nCategoryServer

    @brief maintains collections of entities which belong to particular categories

    for now this is intendend to remove some fo the ccode from planner ui, and provide a clearer place to store this stuff in the future

    (C)	2006	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nCategoryServer
#include "kernel/ndefdllclass.h"

class nEventServer;
//------------------------------------------------------------------------------
class nCategoryServer : public nThing {
public:
    /// constructor
    nCategoryServer();
    virtual void Initialize();
    /// destructor
    virtual ~nCategoryServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual int  CreateCategory               ( const char* name, const char* path = 0);
    virtual bool AddEntToCategory             ( int handle, nEnt* e );
    virtual bool RemoveEntFromCategory        ( int handle, nEnt* e );
    virtual bool UpdateCategory               ( int handle, const EntArray& newEnts );
    virtual bool ClearCategory                ( int handle );
    virtual const EntArray* GetEntsInCategory ( int handle );
    virtual const char* GetCategoryName       ( int handle )                                                            { return categories[handle].name.Get(); }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual void CategoryChanged              ( int handle );
    struct Category {
        nString name;                   ///short name for this Category
        nString path;                   ///full path to the vis node
        EntArray members;               ///list of entities within this group
        bool hasVis;                    ///do i even link to a vis node?
        void* event;
        Category(): hasVis(false) {}
    };
    nArray<Category> categories;
    nAutoRef<nEventServer>              refEventServer;
};
//------------------------------------------------------------------------------
#endif

