#ifndef N_CHANNELHOLDER_H
#define N_CHANNELHOLDER_H
//------------------------------------------------------------------------------
/**
    @class nChannelHolder

    @brief holds channel variables - intermediating between the entity system and the channel system

    an intermediary between the entity/variable system and the channel system,  aspects should keep a pointer to this and add/set any channels they want to display nicely 
    hp's are an obvious case...infact we might override the n3dnode and use this as the base class..that would be awesome
    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_VISNODE_H
#include "node/nvisnode.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nChannelHolder
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nChannelHolder : public nVisNode
{
public:
    /// constructor
    nChannelHolder();
    virtual void Initialize();
    /// destructor
    virtual ~nChannelHolder();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual int Add( const char* name, float* value, int l);
    virtual void Set( int index, float* value, int l);
    virtual void Compute( nSceneGraph2* );
    virtual void AttachChannels( nChannelSet* channelSet );
    virtual nString Sum();
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    struct ChannelInfo {
        nString		name;
        int 		handle;
        float* 		value;
        int l;

    };
    nArray<ChannelInfo> channels;
};
//------------------------------------------------------------------------------
#endif

