#ifndef MESSAGE_H
#define MESSAGE_H
#include "util/nstring.h"
#include "mathlib/vector.h"

class nMessage
{
public:
    float time;
    nString from;
    nString to;
    nString title;
    nString data;
    float f0;
    float f1;
    float f2;
    vector3 v;
    nString string;

    void init(){
        time = -1.0f;
        from = "anon";
        to = "all";
        title = "none";
        data = "none";
        f0 = -1.0f;
        f1 = -1.0f;
        v.set( -1.0f, -1.0f, -1.0f );
    }

    nMessage(){
        init();
    }
    const char* toString(){
        char answer[1024];
        char add[256];
        sprintf( answer, "%s -> %s %s", from.Get(), to.Get(), title.Get() );
        if( data != "none" ){
            sprintf( add, " d: %s", data.Get() );
            strcat( answer, add );
        }
        sprintf( add, " f0: %f f1: %f", f0, f1 );
        strcat( answer, add );
        sprintf( add, " v: %.2f,%.2f,%.2f", v.x, v.y, v.z );
        strcat( answer, add );
        string = answer;
        return string.Get();
    }

    nMessage& operator = ( nMessage& rhs ){
        time = rhs.time;
        from = rhs.from;
        to = rhs.to;
        title = rhs.title;
        data = rhs.data;
        f0 = rhs.f0;
        f1 = rhs.f1;
        v = rhs.v;
        return *this;
    }
};
#endif
