#ifndef N_MESSAGESERVER_H
#define N_MESSAGESERVER_H
//------------------------------------------------------------------------------
/**
    @class nMessageServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2003	Chris Miles
*/
#include "kernel/nroot.h"

#undef N_DEFINES
#define N_DEFINES nMessageServer
#include "kernel/ndefdllclass.h"
#include "enkiduo/nmessage.h"
#include "util/nheap.h"
#include "enkiduo/nthing.h"

//------------------------------------------------------------------------------
class nMessageServer : public nThing
{
public:
    /// constructor
    nMessageServer();
    virtual void Initialize();
    /// destructor
    virtual ~nMessageServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void Tick( float time, float dtime );
    virtual void Send( nMessage* m );
    virtual void SetTime( float f );

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    float time;
    nAutoRef<nThing> root;
    nHeap< nMessage* > heap;
};
//------------------------------------------------------------------------------
#endif

