#ifndef __WIN32__
#ifndef N_OPENALSERVER_H
#define N_OPENALSERVER_H
//------------------------------------------------------------------------------
/**
    @class nOpenALServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nOpenALServer
#include "kernel/ndefdllclass.h"

#include <AL/al.h>
#include <AL/alut.h>
class nEnt;


//------------------------------------------------------------------------------
class nOpenALServer : public nThing
{
public:
    /// constructor
    nOpenALServer();
    virtual void Initialize();
    /// destructor
    virtual ~nOpenALServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void InitBuffers( int i );
    virtual void Play( const char* soundName );
    virtual void StartLoop( const char* soundName );
    virtual void Stop( const char* soundName );
    virtual void LoadWav( const char* name, const char* filename );

    virtual int CreateEmitter( const char* name );
    virtual void UpdateEmitter( int handle, vector3 pos, vector3 vel );
    virtual void UpdateListener();

    virtual void SetDopplerCoef( float f ) 	{ this->dopplerCoef = f; alDopplerFactor( dopplerCoef );}
    virtual float GetDopplerCoef( ) 		{ return this->dopplerCoef; }

    virtual void SetCameraVelCoef( float f ) 	{ this->cameraVelCoef = f; alDopplerFactor( cameraVelCoef );}
    virtual float GetCameraVelCoef( ) 		{ return this->cameraVelCoef; }

    //***********************************************************************
    //	NEW STUFF
    //***********************************************************************
    virtual int CreateEmitter();
    //virtual void StartPlaying( int emitterHandle );
    virtual void Queue	( int emitterHandle, const char* filename );
    virtual void StopPlaying	( int emitterHandle );

    //options
    virtual void SetGain	( int emitterHandle, float gain );
    virtual void SetPitch	( int emitterHandle, float pitch );
    virtual void SetLooping	( int emitterHandle, bool looping );

    //what should it look like
    //virtual int LoopAmbient( const char* soundName );
    //virtual int PlayAmbient( const char* soundName );
    //virtual int LoopSound( const char* soundName );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual int CreateSource();
    virtual void CheckError();

    struct Sound {
        nString name;
        nString filename;
        ALuint buffer;
        ALuint source;
        ALenum format;
        ALsizei size, freq;
    };
    nArray<Sound> sounds;
    nArray<Sound> emitters;

    ALfloat* listenerPos;
    ALfloat* listenerVel;
    ALfloat* listenerOri;

    ALfloat* defaultSourcePos;
    ALfloat* defaultSourceVel;

    nArray<ALuint> buffer;
    nArray<ALuint> source;

    nAutoRef< nEnt> camera;

    float dopplerCoef;
    float cameraVelCoef;
};
//------------------------------------------------------------------------------
#endif
#endif
