#ifndef N_RCSERVER_H
#define N_RCSERVER_H
//------------------------------------------------------------------------------
/**
    @class nRCServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nRCServer
#include "kernel/ndefdllclass.h"
#include "kernel/nscriptserver.h"

//------------------------------------------------------------------------------
class nRCServer : public nThing
{
public:
    /// constructor
    nRCServer();
    virtual void Initialize();
    /// destructor
    virtual ~nRCServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void SetRC( const char* targetName, rc* target ){
        this->targetName = targetName;
        this->targetRc = target;
        this->Update();
    }
    virtual void Update(){
        const char* err = 0;
        script->Run("RC::update", err);
        if( err )
            n_printf("%s\n", err );
    }
    virtual void SetEdge( int i, float f ){
        n_assert( targetRc );
        targetRc->SetBucketEdge( i, f );
    }
    virtual float GetEdge( int i ){
        n_assert( targetRc );
        return targetRc->GetBucketEdge( i );
    }
    virtual int GetCount(){ 
        if( targetRc == 0 ) 
            return 0;
        return targetRc->GetBucketCount();
    }
    virtual float GetInputMin(){
        if( targetRc == 0 ) return 0;
        return targetRc->GetInputMin();
    }
    virtual float GetInputMax(){
        if( targetRc == 0 ) return 0;
        return targetRc->GetInputMax();
    }
    virtual float GetMin(){
        if( targetRc == 0 ) return 0;
        return targetRc->GetOutputMin();
    }
    virtual float GetMax(){
        if( targetRc == 0 ) return 0;
        return targetRc->GetOutputMax();
    }
    virtual float  GetLastChecked(){ 
        if( targetRc == 0 ) return 0;
        return targetRc->GetLastChecked();
    }
    virtual float GetResponse( float f ) {
        if( targetRc == 0 ) return 0;
        return targetRc->Response( f );
    }
    virtual float GetLastResponse( ) {
        if( targetRc == 0 ) return 0;
        return targetRc->GetLastResponse( );
    }
    virtual const char* GetTarget(){
        return targetName.Get();
    }
    virtual void Save( const char* s ) { 
        if( targetRc == 0 ) return;
        targetRc->Save( s );
    }
    virtual void Load( const char* s ) { 
        if( targetRc == 0 ) return;
        targetRc->Load( s );
    }
protected:
    nString targetName;
    rc* targetRc;
    nAutoRef<nScriptServer> script;
};
//------------------------------------------------------------------------------
#endif

