#ifndef N_TRIGGERSERVER_H
#define N_TRIGGERSERVER_H
//------------------------------------------------------------------------------
/**
    @class nTriggerServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nTriggerServer
#include "kernel/ndefdllclass.h"
#include "gfx/nchannelserver.h"
#include "enkiduo/nprofserver.h"

class nTriggerServer : public nThing
{
public:
    /// constructor
    nTriggerServer();
    virtual void Initialize();
    /// destructor
    virtual ~nTriggerServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void TriggerThings( float time );
    virtual void Enqueue( nThing* thing, TICKS_PER_FRAME ticksPerFrame );
    virtual void AddToTriggerList( nThing* root )      { toTrigger.Append( root );                     } 
    virtual void RemoveFromTriggerList( nThing* root ) { toTrigger.Erase( toTrigger.Find(root) );      } 
    virtual void SetTimeScale( float f )               { this->timeScale = f;                          } 
    virtual float GetTimeScale()                       { return this->timeScale;                       } 

    virtual void SetMaxTimeSteps( int i )              { this->maxTimeStepsPerFrame= i;                } 
    virtual int GetMaxTimeSteps()                      { return this->maxTimeStepsPerFrame;            } 
    
    virtual void SetTimeStep( float f )                { this->timeStep = f;                           } 
    virtual float GetTimeStep()                        { return this->timeStep;                        } 
    virtual void JumpTime( float f )                   { /*this->gameTime += f; this->timeLost += f;*/ } //10 minute advance
    virtual float GetGameTime()                        { return gameTime;                              } 
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;

    inline float GetActualTime()                       { return this->actualTime;                      } 
protected:
    virtual void TickThings( nThing* root );
    virtual void TickQueue( int queue, float dtime );
    float lastTime;
    float timeScale;
    float scaledTime;
    float gameTime;
    float timeStep;
    float timeLost;
    float actualTime;
    int maxTimeStepsPerFrame;
    nArray< nArray<nThing*> > queues; //1,2,4,8,16
    nAutoRef<nChannelServer> channel;
    nArray< nThing* > toTrigger;
    nAutoRef< nProfServer>          prof;
};
//------------------------------------------------------------------------------
#endif

