#ifndef N_WAVER_H
#define N_WAVER_H
//------------------------------------------------------------------------------
/**
    @class nWaver

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_MESHMIXER_H
#include "node/nmeshmixer.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nWaver
#include "kernel/ndefdllclass.h"
#include "enkiduo/var.h"
#include "map/nmap.h"
class nTriggerServer;
class nEnt;

//------------------------------------------------------------------------------
class nWaver : public nMeshMixer {
    enum WAVE_TYPE {
        WAVE_POINT,
        WAVE_DIRECTIONAL,
        WAVE_WAKE,
    };
    struct WaveInfo {
        var typeVar;
        var periodVar;
        var amplitudeVar;
        var directionVar;
        var wavelengthVar;

        WAVE_TYPE type;
        float xCoef, zCoef;
    };
public:
    /// constructor
    nWaver();
    virtual void Initialize();
    /// destructor
    virtual ~nWaver();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    float displacementAt( float x, float z );
protected:
    float forceAboveLand( float x, float y, float z );
    virtual void mix(nVertexBuffer **, float *, int, nSceneGraph2*);
    nAutoRef<nEnt> camera;
    nAutoRef<nTriggerServer> triggerServer;
    nAutoRef<nEnt> waveRoot;
    nArray<WaveInfo> waves;
    nRoot* lastWaveChecked;
    float time;
    nAutoRef<nMap> refMap;
};
//------------------------------------------------------------------------------
#endif

