#ifndef N_GAMASTER_H
#define N_GAMASTER_H
//------------------------------------------------------------------------------
/**
    @class nGAMaster

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_GA_H
#include "ga/nga.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGAMaster
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nGAMaster : public nGA
{
public:
    /// constructor
    nGAMaster();
    virtual void Initialize();
    virtual void InitVars();
    virtual void InitGA();
    /// destructor
    virtual ~nGAMaster();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void Step();
    virtual void Delegate( int individual, int slaveNum );

    virtual void ReceiveStrikeServer 	( int from, const char* msg );
    virtual void ReceiveSituation	( int from, const char* msg );
    virtual void ReceiveSlave		( int from, const char* msg );
    virtual void ReceiveFitness		( int from, const char* msg );                	
    virtual void ReceiveProfiling	( int from, const char* msg );                 
    virtual void ReceiveRun		( int from, const char* msg );
    virtual void ReceiveSlaveReady	( int from, const char* msg );
    virtual void ReceiveSlaveAborted	( int from, const char* msg );
    virtual nString GetSlaveInfo		();

    virtual void ConnectionDied		( int i );	//a conection, hopefully to the slaves died

    virtual void NextGeneration();
    virtual void DoneRunning();
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nAutoRef<nSocket> socket;
    int strikeServerHandle;
    nArray<Times> slaveTimes;
    nArray<nEnv*> slaveProfilingEnvs;

    struct SlaveInfo {              //info the master keeps about each slave
        nString ip;
        int socketHandle;
        bool busy;                  //as it working?
        int individualSent;         //what is it working on
        bool ready;		//has it finished parsing the situation / other stuff
        int numEvaluated;
        int evaluationsFailed;
        SlaveInfo(){
            socketHandle = -1;
            busy = false;
            individualSent = -1;
            ready = false;
            numEvaluated = 0;
            evaluationsFailed = 0;
        }
    };
    //SlaveInfo* slave;
    nArray<SlaveInfo> slaves;
    float time;
    var maxEvalTime;
    var maxBoots;
    var numBoots;
};
//------------------------------------------------------------------------------
#endif

