#ifndef N_GAOPS_H
#define N_GAOPS_H
//------------------------------------------------------------------------------
/**
    @class nGAOPS

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_GAPROBLEM_H
#include "ga/ngaproblem.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGAOPS
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nGAOPS : public nGAProblem
{
public:
    /// constructor
    nGAOPS();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nGAOPS();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );

    virtual bool IsEvaluationDone();  						//checks to see if the evaluation is finished every tick
    virtual void ParseFitness( float& damageBlue, float& damageRed, float& distancePenalty);                          	//called when a game is over to parse out the fitness
    virtual void SetActive( bool b ) { this->active = b; }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    bool active;
    nAutoRef<nRoot> platformEntRoot,    //the root of the platform tree
                    targetEntRoot;      //root of the target tree
};
//------------------------------------------------------------------------------
#endif

