#ifndef N_GASLAVE_H
#define N_GASLAVE_H
//------------------------------------------------------------------------------
/**
    @class nGASlave

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_GA_H
#include "ga/nga.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGASlave
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nGASlave : public nGA
{
public:
    /// constructor
    nGASlave();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nGASlave();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void BuildEncoding();   //constructs the encoding

    virtual void ReceiveSituation	( nString s );
    //virtual void ReceiveMission( 	const char* msg );
    virtual void ReceiveEvaluate	( nString msg );
    virtual void ReceiveDie		( const char* msg );
    virtual void ReceiveAbortEvaluation	( const char* msg );
    
    virtual void DoneEvaluating( int individual, float fitness );
    virtual void CheckIfDone()		{ }	//the gaslave never really finishes running
    virtual void ConnectionDied( int handle );

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nAutoRef<nSocket> socket;
    nGenome* genome;		//the genome i evaluate 
    nGenome* alloc;		//alloc child of the genome
    int GAMasterHandle;
};
//------------------------------------------------------------------------------
#endif

