#ifndef N_ENTVICINITYIM_H
#define N_ENTVICINITYIM_H
//------------------------------------------------------------------------------
/**
    @class nEntVicinityIM

    @brief im representing vicinity to particular entities of different types

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_IM_H
#include "im/nim.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nEntVicinityIM
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nEntVicinityIM : public nIM {
public:
    /// constructor
    nEntVicinityIM();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nEntVicinityIM();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;

    ///update my vals
    virtual void calculateValues(void* v);
protected:
    myvar sideWatching;                   ///we only want ents on a particular side
    myvar radius;                         ///how big of a radius we should give each entity
};
//------------------------------------------------------------------------------
#endif

