#ifndef N_IM_H
#define N_IM_H
//------------------------------------------------------------------------------
/**
    @class nIM

    @brief Influence Map

    okay so we need to rewrite this, then what do we do
    well lets get a simple linear fallof going, min/max values, etc..
    be sure to use vars this time

    (C)	2005	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIM
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"
#include "enkiduo/neventserver.h"

class nAllocator;
//------------------------------------------------------------------------------
class nIM : public nAspect {
public:
    /// constructor
    nIM();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIM();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick                   ( float time, float dtime );
    virtual void Display                ( nGfxServer* gfx );

    //wraps calculateValues (the one that is really called)
    void calcVals();
    ///THE IM function - go through and set all my values (what to extend in subclasses)
    virtual void calculateValues();
    virtual void calculateValues(void** const v );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    inline float getVal( int x, int y )                                         { return vals[x][y]; }
    float getVal( vector3 v );
    inline vector3 getPoint( int x, int y )                                     { return this->points[x][y]; }
    void getCoord( vector3 point, int& x, int& y );
    inline float getFinalVal( int x, int y )                                    { return vals[x][y] * this->coef; }
    virtual void SetCoef( float f )                                             { this->coef = f; ref_eventServer->pullLater( "updateIMs", str(this));}
    float GetCoef()                                                             { return this->coef; }
    vector3 getMax()                                                            { return maxLocation.GetV(); }
    void getMinMaxCoords( int& minx, int&miny, int&maxx, int& maxy )            { minx = this->minx; miny = this->miny; maxx = this->maxx; maxy = this->maxy; }
    virtual const char* GetBehavior();
    virtual void SetBehavior( const char* s )                                   { this->behavior = s; ref_eventServer->pullLater( "updateIMs", str(this));}
    int getResolution()                                                         { return this->res; }
    virtual bool isdirty();
protected:
    void allocArrays();
    void deallocArrays();
    ///translate a value into a color (-1 = red, 0 = blue, 1 = yellow)
    void GetColor                       ( float val, nGfxServer* gfx );
    void clearVals();
    void calcSquareSize();
    void calcPoints();
    void calcNormVals();
    void findMaxMinPoints();

    var worldMin;
    var worldMax;
    var worldSize;
    var resolution;
    var lineBrightness;
    int res;
    int oldRes;
    float** vals;
    float** normVals;
    vector3 squareSize;
    vector3 ** points;
    nAutoRef<nMap> map;
    int minx, miny, maxx, maxy;

    myvar minLocation;
    myvar maxLocation;

    bool valsDirty;
    bool dirty;

    float coef;

    //var myGroup;
    nString behavior;
    var steps;

    nAutoRef<nEventServer> ref_eventServer;
    //void* updateIMSEventPtr;
    nAllocator* allocator;
};
//------------------------------------------------------------------------------
#endif
