#ifndef N_IMDUO_H
#define N_IMDUO_H
//------------------------------------------------------------------------------
/**
    @class nIMDuo

    @brief im formed by operations on two base ims

    influence map, that can be the summation, negation, multiplication of division of two other ims

    (C)	2005	Chris Miles
*/
#ifndef N_IM_H
#include "im/nim.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMDuo
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nIMDuo : public nIM {
public:
    /// constructor
    nIMDuo();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIMDuo();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    ///update my vals
    virtual void calculateValues();
protected:
    myvar im1;                          ///first im i am combinining
    myvar im2;                          ///second im i am combinining
    myvar op;                           ///which operator to use
    myvar im1coef;
    myvar im2coef;
    nIM* im1Ptr;                        ///actual pointer to the im
    nIM* im2Ptr;
};
//------------------------------------------------------------------------------
#endif

