#ifndef N_IMGAUSSIANBLUR_H
#define N_IMGAUSSIANBLUR_H
//------------------------------------------------------------------------------
/**
    @class nIMGaussianBlur

    @brief blurs its child's im via a gaussian blur function

    a detailed description of the class

    (C)	2006	Chris Miles
*/
#ifndef N_IM_H
#include "im/nim.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMGaussianBlur
#include "kernel/ndefdllclass.h"

//-----------------------------------------------------------------------------//
enum MODES {
    NORMAL, 
    MINIMIZE_ONLY,
    MAXIMIZE_ONLY,
};
static const char* modeStrings[] = {
    "NORMAL", 
    "MINIMIZE_ONLY",
    "MAXIMIZE_ONLY",
};
static const int numModes = 3;
//------------------------------------------------------------------------------
class nIMGaussianBlur : public nIM {
public:
    /// constructor
    nIMGaussianBlur();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIMGaussianBlur();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;

    virtual void SetMode( const char* s ) { 
        for ( int i = 0; i < numModes; i ++)
            if (strcmp(modeStrings[i], s) == 0 ) 
                this->mode = (MODES) i; 
        //n_printf("nIMOperator(%s).op = %i,%s\n", this->fn, this->op, s );
    }
    const char* GetMode()               { return modeStrings[this->mode]; }
    virtual void calculateValues(void** const v);
    virtual void SetRadius( float f )   { this->radius = f; }
protected:
    MODES mode;
    int radius;
};
//------------------------------------------------------------------------------
#endif

