#ifndef N_IMFUSER_H
#define N_IMFUSER_H
//------------------------------------------------------------------------------
/**
    @class nIMObjective

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_IM_H
#include "im/nim.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMObjective
#include "kernel/ndefdllclass.h"
#include "im/nimoperator.h"

class nEventServer;
//------------------------------------------------------------------------------
class nIMObjective : public nIMOperator {
public:
    /// constructor
    nIMObjective();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIMObjective();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void calculateValues(void** const v);
    void SetPowerCoef( float powerCoef )                                        { this->powerCoef = powerCoef; }
    void SetSpeedCoef( float speedCoef )                                        { this->speedCoef = speedCoef; }
    void SetValueCoef( float valueCoef )                                        { this->valueCoef = valueCoef; }
    void SetMaxUnits( int maxUnits )                                            { this->maxUnits = maxUnits; }
    float GetPowerCoef()                                                        { return this->powerCoef; }
    float GetValueCoef()                                                        { return this->valueCoef; }
    float GetSpeedCoef()                                                        { return this->speedCoef; }
    int GetMaxUnits()                                                           { return this->maxUnits; }
    const nArray<vector3>* getObjectivePoints()                                 { return &this->objectivePoints; }
    virtual void Display ( nGfxServer* gfx );

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nArray<vector3>                     objectivePoints;
    void* imAssignEvent;
    ///parameters used to determine what kind of units to assign here
    ///alternatively we migth watn to just have a preference for each kind of unit? see that makes a lot of sense too and will be a bit easier to do. okya lets do that then
    ///alternatively one of the perks of donig it the other way is we can dynamically adjust units as they are damaged
    ///hmm thats nice, and the whole thing is probably more flexible, okay ltes go back to just checking power/speewd values
    int maxUnits;
    float powerCoef;
    float valueCoef;
    float speedCoef;
    var objectivePointDistanceThreshold;
};
//------------------------------------------------------------------------------
#endif

