#ifndef N_IMOPERATOR_H
#define N_IMOPERATOR_H
//------------------------------------------------------------------------------
/**
    @class nIMOperator

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_IM_H
#include "im/nim.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMOperator
#include "kernel/ndefdllclass.h"

enum OPERATORS {
    SUM,
    SUB,
    MUL,
    DIV,
    MAX,
    MIN,
};
static const char* operatorsStrings[] = {
    "SUM",
    "SUB",
    "MUL",
    "DIV",
    "MAX",
    "MIN",
};
static const int numOperators = 6;
//-----------------------------------------------------------------------------//
enum MODES {
    NORMAL,
    BINARIZE,
};
static const char* modeStrings[] = {
    "NORMAL",
    "BINARIZE",
};
static const int numModes = 2;
//------------------------------------------------------------------------------
class nIMOperator : public nIM {
public:
    /// constructor
    nIMOperator();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIMOperator();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void SetOperator( const char* s ) { 
        for ( int i = 0; i < numOperators; i ++)
            if (strcmp(operatorsStrings[i], s) == 0 ) 
                this->op = (OPERATORS) i; 
        //n_printf("nIMOperator(%s).op = %i,%s\n", this->fn, this->op, s );
    }
    virtual void SetMode( const char* s ) { 
        for ( int i = 0; i < numModes; i ++)
            if (strcmp(modeStrings[i], s) == 0 ) 
                this->mode = (MODES) i; 
        //n_printf("nIMOperator(%s).op = %i,%s\n", this->fn, this->op, s );
    }
    const char* GetOperator()           { return operatorsStrings[this->op]; }
    const char* GetMode()               { return modeStrings[this->mode]; }
    virtual void calculateValues(void** const v);
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    OPERATORS op;
    MODES mode;
};
//------------------------------------------------------------------------------
#endif

