#ifndef N_BOATENGINE_H
#define N_BOATENGINE_H
//------------------------------------------------------------------------------
/**
    @class nBoatEngine

    @brief throttle / rudder into physical forces
    should just read in our engine power / physics parameters and apply them to the physics module

    (C)	2005	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nBoatEngine
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nBoatEngine : public nPhysicalAspect {
public:
    /// constructor
    nBoatEngine();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    ~nBoatEngine();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    /// called every frame to do things
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    //in from helmsman
    var throttle;
    var rudder;
    //entity parameters
    var enginePower;
    var rudderTorque;
    var engineRudderDissipation;
    var keelForce;
    //state reads
    var rot;
    var vel;
    //out vars
    //vars to calc maxSpeed
    var mass;
    var friction;
    var maxSpeed;
    var accelSpeed;
    //-----------------------------------------------------------------------------//
    var degradeToCovePhysics;
    bool degradedToCove;
};
//------------------------------------------------------------------------------
#endif
