#ifndef N_OILBEACONASPECT_H
#define N_OILBEACONASPECT_H
//------------------------------------------------------------------------------
/**
    @class nOilBeaconAspect

    @brief attaches to an oilbeacon, when boats come nearby it creates buoys which produce resources
    it is responsible for maintaining links to these buoys, and responding properly if they are destroyer (marauders / etc).
    each buoy should produce resources for its side

    (C)	2006	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nOilBeaconAspect
#include "kernel/ndefdllclass.h"

class nGameServer;
//------------------------------------------------------------------------------
class nOilBeaconAspect : public nAspect {
public:
    /// constructor
    nOilBeaconAspect();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nOilBeaconAspect();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var pos;
    var maxBuoys;
    var captureDistanceThreshold;
    var timeSinceLastScan;
    var timeBetweenScans;
    var sideCapturedBy;
    nArray<nDynAutoRef<nEnt> > buoys;
    float buoyPlacementThetaOffset;
    var buoyPlacementThetaRadius;
    var buoyPlacementRandomization;
    nAutoRef<nGameServer> refGameServer;
    var captureR;
    var side;
};
//------------------------------------------------------------------------------
#endif

