#ifndef N_PATHFINDMAP_H
#define N_PATHFINDMAP_H
//------------------------------------------------------------------------------
/**
    @class nPathfindMap

    @brief a brief description of the class

    a detailed description of the class

    (C)	2006	Ryan
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nPathfindMap
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"
#include "enkiduo/neventserver.h"

#include "lagoon/npathfindzone.h"


//------------------------------------------------------------------------------
class nPathfindMap : public nAspect {
public:
    /// constructor
    nPathfindMap();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nPathfindMap();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );   
    void calcMap();
    void calculateValues(); 
    inline float getVal( int x, int y )               { return map[x][y]; }
    float getVal( vector3 v );
    inline vector3 getPoint( int x, int y )           { return this->points[x][y]; }
    void getCoord( vector3 point, int& x, int& y );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    int registerZone(nPathfindZone* zone);
    bool turn(int zoneID);
    int numZones();
    void setZone(nPathfindZone* zone, int x, int y) ;
    void unregisterZone(int zoneID);
    vector3 squareSize;
protected:
    void allocArrays();
    void deallocArrays();
    void calcPoints();

    float** map;
    float** workingMap;
    vector3** points;
    nAutoRef<nMap> terrainMap;
    nKeyArray<nPathfindZone*> zones;
    
    var worldMin;
    var worldMax;
    var worldSize;
    var resolution;
    int res;
    bool working;
    int zonenum;
    int currentzone;


    nAutoRef<nEventServer> ref_eventServer;
};
//------------------------------------------------------------------------------
#endif

