#ifndef N_TANKERAI_H
#define N_TANKERAI_H
//------------------------------------------------------------------------------
/**
    @class nTankerAI

    @brief a brief description of the class

    controls the tanker, navigating automatically between oil points

    (C)	2006	Chris Miles
*/
#ifndef N_FSM_H
#include "enkiduo/nfsm.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nTankerAI
#include "kernel/ndefdllclass.h"

class nBoatMoveTo;
//------------------------------------------------------------------------------
class nTankerAI : public nFSM {
    enum States {
        Init, 
        FindDestination,
        FollowPath,
        PassBoat,
        Dock,
        Wait,
    };
public:
    /// constructor
    nTankerAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nTankerAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    bool States( StateMachineEvent event, uint state, float time, float dtime );
protected:
    var nextOilBeacon;
    var desiredHeading;
    var desiredSpeed;
    var maxSpeed;
    var pos;
    var destination;
    var oilBeaconPos;
    nDynAutoRef<nBoatMoveTo> ref_moveto;
};
//------------------------------------------------------------------------------
#endif

