#ifndef N_GROUNDCOLL_H
#define N_GROUNDCOLL_H
//------------------------------------------------------------------------------
/**
    @class nGroundColl

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGroundColl
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"

//------------------------------------------------------------------------------
class nGroundColl : public nPhysicalAspect
{
public:
    /// constructor
    nGroundColl();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nGroundColl();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void Sum();
    virtual void AddPoint( vector3 p, vector3 normal ){ 
        points.Append( p );  
        normal.norm(); 
        normals.Append( normal ); 
        translatedPoints.Append(vector3()); 
        translatedPoints0.Append(vector3());
    }
    virtual void SetPoint( int i, vector3 p ){ 
        points[i] = p;        
    }
    virtual vector3 GetPoint( int i ) { 
        return points[i];     
    }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var pos;
    var rot;
    var vel;
    var mass;
    nArray<vector3> points;
    nArray<vector3> normals;
    nArray<vector3> translatedPoints;
    nArray<vector3> translatedPoints0;
    nAutoRef<nMap> map;
};
//------------------------------------------------------------------------------
#endif

