#ifndef N_ODECOLLISIONRESPONSE_H
#define N_ODECOLLISIONRESPONSE_H
//------------------------------------------------------------------------------
/**
    @class nODECollisionResponse

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#include "enkiduo/nodeserver.h"
#ifndef N_COLLISIONRESPONSE_H
#include "physics/ncollisionresponse.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nODECollisionResponse
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nODECollisionResponse : public nCollisionResponse
{
public:
    /// constructor
    nODECollisionResponse();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nODECollisionResponse();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void Collision( nEnt* other, vector3 contact, vector3 normal, vector3 otherNormal );

protected:
    nAutoRef<nODEServer> 	odeServer;
    nDynAutoRef<nODEPhysics> 	physics;
    var collisionForce;
};
//------------------------------------------------------------------------------
#endif

