#ifndef N_ODEPHYSICS_H
#define N_ODEPHYSICS_H
//------------------------------------------------------------------------------
/**
    @class nODEPhysics

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#include "enkiduo/nodeserver.h"
#ifndef N_PHYSICS_H
#include "physics/nphysics.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nOdePhysics
#include "kernel/ndefdllclass.h"
class nODEServer;
#include "collide/ncollideobject.h"
#include "enkiduo/ngameserver.h"

//------------------------------------------------------------------------------
class nODEPhysics : public nPhysics
{
public:
    /// constructor
    nODEPhysics();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nODEPhysics();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    dBodyID GetBody(){ return bodies[0]; }
    virtual bool BlockDeath();
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual int ReleasePriority () { return 5; }
protected:
    nArray<dBodyID> bodies;
    nArray<dGeomID> geoms;
    nArray<dJointID> joints;
    //dGeomID geom[3];
    nAutoRef<nODEServer> odeServer;
    //COLLISION
    var collideClass;
    var collideShape;
    nCollideObject* collideObject;
    nAutoRef<nCollideServer> 	collideServer;
    nAutoRef<nGameServer> 	gameServer;
    bool classInitialized, shapeInitialized;
    bool collidedLastTick;
};
//------------------------------------------------------------------------------
#endif

