#ifndef N_SHIPENGINE_H
#define N_SHIPENGINE_H
//------------------------------------------------------------------------------
/**
    @class nShipEngine

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nShipEngine
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nShipEngine : public nPhysicalAspect
{
public:
    /// constructor
    nShipEngine();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nShipEngine();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var heading;	//actuators coming in
    var speed;

    var pos;
    var rot;
    var enginepower;
    var thrusterpower;
};
//------------------------------------------------------------------------------
#endif

