#ifndef N_SPRING_H
#define N_SPRING_H
//------------------------------------------------------------------------------
/**
    @class nSpring

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_OFFSETASPECT_H
#include "physics/noffsetaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nSpring
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"

//------------------------------------------------------------------------------
class nSpring : public nOffsetAspect
{
public:
    /// constructor
    nSpring();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nSpring();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    //called every frame to do work
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var springForce;
    var springLength;
    var springDamping;
    float h0;
    //nMap* map;
    nAutoRef<nMap> map;
};
//------------------------------------------------------------------------------
#endif

