#ifndef N_ARBITER_H
#define N_ARBITER_H
//------------------------------------------------------------------------------
/**
    @class nArbiter

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nArbiter
#include "kernel/ndefdllclass.h"
#include "util/nheap.h"

//------------------------------------------------------------------------------
class nArbiter : public nAI
{
public:
    /// constructor
    nArbiter();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nArbiter();
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void Tick( float time, float dtime );
    static nKernelServer* kernelServer;
    virtual void VoteVelocity( const vector3& vel, float votes, float weight ){
        VelocityVote v;
        v.vel = vel;
        v.weight = weight;
        velocityVotes.add( -votes, v );
    }
    virtual void VoteBearing( float bearing, float votes, float weight ) {
        bearingVotes.add( -votes, bearing );
    }
protected:
    struct VelocityVote{
        vector3 vel;
        float weight;
    };
    nHeap<VelocityVote> velocityVotes;
    nHeap<float> bearingVotes;
    var veldesired;
    var bearingdesired;
};
//------------------------------------------------------------------------------
#endif

