#ifndef N_INTERFACESERVER_H
#define N_INTERFACESERVER_H
//------------------------------------------------------------------------------
/**
    @class nInterfaceServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_FSM_H
#include "enkiduo/nfsm.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nInterfaceServer
#include "kernel/ndefdllclass.h"
#include "physics/nphysics.h"
#include "kernel/nenv.h"
#include "input/ninputserver.h"
//#include "enkiduo/ngameserver.h"
//#include "enkiduo/npathfinder.h"
//#include "aspect/nweapon.h"
//#include "map/nmap.h"

class nUIElement;
class nMap;
class nGameServer;
//------------------------------------------------------------------------------
class nInterfaceServer : public nFSM
{
public:
    /// constructor
    nInterfaceServer();
    virtual void Initialize();
    /// destructor
    virtual ~nInterfaceServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual vector3 ScreenToGroundPlane ( vector2 mousePos );
    virtual vector3 ScreenToWorld       ( vector2 mousePos );
    virtual vector3 MousePosTo0Centered ( vector2 mousePos );
    float GetAspectRatio() { 
        ifvalid( windowSettings )
            return aspectRatio.GetF();
        return 1.0f;
    }
    float GetFieldOfView() {             
        ifvalid( windowSettings ) 
            return fieldOfView.GetF(); 
        return 1.0f;
    }
protected:
    void ProjectMouse();
    void ProjectCameraCornerIntersections();

    var projectMouse;
    var projectCameraCornerIntersections;

    var camera;
    var cameraPos;
    var cameraRot;
    var cameraHeading;
    var cameraULIntersection;
    var cameraURIntersection;
    var cameraLLIntersection;
    var cameraLRIntersection;

    var mousePos;
    var mouseSensitivity; 
    nAutoRef<nMap>          ref_map;
    //nGameServer* ref_game;
    //vector2 lastStart, lastGoal;
    //vector3 start, goal;
    nAutoRef<nGameServer>  ref_game;

    const float mouseReach;

    var mouseScrollRate;
    var windowSettings;
    var aspectRatio;
    var fieldOfView;
};
//------------------------------------------------------------------------------
#endif
