#ifndef N_PLANNER_H
#define N_PLANNER_H
//------------------------------------------------------------------------------
/**
    @class nPlanner

    @brief intercepts mouse events, and parses them out accordingly

    (C)	2004	Chris Miles
*/
#ifndef N_FSM_H
#include "enkiduo/nfsm.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nPlanner
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nPlanner : public nFSM
{
public:
    /// constructor
    nPlanner();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nPlanner();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void SelectionEvent( const EntArray* objectsSelected );
    virtual bool MouseEvent( int button, const EntArray* objectsSelected, const EntArray* objectsOver, vector3 mousePos );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
};
//------------------------------------------------------------------------------
#endif

