#ifndef N_POPUPMENU_H
#define N_POPUPMENU_H
//------------------------------------------------------------------------------
/**
    @class nPopupMenu

    @brief manages all the popup menus in the universe

    okay so the python scripts can call for this to open up a popup menu
    what should the menu look like? well really i want a nice list of things..
    do you want to start looking at how to better integrate python with c? no better time then now i guess

    so how does this wokr
    okay the python scripts say

    /ui/popups.showmenu ['hello', 'world]
    now we need to figure out where the mouse is, and based on that draw the menu, then if you move over an item we can expand it, if it is expandable
    and also we need to  

    (C)	2005	Chris Miles
*/
#ifndef N_VISNODE_H
#include "node/nvisnode.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nPopupMenu
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nPopupMenu : public nVisNode {
public:
    /// constructor
    nPopupMenu();
    virtual void Initialize();
    /// destructor
    virtual ~nPopupMenu();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    //virtual void Show(nArray<nString> elements);
    virtual void NewMenu();
    virtual void AddItem(const char* itemName, const char* eventName);

    virtual bool Attach(nSceneGraph2* sceneGraph);
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    struct MenuInfo {
        const char* name;
        const char* event;
        vector2 position;
        vector2 size;
    };
    nArray<MenuInfo> menuItems;
};
//------------------------------------------------------------------------------
#endif

