#ifndef N_TEXTDISPLAYER_H
#define N_TEXTDISPLAYER_H
//------------------------------------------------------------------------------
/**
    @class nTextDisplayer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	David Leistiko
*/
#ifndef N_VISNODE_H
#include "node/n3dnode.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nTextDisplayer
#include "kernel/ndefdllclass.h"

enum ALIGNMENT {
    ALIGN_LEFT,
    ALIGN_CENTER,
    ALIGN_RIGHT,
};
class nInterfaceServer;
//------------------------------------------------------------------------------
class nTextDisplayer : public n3DNode
{
public:
    /// constructor
    nTextDisplayer();
    virtual void Initialize();
    /// destructor
    virtual ~nTextDisplayer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    /// pointer to nKernelServer
    virtual bool Attach(nSceneGraph2* sceneGraph);
    virtual void SetString( const char* s, ALIGNMENT alignment = ALIGN_LEFT )   { this->text = s; this->alignment = alignment; }
    virtual void SetAlpha( float f )                                            { this->alpha = f; }
    virtual const char* GetString()                                             { return text.Get(); }
    virtual void SetOffset( vector3 v )                                         { this->offset = v; }
    virtual vector3 GetOffset()                                                 { return this->offset; }

    static nKernelServer* kernelServer;
protected:
    nString text;
    vector3 offset;
    ALIGNMENT alignment;
    float alpha;
    nAutoRef<nInterfaceServer> ref_interfaceServer;
    //some kinda lookup table between the letter and the offset
};
//------------------------------------------------------------------------------
#endif

