#ifndef N_UIELEMENT_H
#define N_UIELEMENT_H
//------------------------------------------------------------------------------
/**
    @class nUIElement

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nUIElement
#include "kernel/ndefdllclass.h"
#include "enkiduo/ngameserver.h"

#include "ui/ninterfaceserver.h"
class nPlannerUI;
//------------------------------------------------------------------------------
class nUIElement : public nFSM
{
public:
    /// constructor
    nUIElement();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nUIElement();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void SetScript( const char* s ){
        this->script = s;
    }
    virtual const char* GetScript(){
        return script.get();
    }
    virtual void RunScript();
    virtual void SetNode( const char* nodeName );
    virtual const char* GetNode(){
        return this->node.getname();
    }
    virtual void Tick( float time, float dtime );
    virtual void Hide() {
        node->SetActive( false );
    }
    virtual void Show(){
        node->SetActive( true );
    }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    //virtual bool States( StateMachineEvent event, uint state, float time, float dtime ) { return false; } 
    //nInterfaceServer* interfaceServer;
    //nAutoRef<nInterfaceServer> interfaceServer; 
    nDynAutoRef<n3DNode>           	node;
    nRef<nChannelHolder>	 	nodeChannels;
    int stateChannelHandle;

    nAutoRef<nScriptServer>     scriptServer;
    nAutoRef<nPlannerUI>	ui;
    nString script;
};
//------------------------------------------------------------------------------
#endif

