import wx
import math
from cat.Interface import sensors
from common.defs import *
from common.log import Log
from useful import *
log = Log(tags=['all','sensors'])
#from cat.entity import behaviorset
#from cat.entity import EntityManager
import nEventServer
from common import EventNames
from cat import behaviorInfo

from common import OptionManager
if OptionManager.getOption('map') == 'sandiego':
    MAX_RANGE_SLIDER      = 5000
else:
    MAX_RANGE_SLIDER      = 20000
         
#from primitivebehavior import *

behaviorType = "AVOID LAND"
DEFAULTSIZE               = (200,400)
DIST_FROM_LAND_MULTIPLIER = 20
LOOK_FORWARD_SECONDS      = 240
SWEEPEND = 46 #degrees
SWEEPSTART  = -45 #degrees

SWEEPSIZE   = SWEEPEND - SWEEPSTART  #degrees

STRIDE      = 5
DEPTH_TO_USE_SMALL   = 5
DEPTH_TO_USE_LARGE   = 12
DEPTH_TO_USE_MEDIUM  = 8
DISTANCE_MULT_SMALL  = 30
DISTANCE_MULT_LARGE  = 120
DISTANCE_MULT_MEDIUM = 60


import catBehavior

from common.displayer import Displayer  #chris
class CatAvoidLand(catBehavior.CatBehavior):
    def __init__(self,cPanelA, entity=None,bname=None,sensors=None,actuators = None,recorder = None, size=DEFAULTSIZE,show=False):
        catBehavior.CatBehavior.__init__(self,cPanelA,entity=entity,bname=bname, size=size, show=show)
        self.AddFloat("range",1000.0,0.0,10000.0)
        self.AddFloat("speed",0.0,0.0,28.0)
        self.type = behaviorType
        self.sens = sensors
        self.sensors = sensors
        pushsel(self.entityPath)
        size = gi('size')
        self.width,self.height,self.length = gv('dimension')
        popsel()
        if(size == 1):
            self.depth        = DEPTH_TO_USE_LARGE
            self.distanceMult = DISTANCE_MULT_LARGE
        elif (size == 0):
            self.depth        = DEPTH_TO_USE_SMALL
            self.distanceMult = DISTANCE_MULT_SMALL
        else:
            self.depth        = DEPTH_TO_USE_MEDIUM
            self.distanceMult = DISTANCE_MULT_MEDIUM


        self.displayer = Displayer()    #chris

    def makeBehaviorPanel(self,panel,size=None,entity=None, bname=None, behavior=None, show=False):
        # SD from cat.Interface import catAvoidLandPanel, catTargetPanel
        from cat.Interface import catStartPanel, catTargetPanel
	from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
        # SD alPanel = catAvoidLandPanel.CatAvoidLandPanel(panel,-1,color=None,size=bsize,behaviorType=bname, entity=entity, behavior=behavior)
        alPanel = catStartPanel.CatStartPanel(panel,-1,color=None,size=bsize,behaviorType=bname, entity=entity, behavior=behavior)
	tsize = panelInfo.TARGETPANEL
        targetPanel = wx.Panel(panel,-1,size=tsize)
        if(show):
            panel.addPanel(alPanel,targetPanel, bname)
        return [alPanel, targetPanel]

    def loop(self,time,dtime):
        if exists(self.entityPath):
            weight = .5
            totalx = totaly = 0
            pushsel(self.entityPath)
            speed = gf('speed')
            heading = gf('heading')
            ox,oz,oy = gv('pos')
            width,height,length = gv('dimension')

                
            inEffect = False
            longestDist = 0
            longestBear = 0
            longestBearDiff = 0
            newSpeed =0#speed
            newHeading = heading
            fspeed,fheading = self.entity.actuators.getCurrentVec()
            fourMinuteRange = fspeed * LOOK_FORWARD_SECONDS
            timeToCompletion = self.entity.getTTC()
            distToCompletion = fspeed * 50#timeToCompletion
            #print 'timetocompletion',timeToCompletion,'distToCompletion:',distToCompletion,'fourMinuterange:',fourMinuteRange
            shortestAhead, shortestBear,shortestDist,shortestBearDiff,inEffect = self.landFollow(distToCompletion,heading,ox,oy)

            if inEffect:
                #print 'avoiding some land'
                if shortestDist < length * self.distanceMult:
                    #newSpeed = (fspeed /((length*15 - length*2.0)**2.0))*(shortestDist - length*2.0)**2.0
                    #if shortestDist < length * 2.0:
                    newSpeed = 1
                    #newHeading = shortestBear + math.pi
                    #return (weight, newHeading, newSpeed * behaviorInfo.METERS_PER_SEC_TO_KNOTS)
                else:
                    newSpeed = fspeed

                #newHeading = fheading
                #print 'bearing to nearest land: ' , shortestBearDiff ,' degrees'
                #print 'distance to nearest land: ',shortestDist,' m'

                if shortestBearDiff < 0:
                    newHeading = shortestBear + math.pi/2 - 5
                else:
                    newHeading = shortestBear + 5 - math.pi/2
                    
            else:
                #print 'no land to avoid'
                weight = 0
                newHeading = fheading
                newSpeed = fspeed
                #endifelse
            #endifelse
            popsel()
            return (weight,newHeading,newSpeed*behaviorInfo.METERS_PER_SEC_TO_KNOTS)
        else:
            return (0, 0, 0)

        
    def checkPostconditions(self):
        return False

    def near(self, a, b):
        return (math.fabs(float(a - b)) < STRIDE * 2)


    def landFollow(self,scanRadius,heading, ox,oy):
        self.displayer.clear()          #chris
        inEffect = False
        shortestDist = 10000
        longestDist  = 0
        shortestBear = 0
        shortestBearDiff = 0
        shortestAhead    = 0
        aheadCount       = 0
        scanRadius = self.length * self.distanceMult # Sushil: a function of size, should also be of speed
         #chris - had to increase the scanRadius to get good collisions
        for i in range(SWEEPSTART, SWEEPEND, STRIDE):
            tx = ox + scanRadius*math.sin(heading + math.radians(float(i)))
            ty = oy + scanRadius*math.cos(heading + math.radians(float(i)))
            #pass point (tx,ty) to lineIntersect function
            dist = call('/map/map.getintersect',ox, 0, oy, tx, -self.depth, ty)
            #index = int((i-SWEEPSTART) / STRIDE) #index for if you're keeping the distances in an array 
            if(dist[0] != 0 or dist[2] != 0 or dist[1] != 0):
                if(self.entity.isDebug()):
                    self.displayer.addLine( (ox, 0, oy), dist)

                #print dist
                inEffect = True
                xcoord = dist[0]-ox
                ycoord = dist[2]-oy
                
                mag = math.sqrt(xcoord**2 + ycoord**2)
                
                #print 'dist =',mag
                theta = (heading + (float(i)-90) * math.pi/180.0)
                
                if( self.near(i,(SWEEPSIZE/STRIDE)/2)):
                    shortestAhead += mag
                    aheadCount    += 1

                if mag < shortestDist:
                    shortestDist = mag
                    shortestBear = theta
                    shortestBearDiff = i - 90


        if(aheadCount > 0):
            aheadDist = shortestAhead/aheadCount
        else:
            aheadDist = scanRadius

        return aheadDist, shortestBear, shortestDist, shortestBearDiff, inEffect

                    
def getBehaviorType():
    return behaviorType
