#
# @(#) catMaintain.py 2005/25/17
# @author Monica Nicolescu and Sushil Louis
# Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

from common.defs import *
from cat import panelInfo
DEFAULTSIZE = panelInfo.CONTROLWRAPPERPANEL
import catPrimitiveApproach

from cat import behaviorInfo

REDUCE_RANGE = 60
RANGE_FACTOR = 5
#YDS_PER_SEC_TO_KNOTS = 1.7774514

class CatMaintain(catPrimitiveApproach.CatPrimitiveApproach):
    def __init__(self, cPanelA, entity=None, bname = None, sensors = None, actuators = None, recorder = None, size=DEFAULTSIZE,  show=False):
        catPrimitiveApproach.CatPrimitiveApproach.__init__(self, cPanelA, entity = entity, bname = bname, sensors = sensors, actuators = actuators, recorder = recorder, size = size,  show=show)
#         self.wrapperA = cPanelA
#         self.wrapperE = cPanelE
#         self.targetPath  = None
#         self.aa,self.ata = self.makeMaintainPanel(cPanelA, color="RED", size = size, entity = entity, behavior=self,  show=show)
#         self.ea,self.eta = self.makeMaintainPanel(cPanelE, color="RED", size = size, entity = entity, behavior=self,  show=show)        
        from common import behaviorNames
        self.EXCLUSION_LIST = (behaviorNames.MOVETO, behaviorNames.APPROACH, behaviorNames.RAM)
        

    def makeBehaviorPanel(self, wPanel, size = None, entity=None, bname=None, behavior = None,  show=False):
        # SD from cat.Interface import catApproachPanel, catTargetPanel
        from cat.Interface import catApproachesPanel, catTargetPanel
       
        from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
        
        approachPanel = catApproachesPanel.CatApproachesPanel(wPanel, -1, color=None, size=bsize, behaviorType=bname, entity=entity, behavior = behavior)       
	tsize = panelInfo.TARGETPANEL
        targetPanel = catTargetPanel.CatTargetPanel(wPanel, size=tsize, color=None, entity=entity, behavior=behavior)
        if(show):
            wPanel.addPanel(approachPanel, targetPanel, bname)
        return [approachPanel, targetPanel]

    def checkPostconditions(self):
        return False

    def UpdateReachedStation(self, rangeDiff, rangeLimit, bearingDiff, bearingLimit):
        if rangeDiff < rangeLimit and bearingDiff < bearingLimit:
            self.reachedStation = True
        else:
            self.reachedStation = False

    def GetSpeedAtStation(self):
        return self.GetTargetSpeed()* behaviorInfo.METERS_PER_SEC_TO_KNOTS
    
    def GetHeadingAtStation(self):
        if exists(self.getTarget()):
            pushsel(self.getTarget())
            if call('hasvar', 'heading'):
                tHeadingLagRad = gf('heading')
            else:
                tHeadingLagRad = 0.0
            popsel()
        else:
            tHeadingLagRad = 0.0
        return tHeadingLagRad

    def CheckReduceSpeedNeeded(self, rangeDiff, bearingDiff):
        pushsel (self.entity.getEVAPath())
        x, z, y = gv('dimension')
        speed = gf ('speed')                     #* behaviorInfo.METERS_PER_SEC_TO_KNOTS (we think)
        relSpeed = abs(speed - self.GetTargetSpeed())
        rangeFactor = (relSpeed*10/self.maxSpeed) + 10;
        REDUCE_RANGE = y * rangeFactor
        popsel()

        REDUCE_BEARING = (relSpeed*40/self.maxSpeed) + 20;
        if rangeDiff < REDUCE_RANGE and bearingDiff < REDUCE_BEARING and speed > 1.5*self.GetTargetSpeed (): #40:
            #print "reducing range = ", REDUCE_RANGE, "reducing bearing = ", REDUCE_BEARING
            reduceSpeed = True
        else:
            reduceSpeed = False
        return reduceSpeed

    
