#
# @(#) catRam.py 2005/25/17
# @author Monica Nicolescu and Sushil Louis
# Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#


from cat import panelInfo
DEFAULTSIZE = panelInfo.CONTROLWRAPPERPANEL
MINDIST     = 5
import catPrimitiveApproach
from common.defs import *

class CatRam(catPrimitiveApproach.CatPrimitiveApproach):
    def __init__(self, cPanelA, entity=None, bname = None, sensors = None, actuators = None, recorder = None, size=DEFAULTSIZE,  show=False):
        catPrimitiveApproach.CatPrimitiveApproach.__init__(self, cPanelA, entity = entity, bname = bname, sensors = sensors, actuators = actuators, recorder = recorder, size = size,  show=show)
#         self.wrapperA = cPanelA
#         self.wrapperE = cPanelE

#         self.targetPath  = None
#         self.aa,self.ata = self.makeRamPanel(cPanelA, color="RED", size = size, entity = entity, behavior=self,  show=show)
#         self.ea,self.eta = self.makeRamPanel(cPanelE, color="RED", size = size, entity = entity, behavior=self,  show=show)
        from common import behaviorNames
        self.EXCLUSION_LIST = (behaviorNames.MOVETO, behaviorNames.APPROACH, behaviorNames.MAINTAIN)
        

    def makeBehaviorPanel(self, wPanel, size = None, entity=None, bname = None, behavior = None,  show=False):
        # SD from cat.Interface import catApproachPanel, catTargetPanel
        from cat.Interface import catRamsPanel, catTargetPanel
	from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
	approachPanel = catRamsPanel.CatRamsPanel(wPanel, -1, color=None, size=bsize, behaviorType=bname, entity=entity, behavior = behavior)

	tsize = panelInfo.TARGETPANEL
        targetPanel = catTargetPanel.CatTargetPanel(wPanel, size=tsize, color=None, entity=entity, behavior=behavior)
        if(show):
            wPanel.addPanel(approachPanel, targetPanel, bname)
        return [approachPanel, targetPanel]

#     def setTarget(self, tp):
#         self.targetPath = tp

#     def getTarget(self):
#         return self.targetPath

    from common import defs
    def checkPostconditions(self):
        if(exists(self.getTarget())):
            pushsel(self.entity.getEVAPath())
            posVec = gv('pos')
            popsel()
            pushsel(self.getTarget())
            tarVec = gv('pos')
            popsel()
            return (distance(tarVec, posVec) < MINDIST)
        else:
            from common import behaviorNames
            print behaviorNames.RAM + "Needs a target"
            return True

    def GetDesiredRange(self):
        return 0

import math
def distance(vec1, vec2):
    diff0 = vec1[0] - vec2[0]
    diff1 = vec1[1] - vec2[1]
    diff2 = vec1[2] - vec2[2]    

    return math.sqrt((diff1 * diff1) + (diff2 * diff2) + (diff0 * diff0))

