import math

def diffAngle(angle1,angle2):
    """returns the difference, in radians, between two angles (also in radians)."""
    
    if (isPosAngle(angle1) and isPosAngle(angle2)) or (not isPosAngle(angle1) and not isPosAngle(angle2)):
        return abs(abs(angle1) - abs(angle2))
    else:
        x = abs(abs(angle1) + abs(angle2))
        if x > math.pi:
            return 2*math.pi - x
        else:
            return x

def isPosAngle(angle):
    """tells whether an angle is between 0 and pi."""
    if angle < 0:
        angle += 2 * math.pi
    if angle > 2 * math.pi:
        angle -= 2 * math.pi
    return angle >= 0 and angle <= math.pi
        
def getQuadratic(A,B,C):
    
    discriminant = B * B - 4 * A * C
    sol1 = (-B + math.sqrt(discriminant))/ (2 * A)
    sol2 = (-B - math.sqrt(discriminant))/ (2 * A)
    if sol1 >= sol2:
        return [sol2,sol1]
    return [sol1,sol2]

def distanceRange(vec1, vec2):
    """Given two locations, returns distance"""

    dx = vec1[0] - vec2[0]
    dz = vec1[1] - vec2[1]
    dy = vec1[2] - vec2[2]
    return math.hypot(dx, dy)


twoPI = math.pi * 2.0
PI    = math.pi
def bearing(vec1, vec2):
    """Given two locations, returns bearing"""
    x = math.atan2 (vec2[0] - vec1[0], vec2[2] - vec1[2])
    return x


import random
def flip(prob):
    if (random.random() >= prob):
        return True
    else:
        return False

def betterCPA(newCPA, oldCPA):
    newTime = newCPA[0]
    newDist = newCPA[1]
    oldTime = oldCPA[0]
    oldDist = oldCPA[1]
    if (newTime > oldTime): # or newDist > oldDist):
        print "(", newTime, ",", newDist, ") Better Than (", oldTime, ",", oldDist, ")"
        return True
    else: 
        return False

def deltaS(speed, maxSpeed):
    #print "----------------"
    #print "Speed  : ", speed
    if (speed <= 0.1):
        speed = 0
    sd  = maxSpeed/10.0
    g = random.gauss(math.sqrt(speed), sd) 
    #print "Delta  : ", g 
    #print "----------------"     
    return g

def deltaH(heading):
    #print "----------------"
    #print "Heading: ", heading
    if (heading <= 0.1):
        heading = 0.0
    sd = PI/10.0
    g = random.gauss(math.sqrt(heading), sd) 
    #print "Delta  : ", g 
    #print "----------------"     
    return g
    
