#
# @(#) catRecordManagerPanel.py 2005/11/11
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

'''
Defines the Management Panel in GUI CAT - Authoring.

'''
import wx
import wx.lib.fancytext as fancytext
import common.WindowManager as WindowManager

import catSaveRecordPanel
import catRecordWrapper

class CatRecordManager(wx.Panel):
    
    '''Control panel class in CAT GUI'''
    
    def __init__(self, parent, size = None, color = "CYAN", recType = None, entity = None, recorder=None):
        
        wx.Panel.__init__(self, parent, -1, size=size)
        self.recType = recType
        self.entity  = entity
        self.recorder = recorder

	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)
	
	spacer1 = wx.StaticText(self, -1, "", size= (88, 10), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (195, 5), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (215, 1), style = wx.ALIGN_RIGHT)
	spacer4 = wx.StaticText(self, -1, "", size= (215, 1), style = wx.ALIGN_RIGHT)
	spacer5 = wx.StaticText(self, -1, "", size= (195, 5), style = wx.ALIGN_RIGHT)

        # print "catRecordManager: Color: " + str(color)	

	self.recordWrapper = catRecordWrapper.CatRecordWrapper(self, size = size, color = color, entity = entity, recorder=recorder)
	
	self.xsavePanel 	= catSaveRecordPanel.SavePanel(self.recordWrapper, -1, color=color, size=size, recType = "Save_recorded", recorder=recorder)
	
	self.existsPanel 	= catSaveRecordPanel.ExistsPanel(self.recordWrapper, -1, color=color, size = size, recType = "File_exists", recorder=recorder)
	
	self.emptyFieldsPanel   = catSaveRecordPanel.EmptyFieldsPanel(self.recordWrapper, -1, color=color, size=size, recType = "Empty_fields", recorder=recorder)
	
	self.deletePanel 	= catSaveRecordPanel.DeletePanel(self.recordWrapper, -1, color=color, size=size, recType="Delete_file", recorder=recorder)

	self.recordWrapper.addPanel(self.xsavePanel, "Save_recorded")
        #self.recordWrapper.show("Save_recorded")
        self.recordWrapper.addPanel(self.existsPanel, "File_exists")
        self.recordWrapper.addPanel(self.emptyFieldsPanel, "Empty_fields")
        self.recordWrapper.addPanel(self.deletePanel, "Delete_file")
    
	self.recordWrapper.show("default")
        
	bsizer1 	= wx.BoxSizer(wx.VERTICAL)	
	bsizer1.Add	(self.recordWrapper, 1, wx.EXPAND)
	self.SetSizer(bsizer1)


    def getPanel(self):
        return self

    #def updateNets(self):
    #    self.recordWrapper.updateNets()

    def updatePanels(self, cname):
        self.recordWrapper.updateRecordPanel(cname)
        
