#
# @(#) catRecordPanel.py 2005/11/05
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#
'''
Defines the Network Recording, Loading, and Playback GUI and its operations for cat.

'''
import wx
#from cat.merge import xmlmerger
#from savedialog import SaveDialog
#import netmanagement as nm
from common import EventNames
import nEventServer

from common import tickmanager
from cat import panelInfo

rootlabel = "RECORDER: "
timeconstant = 0.75

from common.defs import *
class CatRecordPanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''

    ID_PAUSE = 23102
    ID_SAVE = 23103
    ID_RECORD = 23104
    ID_STOP = 23105
    ID_PLAY = 23106
    ID_START = 23107
    ID_QUERY = 23108
    ID_DELETE = 23109

    def __init__(self, parent, panelID, color = "CYAN", size=None, recType = "Recorder: ", entity=None, recorder=None):
        
        wx.Panel.__init__(self, parent, -1, size, style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
        self.dtime = 0.0
        self.dots = 1
        self.entity = entity
        self.recorder = recorder
        self.defaultFilename = "test.bn"
        self.defaultNetname  = "testNetwork"
        self.isRecording     = False

        
#        nEventServer.register(EventNames.CAT_SELECT_ENT,  self.onSelectEnt)
#        nEventServer.register(EventNames.CAT_TASKS_CHANGED,  self.loadNetworks)
	
#        tickmanager.register('RecordPanelA', self.tick)
        
        self.SetBackgroundColour(panelInfo.ARECORDPANELCOLOR)
	self.labelM = wx.StaticText(self, -1, recType+'Stopped')
	
	spacer1 = wx.StaticText(self, -1, "", size= (215, 5), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 90), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (215, 4), style = wx.ALIGN_RIGHT)
	spacerS = wx.StaticText(self, -1, "", size= (188, 4), style = wx.ALIGN_CENTER)

	self.tb = wx.ToolBar(self)
        self.tb.SetBackgroundColour(panelInfo.ARECORDPANELCOLOR)
	 
	import os
        prefix = os.path.dirname(__file__)+"/"
    	del os

        self.save_bmp = wx.Bitmap(prefix+"save.gif", wx.BITMAP_TYPE_GIF)
        self.record_bmp = wx.Bitmap(prefix+"record.gif", wx.BITMAP_TYPE_GIF)
        #self.stop_bmp = wx.Bitmap(prefix+"stop.gif", wx.BITMAP_TYPE_GIF)
        self.pause_bmp = wx.Bitmap(prefix+"pause.gif", wx.BITMAP_TYPE_GIF)
        #self.play_bmp = wx.Bitmap(prefix+"play.gif", wx.BITMAP_TYPE_GIF)
        self.delete_bmp = wx.Bitmap(prefix+"delete.gif", wx.BITMAP_TYPE_GIF)
        self.tb.AddSeparator()

        #self.tb2 = wx.ToolBar(self)
        
	
        #self.filename = wx.Choice(self.tb2, -1, size=(180, -1))
        #wx.EVT_CHOICE(self.filename, -1, self.OnSelect)

        #self.loadNetworks()
        
	#self.tb2.AddControl(self.filename)
        #self.tb2.Realize()

        
	self.tb.AddSimpleTool(self.ID_SAVE,   self.save_bmp,   "Save As...", "Save Behavior Network")
        self.tb.AddSimpleTool(self.ID_RECORD, self.record_bmp, "Record",     "Record Behavior Network")
        self.tb.AddSimpleTool(self.ID_PAUSE,  self.pause_bmp,  "Pause",      "Pause Recording Behavior Network")
        self.tb.AddSimpleTool(self.ID_STOP,   self.delete_bmp,   "Stop",       "Stop Recording Behavior Network")
        #self.tb.AddSimpleTool(self.ID_PLAY,  self.play_bmp,    "Run",        "Execute Behavior Network")
        #self.tb.AddSimpleTool(self.ID_DELETE, self.delete_bmp, "Delete",     "Delete Behavior Network")


        self.tb.EnableTool(self.ID_STOP,   False)
        self.tb.EnableTool(self.ID_PAUSE,  False)
        self.tb.EnableTool(self.ID_SAVE,   False)
        #self.tb.EnableTool(self.ID_PLAY,   False)        
        #self.tb.EnableTool(self.ID_DELETE, True)

        self.tb.Realize()

	wx.EVT_TOOL(self.tb, self.ID_SAVE,   self.save)
        wx.EVT_TOOL(self.tb, self.ID_RECORD, self.record)
        wx.EVT_TOOL(self.tb, self.ID_STOP,   self.stop)
        wx.EVT_TOOL(self.tb, self.ID_PAUSE,  self.pause)
        #wx.EVT_TOOL(self.tb, self.ID_PLAY,   self.play)
        #wx.EVT_TOOL(self.tb, self.ID_DELETE, self.delete)

	########################################################################

	box = wx.StaticBox(self, -1, '', style=wx.NO_BORDER)
#	box.SetBackgroundColour(wx.Colour (185, 239, 232))
        bsizer = wx.StaticBoxSizer(box, wx.VERTICAL)
	bsizer.Add(self.tb, 0, wx.TOP|wx.ALIGN_CENTER, 2)
	bsizer.Add(spacerS, 0, wx.CENTER|wx.ALIGN_CENTER, 2)
	#bsizer.Add(self.tb2, 0, wx.BOTTOM|wx.ALIGN_CENTER, 2)
	#border = wx.BoxSizer()
        #border.Add(bsizer, 1, wx.EXPAND|wx.ALL, 2)
    
	sizerE = wx.BoxSizer(wx.VERTICAL)
	sizerE.Add(self.labelM)
	sizerE.Add(spacer1)	
	#sizerE.Add(border)
	sizerE.Add(bsizer)
	sizerE.Add(spacer2)
	self.SetSizer(sizerE)
        # print "Done with catRecord/playback panel"                        

    def save(self, event):
        print "saving network" + str(event)
#        self.recorder.handleSaveRequest(self.defaultFilename, self.defaultNetname)
        pt = {'state':'save', 'networks': self.recorder.getNetwork()}
        self.GetParent().show('Save_recorded', {})
        self.tb.EnableTool(self.ID_STOP,   False)
        self.tb.EnableTool(self.ID_PAUSE,  False)
        self.tb.EnableTool(self.ID_SAVE,   False)
        #self.tb.EnableTool(self.ID_PLAY,   False)        
        #self.tb.EnableTool(self.ID_DELETE, True)
        self.tb.EnableTool(self.ID_RECORD, True)
        # should also update the netlist of available controllers


    def record(self, event):
        # print "catRecordPanel: recording network"+ str(event)
        self.isRecording = True
        self.recorder.handleRecordRequest()
        self.tb.EnableTool(self.ID_STOP,   True)
        self.tb.EnableTool(self.ID_PAUSE,  True)
        self.tb.EnableTool(self.ID_SAVE,   True)
        #self.tb.EnableTool(self.ID_PLAY,   False)
        self.tb.EnableTool(self.ID_RECORD, False)                
        #self.tb.EnableTool(self.ID_DELETE, False)
        
    #def play(self, event):
        # print "catRecordPanel: playing network"+ str(event)
        #netName = self.filename.GetStringSelection()
        #self.entity.handlePlayRequest(netName, {})
        #self.enablePlay()

    #def enablePlay(self):
    #    self.tb.EnableTool(self.ID_STOP,   True)
    #    self.tb.EnableTool(self.ID_PAUSE,  True)
    #    self.tb.EnableTool(self.ID_SAVE,   False)
    #    #self.tb.EnableTool(self.ID_PLAY,   False)
    #    self.tb.EnableTool(self.ID_RECORD, False)                
    #    #self.tb.EnableTool(self.ID_DELETE, True)


    def stop(self, event):
        # print "stop recording/playback network"+ str(event)
        if(self.isRecording):
            self.recorder.handleStopRecording()
            self.isRecording = False
            self.tb.EnableTool(self.ID_SAVE,   False)
            self.tb.EnableTool(self.ID_RECORD, True)                
        #else:
        #    netName = self.filename.GetStringSelection()
        #    self.entity.handleStopRequest(netName)
        self.tb.EnableTool(self.ID_STOP,   False)
        self.tb.EnableTool(self.ID_PAUSE,  False)
        #self.tb.EnableTool(self.ID_PLAY,   True)
        #self.tb.EnableTool(self.ID_DELETE, True)
        


    def pause(self, event):
        #print "pause recording/playback network"+ str(event)
        if(self.isRecording):
            self.recorder.handlePauseRecording()
            self.tb.EnableTool(self.ID_PLAY,   False)
            self.tb.EnableTool(self.ID_RECORD, True)                
            self.tb.EnableTool(self.ID_SAVE,   True)
        #else:
        #    netName = self.filename.GetStringSelection()
        #    self.entity.handlePauseRequest(netName)
        #    self.tb.EnableTool(self.ID_PLAY,   True)
        #    self.tb.EnableTool(self.ID_SAVE,   False)
        #    self.tb.EnableTool(self.ID_RECORD, False)                
        self.tb.EnableTool(self.ID_STOP,   True)
        self.tb.EnableTool(self.ID_PAUSE,  False)
        #self.tb.EnableTool(self.ID_DELETE, True) 

    def delete(self, event):
        print "Deleting network? " + str(event)
        self.GetParent().show('Delete_file')

    def getPanel(self):
        return self

    def show(self, data = {}):
        self.Show()
        if data.get('state') == 'ok':
            myfilename = data['filename']
            netname = data['netname']
            if not myfilename.endswith('.bn'):
                myfilename = myfilename + '.bn'
            #self.recorder.setNetInfo(myfilename, netname)
            self.recorder.saveNetwork(myfilename, netname)
            self.recorder.updateNetDict(myfilename, netname)
        else:
            #print "Cannot handle state: %s, with data: %s" % (data.get('state'), str(data)) #chris
            pass


