#
# @(#) catSlidersPanel.py 2005/12/6
# @author AO and SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
"""
Sliders Panel, e.g Avoid Entity
"""
import wx
import catElementaryPanel
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames

MAX_RANGE_SLIDER = 20000

class CatSlidersPanel(catElementaryPanel.CatElementaryPanel):
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = None, entity = None, behavior=None):    
        catElementaryPanel.CatElementaryPanel.__init__(self, parent, panelID, color, size, behaviorType, entity, behavior)
	
        newSizer = wx.BoxSizer(wx.VERTICAL)
        
	panicSizer = wx.BoxSizer(wx.HORIZONTAL)
        effectiveSizer = wx.BoxSizer(wx.HORIZONTAL)
        speedSizer = wx.BoxSizer(wx.HORIZONTAL)

        self.panicSlider = wx.Slider(self,-1,100,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
	self.effectiveSlider = wx.Slider(self,-1,150,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
	self.speedSlider = wx.Slider(self,-1,0,0,0,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        
	wx.EVT_SLIDER(self.panicSlider,-1,self.OnPanicChange)
        wx.EVT_SLIDER(self.effectiveSlider,-1,self.OnEffectiveChange)
        wx.EVT_SLIDER(self.speedSlider,-1,self.OnSpeedChange)

        newSizer.Add(wx.StaticText(self,-1,"Panic Range"))
        panicSizer.Add(self.panicSlider, 1, border=5,flag=wx.RIGHT|wx.EXPAND)
        panicSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
        newSizer.Add(panicSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)        
        
	newSizer.Add(wx.StaticText(self,-1,"Effective Range"))
        effectiveSizer.Add(self.effectiveSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
        effectiveSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
        newSizer.Add(effectiveSizer, 0, border=10,flag=wx.BOTTOM|wx.EXPAND)
        
	newSizer.Add(wx.StaticText(self,-1,"Speed"))
        speedSizer.Add(self.speedSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
        speedSizer.Add(wx.StaticText(self, -1, "knots"), flag=wx.ALIGN_BOTTOM)        
        newSizer.Add(speedSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)
        
	self.startStopButton = wx.Button(self,-1,'Start', style=wx.BU_EXACTFIT)
      	self.startStopButtonState = 'start'
      	wx.EVT_BUTTON(self.startStopButton,-1,self.OnClick)
      	emptySizer = wx.BoxSizer()
      	newSizer.Add(emptySizer, 1, flag=wx.EXPAND)
      	newSizer.Add(self.startStopButton, 0 , flag=wx.CENTER)#ALIGN_RIGHT|wx.ALIGN_BOTTOM)
      	spacerX =wx.StaticText(self, -1, "", size=(180,10), style=wx.ALIGN_LEFT)
	newSizer.Add(spacerX)
	self.sizer.Add(newSizer,1,border = 10,flag=wx.TOP|wx.EXPAND)
      	
	#self.EXCLUSION_LIST = ()
       
        pushsel(self.entity.getEVAPath())
        self.speedSlider.SetValue(gf('maxSpeed')/2.0)
        popsel()
        
    def OnPanicChange(self,event):
        self.behavior.SetVar('panicRange',self.panicSlider.GetValue())
        
    def OnEffectiveChange(self,event):
        self.behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())        
       
    def OnSpeedChange(self,event):
        self.behavior.SetVar('Speed',self.speedSlider.GetValue())        
       
    def OnClick(self,event):
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print "I am on a time out due to bad behavior"
       
    def handlePageChange(self, msg):
        self.startStopButton.SetLabel(self.behavior.startStop)
 
    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)

    def updatePanels(self):
        self.SetStartStop()
        self.Layout()
        self.Validate()
        self.Show()

        
#     