#
# @(#) catStartPanel.py 2005/12/6
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

"""
Start panel, e.g. Fire

"""
import wx
import catElementaryPanel
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames
from cat import panelInfo

class CatStartPanel(catElementaryPanel.CatElementaryPanel):
	
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = None, entity = None, behavior=None):
	    
        catElementaryPanel.CatElementaryPanel.__init__(self, parent, panelID, color, size, behaviorType, entity, behavior)

        x, y = size
#        print "CatStartPanel Spacer size = ", str((x, y - 50)), " Panel Size ", str(panelInfo.BEHAVIORPANEL)
        
	spacerX =wx.StaticText(self, -1, "", size=(x, y - 50), style=wx.ALIGN_LEFT)
	self.sizer.Add(spacerX)

	self.startStopButton = wx.Button(self, -1, "Start", style=wx.BU_EXACTFIT)
	self.startStopButtonState = "start"
        wx.EVT_BUTTON(self.startStopButton, -1, self.OnClick)
	
	self.sizer.Add(self.startStopButton, 0, wx.ALIGN_CENTER|wx.ALIGN_BOTTOM)
	
# 	notifLabel = wx.StaticText (self, -1," Status: ")
# 	self.notifMsg = wx.StaticText (self, -1, "_____", size = (100, 20), style = wx.TE_READONLY | wx.TE_LEFT)
# 	space = 2
# 	notifSizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
# 	notifSizer.AddMany ([notifLabel, self.notifMsg])
# 	self.sizer.Add(notifSizer)

        nEventServer.register(EventNames.CAT_PAGE_CHANGED, self.handlePageChange)
 
        
    def OnClick(self, event):
        
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print "Start panel: I am on a time out due to bad behavior"

    def handlePageChange(self, msg):
        self.startStopButton.SetLabel(self.behavior.startStop)
        
    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)

    def updatePanels(self):
        self.SetStartStop()
        self.Layout()
        self.Validate()
        self.Show()
