#
# @(#) catTriggerWrapper.py 2006/3/7
# @author Copyright (c) 2006 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
#TODO: Look into horizontal layout
#TODO: Set up recorder
#TODO: Tighten interface
'''
Defines the GUI and its operations for cat.

'''
import wx
#import wx.lib.fancytext as fancytext
#import common.WindowManager as WindowManager
from common.defs import *
import math
import nEventServer

from common import EventNames
import panelWrapper
from cat import panelInfo

TRIGGERAUTHORPANELNAME = "triggerAuthor"
TRIGGERDELETEPANELNAME = "triggerDelete"
CREATEDIALOGPANELNAME  = "createDialog"
TRIGGEREXECPANELNAME   = "execAuthor"

import triggerDeletePanel
import triggerNewPanel
import triggerMainPanel
import triggerInfoPanel

class CatTriggerWrapper(wx.Panel):
    
    '''Entity panel class'''
    
    def __init__(self, parent, size=None, color = "CYAN", entity=None):
        wx.Panel.__init__(self, parent, -1, size = size)
        self.SetBackgroundColour(color)

        self.sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(self.sizer)
        self.entity = entity

        mainPanel   = triggerMainPanel.TriggerMainPanel(self, size, color, entity)
        newPanel    = triggerNewPanel.TriggerNewPanel(self, size, color, entity)
        deletePanel = triggerDeletePanel.TriggerDeletePanel(self, size, color, entity)
        infoPanel   = triggerInfoPanel.TriggerInfoPanel(self, size, color, entity)

        self.panels = {}

        self.addPanel(mainPanel, 'main')
        self.addPanel(newPanel, 'new')
        self.addPanel(deletePanel, 'delete')
        self.addPanel(infoPanel, 'info')

        self.showPanel('main')

    def addPanel(self, panel, name):
        panel.Hide()
        self.sizer.Add(panel, 1, flag=wx.EXPAND)
        self.panels[name] = panel
        self.sizer.Layout()

    def showPanel(self, name):
        self.hideAll()
        if self.panels.has_key(name):
            panel = self.panels[name]
            panel.Show()
            self.sizer.Layout()

    def show(self, name, passthru=''):
        found = False
        for panelName, panel in self.panels.iteritems():
            if panelName != name:
                panel.Hide()
            else:
                panel.show(passthru)
                found = True
        self.sizer.Layout()
            
    def hideAll(self):
        for panelName, panel in self.panels.iteritems():
            panel.Hide()
	    self.sizer.Layout()
    
    def showEvent(self, event):
	name = event.GetEventObject().GetName()
	self.showPanel(name)
           
    def hide(self):
        for panelName, panel in self.panels.iteritems():
            panel.Hide()
	    self.sizer.Layout()


