
import wx

DEFAULTSIZE  = (200, 100)
DEFAULTCOLOR = "RED"

class PanelWrapper(wx.Panel):
    def __init__(self, parent, id, color = DEFAULTCOLOR, size=DEFAULTSIZE):
        wx.Panel.__init__(self, parent, id, size=size, style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
	
	self.sizer = wx.BoxSizer(wx.VERTICAL)

	self.SetSizer(self.sizer)

        #self.bgcolor = self.GetParent().GetBackgroundColour()
        self.bgcolor = color
        self.SetBackgroundColour(color)

	self.panels = {}
        self.currentPanelName = None
        
        self.sizer.Layout()
        self.Layout()
        self.GetParent().Layout()

    def addPanel(self, panel, name):
        panel.Hide()
        self.panels[name] = panel
        panel.SetBackgroundColour(self.bgcolor)

    def getPanel(self, name):
        print "getting panels: ", name
        if self.panels.has_key(name):
            return self.panels[name]

    def showPanel(self, name):
        print "ShowingPanel: %s  " % name
        if(self.currentPanelName):
            self.hidePanel(self.currentPanelName)
        if(self.panels.has_key(name)):
            p = self.panels[name]
        self.sizer.Insert(0, p, 0, flag=wx.FIXED_MINSIZE, border = 0)
        self.sizer.Layout()
        p.Show()
        p.Validate()
        self.currentPanelName = name

    def hidePanel(self, name):
        print "Hiding panels for ", name
        p = self.panels[name]
        p.Hide()

        if(not self.sizer.Detach(p)):
            pass
#            print "Could NOT detach %s Behavior Panel from controlWrapper" % name
        self.sizer.Layout()


    def hideAll(self):
        for name, panels in self.panels.iteritems():
            self.hidePanel(name)

