import wx

class SaveDialog(wx.Dialog):
    def __init__(self, parent, ID, title, size=wx.DefaultSize, \
                 pos=wx.DefaultPosition, style=wx.DEFAULT_DIALOG_STYLE, \
                 netname="Default", filename="default.bn"):
        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)
        sizer = wx.BoxSizer(wx.VERTICAL)
        label = wx.StaticText(self, -1, "Please choose a name and filename for the network")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Network Name:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.netname = wx.TextCtrl(self, -1, netname, size=(80, -1))
        box.Add(self.netname, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "File Name:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.filename = wx.TextCtrl(self, -1, filename, size=(80, -1))
        box.Add(self.filename, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        btnsizer = wx.StdDialogButtonSizer()
        btn = wx.Button(self, wx.ID_OK)
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)
