#
# @(#) triggerAuthorPanel.py 2006/3/7
# @author Copyright (c) 2006 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
'''
Defines Gui for trigger authoring in cat
'''
import wx
#import wx.lib.fancytext as fancytext
#import common.WindowManager as WindowManager
from common.defs import *

import triggerPanelBase
CREATEID = 100
DELETEID = 101


class TriggerAuthorPanel(triggerPanelBase.TriggerPanelBase):
    '''Trigger Panel for authoring (creating/deleting) and firing triggers'''
    def __init__(self, parent, size=None, color = "CYAN", entity=None):
        triggerPanelBase.TriggerPanelBase.__init__(self, parent, size=size, color=color, entity=entity)

	self.createButton = wx.Button(self, CREATEID, "Create", style = wx.BU_EXACTFIT)
	spacer1 = wx.StaticText(self, -1, "", size= (102, 2), style = wx.ALIGN_RIGHT)
        self.deleteButton = wx.Button(self, DELETEID, "Delete", style = wx.BU_EXACTFIT)
        self.createButton.SetBackgroundColour(color)
        self.deleteButton.SetBackgroundColour(color)        
        
        sbox = wx.StaticBox(self, -1, "Triggers", size= (size[0]-10, 20))
        self.buttonSizer = wx.StaticBoxSizer(sbox, wx.HORIZONTAL)

        self.buttonSizer.Add(self.createButton)
        self.buttonSizer.Add(spacer1)
        self.buttonSizer.Add(self.deleteButton, flag=wx.ALIGN_RIGHT)

        self.sizer       = wx.BoxSizer(wx.VERTICAL)
        self.sizer.Add(self.buttonSizer)

        self.buttonSizer.Layout()
        self.sizer.Layout()
	
        print "-------->Finished Initializing Trigger Author panel"
