#
# @(#) triggerDeletePanel.py 2006/3/8
# @author Copyright (c) 2006 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
'''
Defines GUI for trigger delete in CAT
'''
import wx
from common.defs import *
import triggerPanelBase

class TriggerDeletePanel(triggerPanelBase.TriggerPanelBase):
    '''Trigger Delete Panel for deleting triggers'''
    def __init__(self, parent, size=None, color = "CYAN", entity=None):
        triggerPanelBase.TriggerPanelBase.__init__(self, parent, size=size, color=color, entity=entity)
	self.entity 	= entity
	self.bgcolor 	= color
        self.SetBackgroundColour(color)

	spacer1 = wx.StaticText(self, -1, "", size= (215, 15), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 15), style = wx.ALIGN_RIGHT)
	
	self.labelWarning = wx.StaticText(self, -1, "DELETING TRIGGER! \n \n [trigger name here] \n \n Are you sure you want to delete?", size = (200, 90), style = wx.ALIGN_CENTER)
	 
	l1 	= wx.StaticText (self, -1,"              ")
	l2 	= wx.StaticText (self, -1,"              ")
	
	self.deleteNoButton = wx.Button(self, -1, "  No  ", style=wx.BU_EXACTFIT)
	wx.EVT_BUTTON(self.deleteNoButton, -1, self.OnNoClick)

	self.deleteYesButton = wx.Button(self, -1, " Yes ", style=wx.BU_EXACTFIT)
	wx.EVT_BUTTON(self.deleteYesButton, -1, self.OnYesClick)
	
	space 	= 2
	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, l2, self.deleteNoButton, self.deleteYesButton])
	   
	sizerDelete = wx.BoxSizer(wx.VERTICAL)
	sizerDelete.Add(spacer1)	
	sizerDelete.Add(self.labelWarning)
	sizerDelete.Add(sizer, flag = wx.ALIGN_CENTER)
	sizerDelete.Add(spacer2)
	self.SetSizer(sizerDelete)

    def getPanel(self):
        return self
    
    def OnNoClick(self, event):
        self.GetParent().show('main')
	
    def OnYesClick(self, event):
	self.entity.deleteTrigger(self.name)
	self.GetParent().show('main')

    def show(self, name="test trigger"):
	self.name = name
	self.labelWarning.SetLabel("DELETING TRIGGER! \n \n" + self.name +"\n \n Are you sure you want to delete?")
        self.Show()


 
