#
# @(#) triggerAuthorPanel.py 2006/3/7
# @author Copyright (c) 2006 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

'''
Defines GUI for creating triggers
'''

import wx
from common.defs import *
from cat import catInfo
from cat.triggers.trigger import Trigger

import triggerPanelBase
CREATEID = 100
CANCELID = 101
BOX1	 = (80, 20)
BOX2	 = (125, 20)
SPACERSIZE = (215, 2)

class TriggerNewPanel(triggerPanelBase.TriggerPanelBase):
    '''Panel for creating Triggers'''

    def __init__(self, parent, size=None, color='CYAN', entity=None):
        triggerPanelBase.TriggerPanelBase.__init__(self, parent, size, color, entity)
        self.trigtypes = [catInfo.ALERT_SENSOR, catInfo.DISTANCE_SENSOR, catInfo.DAMAGE_SENSOR]
        self.subtypes = [catInfo.LESS_THAN, catInfo.GREATER_THAN, catInfo.APPROX]
        
	sizer = wx.BoxSizer(wx.VERTICAL)
        
        title = wx.StaticText(self, -1, "CREATE TRIGGER")
        sizer.Add(title)

	spacer1 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)
        spacer4 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)
	spacer5 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)
        spacer6 = wx.StaticText(self, -1, "", size= SPACERSIZE, style = wx.ALIGN_RIGHT)

	#Name
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        nameLabel = wx.StaticText(self, -1,"  Name: ", size = BOX1)
        self.nameBox = self.t2 = wx.TextCtrl (self, -1, "", size = BOX2, style = wx.TE_RIGHT)
        tmpSizer.Add(nameLabel, flag = wx.ALIGN_LEFT)
        tmpSizer.Add(self.nameBox, flag = wx.ALIGN_RIGHT)
        sizer.Add(tmpSizer)
	sizer.Add(spacer1)
	
        #Type
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        typeLabel = wx.StaticText(self, -1, "  Type:   ", size = BOX1)
        self.typeList = wx.ComboBox(self,-1,value=self.trigtypes[0], choices=self.trigtypes, size= BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY|wx.TE_RIGHT)
        wx.EVT_COMBOBOX(self.typeList,-1,self.onTypeSelect)
        tmpSizer.Add(typeLabel, flag = wx.ALIGN_LEFT)
	tmpSizer.Add(self.typeList, flag = wx.ALIGN_RIGHT)
        sizer.Add(tmpSizer)
	sizer.Add(spacer2)
	
        #Subtype
        self.subtypePanel = wx.Panel(self, -1)
        self.subtypePanel.SetBackgroundColour(color)
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.subtypeLabel = wx.StaticText(self.subtypePanel, -1, "  Subtype:   ", size = BOX1)
        self.subtypeList = wx.ComboBox(self.subtypePanel,-1,value=self.subtypes[0],choices=self.subtypes, size = BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY|wx.TE_RIGHT)
        tmpSizer.Add(self.subtypeLabel)
        tmpSizer.Add(self.subtypeList)
        self.subtypePanel.SetSizer(tmpSizer)
        self.subtypePanel.Hide()
        sizer.Add(self.subtypePanel)
	sizer.Add(spacer3)
        
	#toPath
        self.toPanel = wx.Panel(self, -1)
        self.toPanel.SetBackgroundColour(color)
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.toLabel = wx.StaticText(self.toPanel, -1, "  To:   ", size = BOX1)
        self.toList = wx.ComboBox(self.toPanel,-1,value='None',choices=['None'], size = BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY|wx.TE_RIGHT)
        tmpSizer.Add(self.toLabel)	
	tmpSizer.Add(self.toList)
        self.toPanel.SetSizer(tmpSizer)
        self.toPanel.Hide()
        sizer.Add(self.toPanel)
	sizer.Add(spacer4)
	
        #fromPath
        self.fromPanel = wx.Panel(self, -1)
        self.fromPanel.SetBackgroundColour(color)
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.fromLabel = wx.StaticText(self.fromPanel, -1, "  From:   ", size = BOX1)
        self.fromList = wx.ComboBox(self.fromPanel,-1,value='None',choices=['None'], size = BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY|wx.TE_RIGHT)
        tmpSizer.Add(self.fromLabel)
        tmpSizer.Add(self.fromList)
        self.fromPanel.SetSizer(tmpSizer)
        self.fromPanel.Hide()
        sizer.Add(self.fromPanel)
	sizer.Add(spacer5)
        
	#value  (not shown)
        self.valuePanel = wx.Panel(self, -1)
        self.valuePanel.SetBackgroundColour(color)
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        valueLabel = wx.StaticText(self.valuePanel, -1,"  Value:   ", size = BOX1)
        self.valueBox = self.t2 = wx.TextCtrl (self.valuePanel, -1, "", size= BOX2, style = wx.TE_RIGHT)
        tmpSizer.Add(valueLabel)
        tmpSizer.Add(self.valueBox)
        self.valuePanel.SetSizer(tmpSizer)
        self.valuePanel.Hide()
        sizer.Add(self.valuePanel)

        #buttons
        
	self.cancelButton = wx.Button(self, -1, " Cancel ", style=wx.BU_EXACTFIT)
	wx.EVT_BUTTON(self.cancelButton, -1, self.onCancel)

	self.addButton = wx.Button(self, -1, "  Add  ", style=wx.BU_EXACTFIT)
	wx.EVT_BUTTON(self.addButton, -1, self.onAddTrigger)
	space 	= 2
	sizerB 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizerB.AddMany ([self.cancelButton, self.addButton])
	tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        tmpSizer.Add(sizerB, flag = wx.ALIGN_CENTER)
	sizer.Add(tmpSizer, flag = wx.ALIGN_CENTER)
        
        sizer.Layout()
        self.SetSizer(sizer)

        self.trigid = 0

    def show(self, name):
        self.nameBox.SetValue('trig%i'%self.trigid)
        self.trigid += 1
        self.typeList.SetValue(catInfo.ALERT_SENSOR)
        self.onTypeSelect(None)
        self.Show()

    def onAddTrigger(self, event):
        name = str(self.nameBox.GetValue())
        type = str(self.typeList.GetValue())
        subtype = str(self.subtypeList.GetValue())
        topath = str(self.toList.GetValue())
        if topath == 'None':
            topath = None
        else:
            topath = self.entlist[topath]
        frompath = str(self.fromList.GetValue())
        if frompath == 'None':
            frompath = None
        else:
            frompath = self.entlist[frompath]
        trigger = Trigger(self.entity, name, type, subtype, toPath=topath, fromPath=frompath)
        self.entity.addTrigger(trigger)
        self.GetParent().show('main', '')

    def onCancel(self, event):
        self.GetParent().show('main', '')

    def onTypeSelect(self, event):
        if self.typeList.GetValue() == catInfo.ALERT_SENSOR:
            self.subtypePanel.Hide()
            self.toPanel.Hide()
            self.fromPanel.Hide()
            self.valuePanel.Hide()
            self.createLists()
        elif self.typeList.GetValue() == catInfo.DISTANCE_SENSOR:
            self.entlist = self.getEntList()
            keys = self.entlist.keys()

            self.createLists(keys, keys)

            self.subtypePanel.Show()
            self.toPanel.Show()
            self.fromPanel.Show()
            self.valuePanel.Hide()
        elif self.typeList.GetValue() == catInfo.DAMAGE_SENSOR:
            self.entlist = self.getEntList()
            keys = self.entlist.keys()

            self.createLists(keys)

            self.subtypePanel.Show()
            self.toPanel.Show()
            self.fromPanel.Hide()
            self.valuePanel.Hide()

        self.Layout()

    def createLists(self, tolist=('None', ), fromlist=('None', )):
        self.toList.Destroy()
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.toList = wx.ComboBox(self.toPanel,-1,value=tolist[0],choices=tolist,size = BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY)
        tmpSizer.Add(self.toLabel)
        tmpSizer.Add(self.toList)
        self.toPanel.SetSizer(tmpSizer)
        
        self.fromList.Destroy()
        tmpSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.fromList = wx.ComboBox(self.fromPanel,-1,value=fromlist[0],choices=fromlist,size= BOX2, style=wx.CB_DROPDOWN|wx.CB_READONLY)
        tmpSizer.Add(self.fromLabel)
        tmpSizer.Add(self.fromList)
        self.fromPanel.SetSizer(tmpSizer)

    def getEntList(self):
        entlist = {}

        pushsel()
        sel('/game/ents')
        dir = ndir()
        for subdir in dir:
            sel('/game/ents/'+subdir)
            dir2 = ndir()
            for subdir2 in dir2:
                sel('/game/ents/'+subdir+'/'+subdir2)
                if getselectable():
                    name = getname()
                    fullname = getfullname()
                    entlist[name] = fullname
        popsel()

        return entlist
