import wx
import wx.lib.ogl as ogl

from cat import *
from common import *
import shape

class BehaviorShape(shape.Shape):
    """holds information about one behavior"""
    def __init__(self, x, y, behavior, canvas, onBehaviorLeftClick, onBehaviorRightClick):
        self.behavior = behavior
        self.active = False

        nameDict = {}
        nameDict[behaviorNames.MAINTAIN] = "MA"
        nameDict[behaviorNames.APPROACH] = "AP"
        nameDict[behaviorNames.MOVETO] = "MO"
        nameDict[behaviorNames.RAM] = "RA"
        nameDict[behaviorNames.FIRE] = "FI"
        nameDict[behaviorNames.AVOIDLAND] = "AL"
        nameDict[behaviorNames.AVOIDENTITY] = "AE"
        nameDict[behaviorNames.STOPALL] = "ST"
        nameDict[behaviorNames.NONE] = "NO"
        nameDict[behaviorNames.EMPTY] = "EM"

        w = 35
        h = 25
        thList = []

        if self.getName() in nameDict.keys():
            text = nameDict[self.getName()]
        else:
            text = self.getName()[0:2]

        shape.Shape.__init__(self,x,y,w,h,canvas,text,onBehaviorLeftClick,onBehaviorRightClick)

    def getName(self):
        return self.behavior.bname
