import wx
import wx.lib.ogl as ogl

from cat import *
from common import *

class Shape(ogl.EllipseShape):
    def __init__(self, x, y, w, h, canvas, text, onLeftClick, onRightClick):
        self.canvas = canvas
        self.onLeftClick = onLeftClick
        self.onRightClick = onRightClick
        self.lastx = 0
        self.lasty = 0
        self.topx = 0
        self.bottomx = 0
        self.text = text
        self.box = None

        thList = []

        ogl.EllipseShape.__init__(self,w,h)
        self.AddText(text)

        self.SetX(x)
        self.SetY(y)
        
        self.SetBrush(wx.Brush(wx.Colour(100,100,255),wx.SOLID))
        self.SetPen(wx.Pen(wx.Colour(255,255,255),0,wx.SOLID))

        self.canvas.AddShape(self)

    def makeBox(self):
        self.box = ogl.RectangleShape(self.GetWidth(),self.GetHeight())
        self.box.SetX(self.GetX())
        self.box.SetY(self.GetY())
        self.box.SetBrush(wx.Brush(wx.Colour(0,0,0),wx.TRANSPARENT))
        self.box.SetPen(wx.Pen(wx.Colour(255,255,255),1,wx.SOLID))
        self.box.SetDraggable(False)
        self.canvas.RemoveShape(self)
        self.canvas.AddShape(self.box)
        self.canvas.AddShape(self)

    def removeBox(self):
        self.canvas.RemoveShape(self.box)
        self.box = None

    def updateBox(self):
        if self.box:
            self.box.SetX(self.GetX())
            self.box.SetY(self.GetY())
            self.box.SetWidth(self.GetWidth())
            self.box.SetHeight(self.GetHeight())

    def collides(self, testx, testy):
        w = self.GetWidth()
        h = self.GetHeight()
        x = self.GetX() - w/2
        y = self.GetY() - h/2
        return testx >= x and testx <= x + w and testy >= y and testy <= y + h

    def OnRightClick(self, x, y, keys, attachment):
        self.onRightClick(self)

    def OnLeftClick(self, x, y, keys, attachment):
        self.onLeftClick(self)

