import wx
import wx.lib.ogl as ogl

from cat import *
from common import *

class TriggerMenu(wx.Panel):
    def __init__(self, parent, size, triggerShape, entity, reloadTriggers):
        self.triggerShape = triggerShape
        if self.triggerShape:
            self.trigger = self.triggerShape.trigger
        else:
            self.trigger = None
        self.entity = entity
        self.reloadTriggers = reloadTriggers

        wx.Panel.__init__(self,parent,size=size)

        self.SetBackgroundColour(wx.Colour(100,150,255))
        
        self.vsizer = wx.BoxSizer(wx.VERTICAL)

        print "getting trigger panel"
        self.triggerPanel = self.entity.triggerPanel
        self.oldTriggerPanelParent = self.triggerPanel.GetParent()
        self.triggerPanel.Reparent(self)
        self.oldTriggerPanelColour = self.triggerPanel.GetBackgroundColour()
        self.triggerPanel.SetBackgroundColour(self.GetBackgroundColour())
        #self.oldTriggerPanelSize = self.triggerPanel.GetSize()
        self.oldTriggerPanelPosition = self.triggerPanel.GetPosition()
        self.vsizer.Add(self.triggerPanel,1,wx.EXPAND)

        self.SetPosition((0,0))
        self.SetSize(size)

        #self.triggerPanel.SetPosition((0,0))
        #self.triggerPanel.SetSize(size)
        self.SetSizer(self.vsizer)
        self.SetAutoLayout(1)
        self.vsizer.Fit(self)
        self.Layout()
        self.Show()

    def cleanup(self):
        print "sending trigger panel back"
        self.triggerPanel.SetBackgroundColour(self.oldTriggerPanelColour)
        self.triggerPanel.Reparent(self.oldTriggerPanelParent)
        #self.triggerPanel.SetSize(self.oldTriggerPanelSize)
        self.triggerPanel.SetPosition(self.oldTriggerPanelPosition)
        return None

