#
# @(#) ports.py 2005/11/19
# @author SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#


class Port:
    def __init__(self, name = None, trigid = None):
        self.name    = name
        self.done    = False
        self.running = False
        self.trigid = trigid

    def isDone(self):
        return self.done

    def isRunning(self):
        return self.running

    def setIsDone(self, val):
        self.done = val

    def setIsRunning(self, val):
        self.running = val

class SensorPort:
    def __init__(self, sensor, val, type):
        self.sensor = sensor
        self.val    = val
        self.type   = type

    def getType(self):
        return self.type

    def getSensor(self):
        return self.sensor

    def getValue(self):
        return self.val

        
class PortCondition:
    def __init__(self, port, cond):
        self.port = port
        self.cond = cond

    def setCondition(self, newC):
        self.cond = newC

    def getPort(self):
        return self.port

    def getCondition(self):
        return self.cond
