#
# @(#) environment.py 2005/11/25
# @author SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

BINDING_SEP_CHAR       = ":"

class Environment:
    """Environment for bindings"""

    def __init__(self, envName = None):
        self.envName = str(envName)
        self.bindingMap = {}

    def addBinding(self, name = None, val = None, humanReadable = None):
        """ Puts dictionary entry"""
        if(name and val):
            self.bindingMap[name] = (val, humanReadable)
        else:
            print "Cannot add binding: ", name, val, humanReadable

    def lookup(self, name):
        """Retrieves dictionary entry """
        if(self.bindingMap.has_key(name)):
            val, hr = self.bindingMap[name]
            if(val.find(":") > 0):
                return self.lookup(val)
            else:
                return val
        else:
            return None

    def changeBinding(self, oldVal, newVal):
        
        keyList = self.reverseLookup(oldVal)
        for keyPair in keyList:
            key, hr = keyPair
            #print "-------------------------Bindings change: key: %s old: %s, new: %s " % (key, oldVal, newVal)    
            self.bindingMap[key] = (newVal, hr)

    def reverseLookup(self, oldVal):
        klist = []
        for key, valHrPair in self.bindingMap.iteritems():
            val, humanReadable = valHrPair
            if (val.startswith(oldVal)):
                klist.append((key, humanReadable))
        return klist
                
