import os
from npython import *
from defs import *
import StatsManager
import EntityDefiner

from common.log import Log
from common.defs import struct
log = Log(tags=['all', 'FileManager'])

projects = {}
sortedProjects = []
types = {
    'xml':('.xml',),
    'tex':('.bmp', '.jpg', '.gif'),
    'mesh':('.n3d',),
    'objs':('.obj',),
    'particle':('.psys',),
    'sounds':('.wav',),
}
#/-----------------------------------------------------------------------------//
def loadFiles(project):
    global projects
    global sortedProjects
    projectFiles = {}
    for root,dirs,files in os.walk(project):
        if root.split('/')[-1] == 'CVS': continue                               #Dont parse
        #print 'root', root, 'dirs', dirs, 'files', files
        for file in files:
            path = os.path.join(root, file)
            name,ext = os.path.splitext(file)
            #search for the category to put it under
            type = 'nocat'
            for t in types:
                for e in types[t]:
                    if ext == e:
                        type = t
                        break
            #print 'categorizing %s into files[%s][%s]' % (file,type,name)

            if not projectFiles.has_key(type):
                projectFiles[type] = {}
                projectFiles[type,'sorted'] = []
            projectFiles[type][name] = path
            projectFiles[type,'sorted'].append(name)
    #print 'projects[%s] = %s' % ( project, projectFiles )
    projects[project] = projectFiles
    sortedProjects.append( project )
#/-----------------------------------------------------------------------------//
def load(project):
    log.write('FileManager.loadProject(%s)' % project)
    import profile
    #profile.run('from common.FileManager import loadFiles')
    #profile.run('loadFiles(%s)' % project)
    loadFiles(project)
    #command = 'import %s' % project
#/-----------------------------------------------------------------------------//
def find(type, name):
    log.write('FileManager.find(%s,%s)'%(type,name))
    path = None
    for proj in sortedProjects:
        #print 'proj', proj
        try:
            path = projects[proj][type][name]
        except:
            pass
    if path:
        #print 'found %s.%s at %s' % (type,name,path)
        pass
    else:
        #print 'failed to find %s.%s' % (type,name)
        pass
    return path
#/-----------------------------------------------------------------------------//
def runDefaultXMLParsers():
    log.open('FileManager.runDefaultXMLParsers')
    for pf in sortedProjects:
        projectFiles = projects[pf]
        if projectFiles.has_key('xml'):
            for name in projectFiles['xml','sorted']:
                log.write('xml file', name)
                file = projectFiles['xml'][name]
                try:
                    EntityDefiner.parse(file)
                except:
                    printExcept('EntityDefiner.parse(%s)' % file)
                StatsManager.parse(file)
        if projectFiles.has_key('sounds'):
            for name in projectFiles['sounds']:
                file = projectFiles['sounds'][name]
                #print('sound file', name, file)
                call('/sys/servers/audio.loadwav', name, file)
                import soundexplorer
                soundexplorer.add(name)
        if projectFiles.has_key('particle'):
            for name, file in projectFiles['particle'].iteritems():
                #print('particle file', name, file)
                pass
                #pushsel('/lib/particles')
                #get(file)
                #popsel()
    log.close()
#/-----------------------------------------------------------------------------//
