import os
from npython import *
from defs import *
from common import FileManager
#/-----------------------------------------------------------------------------//
class MissionInfo:
    def __init__(self):
        self.name             = None
        self.brief             = None
        self.description     = None
    def __str__(self):
        return "Mission (%s)[%s]{%s}" % (self.name, self.brief, self.description)
missionInfo = MissionInfo()
#/-----------------------------------------------------------------------------//
def load(missionname):
    """load a mission from an xml file"""
    global missionInfo
    filepath = FileManager.find('xml', missionname)
    print 'MissionManager.load(%s,%s)' % (missionname, filepath)
    if not filepath:
        print 'could not find xml file to open -- returning'
        return
    document = parseXML( filepath )

    #print 'loading mission at', filepath
    counter = 0
    #foreach map node 
    pushsel()
    new('nent', '/comm/groups')
    for root in document.getElementsByTagName('MISSION'): 
        assert counter == 0 #make sure only one map node in the xml file
        counter += 1
        missionInfo.name = getText( root )
        for e in root.getElementsByTagName('BRIEF'):            missionInfo.brief = getText( e )
        for e in root.getElementsByTagName('DESCRIPTION'):        missionInfo.description = getText( e )
        for ents in root.getElementsByTagName('ENTITIES'):
            for e in ents.getElementsByTagName('ENT'):
                loadEntity(e)
    popsel()
#/-----------------------------------------------------------------------------//
def loadEntity(e):
    print 'loadEntity'
    label = str(getText(e))
    type = str(e.getAttribute('type'))
    side = str(e.getAttribute('side'))
    group = str(e.getAttribute('group'))
    print 'label', label, 'type', type, 'side', side, 'group', group

    from sp.entmanager import entManager
    path = entManager.createEnt(entType=type, groupName = group, side=side, place=False)
    sel(path)

    for var in e.getElementsByTagName('var'):
        name                            = var.getAttribute('name')
        varType                         = var.getAttribute('type')
        value                           = var.getAttribute('value')
        name, varType                   = str(name), str(varType)
        print '  var', name, type, value
        if   varType == 'int':           ci(  name, int    (value))
        elif varType == 'float':         cf(  name, float  (value))
        elif varType == 'vector3' and value:       cv(  name, vector3(value))
        elif varType == 'vector3':       cv(  name, float(var.getAttribute('x')), float(var.getAttribute('y')) , float(var.getAttribute('z')))
        elif varType == 'string':        cs(  name, str    (value))
        elif varType == 'ref':           cref(name, str    (value))
        elif varType == 'rotation':      crot(name, vector3(value))
#/-----------------------------------------------------------------------------//
