from npython import *
from common.defs import *
"""
    load the statistics xml file into the /stats dir in eva
"""
import sys
import inspect
from xml.dom import minidom
from xml.dom.minidom import getDOMImplementation
from common.log import Log
log = Log(tags=['all', 'statsmanager'])
#/-----------------------------------------------------------------------------//
stats = {}
statsChanged = False
def parse(filename):
    """parses an xml file - loading stats"""
    global stats
    global statsChanged
    #from common.defs import *
    from common.defs import struct
    pushsel()
    log.write('StatsManager.parse(%s)' % filename)
    file                                = open( filename )
    document                            = minidom.parse( file )
    file.close()
    global stats
    for sd in document.getElementsByTagName('statdefinitions'): #foreach entitydefinition node
        sn('nthing', '/stats')
        for ent in sd.getElementsByTagName('enttype'):              #foreach enttype
            entname = getText(ent)
            if not stats.has_key(entname):
                stats[entname] = {}
            for levelgroup in sd.getElementsByTagName('levelname'):
                lgname = getText(levelgroup)
                if not stats[entname].has_key(lgname):
                    stats[entname][lgname] = {}
                for level in levelgroup.getElementsByTagName('level'):
                    lvl = getText(level)
                    if not stats[entname][lgname].has_key(lvl):
                        stats[entname][lgname][lvl] = {}
                    for var in level.getElementsByTagName('var'):
                        name            = str(var.getAttribute('name'))
                        assert name != None
                        value           = float(var.getAttribute('value'))
                        assert value != None
                        try:            priority        = int(var.getAttribute('priority'))
                        except:         priority = 0
                        stats[entname][lgname][lvl][name] = struct(name=name, value=value, priority=priority)
                        statsChanged = True
    exportToEva()

def exportToEva():
    from defs import ndel
    from defs import sn
    from defs import cv
    global stats
    global statsChanged
    if not statsChanged: 
        return

    log.write('StatsManager.exportToEva', stats)
    ndel('/stats')
    for enttype in stats:
        for levelgroup in stats[enttype]:
            for level in stats[enttype][levelgroup]:
                path = '/stats/%s/%s/%s' % (enttype, levelgroup, level)
                sn('nent', path)
                for varname in stats[enttype][levelgroup][level]:
                    var = stats[enttype][levelgroup][level][varname]
                    cv(var.name, var.priority, var.value, 0)
    statsChanged = False
