#/-----------------------------------------------------------------------------//
from npython import *
from common.defs import *
from common.colours import COLOUR
#/-----------------------------------------------------------------------------//
class Displayer:
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        self.context = call('/sys/servers/displayer.getContext')
    #/-----------------------------------------------------------------------------//
    def __str__(self):
        return 'Displayer[%i]' % self.context
    #/-----------------------------------------------------------------------------//
    def clear(self):
        call('/sys/servers/displayer.clearContext', self.context )
    #/-----------------------------------------------------------------------------//
    def addLine(self, a, b, colour = COLOUR.WHITE):
        self.drawLine(a,b,colour)
    #/-----------------------------------------------------------------------------//
    def drawLine(self, a, b, colour = COLOUR.WHITE):
        call('/sys/servers/displayer.drawLine', self.context, a[0], a[1], a[2], b[0], b[1], b[2], colour)
    #/-----------------------------------------------------------------------------//
    def drawAngle(self, pos, heading, length = 50.0, colour = COLOUR.WHITE):
        #print 'call(/sys/servers/displayer.drawAngle %i %f %f %f %f %f %i' % ( self.context, pos[0], pos[1], pos[2], heading, length, colour )
        call('/sys/servers/displayer.drawAngle', self.context, pos[0], pos[1], pos[2], heading, length, colour )
    #/-----------------------------------------------------------------------------//
    def drawPoint(self, pos, size = 5.0, colour = COLOUR.WHITE):
        if type(size) == float:
            size = (size, size, size)
        call('/sys/servers/displayer.drawPoint', self.context, pos[0], pos[1], pos[2], size[0], size[1], size[2], colour )
    #/-----------------------------------------------------------------------------//
    def drawCircle(self, pos, radius,  colour = COLOUR.WHITE):
        call('/sys/servers/displayer.drawCircle', self.context, pos[0], pos[1], pos[2], radius, colour )
    #/-----------------------------------------------------------------------------//
    def drawSphere(self, pos, radius,  colour = COLOUR.WHITE):
        call('/sys/servers/displayer.drawSphere', self.context, pos[0], pos[1], pos[2], radius, colour )
    #/-----------------------------------------------------------------------------//
    def tick(self, time, dtime):
        """was using to test this system"""
        import random
        from common.colours import COLOUR
        #a = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        #b = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        #colour = random.choice( COLOUR.__dict__.values() )
        #self.displayer.drawLine( a, b, colour )

        pos = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        for i in range(10):
            angle = random.uniform( -3.1415, 3.1415 )
            length = random.uniform(0, 100.0)
            colour = random.choice( COLOUR.__dict__.values() )
            self.displayer.drawAngle( pos, angle, length, colour )

        pos = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        size = (random.random() * 10.0, random.random() * 10.0, random.random() * 10.0)
        colour = random.choice( COLOUR.__dict__.values() )
        self.displayer.drawPoint( pos, size, colour )

        pos = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        radius = random.uniform( 0, 50.0 )
        colour = random.choice( COLOUR.__dict__.values() )
        self.displayer.drawCircle( pos, radius, colour )

        pos = (random.random() * 5000.0, random.random() * 5000.0, random.random() * 5000.0)
        radius = random.uniform( 0, 50.0 )
        colour = random.choice( COLOUR.__dict__.values() )
        self.displayer.drawSphere( pos, radius, colour )
#/-----------------------------------------------------------------------------//
