import wx
from npython import *
from common.defs import *
class EntityTypeList(wx.ListBox):
    """listbox containing all selectable entity types"""
    def __init__(self, parent, id, size=wx.DefaultSize):
        """figure out which entities are available by looking in lib/ents/"""
        #figure out what the entity types are
        pushsel('/lib/ents')
        self.entityTypes = []
        for type in ndir():
            if getselectable(type):                                              #if its not selectable (weapons/turrets) dont put it on the list
                self.entityTypes.append(type)
        popsel()
        wx.ListBox.__init__(self, parent, id, size=size, choices=self.entityTypes)
    def GetSelection(self):
        return self.entityTypes[wx.ListBox.GetSelection(self)]
