import wx
import xml.dom.minidom
from common.defs import *
from npython import *

#/-----------------------------------------------------------------------------//
class GameState:
    """this class should have functions for saving/loading the game to an xml file
    it should be verry similar ofcourse to everything else, so life sohld be good
    we should split off some of the common functionality at some point, but until then =)
    """
    def __init__(self):
        print 'GameState.init'
        import nEventServer
        from common import EventNames
        nEventServer.register( EventNames.STORE_WORLD, self.storeWorld )
        nEventServer.register( EventNames.RESET_WORLD, self.resetWorld )
        self.gameStateDoc               = None
        self.gameStateRoot              = None
        new('nbasicent', '/game/state')
    #/-----------------------------------------------------------------------------//
    def save(self, fileName):
        """
        Look at the game state, and dump all the units and their stats
        out to xml somewhere.
        """
        print 'GameState.save', event

    #/-----------------------------------------------------------------------------//
    def load(self, fileName):
        """
        Load the world from an xml file.
        """
        print 'GameState.load', event

    #/-----------------------------------------------------------------------------//
    def loadXMLFile(self, missionname):
        """load a mission from an xml file"""
        global missionInfo
        filepath = FileManager.find('xml', missionname)
        print 'MissionManager.load(%s,%s)' % (missionname, filepath)
        if not filepath:
            print 'could not find xml file to open -- returning'
            return
        document = parseXML( filepath )

        #print 'loading mission at', filepath
        counter = 0
        #foreach map node 
        pushsel()
        new('nent', '/comm/groups')
        for root in document.getElementsByTagName('MISSION'): 
            assert counter == 0 #make sure only one map node in the xml file
            counter += 1
            missionInfo.name = getText( root )
            for e in root.getElementsByTagName('BRIEF'):            missionInfo.brief = getText( e )
            for e in root.getElementsByTagName('DESCRIPTION'):        missionInfo.description = getText( e )
            for ents in root.getElementsByTagName('ENTITIES'):
                for e in ents.getElementsByTagName('ENT'):
                    loadEntity(e)
        popsel()
    #/-----------------------------------------------------------------------------//
    def loadEntity(self, e):
        #print 'loadEntity'
        label = str(getText(e))
        type = str(e.getAttribute('type'))
        side = str(e.getAttribute('side'))
        group = str(e.getAttribute('group'))
        #print 'label', label, 'type', type, 'side', side, 'group', group

        from sp.entmanager import entManager
        path = entManager.createEnt(entType=type, groupName = group, side=side, place=False)
        sel(path)

        for var in e.getElementsByTagName('var'):
            name                            = var.getAttribute('name')
            varType                         = var.getAttribute('type')
            value                           = var.getAttribute('value')
            name, varType                   = str(name), str(varType)
            #print '  var', name, type, value
            if   varType == 'int':           ci(  name, int    (value))
            elif varType == 'float':         cf(  name, float  (value))
            elif varType == 'vector3':       cv(  name, vector3(value))
            elif varType == 'string':        cs(  name, str    (value))
            elif varType == 'ref':           cref(name, str    (value))
            elif varType == 'rotation':      crot(name, vector3(value))
#/-----------------------------------------------------------------------------//
    def storeWorld(self, msg):
        try:
            #okay so what i need to do is convert the entire world into an xml document
            print 'GameState.storeWorld', msg
            self.gameStateDoc      = xml.dom.minidom.Document()
            self.gameStateRoot     = self.gameStateDoc.createElement('GameState %s' % msg)
            self.gameStateDoc.appendChild(self.gameStateRoot)

            for entType in ndirin('/game/ents'):
                print 'entType', entType
                for ent in ndirin('/game/ents/%s' % entType):
                    print 'ent', ent
                    entPath = '/game/ents/%s/%s' % (entType, ent)
                    #basic ent stuff
                    node = self.gameStateDoc.createElement('ent')
                    node.setAttribute('type', entType)
                    node.setAttribute('name', ent)
                    node.setAttribute('path', entPath)
                    self.gameStateRoot.appendChild(node)
                    #vars
                    for var in ndirin('/game/ents/%s/%s/vars' % (entType,ent)):
                        varPath = '/game/ents/%s/%s/vars/%s' % (entType, ent, var)
                        if call('%s.isa' % varPath, 'nvar'):
                            varnode = self.gameStateDoc.createElement('var')
                            varnode.setAttribute('name', var)
                            varType = call('%s.gettype' % varPath)
                            varnode.setAttribute('type', varType)
                            node.appendChild(varnode)
                            value = None
                            if   varType == 'int':                                    value = call('%s.gi' % entPath, var)
                            elif varType == 'float':                                  value = call('%s.gf' % entPath, var)
                            elif varType == 'string':                                 value = call('%s.gs' % entPath, var)
                            elif varType == 'vector3':                                value = call('%s.gv' % entPath, var)#; value = '(%f,%f,%f)' % (value[0], value[1], value[2])
                            elif varType == 'quaternion':                             value = call('%s.gq' % entPath, var)#; value = '(%f,%f,%f,%f)' % (value[0], value[1], value[2], value[3])
                            elif varType == 'ref':                                    value = call('%s.gref' % entPath, var)
                            varnode.setAttribute('value', str(value))

            print 'worldState', self.gameStateDoc.toprettyxml('    ')
            call('/game/state.cs', 'xml', self.gameStateDoc.toprettyxml('    '))
        except:
            printExcept('GameState.storeWorld')
#/-----------------------------------------------------------------------------//
    def resetWorld(self, randomizeRelativeTo = None):
        randomizeRelativeTo = None
        try:
            if self.gameStateRoot == None:
                print 'error - trying to reset world before storing it'
                return
            print 'GameState.resetWorld', randomizeRelativeTo
            for entNode in self.gameStateRoot.getElementsByTagName('ent'):
                entType = entNode.getAttribute('type')
                name = entNode.getAttribute('name')
                path = entNode.getAttribute('path')
                if not exists(path):
                    print 'error - ent(%s) has been removed and gamestate.resetworld is not yet smart enough to deal with this' % path
                    return
                for varNode in entNode.getElementsByTagName('var'):
                    var                 = str(varNode.getAttribute('name'))
                    varType             = str(varNode.getAttribute('type'))
                    value               = str(varNode.getAttribute('value'))
                    if   varType == 'int':                                    value = int(value)
                    elif varType == 'float':                                  value = float(value)
                    elif varType == 'string':                                 value = str(value)
                    elif varType == 'vector3':                                value = vector3(value)
                    elif varType == 'quaternion':                             value = quaternion(value)
                    elif varType == 'ref':                                    value = str(value)
                    if randomizeRelativeTo:
                        if var == 'pos':
                            pos = value
                            #print 'pos was', pos
                            centerPoint = call('%s.gv' % randomizeRelativeTo, 'pos')
                            #print 'centerPoint', centerPoint
                            import math
                            dist = math.sqrt((pos[0] - centerPoint[0])**2 + (pos[2] - centerPoint[2])**2)
                            #print 'dist', dist
                            import random
                            theta = random.uniform(0, 2 * math.pi)
                            newpos = dist * math.cos(theta) + centerPoint[0], 0, dist * math.sin(theta) + centerPoint[2]
                            #print 'newpos', newpos
                            pos = newpos
                            value = pos

                    if   varType == 'int':                                    call('%s.ci' % path, var, value)
                    elif varType == 'float':                                  call('%s.cf' % path, var, value)
                    elif varType == 'string':                                 call('%s.cs' % path, var, value)
                    elif varType == 'vector3':                                call('%s.cv' % path, var, value[0], value[1], value[2])
                    elif varType == 'quaternion':                             call('%s.cq' % path, var, value[0], value[1], value[2], value[3])
                    elif varType == 'ref':                                    call('%s.cref' % path, var, value)
        except:
            printExcept('GameState.resetWorld')
#/-----------------------------------------------------------------------------//
gameState = GameState()
