#/-----------------------------------------------------------------------------//
#firstly before we get stuck somewhere -> tell the socket it only has 5 seconds to connect / find my ip / etc...
#/-----------------------------------------------------------------------------//
sel('/')
import socket
socket.setdefaulttimeout(30)
#/-----------------------------------------------------------------------------/
#setup basic directory stuff
#/-----------------------------------------------------------------------------//
import os
nebuladir = os.getenv('NEBULADIR')
os.chdir(os.getenv('NEBULADIR') + '/data')
sys.path.append(nebuladir + '/code/scripts/')
from common.defs import *
#/-----------------------------------------------------------------------------//
from common import app                  #setup the wxApp
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
from common import OptionManager                                                #command line options manager - loads a preferences file (not in cvs) or uses defaults in the options file
from common import options
OptionManager.load()
#/-----------------------------------------------------------------------------//
#setup the log system
import common.log
logManager = common.log.LogManager(None,-1)
#logManager.tagsToPrint = ['sp']

#/-----------------------------------------------------------------------------//
#load various aspects of the engine
from common import tree
from common import servers
from common import keymappings
from common import camera
from common import interface
from common import sides
from common import shaders
from common import radar
#/-----------------------------------------------------------------------------//
from common import EventNames
from common import quickcommands
#/-----------------------------------------------------------------------------//
def loadTclStartupScripts():
    """loads the older tcl startup scripts"""
    set('/sys/servers/game.runtclscript', 'scripts/goReduced.tcl')
loadTclStartupScripts()

#setup selection manager for dealing with mouse clicks in the game world
from common import SelectionManager
#/-----------------------------------------------------------------------------//
#load project files
#/-----------------------------------------------------------------------------//
try:
    from common import FileManager
    FileManager.load('common')
    FileManager.load('sp')
    #FileManager.load('delta3d')
    FileManager.load('naval')
    if OptionManager.getOption('cove'):
        FileManager.load('cove')
    else:
        FileManager.load('lagoon')
    FileManager.load('coveheightmaps')
    #FileManager.load('coveobjs')
    if OptionManager.getOption('cove2.0'):
        FileManager.load('cove2.0')
    #if OptionManager.getOption('extra'):
        #FileManager.load('extra')
    FileManager.runDefaultXMLParsers()
except:
    printExcept('fileManager')
#/-----------------------------------------------------------------------------//
#setup some addition /lib stuff
#/-----------------------------------------------------------------------------//
try:
    import common.overlays
except:
    printExcept('overlays')

#/-----------------------------------------------------------------------------//
#setup targetline /lib stuff
#/-----------------------------------------------------------------------------//
try:
    import common.targetline
except:
    printExcept('targetline')

#/-----------------------------------------------------------------------------//
#load misc stuff
#/-----------------------------------------------------------------------------//
from common import compass              #nice on screen compass
if OptionManager.getOption('prof'):     #display the profiling information
    call('/sys/servers/prof.display')
#/-----------------------------------------------------------------------------//
#load optional gui elements
#/-----------------------------------------------------------------------------//
if OptionManager.getOption('log'):
    logManager.Show()
#/-----------------------------------------------------------------------------//
if OptionManager.getOption('projectexplorer'):
    try:                                
        import common.projectexplorer
        common.projectexplorer.open()
    except:                             
        printExcept('projectexplorer')
#/-----------------------------------------------------------------------------//
if OptionManager.getOption('evaexplorer'):
    try:                                
        import evaexplorer
        evaexplorer.open()
    except:                             
        printExcept('evaexplorer')
#/-----------------------------------------------------------------------------//
if OptionManager.getOption('soundexplorer'):
    try:                                
        import common.soundexplorer
        common.soundexplorer.open()
    except:                             
        printExcept('soundexplorer')
#/-----------------------------------------------------------------------------//
if OptionManager.getOption('optionexplorer'):
    try:                                
        import common.optionexplorer
        common.optionexplorer.open()
    except:                             
        printExcept('optionexplorer')
#/-----------------------------------------------------------------------------//
#initialize projects
#/-----------------------------------------------------------------------------//
try:
    import go
except:
    printExcept('loadingGo')
try:
    from common import GUIManager
    frame = GUIManager.MainFrame(None, -1)    
except:
    printExcept('loadingGui')
#/-----------------------------------------------------------------------------//
#setup networking
#/-----------------------------------------------------------------------------//
try:
    net = OptionManager.getOption('net')
    if   net == 'standalone':               import net.standalone
    elif net == 'server':                   import net.server
    elif net == 'client':                   import net.client
except:
    printExcept('networking')
#/-----------------------------------------------------------------------------//
#setup the rmenus
#/-----------------------------------------------------------------------------//
try:
    import common.rmenu
except:
    printExcept('setuping rmenus')
try:
    import common.widgets
except:
    printExcept('common.widgets FAILED')

#/-----------------------------------------------------------------------------//
#setup backround sound
#/-----------------------------------------------------------------------------//
if(OptionManager.getOption('bgSound')):
    try:
        import common.widgets.bgMusic
    except:
        printExcept('common.widgets.bgMusic problem')

#/-----------------------------------------------------------------------------//
#new adhoc crap
#/-----------------------------------------------------------------------------//
#try:
    #new('nent', '/game/astar')
    #new('nboatastar', '/game/astar/boat')
#except:
    #printExcept('initializing adhoc crap')
#/-----------------------------------------------------------------------------//
#start recording freshly
from sp.recorder import recorder
recorder.newDoc()
import ga.gaexplorer
#/-----------------------------------------------------------------------------//
sel('/game/ents')
