'''this file lists the values for the various optiosn handled by the option manager'''

import socket
#myip = socket.gethostbyname(socket.gethostname())
myip = "127.0.0.1"
from common import OptionManager                                                
#boolean options
OptionManager.createCategory('Boolean Options')
OptionManager.createOption('nomem',     possibilities = [0,1],                  default=1, descr='Remember options between runs')
OptionManager.createOption('gfx',       possibilities = [0,1],                  default=1, descr='Display the 3d window')
OptionManager.createOption('sp',        possibilities = [0,1],                  default=1, descr='Load sp and its widgets')
OptionManager.createOption('executive', possibilities = [0,1],                  default=1, descr='Initialize executive')
OptionManager.createOption('cat',       possibilities = [0,1],                  default=1, descr='Load cat and its widgets')
OptionManager.createOption('firing',    possibilities = [0,1],                  default=0, descr='Enables/Disables weapon firing')
OptionManager.createOption('damage',    possibilities = [0,1],                  default=0, descr='Enables/Disables weapons doing damage')
OptionManager.createOption('prof',      possibilities = [0,1],                  default=0, descr='Display profiling data')
OptionManager.createOption('stickyselect',  possibilities = [0,1],              default=0, descr='Disable enable sticky select - where clicking in the open does not unselect entities')

#special guis
OptionManager.createCategory('Tools')
OptionManager.createOption('projectexplorer', possibilities = [0,1],            default=0, descr='Load a Gui which allows you to see which project files have been loaded - Old')
OptionManager.createOption('logexplorer',     possibilities = [0,1],            default=1, descr='Load a Gui which shows all the data saved to logs')
OptionManager.createOption('evaexplorer',     possibilities = [0,1],            default=0, descr='Load a Gui which allows you to go through the eva tree')
OptionManager.createOption('soundexplorer',   possibilities = [0,1],            default=0, descr='Load a Gui which lists all the sounds, and allows you to play them')
OptionManager.createOption('optionexplorer',  possibilities = [0,1],            default=0, descr='Load a Gui allowing the user to see / edit all runtime options')

#game initialization options
OptionManager.createCategory('Cove')
OptionManager.createOption('cove',      possibilities = [0,1],                  default=1, descr='Load cove data, or lagoon data')
OptionManager.createOption('coveserver',  possibilities = [],                     default='192.168.1.4', descr='IP to the cove server')
OptionManager.createOption('coveport',  possibilities = [],                     default='4000', descr='Port on the cove-server to connect to')
OptionManager.createOption('harborclient',    possibilities = [0,1],            default=0,                              descr='Enable / disable transfering of harbors from cove')
#OptionManager.createOption('idle',      possibilities = [0,1],                 default=1, descr='Tick the python idle function, otherwise it only responds to events')

#any string options
OptionManager.createCategory('Game Options')
OptionManager.createOption('name',      possibilities = [],                     default='localplayer',                  descr='Name of the current player - Identified as in multiplayer')
OptionManager.createOption('side',      possibilities = ['blue', 'red', 'green', 'yellow', 'bm', 'observer', ''], default='bm', descr='Which side Should I run as, empty string enables the dialog')
OptionManager.createOption('map',       possibilities = [],                     default='openwater',                    descr='Which map should the thing used')
OptionManager.createOption('mission',   possibilities = [],                     default='empty',                        descr='Which mission should be loaded')
OptionManager.createOption('loadplan',  possibilities = [],                     default=None,                           descr='Which saved plan should be loaded')
OptionManager.createOption('loadplaninst',  possibilities = [0,1],              default=1,                              descr='Should the autoloaded plan execute all its command immediately')
OptionManager.createOption('skybox',    possibilities = [],                     default=None,                           descr='Overload which skybox to load')
OptionManager.createOption('windowsettings',  possibilities = [],               default='windowsettings',               descr='which windowsettings xml file to use - for different resolutions')
OptionManager.createOption('maxastarsteps', possibilities = [],                 default='100000',                       descr='How many steps can an AStar search take before failing')

#networking options
OptionManager.createCategory('Networking Options')
OptionManager.createOption('net',       possibilities = ['server', 'client'],   default='server' ,                      descr='Is this machine running a server / standalone, or as a client')
OptionManager.createOption('ip',        possibilities = [],                     default=myip,                           descr='What is this machines IP? can detect if properly setup, otherwies overload here')
OptionManager.createOption('server',    possibilities = [],                     default='134.197.40.138',               descr='If you are running as the client, who is the server')
OptionManager.createOption('port',      possibilities = [],                     default='28000',                        descr='Port to connect to server over, note: server must have matching port')

#chris's options
OptionManager.createCategory('Chris\'s Research Options')
OptionManager.createOption('imga',      possibilities = [0,1],                  default=0,                              descr='Allows the evolution of influence maps')
#OptionManager.createOption('bypassSP',  possibilities = [0,1],                  default=0, descr='BypassSp used to allow the allocator to command units without going through sp/cat, unsure if it is still being used')
