from common.defs import *
#/-----------------------------------------------------------------------------//
defaultOverlayActivationDistance = 100
defaultOverlayFullBrightDistance = 400
#/-----------------------------------------------------------------------------//
def genOverlay(name, expandName=True, subdir=False, colored=None, scale=1.0, overlayActivationDistance=None, overlayFullBrightDistance=None, mesh='plane'):
    """create a new overlay
    an overlay is a mesh/tex/shader hidden below a flipflop that deactivates it at a current distance
    """
    try:
        if overlayActivationDistance == None:
            overlayActivationDistance = defaultOverlayActivationDistance
        if overlayFullBrightDistance == None:
            overlayFullBrightDistance = defaultOverlayFullBrightDistance
        if expandName:
            name = 'overlay%s' % name
        if subdir:
            sn('n3dnode', '/lib/node/overlay/%s' % name)
        else:
            sn('n3dnode', '/lib/node/%s' % name)
        if True:
            #add a nipol which scales based upon the size of the entity
            if sn('nipol', 'sxyz'):
                call('.connect', 'sxyz')
                call('.setchannel', 'overlaySize')
                call('.addkey3f', 0, 0, 0, 0)
                x = 10000000
                call('.addkey3f', x, x * scale, x * scale, x * scale)
            sel('..')

            if sn('nflipflop','flipflop'):
                #empty inactive node which is displayed when the camera is too close
                if sn('n3dnode', 'inactive'):
                    pass
                sel('..')
                if sn('n3dnode', 'active'):
                    genMesh(mesh)
                    #if its not a colored overlay just give it the plain old boring texture
                    if not colored:
                        genTex(name)
                    elif colored == 'side':
                        if sn('nflipflop', 'colorflipflop'):
                            call('.setchannel', 'sideHandle')
                            for i, color in enumerate(['neutral', 'blue', 'yellow', 'green', 'red']):
                                new('ntexarraynode', color)
                                from common import FileManager
                                filepath                                            = FileManager.find( 'tex', 'pure' + color )
                                filepathalpha                                       = FileManager.find( 'tex', name + 'Alpha')
                                #print                                               '%s.settexture %i %s %s' % (color, 0, filepath, filepathalpha)
                                call                                                ('%s.settexture' % color, 0, filepath, filepathalpha)
                                #genTex(color)
                                #call('tex.setname', color)
                                call                                                ('.addkey', i, color)
                            call('.addkey', i+1, color)
                        sel('..')
                    genShader('overlay')
                    if sn('nipol', 'shader/setconst0'):
                        call('.connect', 'setconst0')
                        call('.setchannel', 'cameraDist')
                        call('.addkey4f', 0,                                    1,1,1, 0.0)
                        call('.addkey4f', overlayActivationDistance,            1,1,1, 0.0)
                        call('.addkey4f', overlayFullBrightDistance,            1,1,1, 1.0)
                        call('.addkey4f', 1000000,                              1,1,1, 1.0)
                    sel('../..')
                    if sn('nipol', 'sxyz'):
                        call('.connect', 'sxyz')
                        call('.setchannel', 'cameraDist')
                        call('.addkey3f', 0, 1,1,1)
                        call('.addkey3f', 10000, 10,10,10)
                        call('.addkey3f', 10000000, 10,10,10)
                    sel('..')
                sel('..')
                call('.setchannel', 'cameraDist')
                call('.addkey', 0, 'inactive')
                call('.addkey', overlayActivationDistance, 'active')
                call('.addkey', 100000000, 'active')
            sel('..')
        sel('..')
    except:
        printExcept('Generating Overlay %s' % name)
#/-----------------------------------------------------------------------------//
genOverlay('mouseOver',        False, True, scale=1.3, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
genOverlay('mouseOverGroup',   False, True, scale=1.3, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
genOverlay('selected',         False, True, scale=1.2, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
genOverlay('selectedGroup',    False, True, scale=1.2, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
genOverlay('catSelected',      False, True, scale=1.2, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
genOverlay('targetted',        False, True, scale=1.2, overlayActivationDistance = 0, overlayFullBrightDistance = 200)
#genOverlay('constructionBar',  False, True, scale=1.3, mesh='splitring' )
#/-----------------------------------------------------------------------------//
genOverlay('Hexagon',          colored='side')
genOverlay('Pentagon',         colored='side')
genOverlay('Square',           colored='side', scale=5.0)
genOverlay('Triangle',         colored='side', scale=5.0)
genOverlay('Circle',           colored='side')
#/-----------------------------------------------------------------------------//
# Move to glowing point
if sn('n3dnode', '/lib/node/overlay/destination'):
    genMesh('moveto')
    genTex('movetopoint')
    genShader('overlay')
    call('.sxyz', 50, 50, 50)
    # Time Interpolator
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'time')
        call('.addkey3f',  0, 1,  1,  1)
        call('.addkey3f',  2, 2,  2,  2) 
        call('.addkey3f',  4, 1,  1,  1)
#call('.addkey3f',  5, 2,  2,  2) 
#call('.addkey3f', 10, 1,  1,  1)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlayWeaponRadius'):
    genMesh('plane')
    genTex('circle')
    genShader('overlay')
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'imWeaponRadius')
        call('.addkey3f', 0, 1,1,1)
        call('.addkey3f', 100000, 100000,100000,100000)
        sel('..')
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlay/constructionBar'):
    genMesh('splitring')
    genTex('white')
    genShader('overlay')
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'overlaySize')
        call('.addkey3f', 0, 0, 0, 0)
        x = 10000000
        call('.addkey3f', x, x, x, x )
    sel('..')

    sel('shader')
    if True:
        call('.setcullmode', 'ccw')
        call('.setcolorop', 0, 'mul tex const')
        call('.setalphaop', 0, 'mul tex const')
        #call('.setconst0', 0, 0, 1, 1 )
        if sn('nipol', 'setconst0'):
            call('.connect', 'setconst0')
            call('.setchannel', 'constrRatio')
            call('.addkey4f',    0,   1,   0,   0,   0)
            call('.addkey4f',  .05,   1,   0,   0,   1)
            call('.addkey4f',  .50,   1, .75, .25,   1)
            call('.addkey4f',    1,   0,  .9,   0,   1) 
        sel('..')
        call('.begintunit', 0)
        call('.setalphaenable', True)
        call('.setaddress', 'wrap', 'wrap')
        call('.setenabletransform', True)
        call('.endtunit')
        if sn('nipol', 'txyz0'):
            call('.connect', 'txyz0')
            call('.setchannel', 'constrRatio')
            call('.addkey3f',  0,     -1,  0,  0 )
            call('.addkey3f',  1, 2/32.0,  0,  0 ) #need to go 1/32 too far to get past the black line / and avoid bleeding
            call('.addkey3f',  2, 2/32.0,  0,  0 )
        sel('..')
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlay/captureBar'):
    genMesh('splitring')
    genTex('white')
    genShader('overlay')
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'overlaySize')
        call('.addkey3f', 0, 0, 0, 0)
        x = 10000000
        call('.addkey3f', x, x, x, x )
    sel('..')

    sel('shader')
    if True:
        call('.setcullmode', 'ccw')
        call('.setcolorop', 0, 'mul tex const')
        call('.setalphaop', 0, 'mul tex const')
        #call('.setconst0', 0, 0, 1, 1 )
        if sn('nipol', 'setconst0'):
            call('.connect', 'setconst0')
            call('.setchannel', 'captureR')
            call('.addkey4f',    0,   1,   0,   0,   0)
            call('.addkey4f',  .05,   1,   0,   0,   1)
            call('.addkey4f',  .50,   1, .75, .25,   1)
            call('.addkey4f',    1,   0,  .9,   0,   1) 
        sel('..')
        call('.begintunit', 0)
        call('.setalphaenable', True)
        call('.setaddress', 'wrap', 'wrap')
        call('.setenabletransform', True)
        call('.endtunit')
        if sn('nipol', 'txyz0'):
            call('.connect', 'txyz0')
            call('.setchannel', 'captureR')
            call('.addkey3f',  0,     -1,  0,  0 )
            call('.addkey3f',  1, 2/32.0,  0,  0 ) #need to go 1/32 too far to get past the black line / and avoid bleeding
            call('.addkey3f',  2, 2/32.0,  0,  0 )
        sel('..')
    sel('..')
sel('..')

#/-----------------------------------------------------------------------------//
'''
if sn('n3dnode', '/lib/node/hpBar'):
    genMesh('splitring')
    genTex('constructionBar')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    #call('.setcolorop', 1, 'mul const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'constrRatio')
        call('.addkey4f',    0,   1,   0,   1,   1)
        call('.addkey4f',  .50, .75,  .5, .25,   1)
        call('.addkey4f',    1,   0,   1,   1,   1) 
    sel('..')
    call('.begintunit', 0)
    call('.setaddress', 'clamp', 'clamp')
    call('.setenabletransform', True)
    call('.endtunit')
    if sn('nipol', 'sxyz0'):
        call('.connect', 'txyz0')
        call('.setchannel', 'constrRatio')
        call('.addkey3f',  0, -1,  0,  0)
        call('.addkey3f',  1, 2/32.0,  0,  0) #need to go 1/32 too far to get past the black line / and avoid bleeding
        call('.addkey3f',  2,  0,  0,  0)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/enemyHpBar'):
    genMesh('splitring')
    genTex('constructionBar')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    #call('.setcolorop', 1, 'mul const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'constrRatio')
        call('.addkey4f',    0,   1,   0,   1,   1)
        call('.addkey4f',  .50,  .5,  .1,  .7,   1)
        call('.addkey4f',    1,   0,  .8,  .9,   1) 
    sel('..')
    call('.begintunit', 0)
    call('.setaddress', 'clamp', 'clamp')
    call('.setenabletransform', True)
    call('.endtunit')
    if sn('nipol', 'sxyz0'):
        call('.connect', 'txyz0')
        call('.setchannel', 'constrRatio')
        call('.addkey3f',  0, -1,  0,  0)
        call('.addkey3f',  1, 2/32.0,  0,  0) #need to go 1/32 too far to get past the black line / and avoid bleeding
        call('.addkey3f',  2,  0,  0,  0)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlayHexRing'):
    if sn('nmeshipol', 'mesh'):
        genMesh('hexringempty', 'hexringempty', readonly=True)
        genMesh('hexringfull', 'hexringfull', readonly=True)
        call('.beginkeys', 3)
        call('.setkey', 0, 0, 'hexringempty')
        call('.setkey', 1, 1, 'hexringfull')
        call('.setkey', 2, 2, 'hexringfull')
        call('.endkeys')
        call('.setupdatecoord', True)
        call('.setchannel', 'hpRatio')
    sel('..')
    genTex('white')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'hpRatio')
        call('.addkey4f',    0,   1,   0,   0,   1)
        call('.addkey4f',  .50,   1, .75, .25,   0.7)
        call('.addkey4f',  .95,   0,  .9,   0,   0.7) 
        call('.addkey4f',    1,   0,  .9,   0,   0.0) 
        call('.addkey4f',    2,   0,  .9,   0,   0.0) 
    sel('..')
    sel('..')
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'cameraDist')
        call('.addkey3f', 0, 1,1,1)
        call('.addkey3f', 10000, 10,10,10)
        call('.addkey3f', 10000000, 10,10,10)
        sel('..')
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
'''
