from defs import *
from xml.dom import minidom
from xml.dom import *
from log import Log
log = Log(tags=['all', 'struct'])
class struct(dict):
    """anonymous struct class,  
        replaces the standard use of dict for this purpose,
        has convenience functions to:
            export to TreeCtrl
    """
    def __init__(self, **kw):
        self.__dict__ = kw
        #self.children = {}
    def __setitem__(self, index, value):
        dict.__setitem__(self,index,value)
        self.__dict__[index] = value
    def __str__(self):
        return str(self.__dict__)
    def __repr__(self):
        return str(self.__dict__)
    def __eq__(self, other):
        if other == None: 
            return False
        if 'name' in self.__dict__ and 'name' in other.__dict__:
            return self.name == other.name
        else:
            print 'struct is missing name - cannot do eq'
            return False
    def getattr(self,v):
        print 'getattr', v
    def exportToTreeCtrl(self,tree,parent,myname,expand=True):
        myroot                          = tree.AppendItem(parent,myname)
        if expand:                      tree.Expand(myroot)
        for elem in self.__dict__:
            node = tree.AppendItem      (myroot, '%s=%s'%(elem,str(self.__dict__[elem])) )
            if expand:                  tree.Expand(node)
        tree.SetPyData                  (myroot, self)
        self.treeNode                   = myroot
        return myroot
    #/-----------------------------------------------------------------------------//
    def fromXML(self, filepath):
        """import this struct from an xmlfile"""
        log.write('struct.fromXML', self, filepath)
        try:
            file                                = open(filepath)
            doc                                 = minidom.parse(file)
            file.close()
        except IOError:
            print 'struct could not read from file', filepath
        else:
            root = doc.documentElement
            self.fromXMLNode(root)
    #/-----------------------------------------------------------------------------//
    def fromXMLNode(self, node):
        """import this struct from an xmlnode"""
        from defs import getText
        assert node.nodeType == Node.ELEMENT_NODE
        text = getText(node)
        if text:
            self.text = text
        for i in range(len(node.attributes)):
            attributeName = str(node.attributes.item(i).name)
            self.__dict__[attributeName] = str(node.getAttribute(attributeName))
        for child in node.childNodes:
            if child.nodeType == Node.ELEMENT_NODE:
                childname = str(child.tagName)
                childStruct = struct()
                childStruct.fromXMLNode(child)
                if node.tagName == childname + 's':
                    childname = str(child.getAttribute('name'))
                    self[childname] = childStruct
                    #self.children[childname] = childStruct
                self.__dict__[childname] = childStruct
    #/-----------------------------------------------------------------------------//
    def toXML(self, filepath):
        """export this struct to an xmlfile"""
        doc = minidom.Document()
        root = doc.createElement(self.name)
        doc.appendChild(root)
        self.toXMLNode(root, doc)

        f = file(filepath, 'w')
        f.write(doc.toprettyxml('    '))
        f.close()
    #/-----------------------------------------------------------------------------//
    def toXMLNode(self, node, doc, plural=False):
        for name,value in self.__dict__.iteritems():
            t = type(value)
            #print 'name', name, 't', t, 'value', value, 'plural', plural
            if name == 'name' and not plural:                                       continue
            if   t == int:                                                      node.setAttribute(name, str(value))
            elif t == float:                                                    node.setAttribute(name, str(value))
            elif t == str:                                                      node.setAttribute(name, str(value))
            elif t == type(struct()):
                if not self.has_key(name):
                    childnode = doc.createElement(name)
                    node.appendChild(childnode)
                    value.toXMLNode(childnode, doc)
                else:                   #its a child
                    childnode = doc.createElement(self.name[:-1])
                    node.appendChild(childnode)
                    value.toXMLNode(childnode, doc, True)                       #my children are plural
            else:                                                               print 'struct data type to xml %s, %snot supported' % (t,value)
    #/-----------------------------------------------------------------------------//
    def fromEVA(self, evapath, plural=False):
        """export this struct into the eva tree"""
        #log.write( 'struct.fromEVA', self, evapath)
        import defs
        from defs import getname
        from defs import pushsel
        from defs import popsel
        from defs import ndirin
        #print 'fromEva', evapath
        pushsel(evapath)
        self.name = getname()
        #print 'fromeva', 'name', self.name
        for var in ndirin('vars')[4:]:
            #print 'var', var
            t = call('vars/%s.gettype' % var)
            if   t == 'int':            v = defs.gi(var)
            elif t == 'float':          v = defs.gf(var)
            elif t == 'vector3':        v = defs.gv(var)
            elif t == 'quaternion':     v = defs.gq(var)
            elif t == 'string':         v = defs.gs(var)
            elif t == 'ref':            v = defs.gref(var)
            self.__dict__[var] = v
        for childname in ndirin():
            #print 'childname', childname
            child = struct()
            child.fromEVA('%s/%s' % (evapath, childname))
            self.__dict__[childname] = child
            if plural or self.name[-1] == 's':
                #print 'child', childname
                self[childname] = child
            #self.children[childname] = child
        popsel()
        #print 'fromeva', self
    #/-----------------------------------------------------------------------------//
    def toEVA(self, evapath):
        """import this struct from the eva tree"""
        #print 'toEva', evapath
        log.write('struct.toEVA', evapath)
        from defs import ndel
        from defs import pushsel
        from defs import popsel
        from defs import sn
        from defs import ci
        from defs import cf
        from defs import cs
        from defs import cv
        from defs import cq
        ndel(evapath)
        pushsel()
        sn('nent', evapath)
        call('.setselectable', False)
        call('.sethasside', False)
        for name,value in self.__dict__.iteritems():
            t = type(value)
            #print 'name', name, 't', t, 'value', value
            if   t == int:                                                      ci(name, value)
            elif t == float:                                                    cf(name, value)
            elif t == str:                                                      cs(name, value)
            elif t == unicode:                                                  cs(name, str(value)); print 'silly unicode string in a struct', value
            elif t == tuple and len(value) == 3:                                cv(name, value[0], value[1], value[2])
            elif t == tuple and len(value) == 4:                                cq(name, value[0], value[1], value[2], value[3])
            elif t == type(struct()):                                           value.toEVA('%s/%s' % (evapath, name))
            else:                                                               assert 0, 'struct data type %s, %snot supported' % (t,value)
        popsel()
    #/-----------------------------------------------------------------------------//
