from common.defs import *

def genTargetLineTex():
    '''
    Creates target line textures.
    '''
    pushsel()

    sn('n3dnode', '/lib/node/targetline')
    sn('nflipflop', 'colorflipflop')
    call('.setchannel', 'linetype')

    # Create a switch to toggle target line color based on behavior
    for i, color in enumerate(['approach', 'maintainstation', 'ramship', 'moveto', 'avoidland', 'avoidentity', 'fire']):
        new('ntexarraynode', color)
        from common import FileManager
        filepath   = FileManager.find( 'tex', color )

        alphapath = FileManager.find( 'tex', color+ 'Alpha' )
        if not alphapath:
            alphapath = FileManager.find( 'tex', color + 'alpha' )
        if not alphapath:
            alphapath = 'none'

        call('%s.settexture'%color, 0, filepath,alphapath)
        call('.addkey', i, color)
    call('.addkey', i+1, color)
    popsel()

genTargetLineTex()
