import re
from common.defs import *
import nEventServer
from common import EventNames
#from common import behaviorNames
import string

namePathMap = {}
pathPairs = {}

def cache(name, path, pair):
    print "LineCache: ", name, path
    namePathMap[name] = (path, pair)

def drwLine(entities):
    """ Draws a line between two entities. """
    #Split entities name
    pp = pathPairs
    targets = re.split(' ', entities);

    triggerName = targets[0]
    targetA = targets[-2];
    targetB = targets[-1];

    pair1 = (targetA, targetB)
    pair2 = (targetB, targetA)

    # If drawing a line to itself then return
    if targetA == targetB:
        return

    if pp.has_key(pair1):
        print "PP pairs", str(pp[pair1])
        top = pp[pair1][0]
        tmp = namePathMap[top]
        cache(triggerName, tmp[0], tmp[1])
        pp[pair1].append(triggerName)
    elif pp.has_key(pair2):
        pair1 = pair2
        top = pp[pair1][0]
        tmp = namePathMap[top]
        cache(triggerName, tmp[0], tmp[1])
        pp[pair1].append(triggerName)
    else:
        pp[pair1] = [triggerName]
    
    if len(pp[pair1]) == 1:
        pushsel()
        try:
            sel('/game/ents/line')
            duplicate=0
            ents = ndir()
            for ent in ents:
                sel(ent)
                tempTargetA=gref('targetA')
                tempTargetB=gref('targetB')
                if (tempTargetA == targetA and tempTargetB == targetB) or (tempTargetA == targetB and tempTargetB == targetA):
                    popsel()
                    return
                sel('..')
        except:
            print "targetA: ",targetA," ::: targetB: ",targetB

        linepath=genEnt('line')
        sel(linepath);
        cache(triggerName, linepath, pair1)
        sref('targetA', targetA);
        sref('targetB', targetB);
        popsel()

#-------------------------------------------------------

def deleteLine(name):
    """ Draws a line between two entities. """
    #Split entities name
    print "Deleting line: ", str(name)
    path, pair = namePathMap[name]
    print "Path: ", str(path), " pair: ", str(pair)
    if pathPairs.has_key(pair):
        if name in pathPairs[pair]:
            pathPairs[pair].remove(name)

        if len(pathPairs[pair]) == 0:
            if (exists(path)):
                print "Deleting Line Entity: ", path
                ndel(path)
                del pathPairs[pair]
#-------------------------------------------------------

colors=['approach', 'maintainstation', 'ramship', 'moveto', 'avoidland', 'avoidentity', 'fire']

def drwTargetLine(entities, type='moveto'):
    """ 
    Draws a line from an entity to its target.
    """
    #Split entities name
    targets = re.split(' ', entities);

    triggerName = targets[0]
    targetA = targets[-2];
    targetB = targets[-1];

    # If drawing a line to itself then return
    if targetA == targetB:
        return

    # Create line entity and set target references
    linepath=genEnt('targetline')
    pushsel()
    sel(linepath)
    sref('targetA', targetA)
    sref('targetB', targetB)
    # Turn line text off
    si('toggleText', 0)
    if(type.find("_")):
        type = type.split("_")[0]
    # Set color texture
    si('linetype', colors.index(string.lower(type)))

    popsel()

    return linepath

def deleteTargetLine(path):
    """ 
    Draws a line between two entities. 
    """

    if (exists(path)):
        print "Deleting Line Entity: ", path
        ndel(path)


nEventServer.register(EventNames.DISTANCE_SENSOR_CREATED, drwLine);
nEventServer.register(EventNames.DISTANCE_SENSOR_DELETED, deleteLine);
