
from common.defs import *
import nEventServer
from common import EventNames
from common import tickmanager
import re

def displayUnitInfo(msg):
    """Displays two line text information about the entity selected."""
    args = parseRMenuMsg(msg);
    # Get entity name and text to display
    ent = args.objectsOver[0]
    # Retrieve entity name without the complete path
    entName = re.sub("/game/ents/[^/]+/", "", ent)
    sel(ent)

    disController=gs('disController')
    if disController== ":null:":
        text='No Controller'
    else:
        text=disController
        """if disController!="move":
#print "not moving!!!!!!!!!!!!!!!"       
                targetName = re.sub("/game/ents/[^/]+/", "", gref('disTarget'))
                text=text+' - Target:'+targetName
                """

    ss('text', text)
    # Retrieve group name without the complete path
    groupRef=gref("group")
    groupName = re.sub("/comm/groups/", "", groupRef)
#text2="Group:"+groupName

    toggle=gi('displayEntInfo')
    # Toggle display of unit info
    if toggle == 0:
        si('displayEntInfo', 1)
    else:
        si('displayEntInfo', 0)

    sref('targetA', ent)




def updateUnitInfo(time, dtime):
    """
    Updates unit display info.
    updateUnitInfo is called by the tickmanager.
    """
    pushsel()
    sel('/game/ents/')
    entTypes=ndir()
    # Iterate through all existing entities
    for entType in entTypes:
        sel(entType)
        ents = ndir()
        for ent in ents:
                sel(ent)
                if hasvar('/game/ents/'+entType+'/'+ent+'/','displayEntInfo'):
                    displayFlag = gi('displayEntInfo')
                    # Update display info for entities with info flag set
                    if displayFlag == 1:
                            if hasvar('/game/ents/'+entType+'/'+ent+'/','disController'):
                                # If controller running, display controller name as unit info
                                text=gs('disController')
                                ss('text',text)
                            else:
                                text="No Controller" 
                                ss('text',text)
                sel('..')
        sel('..')

    popsel()

tickmanager.register('updateUnitInfo', updateUnitInfo)

# Register event handler for the unit info menu option
nEventServer.register(EventNames.RMENU_UNIT_INFO, displayUnitInfo);
