import socket
import wx
import sys
import os
import pickle
import wx
from common.defs import *
from wxPython.wx import *
from common import OptionManager
packetSize = 1024 * 1024
#/-----------------------------------------------------------------------------//
class HarborClient:
    """Lagoon side client which is responsibel for downloading / applying harbors from cove"""
    #/-----------------------------------------------------------------------------//
    gridsize                            = 369
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        self.socket                 = None
        pass
    #/-----------------------------------------------------------------------------//
    def createMenu(self, panel, parent):
        """setup the menubar
        first download the list of available harbors from cove
        then create a menu item for each one
        """
        print 'HarborClient.createMenu'
        if self.socket.connected == False:
            print 'createMenu failinng - harborClient is not connected'
            return None
        else:
            menu = wx.Menu()
            self.getHarborList()
            for i, harbor in enumerate(self.harborList):
                menu.Append(i, harbor, 'Download %s' % harbor)
                EVT_MENU(parent, i, self.downloadHarborButton)
            return menu
    #/-----------------------------------------------------------------------------//
    def downloadHarborButton( self, event ):
        """user has selected one of the download harbor buttons
        determine which harbor it corresponds too
        and then download it
        """
        harborName                      = self.harborList[event.GetId()]
        self.getHarbor                  (harborName)
    #/-----------------------------------------------------------------------------//
    def getHarborList(self):
        """connect to cove and get a list of the available maps
        tell cove i want the harbor list
        then wait for it
        """
        self.socket.sendData({'getHarborList':True}, threadOff=False)
        self.harborList = self.socket.recvData()
        print 'Received harborList', self.harborList
    #/-----------------------------------------------------------------------------//
    def getHarbor( self, harborName ):
        """download a particular harbor from the coveServer"""
        print 'HarborClient:getHarbor(%s)' % harborName
        self.socket.sendData({'getHarbor':harborName}, threadOff=False)
        print 'Waiting for harbor'
        harbor = self.socket.recvData()
        print 'Harbor received'

        print 'Saving to a file'
        self.saveToFile(harbor['map'], harbor['filename'], harbor['worldMin'], harbor['worldMax'])

        print 'Loading cove harbor file', harbor['filename']
        from common import MapManager
        MapManager.setHeightRange       ( -self.maxDepth, -self.minDepth)
        MapManager.changeHeightmap      ( harbor['filename'] )
    #/-----------------------------------------------------------------------------//
    def saveToFile( self, map, filename, worldMin, worldMax):
        """Save a depth array into a bmp
        actually we cant directly save as a bmp, so save as a png, and then convert it to a bmp - stupid copyrights
        """
        print 'HarborClient:saveToFile', filename
        image = wx.EmptyImage(self.gridsize,self.gridsize,True)
        first = True
        minDepth = maxDepth = 0

        #calc min/max depth
        for depth in map.values():
            if depth == 999999 or depth < 0:
                continue
            if first:
                minDepth = maxDepth = depth
                first = False
            else:
                if depth < minDepth:
                    minDepth = depth
                if depth > maxDepth:
                    maxDepth = depth
        print 'HarborClient:minDepth', minDepth
        print 'HarborClient:maxDepth', maxDepth
        self.minDepth = minDepth
        self.maxDepth = maxDepth
        num = 0
        #set pixels
        for (x,y), depth in map.items():
            if depth == 999999:
                depth = maxDepth
            if num % self.gridsize == 0:
                sys.stdout.write('*')
                #sys.stdout.flush()
            num += 1
            x = float(x)
            y = float(y)
            pixelx = ((x - worldMin[0]) * 368 )/ (worldMax[0] - worldMin[0])
            pixely = ((y - worldMin[1]) * 368 )/ (worldMax[1] - worldMin[1])
            pixelx = int(pixelx)
            pixely = int(pixely)
            colour = (depth - minDepth) / float(maxDepth - minDepth)
            colour = 1.0 - colour
            colour = colour * 255.0
            colour = int(colour)
            #print x, y, depth, pixelx, pixely, colour
            image.SetRGB( 368 - pixelx, 368 - pixely, colour, colour, colour)   #have to flip the pixels to get them to line up right

        print 'HarborClient:saving as png'
        image.SaveFile('coveheightmaps/%s.png' % filename, wx.BITMAP_TYPE_PNG)
        print 'HarborClient:converting to bmp'
        os.system('convert coveheightmaps/%s.png coveheightmaps/%s.bmp' % (filename, filename))    #wx refuses to save to bmps under linux for some reason, but the heightmaps have to be bmps, so we just convert them
        print 'HarborClient:loading'
        from common import FileManager
        FileManager.load('coveheightmaps')
    #/-----------------------------------------------------------------------------//
harborClient = HarborClient()
