import cPickle as pickle
import socket
import sys
import threading
from common.defs import *
#/-----------------------------------------------------------------------------//
class SendThread(threading.Thread):
    """a thread to do the send call -> otherwise it blocks for too long"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, socketWrapper):
        threading.Thread.__init__(self)
        self.socketWrapper = socketWrapper
        self.str = None
    #/-----------------------------------------------------------------------------//
    def run(self):
        assert self.socketWrapper
        assert self.str
        self.socketWrapper.sendString(self.str, threadOff = False)
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class SocketWrapper:
    """A wrapper to the basic socket class which allows you to send abitrary length strings and arbitrary python objects over
    """
    #/-----------------------------------------------------------------------------//
    packetSize = 1024 * 8 
    #/-----------------------------------------------------------------------------//
    def __init__(self, newSocket):
        self.socket                     = newSocket
        self.connected                  = False
        assert newSocket
    #/-----------------------------------------------------------------------------//
    def sendString(self, str, threadOff = True, quiet = True):
        """send a long string of data across the connection
        if thread off is set to true then spawn off a thread to do the actual sending
        """
        try:
            if threadOff:
                sendThread = SendThread(self)
                sendThread.str = str
                sendThread.start()
            else:
                #print 'SocketWrapper.sendString', str
                l = len(str)
                self.socket.send('%020i' % l, socket.MSG_WAITALL)

                mini = 0
                done = False
                totalBytesSent = 0
                if not quiet:
                    print 'Uploading ---', 
                    progressbar = 0
                while not done:            
                    maxi = mini + self.packetSize
                    if maxi > l:
                        maxi = l
                        done = True	
                    substring                   = str[mini:maxi]
                    bytesSent                   = self.socket.send(substring, socket.MSG_WAITALL)
                    totalBytesSent             += bytesSent
                    if not quiet:
                        while totalBytesSent * 80 / l > progressbar:
                            progressbar            += 1
                            sys.stdout.write('*')
                    mini += self.packetSize
                if not quiet:
                    print '--- done'
            #/-----------------------------------------------------------------------------//
        except:
            printExcept('SocketWrapper.sendString')
            self.connected = False
    #/-----------------------------------------------------------------------------//
    def recvString(self, quiet=True):
        """recv a lng string of data from a connection"""
        #get back the length of the thing
        #print 'SocketWrapper.recvString'
        try:
            l                               = self.socket.recv(20, socket.MSG_WAITALL)
            if not quiet:
                print 'received length string', l
            if not l or len(l) == 0:    return None
            l                           = int(l)

            str                         = ''
            if not quiet:
                print 'Downloading ---', 
            progressbar                 = 0
            while len(str) < l:
                bytesToReceive          = l - len(str)
                dataReceived            = self.socket.recv(bytesToReceive)
                assert                  dataReceived,                           'Failed to receive data - connection Died'
                str                    += dataReceived
                if not quiet:
                    while len(str) * 80 / l > progressbar:
                        progressbar        += 1
                        sys.stdout.write('*')
            if not quiet:
                print '--- done'
            return str
        except:
            printExcept('SocketWrapper.recvString')
            self.connected = False
    #/-----------------------------------------------------------------------------//
    def sendData(self, data, threadOff=False, quiet=True):
        str = pickle.dumps( data )          #beautiful pickle, how i love you, turn anything into a string, how brilliant - Chris's Crappy Haiku
        self.sendString(str, threadOff, quiet)
    #/-----------------------------------------------------------------------------//
    def recvData(self, quiet=True):
        str = self.recvString(quiet)
        if not str:
            return None
        data = pickle.loads( str )
        return data
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
