from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'evaexplorer'])
import wx
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class EVATreeCtrl(wx.TreeCtrl):
#/-----------------------------------------------------------------------------//
    def __init__(self,parent,id,pos,size,style):
        wx.TreeCtrl.__init__(self,parent,id,pos,size,style)
        #print 'size', size
#/-----------------------------------------------------------------------------//
    def OnCompareItems(self, item1, item2):
        print 'DictTreeCtrl.OnCompareItems', item1, item2

#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
NebulaClasses = ['nroot', 'nthing']
class EVATree(wx.Panel):
    """Displays a dictionary / heirarchy of dicts in a treeview"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, hook):
        wx.Panel.__init__(self,parent,wx.NewId(),style=wx.WANTS_CHARS)
        self.Bind(wx.EVT_SIZE, self.onSize)

        self.tree = EVATreeCtrl(self,wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TR_HAS_BUTTONS | wx.TR_EDIT_LABELS )

        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))

        self.tree.SetImageList(il)
        self.il = il

        #self.reloadTree()

        self.Bind(wx.EVT_TREE_SEL_CHANGED, hook, self.tree)
    #/-----------------------------------------------------------------------------//
    def onSize(self, event):
        w,h = self.GetClientSizeTuple()
        self.tree.SetDimensions(0,0,w,h)
    #/-----------------------------------------------------------------------------//
    def parseTree( self, root, path ):
        global NebulaClasses
        #print 'parseTree', 'root', root, 'path', path, 'type', type(path)
        sel(path)
        children = ndir()
        self.tree.SetPyData(root, getfullname())
        clazz = call('.getclass')
        #print 'clazz', clazz
        if clazz not in NebulaClasses:
            #print 'adding new class', clazz
            NebulaClasses.append(clazz)

            for possibleParentClass in NebulaClasses:
                if possibleParentClass == clazz:
                    continue
                myIndex                     = NebulaClasses.index(clazz)
                otherIndex                  = NebulaClasses.index(possibleParentClass)
                isParent                    = call('.isa', possibleParentClass)
                #print 'isParent', isParent
                if isParent and myIndex < otherIndex:
                    NebulaClasses.remove(clazz)
                    NebulaClasses.insert(otherIndex + 1, clazz)
                    print 'moving %s after %s' % (clazz, possibleParentClass)

        #print 'children', children
        #print 'parsing children'
        for child in children:
            #print 'child', child
            node = self.tree.AppendItem( root, child )
            #self.tree.SetPyData(node, getfullname() + child )
            self.parseTree(node, child)
        if path != '/':
            sel('..')
    #/-----------------------------------------------------------------------------//
    def refresh(self, event):
        log.write('EVATree.refresh')
        self.reloadTree()
    #/-----------------------------------------------------------------------------//
    def reloadTree(self):
        #print 'EVATree.reloadTree()'
        self.tree.DeleteAllItems()
        self.root = self.tree.AddRoot('EVA Tree')
        self.parseTree(self.root, '/')
        self.tree.Expand(self.root)
