from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'imtree'])
import wx
import wx.gizmos
#/-----------------------------------------------------------------------------//
class IMTree(wx.TreeCtrl):
    #/-----------------------------------------------------------------------------//
    def __init__(self,parent,id,pos=wx.DefaultPosition,size=wx.DefaultSize,style=wx.TR_HAS_BUTTONS | wx.TR_EDIT_LABELS ):
        self.currentlyDisplayed = None
        wx.TreeCtrl.__init__(self,parent,id,pos,size,style)

        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))
        self.SetImageList(il)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.selChanged, self)
        import nEventServer
        from common import EventNames
        nEventServer.register( EventNames.UPDATE_IMS, self.update )
    #/-----------------------------------------------------------------------------//
    def parseTree(self, root, path, rootNode=True):
        #print 'parseTree(%s,%i)' % (path, rootNode)
        if not exists(path): return
        if rootNode:                    
            self.nodesToExpand              = []
        sel                             (path)
        #print 'setpydata',              getfullname()
        self.SetPyData                  (root, getfullname())
        self.nodesToExpand.append       (root)

        if call('.isa', 'nim'):
            behavior            = call('.getbehavior')
            coef                = call('.getcoef')
            if behavior and behavior != "none":
                self.AppendItem( root, 'Behavior - %s' % behavior)
            self.AppendItem( root, 'Coef - %f' % coef)
        if call('.isa', 'niment'):
            func                = call('.getfunc')
            ipol                = call('.getipol')
            radius              = call('.getradius')
            who                 = call('.getwho')
            radiusCoef          = call('.getradiuscoef')
            self.AppendItem( root, 'func - %s' % func)
            self.AppendItem( root, 'ipol - %s' % ipol)
            self.AppendItem( root, 'radius - %s' % radius)
            self.AppendItem( root, 'who - %s' % who)
            self.AppendItem( root, 'radiusCoef - %f' % radiusCoef)

        for child in ndirin():
            if child == 'manager': continue
            if call('.getclass') == 'nent' and hasvar('myGroup') and exists(gref('myGroup')):
                node                    = self.AppendItem( root, '%s - %s' % (child, getname(gref('myGroup'))) )
            else:
                node                    = self.AppendItem( root, child )
            self.parseTree              (node, child, False)

        sel('..')
        if rootNode:
            for node in self.nodesToExpand:
                self.Expand(node)
    #/-----------------------------------------------------------------------------//
    def update(self, *args):
        #print 'EVATree.reloadTree()'
        self.DeleteAllItems()
        self.root                       = self.AddRoot('IMs')
        #self.SetItemText                (self.root, 'nop1', 1)
        #self.SetItemText                (self.root, 'nop2', 2)
        self.parseTree                  (self.root, '/game/sides/red/allocator')
        self.parseTree                  (self.root, '/game/sides/blue/allocator')
        self.Expand(self.root)
    #/-----------------------------------------------------------------------------//
    def selChanged(self, event):
        #print 'selChanged', event
        item = event.GetItem()
        path = self.GetPyData(item)
        #print 'item', item, 'path', path
        if self.currentlyDisplayed:
            call('%s.undisplay' % self.currentlyDisplayed)
        if call('%s.isa' % path, 'nim'):
            call('%s.display' % path)
            self.currentlyDisplayed = path
        else:
            self.currentlyDisplayed = None
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
