from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'imtree'])
import wx
import wx.gizmos
#/-----------------------------------------------------------------------------//
class IMTree(wx.TreeCtrl):
    #/-----------------------------------------------------------------------------//
    def __init__(self,parent,id,pos=wx.DefaultPosition,size=wx.DefaultSize,style=wx.TR_HAS_BUTTONS | wx.TR_EDIT_LABELS ):
        self.currentlyDisplayed = None
        wx.TreeCtrl.__init__(self,parent,id,pos,size,style)

        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))
        self.SetImageList(il)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.selChanged, self)
        #self.AddColumn('IM')
        #self.AddColumn('Operand')
        #self.AddColumn('Which')
        #self.SetColumnWidth(0,200)
        #self.SetMainColumn(0)
    #/-----------------------------------------------------------------------------//
    def parseTree(self, root, path, rootNode=True):
        #print 'parseTree(%s,%i)' % (path, rootNode)
        if rootNode:                    
            self.nodesToExpand              = []
        sel                             (path)
        #print 'setpydata',              getfullname()
        self.SetPyData                  (root, getfullname())
        self.nodesToExpand.append       (root)
        #if hasvar('op'):                op = gs('op')
        #else:                           op = 'add mul div'
        #if hasvar('which'):             which = gs('which')
        #else:                           which = 'everyone'
        #op                              = str(root.getAttribute('op'))
        #which                           = str(root.getAttribute('which'))
        #self.SetItemText                (root, 'op')
        #self.SetItemText                (root, 'which')
        for child in ndirin():
            if child != 'manager':
                #print 'self.AppendItem(%s,%s)' %(root,child)
                node                        = self.AppendItem( root, child )
                self.parseTree              (node, child, False)
        sel('..')
        if rootNode:
            for node in self.nodesToExpand:
                self.Expand(node)
    #/-----------------------------------------------------------------------------//
    def update(self):
        #print 'EVATree.reloadTree()'
        self.DeleteAllItems()
        self.root                       = self.AddRoot('IMs')
        #self.SetItemText                (self.root, 'nop1', 1)
        #self.SetItemText                (self.root, 'nop2', 2)
        self.parseTree                  (self.root, '/im')
        self.Expand(self.root)
    #/-----------------------------------------------------------------------------//
    def selChanged(self, event):
        #print 'selChanged', event
        item = event.GetItem()
        path = self.GetPyData(item)
        #print 'item', item, 'path', path
        if self.currentlyDisplayed:
            call('%s.undisplay' % self.currentlyDisplayed)
        if call('%s.isa' % path, 'nim'):
            call('%s.display' % path)
            self.currentlyDisplayed = path
        else:
            self.currentlyDisplayed = None
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
