import xml.dom.minidom
import nEventServer
from common import EventNames
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sp', 'SPRecorder'])
class SPRecorder:
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        self.newDoc()
        nEventServer.register(EventNames.ENT_PLACED, self.placeEnts)
    #/-----------------------------------------------------------------------------//
    def newDoc(self):
        self.doc                        = xml.dom.minidom.Document()
        self.docroot                    = self.doc.createElement('plan')
        self.doc.appendChild            (self.docroot)
    #/-----------------------------------------------------------------------------//
    def rightClick(self, string, selectedGroup = None):
        #record it
        node = self.doc.createElement('command')
        self.docroot.appendChild(node)
        node.setAttribute('func', 'rightClick')
        #node.setAttribute('time', str(self.time))
        node.setAttribute('selected', groupCommanding.name)
        node.setAttribute('string', string)
        self.saveLoadPanel.textCtrl2.SetValue('%s->%s' % (groupCommanding.name, string))
        self.saveRecordedPlan()
    #/-----------------------------------------------------------------------------//
    def createEnt(self, entType, groupName, position, side, place):
        log.write( 'SPRecorder.createEnt', entType, groupName, position, side, place)
        node                            = self.doc.createElement('command')
        time                            = str(getTime())
        entType                         = str(entType)
        groupName                       = str(groupName) 
        position                        = str(position)
        side                            = str(side)
        place                           = str(place)
        node.setAttribute('func',       'createEnt')
        node.setAttribute('time',       time )
        node.setAttribute('entType',    entType)
        node.setAttribute('groupName',  groupName)
        node.setAttribute('position',   position)
        node.setAttribute('side',       side)
        node.setAttribute('place',      place)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def setSide(self, entPath, side):
        log.write( 'SPRecorder.setSide', entPath, side)
        node                            = self.doc.createElement('command')
        time                            = str(getTime())
        entPath                         = str(entPath)
        side                            = str(side) 
        node.setAttribute('func',       'setSide')
        node.setAttribute('time',       time )
        node.setAttribute('entPath',    entPath)
        node.setAttribute('side',       side)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def assignEntToGroup(self, path, groupName, index):
        log.write( 'SPRecorder.assignEntToGroup', path, groupName, index)
        node                            = self.doc.createElement('command')
        time                            = str(getTime())
        path                            = str(path)
        groupName                       = str(groupName) 
        index                           = str(index)
        node.setAttribute('func',       'assignEntToGroup')
        node.setAttribute('time',       time )
        node.setAttribute('path',       path)
        node.setAttribute('groupName',  groupName)
        node.setAttribute('index',      index)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def assignObjectiveToGroup(self, objectiveName, groupName):
        log.write( 'SPRecorder.assignObjectiveToGroup', objectiveName, groupName)
        node                            = self.doc.createElement('command')
        time                            = str(getTime())
        objectiveName                   = str(objectiveName)
        groupName                       = str(groupName) 
        node.setAttribute('func',       'assignObjectiveToGroup')
        node.setAttribute('time',       time )
        node.setAttribute('objectiveName',objectiveName)
        node.setAttribute('groupName',  groupName)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def commandGroup( self, groupName, point, targets):
        log.write( 'SPRecorder.commandGroup', groupName, point, targets)
        node                            = self.doc.createElement('command')
        time                            = str(getTime())
        groupName                       = str(groupName) 
        point                           = str(point) 
        targets                         = str(targets) 
        node.setAttribute('func',       'commandGroup')
        node.setAttribute('time',       time )
        node.setAttribute('groupName',  groupName)
        node.setAttribute('point',      point)
        node.setAttribute('targets',    targets)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def saveCurrentCameraPos(self):
        pos                             = call('/game/camera.gv', 'pos')
        rot                             = call('/game/camera.gq', 'rot')
        node                            = self.doc.createElement('command')
        pos                             = str(pos)
        rot                             = str(rot)
        time                            = str(getTime())
        node.setAttribute               ('time', time )
        node.setAttribute               ('func','moveCamera')
        node.setAttribute               ('pos', pos)
        node.setAttribute               ('rot', rot)
        self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def placeEnts(self, event):
        #print 'recorder.placeEnts', event
        entsSelected = call('/ui/planner.getobjectsselected')
        #print 'entsSelected', entsSelected
        if not entsSelected:
            entsSelected = call('/ui/planner.getobjectsover')
            #print 'entsOver', entsSelected
        if entsSelected:
            entsSelected                = entsSelected.split(' ')
            node                        = self.doc.createElement('command')
            time                        = str(getTime())
            node.setAttribute           ('time', time )
            node.setAttribute           ('func', str('placeEnts'))
            self.docroot.appendChild( node )
            for ent in entsSelected:
                pos                     = call('%s.gv' % ent, 'pos')
                rot                     = call('%s.gq' % ent, 'rot')
                subnode                 = self.doc.createElement('placeEnt')
                subnode.                setAttribute('entName', str(ent))
                subnode.                setAttribute('pos', str(pos))
                subnode.                setAttribute('rot', str(rot))
                node.appendChild        ( subnode )
    #/-----------------------------------------------------------------------------//
    #def assignIMToGroup( self, groupName, im):
        #log.write( 'SPRecorder.assignIMToGroup', groupName, im)
        #node                            = self.doc.createElement('command')
        #time                            = str(getTime())
        #groupName                       = str(groupName) 
        #im                              = str(im)
        #node.setAttribute('func',       'assignIMToGroup')
        #node.setAttribute('time',       time )
        #node.setAttribute('groupName',  groupName)
        #node.setAttribute('im',         im)
        #self.docroot.appendChild(node)
    #/-----------------------------------------------------------------------------//
    def saveTo( self, filename):
        log.write( 'SPRecorder.saveTo', filename)
        f = file(filename, 'w')
        f.write(self.docroot.toprettyxml('    '))
        f.close()
        #self.newDoc()
    #/-----------------------------------------------------------------------------//
recorder = SPRecorder()
