import wx
import nEventServer
from npython                            import *
from common.defs                        import *
from common.log                         import Log
from common                             import EventNames
from creategrouppanel                   import CreateGroupPanel
from grouplist                          import GroupList
from creategrouppanel                   import SideList
log = Log(tags=['all', 'sp'])
#/-----------------------------------------------------------------------------//
class CloneGroupPanel(wx.Panel):
    """Panel for cloning groups
    how do we do this? very similar to creategroupPanel only we provide a list of existing groups
    """
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, spPanel, size = wx.DefaultSize, pos = wx.DefaultPosition):
        """create all my stuff, align it with a grid bag sizer"""
        wx.Panel.__init__               (self, parent, id, size=size)
        self.spPanel = spPanel

        sizer                           = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer                   (sizer)

        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        vsizer.Add                      (wx.StaticText (self, -1, 'Clone:'))
        self.groupList                  = GroupList(self, -1, size=(200,130))
        vsizer.Add                      (self.groupList)
        sizer.Add                       (vsizer)

        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        sizer.Add                       (vsizer)
        vsizer.Add                      (wx.StaticText (self, -1, 'Side:'))
        self.sideList                   = SideList(self, -1, self.spPanel, size=(200,130))
        self.sideList.Select            (2)         #select red by default
        vsizer.Add                      (self.sideList)

        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        sizer.Add                       (vsizer)
        vsizer.Add                      (wx.StaticText(self, -1, 'Group Name:'))
        self.groupNameCtrl              = wx.TextCtrl(self, -1, 'WARNING, shouldnt see this')
        vsizer.Add                      (self.groupNameCtrl)

        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(vsizer)
        self.createButton               = wx.Button(self, -1, 'Create')
        self.cancelButton               = wx.Button(self, -1, 'Cancel')
        self.Bind                       (wx.EVT_BUTTON, self.create, self.createButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel, self.cancelButton)
        vsizer.Add(self.createButton)
        vsizer.Add(self.cancelButton)
    #/-----------------------------------------------------------------------------//
    def create(self, event):
        """button function - clone my group
        first of all we need to just straight up create the group - use my parent func for that
        then we need to copy all the entities from the previous group - should be straightforward
        """
        log.open                        ('CloneGroupPanel.create')
        groupName                       = self.groupNameCtrl.GetLineText(0)
        side                            = self.sideList.GetSelection()
        fromGroup                       = self.groupList.GetSelection()
        groupName                       = str(groupName)
        side                            = str(side)
        fromGroup                       = str(fromGroup)

        import sp
        sp.cloneGroup(fromGroup, groupName, side)
        self.GetParent().show('sp')
        log.close()
    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write('CloneGroupPanel.cancel')
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def findAvailableGroupName(self):
        """search for the next available group name"""
        for i in range(1,100):
            name = 'red%i' % i 
            if not self.spPanel.groups.has_key(name):
                break
        return name
    #/-----------------------------------------------------------------------------//
    def Show(self):
        self.groupNameCtrl.SetValue(self.findAvailableGroupName())
        wx.Panel.Show(self)
    #/-----------------------------------------------------------------------------//
