import wx
import nEventServer
from npython                            import *
from common.defs                        import *
from common.log                         import Log
from common                             import EventNames
from grouplist                          import GroupList
from entitytypelist                     import EntityTypeList
log = Log(tags=['all', 'sp'])
#/-----------------------------------------------------------------------------//
class CreateEntPanel(wx.Panel):
    """Panel for creating an entity
    listboxes for entity type / group
    create / cancel buttons
    helpful text
    """
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, spPanel, size = wx.DefaultSize, pos = wx.DefaultPosition):
        """create all my stuff, align it with a grid bag sizer"""
        wx.Panel.__init__               (self, parent, id, size=(100,158))
        self.spPanel                    = spPanel
        self.typeText                   = wx.StaticText                         (self, -1, 'Entity Type:', style=wx.ALIGN_CENTER)
        self.groupText                  = wx.StaticText                         (self, -1, 'Group:', style=wx.ALIGN_CENTER)
        self.typeList                   = EntityTypeList                        (self, -1, size=(200,130))
        self.groupList                  = GroupList                             (self, -1, size=(200,130))
        self.createButton               = wx.Button                             (self, -1, 'Create')
        self.cancelButton               = wx.Button                             (self, -1, 'Cancel')
        self.Bind                       (wx.EVT_BUTTON, self.create, self.createButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel, self.cancelButton)

        sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(sizer)

        vsizer = wx.BoxSizer(wx.VERTICAL)
        vsizer.Add(self.typeText)
        vsizer.Add(self.typeList)
        sizer.Add(vsizer)

        vsizer = wx.BoxSizer(wx.VERTICAL)
        vsizer.Add(self.groupText)
        vsizer.Add(self.groupList)
        sizer.Add(vsizer)

        vsizer = wx.BoxSizer(wx.VERTICAL)
        vsizer.Add(self.createButton)
        vsizer.Add(self.cancelButton)
        sizer.Add(vsizer)
    #/-----------------------------------------------------------------------------//
    def create(self, event):
        """button function - create the entity and hide myself
        pull my type/group from the 2 list boxes
        create my entity - link it into the mouse for placement
        add it to the group
        """
        log.open                        ('CreateEntPanel.create')
        entType                         = self.typeList.GetSelection()
        group                           = self.spPanel.groups[self.groupList.GetSelection()]
        log.write                       ('entType', entType, 'group', group)
        import sp
        sp.createEnt(entType, group.name)
        log.close()
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write('CreateEntPanel.cancel')
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
