from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sp'])
from common import EventNames
import wx
import nEventServer
from selectedentlist                    import SelectedEntList
#/-----------------------------------------------------------------------------//
class SideList(wx.ListBox):
    """nice little listbox showing available sides"""
    def __init__(self, parent, id, spPanel, size=wx.DefaultSize):
        """figure out which sides exist by looking at children of /game/sides"""
        self.spPanel = spPanel
        pushsel('/game/sides')
        self.sideList = ndir()
        popsel()
        wx.ListBox.__init__(self, parent, id, choices=self.sideList, size=size)
    def GetSelection(self):
        return self.sideList[wx.ListBox.GetSelection(self)]
#/-----------------------------------------------------------------------------//
class CreateGroupPanel(wx.Panel):
    """Panel for creating a group
    okay so we need a listbox with existing entities to add to the group
    we need a side measure?
    and maybe objectives
    and a textctrl for the name
    """
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, spPanel, size=wx.DefaultSize):
        """create all my stuff, align it with a grid bag sizer"""
        self.spPanel                    = spPanel
        wx.Panel.__init__              (self, parent, id, size=size)
        self.createWidgets              ()
        gbs                             = wx.GridBagSizer                       (3,3)
        self.sizeWidgets                (gbs)
        self.SetSizer                   (gbs)
        self.Bind                       (wx.EVT_BUTTON, self.create, self.createButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel, self.cancelButton)
    #/-----------------------------------------------------------------------------//
    def createWidgets(self):
        self.entListCtrl                = wx.StaticText                         (self, -1, 'Entities:')
        self.entList                    = SelectedEntList                       (self, -1, size=(200,130))
        self.groupNameText              = wx.StaticText                         (self, -1, 'Group Name:')
        self.sideText                   = wx.StaticText                         (self, -1, 'Side:')
        self.groupNameCtrl              = wx.TextCtrl                           (self, -1, 'WARNING, shouldnt see this')
        self.sideList                   = SideList                              (self, -1, self.spPanel, size=(200,130))
        self.Bind                       (wx.EVT_LISTBOX, self.updateDefaultGroupName, self.sideList)
        self.sideList.Select(2)         #select red by default
        self.createButton               = wx.Button                             (self, -1, 'Create')
        self.cancelButton               = wx.Button                             (self, -1, 'Cancel')
    #/-----------------------------------------------------------------------------//
    def sizeWidgets(self, gbs, x=0, y=1):
        gbs.Add                         (self.entListCtrl,                      (x+0,y+0))
        gbs.Add                         (self.entList,                          (x+1,y+0), span=(3,1))
        gbs.Add                         (self.sideText,                         (x+0,y+1))
        gbs.Add                         (self.sideList,                         (x+1,y+1), span=(3,1), flag=wx.EXPAND)
        gbs.Add                         (self.groupNameText,                    (x+0,y+2))
        gbs.Add                         (self.groupNameCtrl,                    (x+1,y+2), span=(1,1))
        gbs.Add                         (self.createButton,                     (x+0,y+3))
        gbs.Add                         (self.cancelButton,                     (x+1,y+3))
        gbs.AddGrowableRow              (3)
        gbs.AddGrowableCol              (1)
    #/-----------------------------------------------------------------------------//
    def create(self, event):
        """button function - create the new group
        pull my type/group from the 2 list boxes
        create my entity - link it into the mouse for placement
        add it to the group
        """
        ents                            = self.entList.GetSelection()
        print 'ents', ents
        name                            = self.groupNameCtrl.GetLineText(0)
        side                            = self.sideList.GetSelection()
        name                            = str(name)
        side                            = str(side)
        log.open('CreateGroupPanel.create', name, side)

        import sp
        sp.createGroup(name, side)
        for ent in ents:
            sp.assignEntToGroup(ent, name)
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write('CreateEntPanel.cancel')
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def Show(self):
        self.updateDefaultGroupName()
        wx.Panel.Show(self)
    #/-----------------------------------------------------------------------------//
    def updateDefaultGroupName(self, event=None):
        side = self.sideList.GetSelection()
        for i in range(1,1000):
            name = '%s%i' % (side, i)
            if not self.spPanel.groups.has_key(name):
                break
        self.groupNameCtrl.SetValue(name)
    #/-----------------------------------------------------------------------------//
