import sys
import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
from sp.playermanager import playerManager
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class GroupList(wx.ListCtrl):
    """nice little listbox showing all the currently existing groups"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the groups from /comm/groups and initialize myself"""
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.LC_NO_HEADER | wx.LC_EDIT_LABELS, size=size) #LC_EDIT_LABELS
        nEventServer.register(EventNames.SIDES_CHANGED,  self.update)
        nEventServer.register(EventNames.GROUPS_CHANGED, self.update)
        nEventServer.register(EventNames.SELECTION_CHANGED, self.selectionChanged)
        #nEventServer.register(EventNames.PLAN_READY, self.update)
        self.InsertColumn(0, 'Objectives')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, size[0]-20)
        self.SetColumnWidth(1, 0)
        self.update()
        self.Bind(wx.EVT_LIST_BEGIN_LABEL_EDIT,                                 self.beginEdit)
        #self.Bind(wx.EVT_LIST_CANCEL_LABEL_EDIT,                                self.endEdit)
        self.Bind(wx.EVT_LIST_END_LABEL_EDIT,                                   self.endEdit)
        self.Bind(wx.EVT_LEFT_DCLICK, self.onDClick)
        self.selectedGroup = None
    #/-----------------------------------------------------------------------------//
    def GetSelection(self):
        index = self.GetFirstSelected(self)
        for group in ndirin('/comm/groups'):
            if not hasvar('/comm/groups/%s' % group, 'index'):
                continue
            groupIndex = call('/comm/groups/%s.gi' % group, 'index')
            if groupIndex == index:
                return group
        return None
    #/-----------------------------------------------------------------------------//
    def update(self, newGroup=None):
        """update the items in my list
        get a list of groups, then sort them basedupon their category -> assigned groups go first
        then alphabetical
        then go through and add them all to the list
        """
        #print 'grouplist.update'
        try:
            pushsel()
            #self.InsertStringItem(sys.maxint, 'hello')
            self.DeleteAllItems()
            #sel('/comm/groups')
            groups = ndirin('/comm/groups')
            #print 'groups', groups
            def func(a,b):
                #sorting function for groups
                typea = call('/comm/groups/%s.gs' % a, 'grouptype')
                typeb = call('/comm/groups/%s.gs' % b, 'grouptype')
                if typeb == 'adhoc': return -1
                if typea == 'adhoc': return 1
                if not hasvar('/comm/groups/%s' % a, 'index'): indexa = None
                else: indexa = call('/comm/groups/%s.gi' % a, 'index')
                if not hasvar('/comm/groups/%s' % b, 'index'): indexb = None
                else: indexb = call('/comm/groups/%s.gi' % b, 'index')
                if indexa and indexb:
                    if indexa < indexb:     return -1
                    else:                   return 1
                return a > b

            groups.sort(func)
            #print 'sortedgroups', groups
            for group in groups:
                if playerManager.canControlGroup(group):
                    sel('/comm/groups/%s' % group)
                    if not hasvar('grouptype'):
                        cs('grouptype', 'adhoc')
                    if not hasvar('label'):
                        cs('label', group)
                    grouptype                   = gs('grouptype')
                    label                       = gs('label')
                    groupIndex                  = None
                    if hasvar('groupIndex'):
                        groupIndex = gi('groupIndex')
                    numUnits                    = len(ndirin())
                    if grouptype == 'adhoc':
                        #print 'InsertStringItem', sys.maxint, group
                        index = self.InsertStringItem(sys.maxint, group)
                        self.SetStringItem(index, 0, label)
                        #print 'SetStringItem', index, 0, label
                    else:
                        print 'InsertStringItem', sys.maxint, group
                        index = self.InsertStringItem(sys.maxint, group)
                        if groupIndex:
                            self.SetStringItem(index, 0, '%i: [%i] %s' % (groupIndex, numUnits, label))
                        else:
                            self.SetStringItem(index, 0, '[%i] %s' % (numUnits, label))
                    ci('index', index)
                    sel('..')
            popsel()
        except:
            printExcept('grouplist.update')
        #print '/grouplist.update'
    #/-----------------------------------------------------------------------------//
    def select(self, groupName):
        #print 'grouplist.select', groupName
        if self.selectedGroup == groupName: return
        self.selectedGroup = groupName
        pushsel('/comm/groups')
        for group in ndirin():
            if playerManager.canControlGroup(group):
                sel('/comm/groups/' + group)
                if not hasvar('index'):
                    print 'warning group %s has no index' % group
                    continue
                if not hasvar('index'):
                    print 'warning selecting group %s which doesn\'t have an index (not in the grouplist?)' % groupName
                    continue
                index = gi('index')
                #print 'group', group, 'index', index, 'groupName', groupName
                if group == groupName:
                    self.Select(index, 1)
                else:
                    self.Select(index, 0)
                sel('..')
        popsel()
    #/-----------------------------------------------------------------------------//
    def unselect(self):
        self.select('')
    #/-----------------------------------------------------------------------------//
    def selectionChanged(self,msg):
        #print 'grouplist.selectionChanged', msg
        ents = call('/ui/planner.getobjectsselected')
        if not ents:
            self.unselect()
        else:
            ents = ents.split(' ')
            for ent in ents:
                if hasvar(ent, 'group'):
                    group = call('%s.gref' % ent, 'group')
                    group = getname(group)
                    #print 'self.select', group
                    #self.select(group)
                else:
                    #print 'ent', ent, 'has no group'
                    from sp.groupmanager import groupManager
                    groupManager.assignEnt( ent, getname(ent) )
    #/-----------------------------------------------------------------------------//
    def beginEdit(self, event):
        selected = self.GetFirstSelected()
        pushsel('/comm/groups')
        for group in ndirin():
            sel(group)
            if hasvar('index'): 
                index = gi('index')
                if index == selected:
                    label = gs('label')
                    self.SetStringItem(index, 0, label)
            sel('..')
        popsel()
    #/-----------------------------------------------------------------------------//
    def endEdit(self, event):
        pushsel('/comm/groups')
        selected = self.GetFirstSelected()
        for group in ndirin():
            sel(group)
            if hasvar('index'):
                index = gi('index')
                if index == selected:
                    #label = gs('label')
                    cs('label', str(event.GetItem().GetText()))
            sel('..')
        popsel()
        event.Veto()
        self.update()
    #/-----------------------------------------------------------------------------//
    def onDClick(self,event):
        selected = self.GetFirstSelected()
        pushsel()
        for group in ndirin('/comm/groups'):
            sel('/comm/groups/%s' % group)
            if hasvar('index') and gi('index') == selected:
                from sp.groupmanager import groupManager
                groupManager.panToGroup(group)
        popsel()
