import wx
import nEventServer
from npython                            import *
from common.defs                        import *
from common.log                         import Log
from common                             import EventNames
from grouplist                          import GroupList
from entitytypelist                     import EntityTypeList
log = Log(tags=['all', 'sp'])
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class LoadPlanPanel(wx.Panel):
    """
    okay what now, 
    okay so we need to save a plan
    just the filename and a save/cancel button

    okay now we need to think about how to actually load this damn thing
    well we pass the xml file to sp somewhere, or some kinda player backer, which can then run it..
    """
    def __init__(self, parent, id, spPanel, size = wx.DefaultSize, pos = wx.DefaultPosition):
        """
        Create all my stuff, align it with a grid bag sizer.
        """
        wx.Panel.__init__               (self, parent, id, size=(100,158))
        self.spPanel                    = spPanel
        sizer1                          = wx.BoxSizer(wx.VERTICAL)
        sizer1.Add                      (wx.Panel(self, -1, size=(2,2)))
        self.SetSizer(sizer1)

        sizer2                          = wx.BoxSizer(wx.HORIZONTAL)
        sizer1.Add                      (sizer2)
        sizer2.Add                      (wx.Panel(self, -1, size=(2,2)))

        sizer2.Add                      ( wx.StaticText ( self, -1, 'Filename:' ) )
        sizer2.Add                      (wx.Panel(self, -1, size=(5,5)))

        # Load available plan file names
        import glob
        longfiles                       = glob.glob('sp/xml/plans/*.xml')
        longfiles.sort()
        reg = re.compile(r'([^\/]+)\.xml')
        files = []
        for longfile in longfiles:
            groups = reg.search(longfile)
            if not groups: continue
            groups = groups.groups()
            files.append(groups[0])
            print '====================='+`groups[0]`
            print '====================='+`longfile`
            
        if len(files) == 0: files.append('No Saved Plans')

        self.filenameCtrl               = wx.ComboBox(self, -1, files[-1], (200,30), (200,30), files, wx.CB_DROPDOWN)

        sizer3                          = wx.BoxSizer(wx.VERTICAL)
        # Spacer
        sizer2.Add(wx.StaticText(self,-1, ' ', size=(30,30)))
        sizer2.Add                      (sizer3)
        self.instantCheck               = wx.CheckBox     (self, -1, 'Run Immediately')
        sizer3.Add                      (self.filenameCtrl)
        sizer3.Add                      (wx.Panel(self, -1, size=(5,5)))
        sizer3.Add                      (self.instantCheck)

        sizer2.Add                      (wx.Panel(self, -1, size=(5,5)))

        buttonsSizer                    = wx.BoxSizer(wx.VERTICAL)
        self.loadButton                 = wx.Button                             (self, -1, 'Load')
        self.browseButton                 = wx.Button                             (self, -1, 'Browse')
        self.cancelButton               = wx.Button                             (self, wx.ID_CANCEL, '')
        self.Bind                       (wx.EVT_BUTTON, self.OnBrowse,              self.browseButton)
        self.Bind                       (wx.EVT_BUTTON, self.load,              self.loadButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel,            self.cancelButton)
        buttonsSizer.Add(self.loadButton)
        buttonsSizer.Add(self.browseButton)
        buttonsSizer.Add(self.cancelButton)
        # Spacer
        sizer2.Add(wx.StaticText(self,-1, ' ', size=(30,30)))
        sizer2.Add(buttonsSizer)

    #/-----------------------------------------------------------------------------//
    def load(self, event):
        """load it from a file"""
        shortfilename                   = self.filenameCtrl.GetValue()
        # If path included in file name
        if '/' in shortfilename:
            filename = shortfilename
        else:
            filename = 'sp/xml/plans/%s.xml' % shortfilename

        log.write                       ('LoadPlanPanel.load', filename)
        from sp.replayer import PlanReplayer
        PlanReplayer(filename, self.instantCheck.GetValue())
        self.GetParent().show           ('sp')
        self.spPanel.saveLoadPanel.textCtrl.SetValue('Replaying %s' % shortfilename.split('/')[-1])

    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write                       ('LoadPlanPanel.cancel')
        self.GetParent().show           ('sp')
    #/-----------------------------------------------------------------------------//

    def OnBrowse(self, event):
        """
        File dialog to choose plan to load.
        """
        # File dialog
        parentDialog = wx.Dialog(self, size=(0,0), pos=(1400,0), style=wx.NO_BORDER|wx.TRANSPARENT|wx.STAY_ON_TOP)
        fileDialog = wx.FileDialog(parentDialog)
        # Set default directory
        fileDialog.SetDirectory(fileDialog.GetDirectory()+'/sp/xml/plans')

        parentDialog.Show()

        # If user selects a file
        if fileDialog.ShowModal() == wx.ID_OK:
            self.filenameCtrl.SetValue(fileDialog.GetPath())
            self.filePath = fileDialog.GetPath()

        fileDialog.Destroy()
        parentDialog.Destroy()


#/-----------------------------------------------------------------------------//
