import sys
import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class ObjectiveList(wx.ListCtrl):
    """nice little listbox showing all the currently existing Objectives"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the Objectives from /comm/objectives and initialize myself"""
        self.objectives = None
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.LC_EDIT_LABELS | wx.BORDER_SUNKEN | wx.LC_NO_HEADER)
        nEventServer.register(EventNames.OBJECTIVES_CHANGED, self.update)
        self.InsertColumn(0, 'Objectives')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, 100)
        self.SetColumnWidth(1, 0)
        self.update()
    #/-----------------------------------------------------------------------------//
    def GetSelection(self):
        index = self.GetFirstSelected(self)
        for objective in self.objectives.values():
            #print 'objective', objective
            if objective.index == index:
                return objective.name
        return None
    #/-----------------------------------------------------------------------------//
    def update(self, newGroup=None):
        """update the items in my list"""
        objectives = struct()
        objectives.fromEVA('/comm/objectives')
        for objectivename, objective in objectives.iteritems():
            if self.objectives == None or objectivename not in self.objectives:
                objective.index = self.InsertStringItem(sys.maxint, objective.name)
                self.SetItemTextColour(objective.index, getattr(wx, objective.colour.upper()))
        self.objectives = objectives
#/-----------------------------------------------------------------------------//
