import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
class ObjectiveTaskList(wx.ListBox):
    """nice little listbox showing all the tasks assigned to the current objective"""
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the Objectives from /comm/objectives and initialize myself"""
        self.objectives = []
        wx.ListBox.__init__(self, parent, id, size=size)
        nEventServer.register(EventNames.GROUPS_CHANGED, self.update)
        self.update()
    def GetSelection(self):
        return self.objectives[wx.ListBox.GetSelection(self)]
    def update(self, selectedObjective=None):
        """update the items in my list"""
        newobjectives = ndirin('/comm/objectives')
        i = 0
        for objective in newobjectives:
            paths = ndirin('/comm/objectives/%s' % objective)
            if objective not in self.objectives:
                self.objectives.append(objective)
                self.Insert(objective,i)
                i += 1
