import wx
import nEventServer
from npython                            import *
from common.defs                        import *
from common.log                         import Log
from common                             import EventNames
from grouplist                          import GroupList
from entitytypelist                     import EntityTypeList
log = Log(tags=['all', 'sp'])
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class SavePlanPanel(wx.Panel):
    """Okay what now, 
    okay so we need to save a plan
    just the filename and a save/cancel button
    DONE
    """
    def __init__(self, parent, id, spPanel, size = wx.DefaultSize, pos = wx.DefaultPosition):
        """
        Create all my stuff, align it with a grid bag sizer.
        """
        wx.Panel.__init__               (self, parent, id, size=(100,158))
        self.spPanel                    = spPanel
        sizer1                          = wx.BoxSizer(wx.VERTICAL)
        sizer1.Add                      (wx.Panel(self, -1, size=(2,2)))
        self.SetSizer(sizer1)

        sizer2                          = wx.BoxSizer(wx.HORIZONTAL)
        sizer1.Add                      (sizer2)
        sizer2.Add                      (wx.Panel(self, -1, size=(2,2)))

        sizer2.Add                      ( wx.StaticText ( self, -1, 'Filename:' ) )
        sizer2.Add                      (wx.Panel(self, -1, size=(5,5)))

        # Load available plan file names
        import glob
        longfiles                       = glob.glob('sp/xml/plans/*.xml')
        longfiles.sort()
        longfiles.append                (findAvailableFilename('sp/xml/plans', 'plan%i.xml'))
        reg = re.compile(r'([^\/]+)\.xml')
        files = []
        for longfile in longfiles:
            groups = reg.search(longfile)
            if not groups: continue
            groups = groups.groups()
            files.append(groups[0])
            
        self.filenameCtrl               = wx.ComboBox(self, -1, files[-1], (200,30), (200,30), files[:-1], wx.CB_DROPDOWN)

        sizer3                          = wx.BoxSizer(wx.VERTICAL)
        # Spacer
        sizer2.Add(wx.StaticText(self,-1, ' ', size=(30,30)))
        sizer2.Add                      (sizer3)
        self.saveCameraCheck            = wx.CheckBox    (self, -1, 'Save Camera Position')
        sizer3.Add                      (self.filenameCtrl)
        sizer3.Add                      (wx.Panel(self, -1, size=(5,5)))
        sizer3.Add                      (self.saveCameraCheck)

        sizer2.Add                      (wx.Panel(self, -1, size=(5,5)))
        buttonsSizer                    = wx.BoxSizer(wx.VERTICAL)

        self.saveButton                 = wx.Button                             (self, wx.ID_SAVE, '')
        self.browseButton               = wx.Button                             (self, -1, 'Browse')
        self.cancelButton               = wx.Button                             (self, wx.ID_CANCEL, '')

        self.Bind                       (wx.EVT_BUTTON, self.OnSave,              self.browseButton)
        self.Bind                       (wx.EVT_BUTTON, self.save,              self.saveButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel,            self.cancelButton)

        buttonsSizer.Add(self.saveButton)
        buttonsSizer.Add(self.browseButton)
        buttonsSizer.Add(self.cancelButton)
        # Spacer
        sizer2.Add(wx.StaticText(self,-1, ' ', size=(30,30)))
        sizer2.Add(buttonsSizer)
    #/-----------------------------------------------------------------------------//
    def OnSave(self, event):
        """
        Save the filename to sp with file dialog.
        """
        # File dialog
        parentDialog = wx.Dialog(self, size=(0,0), pos=(1400,0), style=wx.NO_BORDER|wx.TRANSPARENT|wx.STAY_ON_TOP)
        fileDialog = wx.FileDialog(parentDialog,'Choose plan save file name.', style=wx.SAVE)
        # Set default directory
        fileDialog.SetDirectory(fileDialog.GetDirectory()+'/sp/xml/plans')

        parentDialog.Show()

        # If user selects a file
        if fileDialog.ShowModal() == wx.ID_OK:
            self.filenameCtrl.SetValue(fileDialog.GetPath())

        fileDialog.Destroy()
        parentDialog.Destroy()


    def save(self, event):
        """
        Save the filename to sp
        """
        shortfilename                   = self.filenameCtrl.GetValue()
        # If path included in file name
        if '/' in shortfilename:
            filename = shortfilename
        else:
            filename = 'sp/xml/plans/%s.xml' % shortfilename

        log.write                       ('SavePlanPanel.save', filename)
        from sp.recorder import recorder
        if self.saveCameraCheck.GetValue():                                     #save the camerapos into the file
            recorder.saveCurrentCameraPos()
        recorder.saveTo                 ( filename )
        self.GetParent().show           ('sp')

    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write                       ('SavePlanPanel.cancel')
        self.GetParent().show           ('sp')
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
