import wx
import nEventServer
from npython                            import *
from common.defs                        import *
from common.log                         import Log
from common                             import EventNames
from sp.sidemanager                     import sideManager
from sp.playermanager                   import playerManager
log = Log(tags=['all', 'sp'])
#/-----------------------------------------------------------------------------/
class SideManagerPanel(wx.Panel):
    """so the side manager panel should look like it does in every other game, okay we will list the names of every player adn their side / race in a tabular kinda format, this should be fairly straightwoard
    okay so how do we do tihs?
    well we just need a grid-bag-sizer table layout
    with frames and stuff for each side, should be a piece of cake
    """
    def __init__(self, parent, id, spPanel, size=wx.DefaultSize):
        wx.Panel.__init__               (self, parent, id, size=size)
        self.spPanel                    = spPanel
        hsizer                          = wx.BoxSizer(wx.VERTICAL)
        self.sizer                      = wx.GridBagSizer(2,2)
        hsizer.Add                      ( self.sizer )
        self.rowCounter = 0
        self.playerNameHeader           = wx.StaticText                         (self, -1, 'Player Name',               style = wx.ALIGN_CENTER)
        self.sideHeader                 = wx.StaticText                         (self, -1, 'Side',                      style = wx.ALIGN_CENTER)
        self.factionHeader              = wx.StaticText                         (self, -1, 'Faction',                   style = wx.ALIGN_CENTER)
        self.sizer.Add(                 self.playerNameHeader,                  (self.rowCounter,0),  flag=wx.ALIGN_CENTER | wx.EXPAND | wx.ALL)
        self.sizer.Add(                 self.sideHeader,                        (self.rowCounter,1))
        self.sizer.Add(                 self.factionHeader,                     (self.rowCounter,2))
        self.rowCounter += 1

        self.readyButton                = wx.Button                             (self, -1, 'Ready')
        hsizer.Add(                     self.readyButton,                      flag=wx.ALIGN_RIGHT)
        self.Bind                       (wx.EVT_BUTTON, self.ready, self.readyButton)
        #self.SetSizerAndFit             ( hsizer )
        self.SetSizer                   (hsizer)

        nEventServer.register           (EventNames.PLAYERS_CHANGED,            self.update )
        self.playerWidgets             = {}
        self.update()

    def update(self, msg=None):
        print 'SideManagerPanel.update', msg
        #setup headers 
        #create the rows
        for player in ndirin('/game/players'):
            if player not in self.playerWidgets:
                print 'creating new player widgets for', player
                widgets = self.playerWidgets[player] = struct()
                widgets.playerNameTextField = wx.TextCtrl                           (self, -1, call('/game/players/%s.gs' % player, 'playername'),                  size=(300, 25))
                widgets.sideChoice          = wx.ComboBox                           (self, -1, choices=(ndirin('/game/sides')),                                     size=(300, 25))
                widgets.factionChoice       = wx.ComboBox                           (self, -1, choices=['Space Marine', 'Chaos', 'Ork', 'Eldar', 'Imperial Guard'], size=(300, 25))
                self.sizer.Add              ( widgets.playerNameTextField,          (self.rowCounter, 0))
                self.sizer.Add              ( widgets.sideChoice,                   (self.rowCounter, 1))
                self.sizer.Add              ( widgets.factionChoice,                (self.rowCounter, 2))
                self.Bind                   ( wx.EVT_TEXT,                          self.setPlayerName,                     widgets.playerNameTextField)
                self.Bind                   ( wx.EVT_COMBOBOX,                      self.setPlayerSide,                     widgets.sideChoice)
                self.Bind                   ( wx.EVT_COMBOBOX,                      self.setPlayerFaction,                  widgets.factionChoice)
                self.rowCounter += 1
            print 'updating gui values for', player
            playername                  = call('/game/players/%s.gs' % player, 'playerName')
            playerside                  = call('/game/players/%s.gs' % player, 'playerSide')
            #playerside                  = getname(playerside)
            playerfaction               = call('/game/players/%s.gs' % player, 'playerFaction')
            widgets = self.playerWidgets[player]
            widgets.playerNameTextField.SetValue                                ( playername )
            widgets.sideChoice.SetValue                                         ( playerside )
            widgets.factionChoice.SetValue                                      ( playerfaction )
    #/-----------------------------------------------------------------------------//
    def ready(self, event):
        """button function - create the entity and hide myself
        pull my type/group from the 2 list boxes
        create my entity - link it into the mouse for placement
        add it to the group
        """
        log.open                        ('SideManagerPanel.ready')
        #print                           'side', self.sideChoice.GetLabel()
        #entType                         = self.typeList.GetSelection()
        #group                           = self.spPanel.groups[self.groupList.GetSelection()]
        #log.write                       ('entType', entType, 'group', group)
        #import sp
        #sp.createEnt(entType, group.name)
        log.close()
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def setPlayerName(self, event):
        print 'setPlayerName', event.GetString()
        playerManager.setLocalPlayerName( str(event.GetString()))
    #/-----------------------------------------------------------------------------//
    def setPlayerSide(self, event):
        print 'setPlayerSide', event.GetString()
        playerManager.setLocalPlayerSide( str(event.GetString()))
    #/-----------------------------------------------------------------------------/
    def setPlayerFaction(self, event):
        print 'setPlayerFaction', event.GetString()
        playerManager.setLocalPlayerFaction( str(event.GetString()))
    #/-----------------------------------------------------------------------------//
        
#/-----------------------------------------------------------------------------//
