from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sensors'])
from common import tickmanager
import wx
import sys
import nEventServer
from common import EventNames
from cat.Interface.entitydistancesensor import *
from cat.Interface.damagesensor import *
from cat.Interface.flagsensor import *


#/-----------------------------------------------------------------------------//

class TriggerPanel(wx.Panel):
    def __init__(self, parent, panelsize):
        LISTBOXSIZE = (panelsize[0],500)
        BUTTONSIZE = (74,30)
        log.write("default button size:",wx.Button.GetDefaultSize())
        self.parent = parent
        wx.Panel.__init__(self, parent, -1, size = panelsize)
        self.numTriggers = 0
        self.tmpSizer = []
        self.paramCtrl = []
        self.textLabels = []
        self.currentSensor = 0
        self.entlist = []
        self.entlistfull = []
        self.triggerTypeSelected = False
        self.choices = ['Entity Distance','Entities In Range','Hull Strength','Binary Flag']
        self.stateChange = False
        self.sizerList=[]
        tickmanager.register('TriggerPanel', self.Tick)

        
        self.overSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer = wx.BoxSizer(wx.VERTICAL)
        width,height = panelsize
        self.mainSizer = wx.BoxSizer(wx.VERTICAL)
        self.addSizer = wx.BoxSizer(wx.VERTICAL)
        self.deleteSizer = wx.BoxSizer(wx.VERTICAL)
        self.infoSizer = wx.BoxSizer(wx.VERTICAL)
        
        self.triggerList = wx.CheckListBox(self,-1,size=LISTBOXSIZE,style=wx.LB_SINGLE)
        self.newButton = wx.Button(self,wx.ID_NEW,size=BUTTONSIZE)        
        self.infoButton = wx.Button(self,wx.ID_HELP,"Trigger Info",size=(panelsize[0],30))
        self.deleteButton = wx.Button(self,wx.ID_DELETE,size=BUTTONSIZE)
        
        self.stateChangeButton = wx.Button(self,wx.ID_OK,"Crit J",size=(panelsize[0],30))
        wx.EVT_BUTTON(self.newButton,-1,self.OnNewTrigger)
        wx.EVT_BUTTON(self.deleteButton,-1,self.OnDeleteTrigger)
        wx.EVT_BUTTON(self.stateChangeButton,-1,self.OnStateChange)
        wx.EVT_BUTTON(self.infoButton,-1,self.OnTriggerInfo)


        self.monitorSizer = wx.BoxSizer(wx.VERTICAL)
        #self.triggerListSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.monitorButtonSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.monitorSizer.Add(wx.StaticText(self,-1,"Monitored Triggers:",size=(panelsize[0]-20,20)),flag=wx.EXPAND|wx.ALL,border=10)
        #self.triggerListSizer.Add(self.triggerList,proportion=1,flag=wx.EXPAND)
        self.monitorSizer.Add(self.triggerList,proportion=0,flag=wx.BOTTOM|wx.EXPAND,border=10)
        self.monitorSizer.Add(self.stateChangeButton,flag=wx.BOTTOM|wx.EXPAND,border=10)
        self.monitorSizer.Add(self.infoButton,flag=wx.BOTTOM|wx.EXPAND,border=10)

        
        self.monitorButtonSizer.Add(self.newButton,proportion=1,flag=wx.BOTTOM|wx.EXPAND,border=10)
        self.monitorButtonSizer.Add((2,2),0)
        #self.monitorButtonSizer.Add(self.infoButton,proportion=1,flag=wx.BOTTOM|wx.EXPAND,border=10)
        #self.monitorButtonSizer.Add((10,10),0)
        self.monitorButtonSizer.Add(self.deleteButton,proportion=1,flag=wx.BOTTOM|wx.EXPAND,border=10)

        self.mainSizer.Add(self.monitorSizer,proportion=0,flag=wx.EXPAND|wx.BOTTOM)
        self.mainSizer.Add(self.monitorButtonSizer,flag=wx.BOTTOM|wx.ALIGN_BOTTOM|wx.ALIGN_CENTER|wx.EXPAND)
        

        self.triggerTypeList = wx.ComboBox(self,-1,value='Select Type...',choices=self.choices,style=wx.CB_DROPDOWN|wx.CB_READONLY)
        wx.EVT_COMBOBOX(self.triggerTypeList,-1,self.OnTriggerTypeSelect)
        self.nameTextCtrl = wx.TextCtrl(self)
        self.nameTextCtrl.SetValue('trig0')                                
        
        self.addButton = wx.Button(self,wx.ID_ADD,size=BUTTONSIZE)
        self.cancelButton = wx.Button(self,wx.ID_CANCEL,size=BUTTONSIZE)
        wx.EVT_BUTTON(self.addButton,-1,self.OnAddTrigger)
        wx.EVT_BUTTON(self.cancelButton,-1,self.OnCancelAdd)

        self.addButtonSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.addButtonSizer.Add(self.addButton,1,flag=wx.BOTTOM|wx.EXPAND,border=10)
        self.addButtonSizer.Add((2,2),0,flag=wx.EXPAND)
        self.addButtonSizer.Add(self.cancelButton,1,flag=wx.BOTTOM|wx.EXPAND,border=10)
        self.addSizer.Add(wx.StaticText(self,-1,"Adding Trigger:",size=(panelsize[0]-20,20)),flag=wx.ALL|wx.EXPAND|wx.ALIGN_TOP,border=10)
        self.addSizer.Add(wx.StaticText(self,-1,'Name:'),flag=wx.TOP|wx.LEFT,border=10)
        self.addSizer.Add((1,3),0)
        self.addSizer.Add(self.nameTextCtrl,flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=10)
        self.addSizer.Add(wx.StaticText(self,-1,'Type:'),flag=wx.TOP|wx.LEFT,border=10)
        self.addSizer.Add((1,3),0)
        self.addSizer.Add(self.triggerTypeList,flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=10)
        self.addSizer.Add((1,1),0)
        self.addSizer.Add(self.addButtonSizer,flag=wx.ALIGN_BOTTOM|wx.ALIGN_CENTER|wx.EXPAND)

        self.deleteConfirm = wx.TextCtrl(self,-1,style=wx.TE_READONLY)
        self.deleteButton2 = wx.Button(self,wx.ID_DELETE,size=BUTTONSIZE)
        self.cancelButton2 = wx.Button(self,wx.ID_CANCEL,size=BUTTONSIZE)
        wx.EVT_BUTTON(self.deleteButton2,-1,self.OnDeleteSpecificTrigger)
        wx.EVT_BUTTON(self.cancelButton2,-1,self.OnCancelDelete)

        self.deleteButtonSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.deleteButtonSizer.Add(self.deleteButton2,1,flag=wx.EXPAND)
        self.deleteButtonSizer.Add((2,2),0,flag=wx.EXPAND)
        self.deleteButtonSizer.Add(self.cancelButton2,1,flag=wx.ALIGN_RIGHT|wx.EXPAND)
        self.deleteSizer.Add(wx.StaticText(self,-1,"Delete this trigger?",size=(panelsize[0]-20,20)),flag=wx.ALL|wx.EXPAND|wx.ALIGN_TOP,border=10)
        self.deleteSizer.Add(wx.StaticText(self,-1,"Name:"),flag=wx.LEFT,border=10)
        self.deleteSizer.Add((1,3),0)
        self.deleteSizer.Add(self.deleteConfirm,flag = wx.BOTTOM|wx.LEFT|wx.EXPAND|wx.RIGHT,border=10)
        self.deleteSizer.Add((1,1),0)
        self.deleteSizer.Add(self.deleteButtonSizer,flag=wx.EXPAND|wx.BOTTOM|wx.ALIGN_BOTTOM|wx.EXPAND,border=10)
                                    
        self.infoName = wx.TextCtrl(self,-1,style=wx.TE_READONLY)
        self.infoButton2 = wx.Button(self,wx.ID_OK)
        wx.EVT_BUTTON(self.infoButton2,-1,self.OnCancelInfo)
                                    

        self.infoSizer.Add(wx.StaticText(self,-1,"Trigger Info:",size=(panelsize[0]-20,20)),flag=wx.ALL|wx.EXPAND|wx.ALIGN_TOP,border=10)
        self.infoSizer.Add(wx.StaticText(self,-1,"Name:"),flag=wx.LEFT,border=10)
        self.infoSizer.Add((1,3),0)
        self.infoSizer.Add(self.infoName,flag=wx.BOTTOM|wx.LEFT|wx.RIGHT|wx.EXPAND,border=10)
        self.infoSizer.Add((1,1),0)
        self.infoSizer.Add(self.infoButton2,flag=wx.EXPAND|wx.LEFT|wx.RIGHT|wx.BOTTOM,border=10)


        """
        self.newButton.SetMaxSize((74,30))
        self.deleteButton.SetMaxSize((74,30))
        self.addButton.SetMaxSize((74,30))
        self.cancelButton.SetMaxSize((74,30))
        self.deleteButton2.SetMaxSize((74,30))
        self.cancelButton2.SetMaxSize((74,30))
        self.infoButton.SetMaxSize((150,150))
        self.stateChangeButton.SetMaxSize((150,150))
        """   
        self.sizer.Add(self.mainSizer,proportion=1)
        #self.sizer.Add(self.addSizer,proportion=1)
        #self.sizer.Add(self.deleteSizer,proportion=1)
        #self.overSizer.Add(self.sizer)
        self.SetSizer(self.sizer)
        self.sizer.SetMinSize(panelsize)

        self.addSizer.ShowItems(0)
        self.deleteSizer.ShowItems(0)
        self.infoSizer.ShowItems(0)
#        self.SetAutoLayout(1)
        self.mainSizer.ShowItems(1)
        self.Layout()
        

        log.write(self.newButton.GetSize(),self.deleteButton.GetSize())
        log.write('Minimum Sizer Size:',panelsize)
        log.write('Actual Sizer Size:',self.sizer.GetSize())
        log.write('statechangebutton size',self.stateChangeButton.GetSize())

    def OnNewTrigger(self, event):
        self.nameTextCtrl.SetValue('trig'+str(self.numTriggers))
        self.sizer.Detach(self.mainSizer)
        self.mainSizer.ShowItems(0)
        self.sizer.Add(self.addSizer,proportion=1)
        self.addSizer.ShowItems(1)
        self.Layout()

    def OnAddTrigger(self, event):
        try:
            addTheTrigger = True
            if self.triggerTypeList.GetValue() != 'Select Type...':
                valueList = []
                for i in range(len(self.paramCtrl)):
                    if self.currentSensor.parameters[i]['type'] == 'ent':
                        if self.paramCtrl[i].GetValue() == 'Select Entity...':
                            addTheTrigger = False
                        else:
                            valueList.append(self.entlistfull[self.entlist.index(self.paramCtrl[i].GetValue())])
                    else:
                        valueList.append(self.paramCtrl[i].GetValue())
                if addTheTrigger:
                    self.currentSensor.setParameters(valueList)
                    self.triggerList.Append(self.nameTextCtrl.GetValue(),(self.nameTextCtrl.GetValue(),self.currentSensor))
                    state = self.currentSensor.getTriggerState()
                    if state[0]['sensorType'] == 'Distance Between Entities':
                        for param in state[1]:
                            if param['name'] == 'From':
                                str1 = param['value']
                            if param['name'] == 'To':
                                str2 = param['value']
                        triggerId = self.nameTextCtrl.GetValue()
                        nEventServer.pull(EventNames.DISTANCE_SENSOR_CREATED, triggerId + " " + str1 + ' ' + str2)

                    self.numTriggers+=1

                    self.clearAddTriggerPanel()

                    self.triggerTypeList.Append('Select Type...')
                    self.triggerTypeList.SetStringSelection('Select Type...')
                    self.triggerTypeList.Delete(self.triggerTypeList.FindString('Select Type...'))

                    self.triggerTypeSelected = False
                    self.addSizer.ShowItems(0)
                    self.sizer.Detach(self.addSizer)
                    self.sizer.Add(self.mainSizer,proportion=1)
                    self.mainSizer.ShowItems(1)
                    self.Layout()
        except:
            printExcept('Adding Trigger')
        #print "TriggerNames: ", str(self.triggerList)

    def OnDeleteTrigger(self,event):
        if self.triggerList.GetSelection() == wx.NOT_FOUND:
            pass
        else:
            self.sizerList = []
            index=0
            self.deleteConfirm.SetValue(self.triggerList.GetStringSelection())
            triggerState = self.triggerList.GetClientData(self.triggerList.GetSelection())[1].getTriggerState()
            print "Trigger name selected for deletion: ", str(self.triggerList.GetClientData(self.triggerList.GetSelection())[0])
            paramSizer = wx.BoxSizer(wx.VERTICAL)
            self.sizerList.append(wx.StaticText(self,-1,'Type:'))
            #index+=1
            paramSizer.Add(self.sizerList[index],flag = wx.LEFT,border=10)
            self.sizerList.append((1,3))
            index+=1
            paramSizer.Add(self.sizerList[index],0)
            if triggerState[0]['sensorType'] == 'Distance Between Entities':
                sensorType = 'Dist. Between Entities'
            else:
                sensorType = triggerState[0]['sensorType']
            self.sizerList.append(wx.StaticText(self,-1,sensorType))
            index+=1
            paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
            sensorEntList = []
            for param in triggerState[1]:
                self.sizerList.append(wx.StaticText(self,-1,param['name']+':'))
                index+=1
                paramSizer.Add(self.sizerList[index],flag =wx.LEFT,border=10)
                self.sizerList.append((1,3))
                index+=1
                paramSizer.Add(self.sizerList[index],0)
                if param['type'] == 'ent':
                    self.sizerList.append(wx.StaticText(self,-1,param['value'].rsplit('/',1)[1]))
                    index+=1
                    paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
                    sensorEntList.append(param['value'])
                else:
                    self.sizerList.append(wx.StaticText(self,-1,str(param['value'])))
                    index+=1
                    paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
            if(triggerState[0]['sensorType'] == 'Distance Between Entities'):
                import string
                print "Params are: " + str(sensorEntList)

                    
            self.deleteSizer.Insert(4,paramSizer)
            self.sizer.Detach(self.mainSizer)
            self.mainSizer.ShowItems(0)
            self.deleteSizer.ShowItems(1)
            self.sizer.Add(self.deleteSizer,1)
            self.Layout()

    def OnTriggerInfo(self,event):
        if self.triggerList.GetSelection() == wx.NOT_FOUND:
            pass
        else:
            self.sizerList = []
            index=0
            self.infoName.SetValue(self.triggerList.GetStringSelection())
            triggerState = self.triggerList.GetClientData(self.triggerList.GetSelection())[1].getTriggerState()
            paramSizer = wx.BoxSizer(wx.VERTICAL)
            self.sizerList.append(wx.StaticText(self,-1,'Type:'))
            #index+=1
            paramSizer.Add(self.sizerList[index],flag = wx.LEFT,border=10)
            self.sizerList.append((1,3))
            index+=1
            paramSizer.Add(self.sizerList[index],0)
            if triggerState[0]['sensorType'] == 'Distance Between Entities':
                sensorType = 'Dist. Between Entities'
            else:
                sensorType = triggerState[0]['sensorType']
            self.sizerList.append(wx.StaticText(self,-1,sensorType))
            index+=1
            paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
            for param in triggerState[1]:
                self.sizerList.append(wx.StaticText(self,-1,param['name']+':'))
                index+=1
                paramSizer.Add(self.sizerList[index],flag =wx.LEFT,border=10)
                self.sizerList.append((1,3))
                index+=1
                paramSizer.Add(self.sizerList[index],0)
                if param['type'] == 'ent':
                    self.sizerList.append(wx.StaticText(self,-1,param['value'].rsplit('/',1)[1]))
                    index+=1
                    paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
                else:
                    self.sizerList.append(wx.StaticText(self,-1,str(param['value'])))
                    index+=1
                    paramSizer.Add(self.sizerList[index],flag = wx.LEFT|wx.BOTTOM,border=10)
            self.infoSizer.Insert(4,paramSizer)
            self.sizer.Detach(self.mainSizer)
            self.mainSizer.ShowItems(0)
            self.infoSizer.ShowItems(1)
            self.sizer.Add(self.infoSizer,1)
            self.Layout()
        

    def OnCancelAdd(self,event):


        if self.triggerTypeList.GetValue() != 'Select Type...':
            self.clearAddTriggerPanel()
            
            self.triggerTypeList.Append('Select Type...')
            self.triggerTypeList.SetStringSelection('Select Type...')
            self.triggerTypeList.Delete(self.triggerTypeList.FindString('Select Type...'))
            
        self.triggerTypeSelected = False
        self.addSizer.ShowItems(0)
        self.sizer.Detach(self.addSizer)
        self.mainSizer.ShowItems(1)
        self.sizer.Add(self.mainSizer,1)
        self.Layout()

    def OnCancelDelete(self, event):
        for item in self.sizerList:
            if isinstance(item,tuple):
                pass
            else:
                item.Destroy()
        self.sizerList = []
        self.deleteSizer.Remove(4)
        self.deleteSizer.Layout()
        self.deleteSizer.ShowItems(0)
        self.sizer.Detach(self.deleteSizer)
        self.mainSizer.ShowItems(1)
        self.sizer.Add(self.mainSizer,1)
        self.Layout()

    def OnCancelInfo(self,event):
        for item in self.sizerList:
            if isinstance(item,tuple):
                pass
            else:
                item.Destroy()
        self.sizerList=[]
        self.infoSizer.Remove(4)
        self.infoSizer.Layout()
        self.infoSizer.ShowItems(0)
        self.sizer.Detach(self.infoSizer)
        self.mainSizer.ShowItems(1)
        self.sizer.Add(self.mainSizer,1)
        self.Layout()
        
#        
    def OnDeleteSpecificTrigger(self, event):
        triggerName = str(self.triggerList.GetClientData(self.triggerList.GetSelection())[0])       
#        print "trigger Name to be deleted: ", self.deleteConfirm.GetValue()
        print "To be deleted ", triggerName
        self.triggerList.Delete(self.triggerList.GetSelection())
        for item in self.sizerList:
            if isinstance(item,tuple):
                pass
            else:
                item.Destroy()
        self.sizerList = []
        self.deleteSizer.Remove(4)
        self.deleteSizer.Layout()
        self.deleteSizer.ShowItems(0)
        self.sizer.Detach(self.deleteSizer)
        self.mainSizer.ShowItems(1)
        self.sizer.Add(self.mainSizer,1)
        self.Layout()
        nEventServer.pull(EventNames.DISTANCE_SENSOR_DELETED, triggerName)

    def OnTriggerTypeSelect(self,event):
        if not self.triggerTypeSelected:
            if self.triggerTypeList.GetValue() != 'Select Type...':
                self.entlist = []
                self.entlistfull = []
                sel('/game/ents')
                dir = ndir()
                for subdir in dir:
                    sel('/game/ents/'+subdir)
                    dir2 = ndir()
                    for subdir2 in dir2:
                        sel('/game/ents/'+subdir+'/'+subdir2)
                        if getselectable():
                            self.entlistfull.append(getfullname())
                            self.entlist.append(getname())


                select = self.triggerTypeList.GetStringSelection()
                if select == 'Entity Distance':
                    log.write('Entity Distance Trigger Selected')
                    self.currentSensor = EntityDistanceSensor()
                elif select == 'Entities In Range':
                    log.write('Entities In Range Trigger Selected')
                    self.currentSensor = EntityDistanceSensor(calculateDistance=False)
                elif select == 'Hull Strength':
                    log.write('Entity Hull Strength Trigger Selected')
                    self.currentSensor = DamageSensor()
                elif select == 'Binary Flag':
                    log.write('Binary Flag Trigger Selected')
                    self.currentSensor = FlagSensor(self.nameTextCtrl.GetValue(),trueFunc)

                paramSizer = wx.BoxSizer(wx.VERTICAL)
                for i in range(len(self.currentSensor.parameters)):
                    if self.currentSensor.parameters[i]['type'] == 'ent':
                        self.textLabels.append(wx.StaticText(self,-1,self.currentSensor.parameters[i]['name']+':'))
                        self.paramCtrl.append(wx.ComboBox(self,-1,'Select Entity...',choices=self.entlist,style=wx.CB_DROPDOWN|wx.CB_READONLY))
                        paramSizer.Add(self.textLabels[i],flag=wx.TOP|wx.LEFT,border=10)
                        paramSizer.Add((1,3),0)
                        paramSizer.Add(self.paramCtrl[i],flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=10)
                    elif self.currentSensor.parameters[i]['type'] == 'int':
                        self.textLabels.append(wx.StaticText(self,-1,self.currentSensor.parameters[i]['name']+':'))
                        self.paramCtrl.append(wx.SpinCtrl(self,style=wx.SP_ARROW_KEYS,max=100000,initial=0))
                        paramSizer.Add(self.textLabels[i],flag=wx.TOP|wx.LEFT,border=10)
                        paramSizer.Add((1,3),0)
                        paramSizer.Add(self.paramCtrl[i],flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=10)


                self.addSizer.Insert(7,paramSizer,flag=wx.EXPAND)
                self.addSizer.Layout()
                self.triggerTypeSelected = True
        else:
            self.clearAddTriggerPanel()
            self.triggerTypeSelected = False
            self.OnTriggerTypeSelect(wx.EVT_COMBOBOX)

    def OnStateChange(self,event):
        self.stateChange = True
    
    def clearAddTriggerPanel(self):
        for txt in self.textLabels:
            txt.Destroy()
        for ctrl in self.paramCtrl:
            ctrl.Destroy()
        #for i in range(len(self.tmpSizer)-1,-1,-1):
        #    self.tmpSizer.Remove(i)
        
        self.tmpSizer = []
        self.paramCtrl = []
        self.textLabels = []
        self.addSizer.Remove(7)
        self.addSizer.Layout()
        
        

    def Tick(self,time,dtime):
        try:
            data = []
            checked = False
            for i in range(self.triggerList.GetCount()):
                if self.triggerList.IsChecked(i):
                    checked = True
                sensor = self.triggerList.GetClientData(i)[1]
                self.triggerList.SetString(i,self.triggerList.GetClientData(i)[0]+': '+str(sensor.Tick(time,dtime)))
                if checked:
                    self.triggerList.Check(i)
                checked = False
            ## if self.didStateChange():
                
##                 log.write('STATE CHANGE!')
##                 log.open('Trigger states')
##                 log.write(self.getRelevantTriggers())
##                 log.close()
                #log.write(sensor.Tick(time,dtime))
        except:
            printExcept('Trigger Tick')

    def didStateChange(self):
        if self.stateChange:
            self.stateChange = False
            return True
        return False

    def tester(self):
        log.write("Testing Trigger Log")

    def getRelevantTriggers(self):
        trigList = []
        for i in range(self.triggerList.GetCount()):
            if self.triggerList.IsChecked(i):
                trigList.append(self.triggerList.GetClientData(i)[1])
        infoList = []
        for trigger in trigList:
            infoList.append(trigger.getTriggerState())

        return infoList

def trueFunc():
    return True

