#define N_IMPLEMENTS nFighterAI
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/nfighterai.h"

nNebulaScriptClass(nFighterAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nFighterAI::nFighterAI():
    lmissle( kernelServer, this ),
    rmissle( kernelServer, this )
{
}

void nFighterAI::Initialize(){
    nAI::Initialize();
    stateNames.Append("stop");
    stateNames.Append("strafe");
    stateNames.Append("regroup");
    //AddToDisplayList();
}

void nFighterAI::InitVars(){
    nAI::InitVars();
    destination.Connect( ent, "destination" );
    destination.DefaultV(0,0,0);
    target.Connect( ent, "target" );
    target.DefaultRef("");
    targetPos.Connect( target, "pos" );
    strafeRadius.Connect( ent, "straferadius");
    strafeRadius.DefaultF( 10 );
    regroupRadius.Connect( ent, "regroupradius" );
    regroupRadius.DefaultF( 20 );

    char fullname[1024];
    ent->GetFullName( fullname, 1024 );
    strcat( fullname, "/lmissle");
    lmissle = fullname;

    ent->GetFullName( fullname, 1024 );
    strcat( fullname, "/rmissle");
    rmissle = fullname;
}

nFighterAI::~nFighterAI(){
}
//------------------------------------------------------------------------------
/**
*/

void nFighterAI::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
}

bool nFighterAI::States( StateMachineEvent event, uint state, float time, float dtime ){
    BeginStateMachine
        State(Stop) 
            OnEnter
            OnTick
        State(Strafe)
            OnEnter
                //n_printf("nFighterAI::Strafe");
            OnTick
                float dist = Move3D( targetPos.GetV(), dtime );
                if( dist < strafeRadius.GetF() )
                    SetState( Regroup );
                //DrawLine( pos.GetV(), targetPos.GetV(), red );
                if( lf > .99f ) {
                    if( lmissle.isvalid() )
                        lmissle->Fire( target.GetRef()->fn );
                    if( rmissle.isvalid() )
                        rmissle->Fire( target.GetRef()->fn );
                }
        State(Regroup)
            OnEnter
                //n_printf("nFighterAI::Regroup");
                float r0 = randF( -N_PI, N_PI );
                float r1 = randF( -N_PI, N_PI );
                //n_printf("r0:%f r1:%f\n", r0, r1 );
                quaternion q;
                q.set_rotate_xyz( r0,r1,0 );
                vector3 dest = targetPos.GetV() + q.rotate(vector3(1,0,0)) * regroupRadius.GetF();
                //n_printv( dest );
                destination.SetV( dest );
            OnTick
                float dist = Move3D( destination.GetV(), dtime );
                if( dist < 10.0f )
                    SetState( Strafe );
                //DrawLine( pos.GetV(), destination.GetV(), white );
    EndStateMachine
}
