#define N_IMPLEMENTS nMoveAI
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/nmoveai.h"

nNebulaScriptClass(nMoveAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nMoveAI::nMoveAI()
{
}

void nMoveAI::Initialize(){
    nAI::Initialize();
    stateNames.Append("Move");
}

void nMoveAI::InitVars(){
    nAI::InitVars();
    destination.Connect( ent, "destination" );
    mass.Connect( ent, "mass" );
    friction.Connect( ent, "friction" );
}

nMoveAI::~nMoveAI(){
}
//------------------------------------------------------------------------------
/**
*/

bool nMoveAI::States( StateMachineEvent event, uint state, float time, float dtime ){
    if( mass.isvalid() && friction.isvalid() )
    if( mass.isdirty() || friction.isdirty() ) {
        maxSpeed = 1.0f / mass.GetF() / friction.GetF();
        //n_printf("maxSpeed:%f\n", maxSpeed );
    }
    if( ent->Held() ) return true;
    BeginStateMachine
        State(Move)
            OnTick
	vector3 v = destination.GetV();
	//n_printf("%s->moveTowards( %f,%f,%f )\n", fn, v.x, v.y, v.z );
	float d = this->MoveTowards( v,  dtime );
	if( d < 30.0 ) {
	    nRoot* wp = ent->Find("wp");
	    if( wp && this->alive) {
	        nRoot* attached = wp->GetHead();
	        if( attached && attached != wp->GetTail()) {
	            nRoot* second = attached->GetSucc();
	            if( second ) {
		//n_printf("%s telling %s->Release\n", this->fn, second->GetName() );
		((nThing*)second)->Die();
	            }
	        }
	    }
	    this->Die();
	}
    EndStateMachine
}
