#define N_IMPLEMENTS nMoveAI_Simple
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/nmoveai_simple.h"

nNebulaScriptClass(nMoveAI_Simple, "nmoveai");

//------------------------------------------------------------------------------
/**
*/
nMoveAI_Simple::nMoveAI_Simple()
{
}

void nMoveAI_Simple::Initialize(){
    nMoveAI::Initialize();
}

void nMoveAI_Simple::InitVars(){
    nMoveAI::InitVars();
}

nMoveAI_Simple::~nMoveAI_Simple(){
}
//------------------------------------------------------------------------------
/**
*/

void nMoveAI_Simple::Tick( float time, float dtime ){
    nMoveAI::Tick( time, dtime );
}

bool nMoveAI_Simple::States( StateMachineEvent event, uint state, float time, float dtime ){
    if( mass.isvalid() && friction.isvalid() )
    if( mass.isdirty() || friction.isdirty() ) {
        maxSpeed = 1.0f / mass.GetF() / friction.GetF();
        //n_printf("maxSpeed:%f\n", maxSpeed );
    }
    if( ent->Held() ) return true;
    BeginStateMachine
        State(Move)
            OnTick
	vector3 v = destination.GetV();
	vector3 p = pos.GetV();
	vector3 dp = v - p; 

	float l = maxSpeed * dtime;
	float d = dp.len();
	if( l > d )
	    l = d;
	dp.norm();
	dp *= l;
	p += dp;
	pos.SetV( p );
	if( d - l < 10.0 )
	    this->Die();
    EndStateMachine
}
