#define N_IMPLEMENTS nCloud
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/ncloud.h"
#include "node/nmeshipol.h"

nNebulaScriptClass(nCloud, "naspect");

//------------------------------------------------------------------------------
/**
*/
nCloud::nCloud():
channelServer( kernelServer, this )
{
}

void nCloud::Initialize(){
    nAspect::Initialize();
    channelServer = "/sys/servers/channel";
}

void nCloud::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    windSpeed.Connect( ent, "windspeed" );
    windSpeed.DefaultV( 1,0,0 );
    changeSpeed.Connect( ent, "changespeed" );
    changeSpeed.DefaultF( 1 );
    shape.Connect( ent, "shape" );
    shape.DefaultF( randF( 0,1 ) );

    nString name;
    //name =  nString(ent->GetVis())+ "/sr/me/mesh";
    //nMeshIpol* mesh = (nMeshIpol*) kernelServer->Lookup(name.Get());
	nMeshIpol* mesh = (nMeshIpol*) ent->GetVis()->Find("sr")->Find("me")->Find("mesh");
    shapeChannel = nString(ent->GetName()) + "shape";
    shapeChannelIndex = channelServer->GenChannel( shapeChannel.Get() );
    n_printf("%s->SetChannel(%s)\n", name.Get(), shapeChannel.Get() );
    ifnonzero( mesh ) 
        mesh->SetChannel(shapeChannel.Get() );
}

nCloud::~nCloud(){
}
//------------------------------------------------------------------------------
/**
*/

void nCloud::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    pos.SetV( pos.GetV() + windSpeed.GetV() * dtime );
    float shp = shape.GetF() + changeSpeed.GetF() * dtime;
    shape.SetF( shp );
    channelServer->SetChannel1f( shapeChannelIndex, shp );
}

