#define N_IMPLEMENTS nEntInfo
//------------------------------------------------------------------------------
//  (C) 2005	Juan
//------------------------------------------------------------------------------
#include "aspect/nentinfo.h"
#include "ui/ntextdisplayer.h"

nNebulaScriptClass(nEntInfo, "nfsm");

//------------------------------------------------------------------------------
nEntInfo::nEntInfo():ref_text(kernelServer,this) {

    ref_text = "/lib/node/text/text";
}

//------------------------------------------------------------------------------
void nEntInfo::Initialize(){
    nFSM::Initialize();

    this->createVisNode(this->fn);

    // Don't display unit info by default
    displayEntInfo.Connect( ent, "displayEntInfo");
    displayEntInfo.DefaultI(0);
    text.Connect( ent, "text");
    text.DefaultS("");

    pos.Connect( ent, "pos" );
    rot.Connect( ent, "rot" );

    // creates a variable on the entity
    pointA.Connect( ent, "pointA");
    pointA.DefaultV(0,0,0);

    targetA.Connect( ent, "targetA");
    targetA.DefaultRef("");
    targetAPos.Connect( targetA, "pos");


    // Initialize camera
    camera.Connect( ent, "camera" );
    camera.DefaultRef("/game/camera");
    cameraPos.Connect( camera, "pos" );
    cameraRot.Connect( camera, "rot" );
}
//------------------------------------------------------------------------------
void nEntInfo::InitVars(){
    nFSM::InitVars();
}
//------------------------------------------------------------------------------
nEntInfo::~nEntInfo(){
}
//------------------------------------------------------------------------------
void nEntInfo::Tick( float time, float dtime ){
    nFSM::Tick( time, dtime );

    vector3 pos;
    if( targetA.isvalid() )     pos = targetAPos.GetV();
    else                        pos = pointA.GetV();
}

bool nEntInfo::Attach(nSceneGraph2* sceneGraph)
{
    float textSize=30;
    bool draw=false;

    int displayInfo=0;
    vector3 pos;

    nString txt="";

    if( targetA.isvalid() )     
    {
        pos = targetAPos.GetV();
        displayInfo=displayEntInfo.GetI();
    }
    else                        
        pos = pointA.GetV();

    // Do the camera math to determine screen position
    matrix44 vrw                = camera.GetRef()->GetM();
    matrix44 vrw_inverted       = vrw;
    vrw_inverted.invert_simple();

    vector3 textPos = vrw_inverted*pos;
    // Normalize text coordinates
    textPos.norm();

    if ( displayInfo == 1 )
    {
        // Draw text if line is in viewing window
        vector2 v(textPos.x, textPos.y);

        if ( v.len() < -textPos.z )
            draw=true;

        if ( draw )
        {
            vector2 v2(textPos.x, textPos.z);

            if ( v2.len() > -textPos.y )
                draw=true;
            else
                draw=false;
        }

        txt.PrintF("%s", text.GetS().Get());
    }

    if ( displayInfo == 1 && draw)
    {
        if(ref_text.isvalid())
        {
            ref_text->SetString(txt.get(), ALIGN_CENTER);
            ref_text->SetOffset(vector3(textPos.x*textSize, textPos.y*textSize+1, -textSize));
            ref_text->Attach(sceneGraph);
        } else {
            n_printf("nLineAspect(%s).ref_text is invalid\n", this->fn);
        }
    }

    this->sceneGraph = sceneGraph;
    this->Process(EVENT_ATTACH, 0, 0);

    return true;
}
