#define N_IMPLEMENTS nHardPointAttach
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nhardpointattach.h"

nNebulaScriptClass(nHardPointAttach, "naspect");

//------------------------------------------------------------------------------
/**
*/
nHardPointAttach::nHardPointAttach()
{
}

void nHardPointAttach::Initialize(){
    nAspect::Initialize();
    mother.Connect( ent, "mother" );
    mother.DefaultRef("");
}

void nHardPointAttach::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    rot.Connect( ent, "rot" );
    vel.Connect( ent, "vel" );
    vel.DefaultV( 0,0,0 );
    rvel.Connect( ent, "rvel");
    rvel.DefaultQ( 0,0,0,0 );
    rotLocal.Connect( ent, "rotlocal" );
    rotLocal.DefaultQ( 0,0,0,1 );
}

nHardPointAttach::~nHardPointAttach(){
    if( hp.isvalid() )
        this->UnAttach();
}
//------------------------------------------------------------------------------

///update my position based up on my local offset, my mothers position, and the offset of my mothers hardpoint
void nHardPointAttach::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( hp.isvalid() ){
        pos.SetV( hp->GetOffsetPos() );
        //n_printf("HardPointAttach::getPos = %s\n", str(pos.GetV()));
        rot.SetQ( rotLocal.GetQ() * hp->GetOffsetRot() );
        vel.SetV( hp->GetVel() );
        rvel.SetQ( hp->GetRVel() );
    }
}

///attempt to attach this entity to another entity - searching for the first available hardpoint
void nHardPointAttach::AttachTo( nEnt* e ){
    n_assert( e );
    classVar(nent, entclass );
    n_assert( e->IsA( entclass ) && "trying to attach to non-ent");
    nRoot* r = e->Find("hardpoints");

    foreachchild( nHardPoint, h, r ) { 
        if( h->Open()){
            //n_printf("%s attaching to %s\n", fn, h->fn );
            this->hp = h;
            h->Attach( ent );           //have it attach my ent
            nEnt* he = h->GetEnt();
            nString s = he->fn;
            //n_printf("s:%s\n", s.Get() );
            mother.SetRef( s.Get() );
            return;
        } else {
            //n_printf( "%s cannot attach to %s, its closed()\n", fn, h->fn );
        }
    }
    n_printf("%s failed to attach\n", fn );
}
