#define N_IMPLEMENTS nSide
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nside.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nSide*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command(units){
    const EntArray* units = self->GetUnits();
    nString unitsString = "";
    //n_printf("Side %s Num Units %i\n", self->GetName(), units->Size() );
    for( int i = 0; i < units->Size(); i ++ ) {
        if( i > 0 )
            unitsString += " ";
        unitsString += units->Get(i)->fn;
    }
        //n_printf("%s\n", units->Get(i)->fn );
    //outi( units->Size() );
    outs( unitsString.Get() );
}
command( setrelationship ){
    const char* side = ins();
    const char* relat = ins();
    self->SetRelationship( side, relat );
}
command( getrelationship ) {
    outi( self->GetRelationship(ins()) );
}
command( addresource ) {
    self->AddResource ( ins() );
}
command ( playerRelationshipsChanged ) {
    self->PlayerRelationshipsChanged( ins() );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("s_units_v", 		'UNIT', 	units );
    clazz->AddCmd("v_setrelationship_ss", 	'SR', 	setrelationship );
    clazz->AddCmd("i_getrelationship_s",                                        'GR',                                   getrelationship );
    clazz->AddCmd("v_addresource_s", 	                                        'AR', 	addresource );
    clazz->AddCmd("v_playerRelationshipsChanged_s",                             'PRC',                                  playerRelationshipsChanged );
    clazz->EndCmds();
}

bool
nSide::SaveCmds(nPersistServer* ps)
{
    if (nAspect::SaveCmds(ps))
    {
        //nCmd* cmd;
        return true;
    }
    return false;
}

