#define N_IMPLEMENTS nTTL
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nttl.h"

nNebulaScriptClass(nTTL, "naspect");

//------------------------------------------------------------------------------
/**
*/
nTTL::nTTL()
{
}

void nTTL::Initialize(){
    nAspect::Initialize();
}

void nTTL::InitVars(){
    nAspect::InitVars();
    timeAlive.Connect( ent, "timeAlive" );
    timeAlive.DefaultF( 0.0f );
    lifetimeRatio.Connect( ent, "lifetimeRatio" );
    lifetimeRatio.DefaultF( 0.0f );
    ttl.Connect( ent, "ttl" );
    ttl.DefaultF( 1.0f );
    startTime = -1.0f;
}

nTTL::~nTTL(){
}
//------------------------------------------------------------------------------
/**
*/

void nTTL::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( startTime < 0.0f )
        startTime = time;
    else {
        timeAlive.SetF( time - startTime );
        lifetimeRatio.SetF( timeAlive.GetF() / ttl.GetF() );
        if( time - startTime > ttl.GetF() )
            ent->Die();
    }
}

