#define N_IMPLEMENTS nVarIpol
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nvaripol.h"

nNebulaScriptClass(nVarIpol, "naspect");

//------------------------------------------------------------------------------
nVarIpol::nVarIpol() {
}
//------------------------------------------------------------------------------
void nVarIpol::Initialize(){
    nAspect::Initialize();
    varTail                             = 0;
    varRoot                             = ent->Find("vars");
}
//------------------------------------------------------------------------------
void nVarIpol::InitVars(){
    nAspect::InitVars();
}
//------------------------------------------------------------------------------
nVarIpol::~nVarIpol(){
}
//------------------------------------------------------------------------------
void nVarIpol::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( varTail != varRoot->GetTail() ){ //we have new vars
        foreachchild( nVar, v, varRoot ) {
            bool found = false;
            for( int i = 0; i < vars; i ++ ) {
                if( vars[i].value.GetVar() == v ) {
                    found = true;
                    break;
                }
            }
            if( !found ){
                const char* name = v->GetName();
                if (strlen(name) < 5) continue;
                const char* nameSuffix = name + strlen(name)-5;
                if (strcmp(nameSuffix, "Error") == 0){
                    //n_printf("new ipol var %s\n", name);
                    VarInfo& vi = vars.Push();
                    char* valueName = n_strdup(name);
                    valueName[strlen(valueName)-5] = '\0';
                    //n_printf("valueName:%s\n", valueName);
                    vi.value.Connect                                             (ent, valueName);
                    vi.error.Connect                                             (ent, name);
                    vi.errorRemaining.set                                        (0,0,0);
                    vi.timeOfLastUpdate                                          = -1.0f;
                    vi.timeBetweenUpdates                                        = 1.0f;
                    vi.type                                                      = v->GetType();
                }
            }
        }
        varTail = varRoot->GetTail();
    }
    for ( int i = 0; i < vars; i ++ ) {
        if ( vars[i].error.isdirty() ){
            vars[i].errorRemaining += vars[i].error.GetV();
            vars[i].error.SetV(0,0,0);            vars[i].error.isdirty();

            //n_printf("new errorRemaining: %s ", str(vars[i].errorRemaining));
            if ( vars[i].timeOfLastUpdate > 0 ) { 
                //vars[i].timeBetweenUpdates = time - vars[i].timeOfLastUpdate;
                vars[i].timeBetweenUpdates = 0.5f;
            }
            vars[i].timeOfLastUpdate = time;
            //n_printf("time:%f timeBetweenUpdates:%f timeOfLastUpdate:%f\n", time, vars[i].timeBetweenUpdates, vars[i].timeOfLastUpdate);
        }
        if ( vars[i].errorRemaining.len() > 0.0f ) { 
            vector3 dpos = vars[i].errorRemaining * dtime / vars[i].timeBetweenUpdates;
            vars[i].errorRemaining -= dpos;
            //n_printf("dpos:%s %f %f\n", str(dpos), dtime, vars[i].timeBetweenUpdates);
            vars[i].value.SetV(vars[i].value.GetV() + dpos);
        }
    }
}
