#define N_IMPLEMENTS nWPAspect
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nwpaspect.h"

nNebulaScriptClass(nWPAspect, "naspect");

//------------------------------------------------------------------------------
/**
*/
nWPAspect::nWPAspect()
{
}

void nWPAspect::Initialize(){
    nAspect::Initialize();
}

void nWPAspect::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    prevwp.Connect (ent, "prevwp" );
    prevwp.DefaultRef("");
    nextwp.Connect (ent, "nextwp" );
    nextwp.DefaultRef("");
    nextwppos.Connect( nextwp, "pos" );
    bearingtonext.Connect( ent, "bearingtonext");
    bearingtonext.DefaultF(0.0);
    distancetonext.Connect( ent, "distancetonext");
    distancetonext.DefaultF(0.0);
}

nWPAspect::~nWPAspect(){
}
//------------------------------------------------------------------------------
/**
*/

void nWPAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    //n_printf("%i, %i\n", nextwp.isvalid(), nextwppos.isvalid() );
    if( nextwp.isvalid() == false ) {
        nRoot* r = ent->GetSucc();
        if( r ) {
            n_assert( r != ent );
            char name[1024];
            r->GetFullName( name, 1024 );
            //n_printf("%s->Nextwp=%s\n", this->fn, name );
            nextwp.SetRef( name );
        } else {
            //n_printf("%s has no next wp\n", ent->fn );
        }
    }
    if( nextwp.isvalid() ) {
        if( nextwp.isdirty() || pos.isdirty() || nextwppos.isdirty() ) {
            //otherwise the if will short on the first is dirty and not check the other 2 -> leading to duplicates
            pos.isdirty();
            nextwppos.isdirty(); 
            //n_printf("%s->recalcing distance\n", this->fn);
            vector3 p = pos.GetV();
            vector3 np = nextwppos.GetV();
            vector3 d = np - p;
            d.y = 0.0f;
            float t = n_rad2deg( atan2( d.x, d.z ) );
            if (t < 0 )
	t += 360.0f;
            bearingtonext.SetF( t );
            distancetonext.SetF( d.len() );
        }
    } else {
            bearingtonext.SetF( 0.0f );
            distancetonext.SetF( 0.0f );
    }

}
