#define N_IMPLEMENTS nChannelHolder
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nchannelholder.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nChannelHolder*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( add1f ) {
    const char* s = ins();
    float f = inf();
    outi( self->Add( s, &f, 1 ) );
}
command( add2f ) {
    const char* s = ins();
    float f[2];
    f[0] = inf();
    f[1] = inf();
    outi( self->Add( s, f, 2 ) );
}
command( add3f ) {
    const char* s = ins();
    float f[3];
    f[0] = inf();
    f[1] = inf();
    f[2] = inf();
    outi( self->Add( s, f, 3 ) );
}
command( add4f ) {
    const char* s = ins();
    float f[4];
    f[0] = inf();
    f[1] = inf();
    f[2] = inf();
    f[3] = inf();
    outi( self->Add( s, f, 4 ) );
}
command( set1f ){
    int i = ini();
    float f = inf();
    self->Set( i, &f, 1 );
}
command( set2f ) {
    int i = ini();
    float f[2];
    f[0] = inf();
    f[1] = inf();
    self->Set( i, f, 2 );
}
command( set3f ) {
    int i = ini();
    float f[3];
    f[0] = inf();
    f[1] = inf();
    f[2] = inf();
    self->Set( i, f, 3 );
}
command( set4f ) {
    int i = ini();
    float f[4];
    f[0] = inf();
    f[1] = inf();
    f[2] = inf();
    f[3] = inf();
    self->Set( i, f, 4 );
}
command(sum){
    outs( self->Sum().Get() );
}


void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("i_add1f_sf", 	'AC1f', add1f );
    clazz->AddCmd("i_add2f_sff", 	'AC2f', add2f );
    clazz->AddCmd("i_add3f_sfff", 	'AC3f', add3f );
    clazz->AddCmd("i_add4f_sffff", 	'AC4f', add4f );
    clazz->AddCmd("v_set1f_if", 	'SC1f', set1f );
    clazz->AddCmd("v_set2f_if", 	'SC2f', set2f );
    clazz->AddCmd("v_set3f_if", 	'SC3f', set3f );
    clazz->AddCmd("v_set4f_if", 	'SC4f', set4f );
    clazz->AddCmd("s_sum_v", 		'SUM', sum );
    clazz->EndCmds();
}

bool
nChannelHolder::SaveCmds(nPersistServer* ps)
{
    if (nVisNode::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}

