#define N_IMPLEMENTS nCommandServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/ncommandserver.h"
#include "enkiduo/nxmlserver.h"

nNebulaScriptClass(nCommandServer, "nthing");

//------------------------------------------------------------------------------
/**
*/
nCommandServer::nCommandServer():
    xml( kernelServer, this ),
    held( 0 )
{
    timeOffset = 0.0f;
}

void nCommandServer::Initialize(){
    nThing::Initialize();
    xml = "/sys/servers/xml";
    commands.initialize( 32 );
    this->AddToTriggerList();
    this->AddLogTag("commandserver");
}

nCommandServer::~nCommandServer(){
}
//------------------------------------------------------------------------------
/**
*/

void nCommandServer::Tick( float time, float dtime ){
    nThing::Tick( time, dtime );
    float commandTime = time - timeOffset;
    if( held )
        timeOffset += time - lastTime;
    while( commands.length() > 0 && commands.topValue() < commandTime ) {
        nString cmd = commands.pop();
        this->ExecCmd( cmd );
    }
    this->lastTime = time;
}

void nCommandServer::AddCmd( nString command ) {
    log("<AddCmd> %s", command.Get() );
    XMLString cmdString; //string for each command
    xml->ParseXML( command.Get() );

    float time = -1.0f;
    while( xml->Next() ) {
        nString type = xml->GetType();
        nString tag  = xml->GetTag();
        nString txt  = xml->GetTxt();
        if( type == "open"  && tag == "command" )
            cmdString == "";

        //duplicate this into the new cmd string
        if( type == "open" )
           cmdString.open( tag.Get(), txt.Get() ) ;
        else
            cmdString.close( tag.Get() );
        
        if( type == "close" && tag == "command" ) {
            log("adding command %f\n%s", time, cmdString.Get() );
            commands.add( time, cmdString );
        }

        //parse time out
        if( type == "open" && tag == "time" ) {
            sscanf( txt.Get(), "%f", &time );
        }
    }
}

void nCommandServer::ExecCmd( nString cmd ) {
    log( "ExecCmd: %s", cmd.Get() );
    nString script;
    script.PrintF("CommandServer::exec {%s}", cmd.Get() );
    RUNSCRIPT( script.Get() );
}

void nCommandServer::ResetTimeOffset(){
    timeOffset = lastTime;
    log("Resetting time offset at time : %f", timeOffset );
}

void nCommandServer::StartHold() { 
    log("StartHold");
    this->held = true;
}
void nCommandServer::StopHold(){ 
    log("StopHold");
    this->held = false; 
}
