#define N_IMPLEMENTS nCubeToVoxels
//------------------------------------------------------------------------------
//  (C) 2004	Jigna Bhatt
//------------------------------------------------------------------------------
#include "enkiduo/ncubetovoxels.h"

nNebulaScriptClass(nCubeToVoxels, "naspect");

//------------------------------------------------------------------------------
/**
*/
nCubeToVoxels::nCubeToVoxels()
{
}

void nCubeToVoxels::Initialize(){
    nAspect::Initialize();
}

void nCubeToVoxels::InitVars(){
    nAspect::InitVars();
}

nCubeToVoxels::~nCubeToVoxels(){
}
//------------------------------------------------------------------------------
/**
*/

void nCubeToVoxels::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
}

/*
   init
   foreach voxel
        if( voxel inside cube )
            voxel = 1
        else 
            voxel = 0
*/
void nCubeToVoxels::Build(){
    matrix44 m;
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/t.dat", m );

    m.ident();
    m.rotate_y( n_deg2rad( 45 ) );
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/tr.dat", m );

    m.ident();
    m.scale( 1.5, 1.5, 1.5 );
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/ts.dat", m );
 
    m.ident();
    m.rotate_x( n_deg2rad( 25 ) );
    m.rotate_y( n_deg2rad( 40 ) );
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/trr.dat", m );

    m.ident();
    m.rotate_x( n_deg2rad( 15 ) );
    m.rotate_y( n_deg2rad( 30 ) );
    m.rotate_z( n_deg2rad( 45 ) );
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/trrr.dat", m );


    m.ident();
    m.scale( .5, .5, .5 );
    m.rotate_y( n_deg2rad( 25 ) );
    m.rotate_y( n_deg2rad( 40 ) );
    m.rotate_y( n_deg2rad( 15 ) );
    m.set_translation( 25, 25, 25 );
    Build( "/home/miles/set1/c/trrrs.dat", m );
}

void nCubeToVoxels::Build( const char* filename, matrix44 transformations){
    transformations.invert();
    const int w = 100, h = 100, d = 100;
    int voxels[w][h][d];
    memset( voxels, 0, sizeof(int) * w * h * d );
    vector3 cubeSize( 10, 10, 10 );
       
	vector3 temp;
	int x, y, z;
    for (x = 0; x < w; x ++){
        for ( y = 0; y < h; y ++){
            for ( z = 0; z < d; z ++){
	temp.set(x, y, z);
	//n_printf("(%f,%f,%f)->", temp.x, temp.y, temp.z );
	temp = transformations * temp;
	//n_printf("(%f,%f,%f)\n", temp.x, temp.y, temp.z );
	if(abs(temp.x) < cubeSize.x && abs(temp.y) < cubeSize.y && abs(temp.z) < cubeSize.z)
	    voxels[x][y][z] = 1;
	else
	    voxels[x][y][z] = 0;
            }
        }
    }
	
    FILE * fout = fopen ( filename, "w");
    n_assert(fout);
    fprintf(fout, "%i %i %i\n", w, h, d);
    for (x = 0; x < w; x ++)
        for ( y = 0; y < h; y ++)
            for ( z = 0; z < d; z ++)
	fprintf(fout, "%i ", voxels[x][y][z]);
    fclose( fout );
}



