#define N_IMPLEMENTS nDisplayer
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/ndisplayer.h"
#include "gfx/nglserver.h"

nNebulaScriptClass(nDisplayer, "nthing");

//------------------------------------------------------------------------------
nDisplayer::nDisplayer() {
    this->clearLines = false;
}
//------------------------------------------------------------------------------
void nDisplayer::Initialize(){
    nThing::Initialize();
    this->AddToDisplayList();
}
//------------------------------------------------------------------------------
nDisplayer::~nDisplayer(){
}
//------------------------------------------------------------------------------
void nDisplayer::updateDisplay( ){
    this->linesToDraw.Clear();
    for( int i = 0; i < contexts; i ++ ){
        Context& context = contexts[i];
        for( int j = 0; j < context.lines; j ++ ) {
            LineInfo& line = context.lines[j];
            this->DrawLine( line.a, line.b, line.colour );
        }
        for( int j = 0; j < context.angles; j ++ ) {
            AngleInfo& angle = context.angles[j];
            this->DrawAngle( angle.pos, angle.heading, angle.colour, angle.length );
        }
        for( int j = 0; j < context.points; j ++ ) {
            PointInfo& point = context.points[j];
            this->DrawPoint( point.pos, point.colour, point.size.x, point.size.y, point.size.z );
        }
        for( int j = 0; j < context.circles; j ++ ) {
            CircleInfo& circle = context.circles[j];
            this->DrawCircle( circle.pos, circle.colour, circle.radius );
        }
        for( int j = 0; j < context.spheres; j ++ ) {
            SphereInfo& sphere = context.spheres[j];
            this->DrawSphere( sphere.pos, sphere.colour, sphere.radius );
        }
    }
}
//-----------------------------------------------------------------------------//
void nDisplayer::Display( nGfxServer* gfx ) {
    glLineWidth(1.0f);
    nThing::Display( gfx );
    glLineWidth(1.5f);
}
