#define N_IMPLEMENTS nPathfinder
//------------------------------------------------------------------------------
//  (C) 2004    Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/npathfinder.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nPathfinder*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB


command( findpath ) {
    vector3 from, to;
    from.x = inf();
    from.y = inf();
    from.z = inf();
    to.x = inf();
    to.y = inf();
    to.z = inf();
    self->FindPath( from, to );
}
command( calculatecoords )        {   self->CalculateCoords();                }
command( setrc )                {    self->SetRC(inf());                        }
command( getrc )                {    outf( self->GetRC());                    }
command( clear )                {    self->Clear();                            }
command( setdrawcoords )        {    self->SetDrawCoords( inb() );            }    
command( getdrawcoords )        {    outb( self->GetDrawCoords());            }
command( setdrawedges )            {    self->SetDrawEdges( inb() );            }
command( getdrawedges )            {    outb( self->GetDrawEdges());            }
command( setdrawpath )            {    self->SetDrawPath( inb() );                }
command( getdrawpath )            {    outb( self->GetDrawPath());             }
command( setdrawspheres )        {    self->SetDrawSpheres( inb() );            }
command( getdrawspheres )        {    outb( self->GetDrawSpheres());            }
command( setcoorddensity )        {    self->SetCoordDensity( inf() );            }
command( getcoorddensity )        {    outf( self->GetCoordDensity() );        }
command( setedgelengththreshold){    self->SetEdgeLengthThreshold( inf() );    }
command( getedgelengththreshold){    outf( self->GetEdgeLengthThreshold() );    }
command( setedgecostthreshold )    {    self->SetEdgeCostThreshold( inf() );    }
command( getedgecostthreshold ) {    outf( self->GetEdgeCostThreshold() );    }
command( setusedetectionrange )    {    self->SetUseDetectionRange( inb() );    }
command( getusedetectionrange )    {    outb( self->GetUseDetectionRange());     }
command( setuseeffectiverange )    {    self->SetUseEffectiveRange( inb() );    }
command( getuseeffectiverange )    {    outb( self->GetUseEffectiveRange());     }
command( cacheall )                {    self->CacheAll();                }

void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_calculatecoords_v",        'CC',    calculatecoords) ;
    clazz->AddCmd("v_clear_v",                    'C',    clear );
    clazz->AddCmd("v_findpath_ffffff",            'FR',    findpath );
    clazz->AddCmd("v_setrc_f",                    'SRC',    setrc );
    clazz->AddCmd("f_getrc_v",                    'GRC',    getrc );
    clazz->AddCmd("v_setdrawcoords_b",            'SDC',    setdrawcoords );
    clazz->AddCmd("b_getdrawcoords_v",            'GDC',    getdrawcoords );
    clazz->AddCmd("v_setdrawedges_b",            'SDE',    setdrawedges );
    clazz->AddCmd("b_getdrawedges_v",            'GDE',    getdrawedges );
    clazz->AddCmd("v_setdrawpath_b",            'SDP',    setdrawpath );
    clazz->AddCmd("b_getdrawpath_v",            'GDP',    getdrawpath );
    clazz->AddCmd("v_setdrawspheres_b",            'SDS',    setdrawspheres );
    clazz->AddCmd("b_getdrawspheres_v",            'GDS',    getdrawspheres );
    clazz->AddCmd("v_setcoorddensity_f",        'SCD',  setcoorddensity );
    clazz->AddCmd("f_getcoorddensity_v",        'GCD',  getcoorddensity );
    clazz->AddCmd("v_setedgelengththreshold_f", 'SELT', setedgelengththreshold );
    clazz->AddCmd("f_getedgelengththreshold_v", 'GELT', getedgelengththreshold );
    clazz->AddCmd("v_setedgecostthreshold_f"  , 'SECT', setedgecostthreshold );
    clazz->AddCmd("f_getedgecostthreshold_v",    'GECT', getedgecostthreshold );
    clazz->AddCmd("v_setusedetectionrange_b"  , 'SUDR', setusedetectionrange );
    clazz->AddCmd("b_getusedetectionrange_v",    'GUDR', getusedetectionrange );
    clazz->AddCmd("v_setuseeffectiverange_b"  , 'SUER', setuseeffectiverange );
    clazz->AddCmd("b_getuseeffectiverange_v",    'GUER', getuseeffectiverange );

    clazz->AddCmd("v_cacheall_v",    'CA', cacheall );
    clazz->EndCmds();
}

    bool
nPathfinder::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        //        nCmd* cmd;
        return true;
    }
    return false;
}

