#define N_IMPLEMENTS nSocket
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nsocket.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nSocket*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB


command( setport ){
    self->SetPort( ini() );
}
command( getport ){
    outi( self->GetPort() );
}
command( openserversocket ){
    self->OpenServerSocket();
}
command( connect ){
    outb( self->Connect( ins() ) );
}
command( disconnect ) {
    self->Disconnect();
}
command( send ) {
    const char* tag = ins();
    const char* msg = ins();
    self->Send( tag, msg );
}
command( sendto ) {
    int destinationHandle = ini();
    const char* tag = ins();
    const char* msg = ins();
    self->Send( destinationHandle, tag, msg );
}
command( addcallback ) {
    const char* tag 	= ins();
    const char* nodeName 	= ins();
    const char* funcName 	= ins();
    self->AddCallback( tag, nodeName, funcName );
}
command( addconnectiondiedcallback ) {
    const char* nodeName 	= ins();
    const char* funcName 	= ins();
    self->AddConnectionDiedCallback( nodeName, funcName );
}
command( addfromcallback ) {
    const char* tag 	= ins();
    const char* nodeName 	= ins();
    const char* funcName 	= ins();
    self->AddCallback( tag, nodeName, funcName, 1 );
}
command( dummy ) {
    n_printf("DUMMY yay : %s\n", ins() );
}
command( receiveiam ) {
    int i = ini();
    const char* s = ins();
    self->ReceiveIAM( i, s );
}
command( setname ) {
    self->SetName( ins() );
}
command( receiveping ) {
    self->ReceivePing( ins() );
}
command( receiveputs ) {
    self->ReceivePuts( ins() );
}
command( receivescript ) {
    self->ReceiveScript( ins() );
}

void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_setport_i", 	'SP', 	setport 	);
    clazz->AddCmd("i_getport_v", 	'GP', 	getport 	);
    clazz->AddCmd("v_openserversocket_v", 	'OSS', 	openserversocket);
    clazz->AddCmd("b_connect_s", 	'C', 	connect 	);
    clazz->AddCmd("v_disconnect_v", 	'DC', 	disconnect 	);
    clazz->AddCmd("v_send_ss", 		'SEND', 	send 	);
    clazz->AddCmd("v_sendto_iss", 	'SNDT', 	sendto 	);
    clazz->AddCmd("v_addcallback_sss", 	'ACB', 	addcallback 	);
    clazz->AddCmd("v_addconnectiondiedcallback_ss", 'ADCB', 	addconnectiondiedcallback );
    clazz->AddCmd("v_addfromcallback_sss", 	'AFCB', 	addfromcallback );
    clazz->AddCmd("v_dummy_s", 		'DUMY', 	dummy 	);
    clazz->AddCmd("v_setname_s",	'SN', 	setname 	);
    clazz->AddCmd("v_receiveiam_is",	'RIAM', 	receiveiam 	);
    clazz->AddCmd("v_receiveping_s",	'RPNG', 	receiveping 	);
    clazz->AddCmd("v_receiveputs_s",	'RPTS', 	receiveputs 	);
    clazz->AddCmd("v_receivescript_s", 	'RSC', 	receivescript 	);
    clazz->EndCmds();
}

bool
nSocket::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}

