#define N_IMPLEMENTS nTriggerServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/ntriggerserver.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nTriggerServer*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( settimestep ){
    self->SetTimeStep( inf() );
}
command( gettimestep ){
    outf( self->GetTimeStep() );
}
command( settimescale ){
    self->SetTimeScale( inf() );
}
command( gettimescale ){
    outf( self->GetTimeScale() );
}
command( setmaxtimesteps ){
    self->SetMaxTimeSteps( ini() );
}
command( getmaxtimesteps ){
    outi( self->GetMaxTimeSteps() );
}
command( jumptime ) {
    self->JumpTime( inf() );
}
void n_initcmds(nClass* clazz){
    clazz->BeginCmds();
    clazz->AddCmd("v_settimestep_f", 'STSP', settimestep );
    clazz->AddCmd("f_gettimestep_v", 'GTSP', gettimestep );
    clazz->AddCmd("v_settimescale_f", 'STS', settimescale );
    clazz->AddCmd("f_gettimescale_v", 'GTS', gettimescale );
    clazz->AddCmd("v_setmaxtimesteps_i", 'SMTS', setmaxtimesteps );
    clazz->AddCmd("i_getmaxtimesteps_v", 'GMTS', getmaxtimesteps );
    clazz->AddCmd("v_jumptime_f", 'JMPT', jumptime );
    clazz->EndCmds();
}

bool nTriggerServer::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        //        nCmd* cmd;
        return true;
    }
    return false;
}

