#define N_IMPLEMENTS nCaseExtractor
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ncaseextractor.h"
#include "ga/ngenome.h"

nNebulaScriptClass(nCaseExtractor, "naspect");

//------------------------------------------------------------------------------
/**
*/
nCaseExtractor::nCaseExtractor()
{
    this->AddLogTag("ga caseextractor");
}

void nCaseExtractor::Initialize(){
    nAspect::Initialize();
}

void nCaseExtractor::InitVars(){
    nAspect::InitVars();
    numgens.Connect( ent, "numgens" );
    generation.Connect( ent, "generation" );
}

nCaseExtractor::~nCaseExtractor(){
}

void nCaseExtractor::Tick( float time, float dtime ) {
    nAspect::Tick( time, dtime );
}
//------------------------------------------------------------------------------
/**
  does case extraction
  every generation it checks to see if the genome in rank 0 - the best - is from the current generation
  if so then it is newly modified - so save it to the casebase
*/
void nCaseExtractor::Extract( const char* s ){ 
    classVar( ngenome, genomeClass );
    log("Extract(%s) gen=%i", s, generation.GetI() );
    nRoot* root = kernelServer->Lookup("/ga/ga");
    for( nRoot* r = root->GetHead(); r; r = r->GetSucc() ) {
        if( r->IsA(genomeClass) == false ) {
            n_printf( "a non genome has snuck into the population" );
            continue;
        }
        nGenome* g = (nGenome*) r;
        int rank = g->GetRank();
        log("genome:%s has rank:%i", g->fn, rank );
        if( rank == 0 ) {
            log("genome:%s has pole place", g->fn );
            int gen = g->GetGenModified();
            int currentGeneration = generation.GetI();
            log("gen:%i current:%i", gen, currentGeneration );
            if( gen == (currentGeneration-1) ) {
	log("saving to casebase");
	nString script;
	script.PrintF("CaseBase::extract %s", g->fn );
	RUNSCRIPTD(script.Get() );
            }
        }
    }
}
