#define N_IMPLEMENTS nGAOPS
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ngaops.h"
#include "ga/nga.h"

nNebulaScriptClass(nGAOPS, "ngaproblem");

//------------------------------------------------------------------------------
/**
*/
nGAOPS::nGAOPS():
    platformEntRoot 	( kernelServer, this ),
    targetEntRoot   	( kernelServer, this )
{
    this->AddLogTag("gaops");
    this->AddToTriggerList();
}

void nGAOPS::Initialize(){
    nGAProblem::Initialize();
    platformEntRoot         	= "/game/ents/platform";
    targetEntRoot           	= "/game/ents/target";
}

void nGAOPS::InitVars(){
    nGAProblem::InitVars();
}

nGAOPS::~nGAOPS(){
}
//------------------------------------------------------------------------------
/**
*/

void nGAOPS::Tick( float time, float dtime ){
    if( active ) {
        if( IsEvaluationDone() ){
            RUNSCRIPTD("Event evaluationDone");
            this->active = false;
        }
    }
}

bool nGAOPS::IsEvaluationDone(){
    nRoot *platform, *aiRoot, *ai;
    int numRunning = 0;
    ifvalid( platformEntRoot ) 
    for ( platform = platformEntRoot->GetHead(); platform; platform = platform->GetSucc() ){
        aiRoot = platform->Find("ai");
        if( aiRoot ) for ( ai = aiRoot->GetHead(); ai; ai = ai->GetSucc() )
            if( ((nThing*)ai)->IsAlive() )
	numRunning++;
    }
    log("%i", numRunning == 0 );
    return ( numRunning == 0 );
}

void nGAOPS::ParseFitness( float& damageBlue, float& damageRed, float& distancePenalty) {
    log ("<nGAOps::DoneEvaluation>" );
    //return plan.toString();
    double fitnessParsingStart = time->GetTime();
    float fitness = 0;
    damageBlue = 0.0f;
    damageRed = 0.0f;

    float totalDistanceTraveled = 0;
    ifvalid( targetEntRoot ) for ( nEnt* target = (nEnt*) targetEntRoot->GetHead(); target; target = (nEnt*) target->GetSucc() ){
        float value = target->GetVarF("value");
        float hp = target->GetVarF("hp");
        float damageDone = (1.0f - hp) * value;
        log("target  : %20s v:%f h:%f d:%f", target->fn, value, hp, damageDone );
        damageRed += damageDone;
    }
    ifvalid( platformEntRoot) for ( nEnt* platform= (nEnt*) platformEntRoot->GetHead(); platform; platform = (nEnt*) platform->GetSucc() ){
        float value = platform->GetVarF("value");
        float hp = platform->GetVarF("hp");
        float distanceTraveled= platform->GetVarF("distancetraveled");
        totalDistanceTraveled += distanceTraveled;
        float damageDone = (1.0f - hp) * value;
        log("platform: %20s v:%f h:%f d:%f dist:%f", platform->fn, value, hp, damageDone, distanceTraveled );
        damageBlue += damageDone;
    }
    distancePenalty = totalDistanceTraveled * .01f;
    fitness = damageRed - damageBlue - distancePenalty;
    log("fitness: %f damageBlue: %f damageRed: %f distancePenalty: %f\n", fitness, damageBlue, damageRed, distancePenalty );
    log ("</nGAOps::DoneEvaluation>" );
}

