#define N_IMPLEMENTS nGASlave
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ngaslave.h"

nNebulaScriptClass(nGASlave, "nga");

//------------------------------------------------------------------------------
/**
*/
nGASlave::nGASlave():
    genome(0),
    alloc(0),
    socket( kernelServer, this )
{
    socket = "/sys/servers/socket";
    AddLogTag("gaslave");
}

void nGASlave::Initialize(){
    nGA::Initialize();
}

void nGASlave::InitVars(){
    nGA::InitVars();
    this->running = true;
    //BuildEncoding();
}

nGASlave::~nGASlave(){
}
//------------------------------------------------------------------------------
/**
*/
void nGASlave::BuildEncoding(){
    nGA::BuildEncoding();
    if( genome )
        genome->Release();
    genome = (nGenome*) sampleEncoding->Clone("/ga/pop/genome0");
    alloc = genome->GetChild(0);
}
void nGASlave::ReceiveSituation ( nString s ){
    log("nGASlave::ReceiveSitaution(%s)", firstLine(s.Get())  );
    printf("nGASlave::ReceiveSituation()\n");
    this->SetSituation( s.Get() );
    printf("nGASlave::send(slaveReady)\n");
    socket->Send("slaveready", "hi");
}
void nGASlave::ReceiveDie( const char* msg ){
    log("nGASlave::ReceiveDie(%s)", msg );
    RUNSCRIPT("quit");
}
void nGASlave::ReceiveEvaluate( nString msg ){
    log("nGASlave::ReceiveEvaluate(%s)", msg.Get() );
    float rc = -1.0f;
    int allocSize = -1;
    char* m = (char*) msg.Get();

    int index = 0;
    while( char* s = strtok_r( 0, " ", &m ) ) {
        log("s:%s m: %s", s, m );
        switch( index ){
            case 0:
	n_assert( rc == -1.0f );
	rc = atof( s );
	break;
            case 1:
	allocSize = atoi( s );
	break;
            default:
	alloc->GetChild(index-2)->SetE( atoi(s) );
	break;
        }
        index++;
    }
    genome->GetChild(1)->SetF( rc );
    this->StartEvaluation( genome );
}

/**
  Evaluation has finished
  send the fitness back to the master
*/
void nGASlave::DoneEvaluating( int individual, float fitness ){
    this->evaluating = false;
    log("nGASlave::DoneEvaluating(%i,%f)", individual, fitness );
    nString msg;
    msg.PrintF("%f", fitness );
    socket->Send("fitness",  msg.Get() );
    msg.PrintF( "%.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f", times.routing, times.loadingMission, times.loadingPlan, times.genomeToPlan, times.parsingFitness, times.loading, times.evaluation, times.running, times.evaluationStarted, times.evaluationStopped, times.runningStarted, times.runningStopped );
    //printf("Evaluation Times:%s\n", msg.Get() );
    socket->Send("profiling", msg.Get() );
    this->StopEvaluation();
}

/**
  connection has died
  if its my master
  kill myself..cuz i just cant live without him
*/
void nGASlave::ConnectionDied( int handle ){
    RUNSCRIPT("/sys/servers/game.stop");
}
///master has told me to stop evaluating
void nGASlave::ReceiveAbortEvaluation( const char* msg ){
    n_printf("aborting evaluation\n");
    this->evaluating = false;
    socket->Send("slaveaborted", "hi");
    this->StopEvaluation();
}
