#define N_IMPLEMENTS nGeneFloat
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ngenefloat.h"
#include "ga/ngenome.h"

nNebulaScriptClass(nGeneFloat, "ngene");

//------------------------------------------------------------------------------
nGeneFloat::nGeneFloat() {
}
//------------------------------------------------------------------------------
void nGeneFloat::Initialize(){
    nGene::Initialize();
}
//------------------------------------------------------------------------------
void nGeneFloat::InitVars(){
    nGene::InitVars();
}
//------------------------------------------------------------------------------
nGeneFloat::~nGeneFloat(){
}
//------------------------------------------------------------------------------
void nGeneFloat::Tick( float time, float dtime ){
    nGene::Tick( time, dtime );
}

/**
 * figure out how many bits I need and get them
 **/
void nGeneFloat::InitF( float min, float max, float precision ) {
    this->min = min;
    this->max = max;
    this->precision = precision;
    float range = fabs(max-min);
    float p = range;
    this->numBits = 1;
    while( p > precision ) {
        this->numBits++;
        p /= 2.0;
    }
    //n_printf("nGeneFloat::InitFloat(%f,%f,%f)->%i\n", min, max, precision, numBits);
    //now we should requisition that many bits from the genome
    this->UpdateBits();
}
/**
 * convert my bits into the appropriate float and return it
 **/
float nGeneFloat::GetF(){
    float range = this->max - this->min;
    float val = this->min;
    //n_printf("bithandle: %i numbits: %i bits: ", this->bitHandle, this->numBits );
    for( int i = 0; i < numBits; i ++ ) {
        range /= 2.0f;
        if ( genome->GetBit( this->bitHandle + i)) {
            //n_printf("1");
            val += range;
        } 
        //else
            //n_printf("0");
    }
    //n_printf("\n");
    //n_printf("val:%f\n", val);
    n_assert( val >= this->min && val < this->max );
    return val;
}
