#define N_IMPLEMENTS nGeneInt
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ngeneint.h"
#include "ga/ngenome.h"

nNebulaScriptClass(nGeneInt, "ngene");

//------------------------------------------------------------------------------
nGeneInt::nGeneInt() {
}
//------------------------------------------------------------------------------
void nGeneInt::Initialize(){
    nGene::Initialize();
}
//------------------------------------------------------------------------------
void nGeneInt::InitVars(){
    nGene::InitVars();
}
//------------------------------------------------------------------------------
nGeneInt::~nGeneInt(){
}
//------------------------------------------------------------------------------
void nGeneInt::Tick( float time, float dtime ){
    nGene::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
///figure out how many bits I need and get them
//-----------------------------------------------------------------------------//
void nGeneInt::InitI( int min, int max, int precision ) {
    n_assert( precision && "cant have 0 precision" );
    this->min = min;
    this->max = max;
    this->precision = precision;
    int range = abs(max-min);
    int valsCovered = precision * 2;
    this->numBits = 1;
    //n_printf("range:%i\n", range );
    while( valsCovered < range ) {
        this->numBits++;
        valsCovered *= 2;
        //n_printf("bits:%i valsCovered:%i\n", numBits, valsCovered );
    }
    //n_printf("nGeneInt::InitI(%i,%i,%i)->%i\n", min, max, precision, numBits);
    //now we should requisition that many bits from the genome
    this->UpdateBits();
}
//-----------------------------------------------------------------------------//
/// convert my bits into the appropriate int and return it
//-----------------------------------------------------------------------------//
int nGeneInt::GetI(){
    //int range = this->max - this->min;
    int val = this->min;
    int bitVal = 1;
    //n_printf("bithandle: %i numbits: %i min:%i max:%i bits: ", this->bitHandle, this->numBits , this->min, this->max );
    for( int i = numBits-1; i >= 0; i-- ) {
        //n_printf("%i-%i-%i ", i, genome->GetBit(this->bitHandle+i), bitVal);
        if (genome->GetBit(this->bitHandle + i)) {
            //n_printf(" true ");
            val += bitVal;
        }
        bitVal *= 2.0f;
    }
    //n_printf("\n");
    //n_printf("val:%i\n", val);
    while ( val >= max )
        val -= (max-min);
    //n_printf("val:%i\n", val);
    n_assert( val >= this->min && val < this->max );
    return val;
}
