#define N_IMPLEMENTS nTTTGA
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ntttga.h"
#include "ga/ngenefloat.h"
#include "ga/ngenome.h"
#include "enkiduo/neventserver.h"

nNebulaScriptClass(nTTTGA, "nga");

//------------------------------------------------------------------------------
nTTTGA::nTTTGA() {
    slaveClassName = "ntttga";
}
//------------------------------------------------------------------------------
void nTTTGA::Initialize(){
    nGA::Initialize();
}
//------------------------------------------------------------------------------
void nTTTGA::InitVars(){
    nGA::InitVars();
    this->updateCounter = 0;
}
//------------------------------------------------------------------------------
nTTTGA::~nTTTGA(){
}
//------------------------------------------------------------------------------
void nTTTGA::Tick( float time, float dtime ){
    nGA::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
/**
 * each genome encodes the table of values representing how good each point is
 * this is just a buncha floats - 10 to be precise for each possible row state, we can map between -1 and 1
 */
void nTTTGA::CreateGenome( nGenome* g ){
    n_printf("nTTTGA(%s).CreateGenome(%s)\n", str(this), str(g));
    for( int i = 0; i < 10; i ++ ) {
        nString varName;
        varName.PrintF("reward:%i", i );
        ((nGeneFloat*) g->CreateChild("ngenefloat", varName.Get()))->InitF(-1, 1, .01);
    }
}
//-----------------------------------------------------------------------------//
void nTTTGA::StartEvaluation( nGenome* g ){
    n_printf("nTTTGA(%s).StartEvaluation(%s)\n", str(this), str(g));
    //okay so i need to pass these floats to the ttt python module
    nString rewards;
    rewards.PrintF("%s:%i:", this->GetName(), this->updateCounter++ );
    bool first = true;
    foreachchild(nGeneFloat, rewardGene, this->slaveGenome ){
        if ( first == false )
            rewards += ";";
        first = false;
        nString rewardString;
        rewardString.PrintF("%f", rewardGene->GetF());
        rewards += rewardString;
    }
    static void* eventPtr;
    ref_event->pull( eventPtr, "setTTTRewards", rewards.Get() );
    returnedFitness = -1.0f;
    this->isFitnessReturned = false;
}
//-----------------------------------------------------------------------------//
bool nTTTGA::EvaluationFinished(){
    //n_printf("nTTTGA(%s)::EvaluationFinished() = %i\n", str(this), this->isFitnessReturned);
    return this->isFitnessReturned;
}
//-----------------------------------------------------------------------------//
/**
 * okay so how do we compute fitness
 * okay well we just check the allocation
 **/
float nTTTGA::GetFitness(){
    return this->returnedFitness;
}
//-----------------------------------------------------------------------------//
void nTTTGA::ReturnFitness( float f ) {
    n_printf("fitness returned as: %f\n", f );
    this->returnedFitness = f;
    this->isFitnessReturned = true;
}
