#define N_IMPLEMENTS nEntVicinityIM
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nentvicinityim.h"
#include "aspect/nside.h"

nNebulaScriptClass(nEntVicinityIM, "nim");

//------------------------------------------------------------------------------
nEntVicinityIM::nEntVicinityIM() {
}
//------------------------------------------------------------------------------
void nEntVicinityIM::Initialize(){
    nIM::Initialize();
}
//------------------------------------------------------------------------------
void nEntVicinityIM::InitVars(){
    nIM::InitVars();
    sideWatching.Connect                (ent, "sideWatching");
    radius.Connect                      (ent, "radius");     
    sideWatching.DefaultRef             ("/game/side/grey");
    radius.DefaultF                     (300.0f);
}
//------------------------------------------------------------------------------
nEntVicinityIM::~nEntVicinityIM(){
}
//------------------------------------------------------------------------------
void nEntVicinityIM::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
/// okay so now we want to calculate our values
//-----------------------------------------------------------------------------//
void nEntVicinityIM::calculateValues(void * v){
    //n_printf("nEntVicinityIM(%s)::calculateValues()\n", this->fn);
    float r                             = radius.GetF();
    vector3 wmin                        = worldMin.GetV();
    vector3 wmax                        = worldMax.GetV();
    int res                             = resolution.GetI();
    this->clearVals();
    n_assert( res );
    n_assert( sideWatching.isvalid() );
    ifvalid( sideWatching ){
        nEnt* sideEnt                   = (nEnt*) sideWatching.GetRef();
        nSide* side                     = dynamic_cast<nSide*> (sideEnt->Find("side") );
        n_assert( side );
        ifnonzero(side){
            const EntArray* ents        = side->GetUnits();
            //n_printf("number of ents: %i\n", ents->Size() );
            for( int i = 0; i < ents->Size(); i ++ ) {
                nEnt* e                 = ents->Get(i);
                vector3 pos             = e->GetVarV("pos");
                float value             = e->GetVarF("value");
                //now what, find the min / max positions
                vector3 min             = pos - vector3(r,0,r);
                vector3 max             = pos + vector3(r,0,r);
                int minx                = int(floor((min.x - wmin.x) / squareSize.x ));
                int minz                = int(floor((min.z - wmin.z) / squareSize.z ));
                int maxx                = int(ceil ((max.x - wmin.x) / squareSize.x ));
                int maxz                = int(ceil ((max.z - wmin.z) / squareSize.z ));
                if( minx < 0 ) minx     = 0;                                    if( minx >= res ) minx  = res-1;
                if( minz < 0 ) minz     = 0;                                    if( minz >= res ) minz  = res-1;
                if( maxx < 0 ) maxx     = 0;                                    if( maxx >= res ) maxx  = res-1;
                if( maxz < 0 ) maxz     = 0;                                    if( maxz >= res ) maxz  = res-1;
                n_assert( minz >= 0 );
                n_assert( minz >= 0 );
                n_assert( minx < res );
                n_assert( minz < res );
                for( int x = minx; x < maxx; x ++ ) {
                    for( int z = minz; z < maxz; z ++ ) {
                        float d = (points[x][z] - pos).len();
                        if( d > r ) continue;                                   //error between the square min/max area and the actual circuler area
                        float rat = d / r;
                        rat = 1.0f - rat;
                        float points = rat * value;
                        n_assert( points >= 0.0f );
                        vals[x][z] += points;
                    }
                }
            }
        }
    }
}
