#define N_IMPLEMENTS nIMDuo
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimduo.h"

nNebulaScriptClass(nIMDuo, "nim");

//-----------------------------------------------------------------------------//
nIMDuo::nIMDuo() {
}
//-----------------------------------------------------------------------------//
void nIMDuo::Initialize(){
    nIM::Initialize();
}
//-----------------------------------------------------------------------------//
void nIMDuo::InitVars(){
    nIM::InitVars();
    im1.Connect                         ( ent, "im1" );
    im2.Connect                         ( ent, "im2" );
    op.Connect                          ( ent, "op" );
    im1coef.Connect                     ( ent, "im1coef" );
    im2coef.Connect                     ( ent, "im2coef" );
    im1.DefaultS                        ( "none" );
    im2.DefaultS                        ( "none" );
    op.DefaultS                         ( "add");
    im1coef.DefaultF                    ( 1.0f );
    im2coef.DefaultF                    ( 1.0f );
}
//-----------------------------------------------------------------------------//
nIMDuo::~nIMDuo(){
}
//-----------------------------------------------------------------------------//
void nIMDuo::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
    if( im1.isdirty() ) {
        im1Ptr = dynamic_cast<nIM*>( ent->Find(im1.GetS().Get()) );
        if( im1Ptr ) {
            im1Ptr->Tick( time, dtime ); //the other two need to calc there vals before we calc ours
            this->valsDirty = true;
        }
    }
    if( im2.isdirty() ) {
        im2Ptr = dynamic_cast<nIM*>( ent->Find(im2.GetS().Get()) );
        if( im2Ptr ) {
            im2Ptr->Tick( time, dtime );
            this->valsDirty = true;
        }
    }
    if( op.isdirty() ) {
        this->valsDirty = true;
    }
}
//-----------------------------------------------------------------------------//
float c1, c2;
float add( float l, float r ) { return (c1*l) + (c2*r); }
float sub( float l, float r ) { return (c1*l) - (c2*r); }
float mul( float l, float r ) { return (c1*l) * (c2*r); }
float div( float l, float r ) { return (c1*l) / (c2*(r != 0? r:1.00f)); }
//-----------------------------------------------------------------------------//
void nIMDuo::calculateValues(){
    //n_printf("nIMDuo::calculateValues()\n");
    n_assert( im1Ptr && im2Ptr );
    nString o = op.GetS();
    float (*func)(float l, float r);
    c1 = im1coef.GetF();
    c2 = im2coef.GetF();
         if ( o == "add" ) func = add;
    else if ( o == "sub" ) func = sub;
    else if ( o == "mul" ) func = mul;
    else if ( o == "div" ) func = div;
    for( int x = 0; x < res; x ++ ) {
        for( int y = 0; y < res; y ++ ) {
            float l = im1Ptr->getVal(x,y);
            float r = im2Ptr->getVal(x,y);
            vals[x][y] = func( l, r );
        }
    }
}
//-----------------------------------------------------------------------------//
