#define N_IMPLEMENTS nIMEnt
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/niment.h"
#include "kernel/npersistserver.h"
#ifdef _CLASSNAME
#error shouldnt be compiling to cmds files together
#undef _CLASSNAME
#endif

#define _CLASSNAME nIMEnt
#include "enkiduo/cmdsMacros.h"
command( setfunc )                      { self->SetFunc(ins()); }
command( getfunc )                      { outs( self->GetFunc() ); }
command( setipol )                      { self->SetIpol(ins());}
command( getipol )                      { outs( self->GetIpol() ); }
command( setradius )                    { self->SetRadius(ins()); }
command( getradius )                    { outs( self->GetRadius() ); }
command( setwho )                       { self->SetWho(ins());}
command( getwho )                       { outs( self->GetWho() ); }
command( setradiuscoef )                { self->SetRadiusCoef(inf()); }
command( getradiuscoef )                { outf( self->GetRadiusCoef()); } 
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_setfunc_s", 'SFUN', setfunc );
    clazz->AddCmd("v_setipol_s", 'SIPL', setipol );
    clazz->AddCmd("v_setradius_s", 'SRDS', setradius );
    clazz->AddCmd("v_setwho_s", 'SWHO', setwho );
    clazz->AddCmd("v_setradiuscoef_f", 'SRCF', setradiuscoef );

    clazz->AddCmd("s_getfunc_v", 'GFUN', getfunc );
    clazz->AddCmd("s_getipol_v", 'GIPL', getipol );
    clazz->AddCmd("s_getradius_v", 'GRAD', getradius );
    clazz->AddCmd("s_getwho_v", 'GWHO', getwho );
    clazz->AddCmd("f_getradiuscoef_v", 'GRCF', getradiuscoef );
    clazz->EndCmds();
}

bool
nIMEnt::SaveCmds(nPersistServer* ps)
{
    if (nIM::SaveCmds(ps))
    {
        nCmd* cmd;
        cmd = ps->GetCmd( this, 'SFUN');
        cmd->In()->SetS( this->GetFunc() );
        ps->PutCmd( cmd );

        cmd = ps->GetCmd( this, 'SIPL');
        cmd->In()->SetS( this->GetIpol() );
        ps->PutCmd( cmd );

        cmd = ps->GetCmd( this, 'SRDS');
        cmd->In()->SetS( this->GetRadius() );
        ps->PutCmd( cmd );

        cmd = ps->GetCmd( this, 'SWHO');
        cmd->In()->SetS( this->GetWho() );
        ps->PutCmd( cmd );

        cmd = ps->GetCmd( this, 'SRCF');
        cmd->In()->SetF( this->GetRadiusCoef() );
        ps->PutCmd( cmd );
        return true;
    }
    return false;
}

