#define N_IMPLEMENTS nIMGaussianBlur
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimgaussianblur.h"

nNebulaScriptClass(nIMGaussianBlur, "nim");

//------------------------------------------------------------------------------
nIMGaussianBlur::nIMGaussianBlur() {
}
//------------------------------------------------------------------------------
void nIMGaussianBlur::Initialize(){
    nIM::Initialize();
    radius = 3;
}
//------------------------------------------------------------------------------
void nIMGaussianBlur::InitVars(){
    nIM::InitVars();
    steps.SetI (1);
}
//------------------------------------------------------------------------------
nIMGaussianBlur::~nIMGaussianBlur(){
}
//------------------------------------------------------------------------------
void nIMGaussianBlur::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
}

//-----------------------------------------------------------------------------//
struct IMGuassianInfo {
    int x;
    IMGuassianInfo():
    x(0)
    {
    }
};
//-----------------------------------------------------------------------------//
void nIMGaussianBlur::calculateValues(void** const v){
    //n_printf("nIMGaussianBlur(%s)::calculateValues(%p)\n", this->fn, *v);
    IMGuassianInfo* info = (IMGuassianInfo*) (*v);
    if ( *v == NULL ) {
        info = new IMGuassianInfo();
        *v = info;
        return; //enough for now
    }
    int& x = info->x;
    nIM* childIM = dynamic_cast<nIM*>(this->GetHead());
    for( int step = 0; x < res && step < steps.GetI(); step++ ) {
        for( int y = 0; y < res; y ++ ) {
            float val0 = childIM->getFinalVal(x,y);
            float val1 = 0.0f;
            int num = 0;
            for ( int dx = -radius; dx <= radius; dx += 1 ) {
                int x0 = x + dx;
                if( x0 < 0 ) continue;
                if( x0 >= res ) continue;
                for ( int dy = -radius; dy <= radius; dy += 1 ) {
                    int y0 = y + dy;
                    if( y0 < 0 ) continue;
                    if( y0 >= res ) continue;
                    float dv = childIM->getFinalVal(x0,y0);
                    val1 += dv;
                    num++;
                }
            }
            val1 = val1 / num;
            //n_printf("x:%i y:%i val0:%f val1:%f over %i steps\n", x, y, val0, val1, num);
            switch( this->mode ){
                case NORMAL:
                    val0 = val1;
                    break;
                case MINIMIZE_ONLY:
                    if( val1 < val0 )
                        val0 = val1;
                    break;
                case MAXIMIZE_ONLY:
                    if( val1 > val1 )
                        val0 = val1;
                    break;
            }
            vals[x][y] = val0;
        }
        x++;
    }
    if( info->x >= res ) { //done
        this->calcNormVals();
        this->findMaxMinPoints();
        delete info;
        *v = NULL;
    }
}
