#define N_IMPLEMENTS nIMManager
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimmanager.h"
#include "im/nim.h"
#include "enkiduo/nprofserver.h"

nNebulaScriptClass(nIMManager, "naspect");

//------------------------------------------------------------------------------
nIMManager::nIMManager() {
    this->AddToTriggerList();
}
//------------------------------------------------------------------------------
void nIMManager::Initialize(){
    nAspect::Initialize();
    v = NULL;
    activated = true;
}
//------------------------------------------------------------------------------
void nIMManager::InitVars(){
    nAspect::InitVars();
    minRefreshTime.Connect( ent, "minRefreshTime");
    minRefreshTime.DefaultF( 00.0f );
    lastRefreshTime.Connect( ent, "lastRefreshTime");
    lastRefreshTime.DefaultF( -1.0f );
}
//------------------------------------------------------------------------------
nIMManager::~nIMManager(){
}
//------------------------------------------------------------------------------
void nIMManager::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( this->activated == false ) 
        return;
    prof->Begin("IM");
    //n_printf("nIMManager::Tick(%i)\n", this->workingList.Size());
    if ( this->workingList.Size() == 0 ) { //create a list of all the ims to call
        if ( lastRefreshTime.GetF() < 0 || time - lastRefreshTime.GetF() > minRefreshTime.GetF() ) {
            //n_printf("Starting new IMManager sweep\n");
            this->CreateWorkingList();
            lastRefreshTime.SetF( time );
            n_assert( v == NULL);
        }
    } else { 
        nString profString;
        profString.PrintF(workingList[0]->GetName());
        prof->Begin(profString);
        workingList[0]->calculateValues(&v);
        prof->End(profString);
        if ( v == NULL ) { //it finished
            workingList.Erase(0);
        }
    }
    prof->End("IM");
}
//-----------------------------------------------------------------------------//
void nIMManager::AddIM(nIM* im){ 
    ims.Append(im); 
}
//-----------------------------------------------------------------------------//
void nIMManager::CreateWorkingList(){
    this->Recurse(this->GetParent());
}
//-----------------------------------------------------------------------------//
void nIMManager::Recurse(nRoot* im){
    foreachchild(nRoot, node, im){
        this->Recurse(node);
    }
    classVar(nIM, imClass);
    if (im->IsA(imClass)) {
        if( ((nIM*)im)->isdirty() )
            this->workingList.Append((nIM*)im);
    }
}
//-----------------------------------------------------------------------------//
