#define N_IMPLEMENTS nIMOperator
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimoperator.h"

nNebulaScriptClass(nIMOperator, "nim");

//------------------------------------------------------------------------------
nIMOperator::nIMOperator() {
}
//------------------------------------------------------------------------------
void nIMOperator::Initialize(){
    nIM::Initialize();
    this->op = SUM;
    this->mode = NORMAL;
}
//------------------------------------------------------------------------------
void nIMOperator::InitVars(){
    nIM::InitVars();
}
//------------------------------------------------------------------------------
nIMOperator::~nIMOperator(){
}
//------------------------------------------------------------------------------
void nIMOperator::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
struct IMOperatorInfo {
    int x;
    nIM* firstChild;
    nArray<nIM*> childIMs;

    IMOperatorInfo():
    x(0),
    firstChild(0),
    childIMs(10,10){
    }
};
//-----------------------------------------------------------------------------//
void nIMOperator::calculateValues(void** const v){
    //n_printf("nIMOperator(%s)::calculateValues(%p)\n", this->fn, *v);
    IMOperatorInfo* info = (IMOperatorInfo*) (*v);
    if ( *v == NULL ) {
        info = new IMOperatorInfo();
        foreachchild(nIM, im, this ) {
            if ( info->firstChild == 0 )
                info->firstChild = im;
            else
                info->childIMs.Append(im);
        }
        //this->clearVals();
        *v = info;
        return; //enough for now
    }
    int& x = info->x;
    for( int step = 0; x < res && step < steps.GetI(); step++ ) {
        for( int y = 0; y < res; y ++ ) {
            vals[x][y] = info->firstChild->getFinalVal(x,y);
            nIM* im;
            for( int i = 0; i < info->childIMs; i ++ ) {
                im = info->childIMs[i];
                switch( this->op ) {
                    case SUM:
                        vals[x][y] += im->getFinalVal(x,y);
                        break;
                    case SUB:
                        vals[x][y] -= im->getFinalVal(x,y);
                        break;
                    case MUL:
                        vals[x][y] *= im->getFinalVal(x,y);
                        break;
                    case DIV:
                        vals[x][y] /= im->getFinalVal(x,y);
                        break;
                    case MAX:
                        vals[x][y] = n_max( vals[x][y], im->getFinalVal(x,y));
                        break;
                    case MIN:
                        vals[x][y] = n_min( vals[x][y], im->getFinalVal(x,y));
                        break;
                }
            }
            switch( this->mode ){
                case NORMAL:
                    break;
                case BINARIZE:
                    if ( vals[x][y] > 0.0f )
                        vals[x][y] = 1.0f;
                    else if ( vals[x][y] < 0.0f )
                        vals[x][y] = -1.0f;
                    else
                        vals[x][y] = 0.0f;
                    break;
            }
        }
        x++;
    }
    if( info->x >= res ) { //done
        this->calcNormVals();
        this->findMaxMinPoints();
        delete info;
        *v = NULL;
    }
}
