#define N_IMPLEMENTS nMacOSXInputServer
//--------------------------------------------------------------------
//  nmacosxinputserver.cc
//  (C) 1999 A.Weissflog
//--------------------------------------------------------------------
#include "kernel/nkernelserver.h"
#include "input/nmacosxinputserver.h"

nClass *nMacOSXInputServer::local_cl  = NULL;
nKernelServer *nMacOSXInputServer::ks = NULL;

extern char *nMacOSXInputServer_version;
extern "C" bool N_EXPORT n_init(nClass *, nKernelServer *);
extern "C" void N_EXPORT n_fini(void);
extern "C" N_EXPORT void *n_create(void);
extern "C" N_EXPORT char *n_version(void);

//--------------------------------------------------------------------
//  n_init()
//--------------------------------------------------------------------
bool N_EXPORT n_init(nClass *cl, nKernelServer *ks)
{
    nMacOSXInputServer::local_cl = cl;
    nMacOSXInputServer::ks       = ks;
    
    // mit Superklasse verketten
    nClass *super = ks->OpenClass("ninputserver");
    if (super) super->AddSubClass(nMacOSXInputServer::local_cl);
    else n_error("Could not open superclass ninputserver!");
    return TRUE;
}

//--------------------------------------------------------------------
//  n_fini()
//--------------------------------------------------------------------
void N_EXPORT n_fini(void)
{
    // von Superklasse abkoppeln
    nClass *super = nMacOSXInputServer::local_cl->GetSuperClass();
    n_assert(super);
    if (super) {
        super->RemSubClass(nMacOSXInputServer::local_cl);
        nMacOSXInputServer::ks->CloseClass(super);
    }
}

//--------------------------------------------------------------------
//  n_new()
//--------------------------------------------------------------------
N_EXPORT void *n_create(void)
{
    return new nMacOSXInputServer;
}

//--------------------------------------------------------------------
//  n_version()
//--------------------------------------------------------------------
N_EXPORT char *n_version(void)
{
    return nMacOSXInputServer_version;
}

//--------------------------------------------------------------------
//  EOF
//--------------------------------------------------------------------

