#define N_IMPLEMENTS nAirPatrol
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "lagoon/nairpatrol.h"

nNebulaScriptClass(nAirPatrol, "nai");

//------------------------------------------------------------------------------
nAirPatrol::nAirPatrol() {
}
//------------------------------------------------------------------------------
void nAirPatrol::Initialize(){
    nAI::Initialize();
}
//------------------------------------------------------------------------------
void nAirPatrol::InitVars(){
    nAI::InitVars();
    flyoverTarget.Connect( ent, "flyoverTarget" );
    flyoverTarget.DefaultRef("");
    flyoverTargetPos.Connect( flyoverTarget, "pos" );
    flyoverAlt.Connect( ent, "flyoverAlt" );
    flyoverAlt.DefaultF( 0.0f );
}
//------------------------------------------------------------------------------
nAirPatrol::~nAirPatrol(){
}
//------------------------------------------------------------------------------
void nAirPatrol::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
    if( flyoverTarget.isvalid() ) {
        float distance = this->Move3D( flyoverTargetPos.GetV() + vector3(0.0f, flyoverAlt.GetF(), 0.0f), dtime);
        if ( distance < 300.0 ) {
            flyoverTarget.SetRef( "" );
        }
    } else {
        EntArray allEnts;
        nRoot* entRoot = kernelServer->Lookup("/game/ents");
        foreachchild(nRoot, entType, entRoot ){
            foreachchild( nEnt, otherEnt, entType ){
                allEnts.Append( otherEnt );
            }
        }
        if( allEnts.Size() > 0 ){  //no one to patrol near
            int i = randI( 0, allEnts.Size() - 1 );
            flyoverTarget.SetRef(allEnts[i]->fn);
            float newFlyoverAlt = randF( 25.0f, 250.0f );
            flyoverAlt.SetF( newFlyoverAlt );
        }
    }
}
