#define N_IMPLEMENTS nBoatRadarSensor
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "lagoon/nboatradarsensor.h"
#include "lagoon/nradarserver.h"
#include "enkiduo/colours.h"

nNebulaScriptClass(nBoatRadarSensor, "naspect");

//------------------------------------------------------------------------------
nBoatRadarSensor::nBoatRadarSensor() {
}
//------------------------------------------------------------------------------
void nBoatRadarSensor::Initialize(){
    nAspect::Initialize();
}
//------------------------------------------------------------------------------
void nBoatRadarSensor::InitVars(){
    nAspect::InitVars();
    radarRange.Connect( ent, "radarRange" );
    radarRange.DefaultF( 5000.0f );
    nRadarServer* radarServer = (nRadarServer*) kernelServer->Lookup("/game/radar/radar");
    if ( radarServer ) {
        radarServer->AddRadar( this );
    } else
        n_printf("radar server not found\n");
}
//------------------------------------------------------------------------------
nBoatRadarSensor::~nBoatRadarSensor(){
}
//------------------------------------------------------------------------------
void nBoatRadarSensor::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    this->DrawCircle( ent->GetVarV("pos" ), green, radarRange.GetF());
    for( int i = 0; i < detectedEnts; i ++ ) {
        this->DrawLine( ent->GetVarV("pos"), detectedEnts[i]->GetVarV("pos"), green );
    }
}
void nBoatRadarSensor::DetectedEntity( nEnt* entity ) {
    //n_printf("ent(%s) detecting(%s)\n", str(this), str(entity));
    detectedEnts.Append( entity );
}
void nBoatRadarSensor::EscapedEntity( nEnt* entity ){
    //n_printf("ent(%s) lost(%s)\n", str(this), str(entity));
    detectedEnts.Erase( detectedEnts.Find( entity ) );
}
bool nBoatRadarSensor::BlockDeath( bool urgent ) {
    //n_printf("%s being removed from radar list\n", str(this));
    nRadarServer* radarServer = (nRadarServer*) kernelServer->Lookup("/game/radar/radar");
    if( radarServer ) {
        radarServer->RemoveRadar( this );
    } else
        n_printf("radar server not found\n");
    return false;
}
