#define N_IMPLEMENTS nBoatStealthyness
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "lagoon/nboatstealthyness.h"

nNebulaScriptClass(nBoatStealthyness, "naspect");

//------------------------------------------------------------------------------
nBoatStealthyness::nBoatStealthyness() {
}
//------------------------------------------------------------------------------
void nBoatStealthyness::Initialize(){
    nAspect::Initialize();
    //this->AddToDisplayList();
}
//------------------------------------------------------------------------------
void nBoatStealthyness::InitVars(){
    nAspect::InitVars();
    stealthPoints.Connect               ( ent, "stealthPoints" );
    stealthPoints.DefaultF              ( 30.0f );
    hideRate.Connect                    ( ent, "hideRate" );
    hideRate.DefaultF                   ( .5f );
    stealthPointsMin.Connect            ( ent, "stealthPointsMin" );
    stealthPointsMin.DefaultF           ( 0.0f );
    stealthPointsMax.Connect            ( ent, "stealthPointsMax" );
    stealthPointsMax.DefaultF           ( 30.0f );
    exposed.Connect                     ( ent, "exposed" );
    exposed.DefaultI                    ( 0 );
}
//------------------------------------------------------------------------------
nBoatStealthyness::~nBoatStealthyness(){
}
//------------------------------------------------------------------------------
void nBoatStealthyness::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    float points = stealthPoints.GetF();
    if ( exposed.GetI() )
        points -= dtime;
    else
        points += dtime * hideRate.GetF();
    points = n_clamp( points, stealthPointsMin.GetF() - .01f, stealthPointsMax.GetF() );
    stealthPoints.SetF( points );

    //this->DrawLine( ent->GetVarV("pos"), ent->GetVarV("pos") + vector3(0, points * 5.0f, 0 ), exposed.GetI() ? red : white);
    //if ( stealthPoints.GetF() <= 0.0f )
        //this->DrawPoint( ent->GetVarV("pos"), red, 35 );
}
