#define N_IMPLEMENTS nBob
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "lagoon/nbob.h"
#include "enkiduo/nwaver.h"

nNebulaScriptClass(nBob, "nphysicalaspect");

//------------------------------------------------------------------------------
nBob::nBob():
    ref_waver( kernelServer, this )
{
}
//------------------------------------------------------------------------------
void nBob::Initialize(){
    nPhysicalAspect::Initialize();
    //this->AddToDisplayList();
}
//------------------------------------------------------------------------------
void nBob::InitVars(){
    nPhysicalAspect::InitVars();
    dimension.Connect( ent, "dimension");
    pos.Connect( ent, "pos" );
    rot.Connect( ent, "rot" );
    ref_waver = "/game/vis/water/waver";
    if( ref_waver.isvalid() == false ) {
        n_printf("nbob:%s failed to find waver at %s\n", ref_waver.getname());
    }
}
//------------------------------------------------------------------------------
nBob::~nBob(){
}
//------------------------------------------------------------------------------
nArray<vector3> genVectors(){
    nArray<vector3> answers;
    answers.Append( vector3(+1,0,+1));
    answers.Append( vector3(+1,0,-1));
    answers.Append( vector3(-1,0,+1));
    answers.Append( vector3(-1,0,-1));
    return answers;
}
void nBob::Tick( float time, float dtime ){
    nPhysicalAspect::Tick( time, dtime );
    ifvalid(ref_waver) {
        vector3 po = pos.GetV();
        quaternion q = rot.GetQ();
        const nArray<vector3> vectors = genVectors();
        vector3 dim = dimension.GetV();
        vector3 forceSum;
        vector3 torqueSum;
        for( int i = 0; i < vectors.Size(); i ++ ) {
            vector3 dp = vector3(vectors[i].x * dim.x, vectors[i].y * dim.y, vectors[i].z * dim.z);
            vector3 p = po + q.rotate(dp);
            float displacement = p.y - ref_waver->displacementAt( p.x, p.z );
            vector3 force = vector3(0, -displacement, 0);
            vector3 torque = dp * force;
            physics->ApplyForce( force );
            physics->ApplyTorque( torque );
            //n_printf("dp:%s p:%s force:%s torque:%s\n", str(dp), str(p), str(force), str(torque));
            //this->DrawLine( p, p + force, white );
            //this->DrawLine( p, p + torque, blue );
        }
        vector3 bottomPoint             = vector3(0, -dim.y, 0);
        bottomPoint                     = q.rotate(bottomPoint);
        vector3 bottomHeavyTorque       = bottomPoint * vector3(0,-1,0);
        //this->DrawLine( po + bottomPoint, po + bottomPoint + bottomHeavyTorque, red );
        physics->ApplyTorque( bottomHeavyTorque );
    }
}
