#define N_IMPLEMENTS nInfluenceMap
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "map/ninfluencemap.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nInfluenceMap*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command(setsize){
    self->SetSize( ini() );
}
command( getsize){
    outi( self->GetSize() );
}
command(setval){
    int x = ini();
    int z = ini();
    float v = inf();
    self->SetVal(x,z,v);
}
command(getval){
    int x = ini();
    int z = ini();
    float v = self->GetVal( x, z );
    outf( v );
}
command(getvalf){
    float x = inf();
    float z = inf();
    float v = self->GetVal(vector2(x,z));
    outf( v );
}
command( getmin ) {
    outf( self->GetMin() );
}
command( getmax ) {
    outf( self->GetMax() );
}
command( getexp ) {
    outs( self->GetExp() );
}
command(normalize){
    self->Normalize();
}
command(setcoef){
    self->SetCoef( inf() );
}
command(getcoef){
    outf( self->GetCoef());
}
command( calculate ) {
    outb( self->Calculate() );
}
command( geta ) { outf( self->GetA()); }
command( getb ) { outf( self->GetB()); }
#undef getc
command( getc ) { outf( self->GetC()); }
command( seta ) { self->SetA( inf() ); }
command( setb ) { self->SetB( inf() ); }
command( setc ) { self->SetC( inf() ); }
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_setsize_i", 'SI', setsize );
    clazz->AddCmd("i_getsize_v", 'GI', getsize );
    clazz->AddCmd("v_setval_iif", 'SV', setval );
    clazz->AddCmd("f_getval_ii", 'GV', getval );
    clazz->AddCmd("f_getvalf_ff", 'GVF', getvalf );
    clazz->AddCmd("f_getmin_v", 'GMIN', getmin );
    clazz->AddCmd("f_getmax_v", 'GMAX', getmax );
    clazz->AddCmd("s_getexp_v", 'GEXP', getexp );
    clazz->AddCmd("v_normalize_v", 'NORM', normalize );
    clazz->AddCmd("v_setcoef_f", 'SCOF', setcoef );
    clazz->AddCmd("f_getcoef_v", 'GCOF', getcoef );
    clazz->AddCmd("b_calculate_v", 'CALC', calculate );
    clazz->AddCmd("v_seta_f", 'SA', seta );
    clazz->AddCmd("v_setb_f", 'SB', setb );
    clazz->AddCmd("v_setc_f", 'SC', setc );
    clazz->AddCmd("f_geta_v", 'GA', geta );
    clazz->AddCmd("f_getb_v", 'GB', getb );
    clazz->AddCmd("f_getc_v", 'GC', getc );

    clazz->EndCmds();
}

bool
nInfluenceMap::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}

