#define N_IMPLEMENTS nLinearFalloffIM
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "map/nlinearfalloffim.h"

nNebulaScriptClass(nLinearFalloffIM, "ninfluencemap");

//------------------------------------------------------------------------------
/**
*/
nLinearFalloffIM::nLinearFalloffIM()
{
}

void nLinearFalloffIM::Initialize(){
    nInfluenceMap::Initialize();
}

nLinearFalloffIM::~nLinearFalloffIM(){
}
//------------------------------------------------------------------------------
/**
*/

void nLinearFalloffIM::Tick( float time, float dtime ){
    nInfluenceMap::Tick( time, dtime );
}

bool nLinearFalloffIM::Calculate(){
    vector2 d(A,B);
    float maxL = squareSize * size * sqrt(2.0f);
    log("maxL:%f", maxL );
    for( int i = 0; i < size; i ++ ) {
        for( int j = 0; j < size; j ++ ) {
            vector2 p(i * squareSize, j * squareSize);
            grid[i][j] = 1.0 - ((p-d).len() / maxL);
        }
    }
    this->Normalize();
    return true;
}
