#define N_IMPLEMENTS nOffsetAspect
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/noffsetaspect.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nOffsetAspect*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( setoffset ){
    float x = inf();
    float y = inf();
    float z = inf();
    self->SetOffset( vector3(x, y, z) );
}
command( setrotlocal ) {
    quaternion q;
    q.x = inf();
    q.y = inf();
    q.z = inf();
    q.w = inf();
    self->SetRotLocal( q );
}
command( getoffset ){
    vector3 v = self->GetOffset();
    outf( v.x );
    outf( v.y );
    outf( v.z );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_setoffset_fff", 'SOF', setoffset );
    clazz->AddCmd("v_setrotlocal_ffff", 'SRL', setrotlocal );
    clazz->AddCmd("fff_getoffset_v", 'GOF', getoffset );
    clazz->EndCmds();
}

bool
nOffsetAspect::SaveCmds(nPersistServer* ps)
{
    if (nPhysicalAspect::SaveCmds(ps))
    {
        nCmd* cmd;
        cmd = ps->GetCmd( this, 'SOF' );
        vector3 v = this->GetOffset();
        cmd->In()->SetF( v.x );
        cmd->In()->SetF( v.y );
        cmd->In()->SetF( v.z );
        ps->PutCmd(cmd);

        cmd = ps->GetCmd( this, 'SRL' );
        quaternion q = this->GetRotLocal();
        cmd->In()->SetF( q.x );
        cmd->In()->SetF( q.y );
        cmd->In()->SetF( q.z );
        cmd->In()->SetF( q.w );
        ps->PutCmd(cmd);

        return true;
    }
    return false;
}

