#define N_IMPLEMENTS nOffsetAspect
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/noffsetaspect.h"

nNebulaScriptClass(nOffsetAspect, "nphysicalaspect");

//------------------------------------------------------------------------------
/**
*/
nOffsetAspect::nOffsetAspect()
{
}
void nOffsetAspect::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    rot.Connect( ent, "rot" );
    vel.Connect( ent, "vel" );
    vel.DefaultV( 0,0,0 );
}

nOffsetAspect::~nOffsetAspect(){
}

void nOffsetAspect::ApplyPointForce( vector3 force ){
    ifvalid( physics ) { 
        physics->ApplyForce( force );
        vector3 t = force * offset;
        physics->ApplyTorque( t );
    }
}

void nOffsetAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    vector3 p = pos.GetV();
    vector3 v = vel.GetV();
    quaternion q = rot.GetQ();
    offsetPos = p + q.rotate(offset);
    //n_assert( offsetPos.x != NAN && offsetPos.y != NAN && offsetPos.z != NAN );

    //q += (rotLocal * q) / 2.0f;
    q = q * rotLocal;
    offsetRot = q;
}
