#define N_IMPLEMENTS nStabilizer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/nstabilizer.h"

nNebulaScriptClass(nStabilizer, "nphysicalaspect");

//------------------------------------------------------------------------------
/**
*/
nStabilizer::nStabilizer()
{
}

void nStabilizer::Initialize(){
    nPhysicalAspect::Initialize();
}

void nStabilizer::InitVars(){
    nPhysicalAspect::InitVars();
    rot.Connect                         ( ent, "rot");
    stabilizationForce.Connect          ( ent, "stabilizationforce" );
    stabilizationForce.DefaultF         ( 1.0f );
    attachedto.Connect                  (ent, "attachedto");
    attachedto.DefaultRef               ("none");
    watching.Connect                    (ent, "watching");
    watching.DefaultRef                 ("");
}

nStabilizer::~nStabilizer(){
}
//------------------------------------------------------------------------------
/**
*/

void nStabilizer::Tick( float time, float dtime ){
    nPhysicalAspect::Tick( time, dtime );
    //if (attachedto.isvalid() /*&& watching.isvalid() == false*/ ) return;
    quaternion q = rot.GetQ();
    float r = q.ToRoll();
    if( fabs(r) > .01 ) {
        physics->ApplyAlignedTorque( vector3(0, 0, stabilizationForce.GetF() * -r / N_PI) );
    }
}
