#define N_IMPLEMENTS nVelOriented
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/nveloriented.h"

nNebulaScriptClass(nVelOriented, "naspect");

//------------------------------------------------------------------------------
/**
*/
nVelOriented::nVelOriented(){
}

void nVelOriented::Initialize(){
    nAspect::Initialize();
}

void nVelOriented::InitVars(){
    nAspect::InitVars();
    vel.Connect(ent, "vel");
    rot.Connect(ent, "rot");
}

nVelOriented::~nVelOriented(){
}
//------------------------------------------------------------------------------
/**
*/

void nVelOriented::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    
    quaternion q;
    quaternion q1;
    vector3 v = vel.GetV();
    vector3 r;
    r.y = atan2( v.x, v.z );
    r.z = atan2( v.y, sqrt(v.x*v.x+v.z*v.z) );
    q1.set_rotate_xyz( r.x, r.y, r.z );
    q.slerp( rot.GetQ(), q1, .3 );
    rot.SetQ( q );
}
