#define N_IMPLEMENTS nFormateAI
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nformateai.h"

nNebulaScriptClass(nFormateAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nFormateAI::nFormateAI():
arbiter( kernelServer, this )
{
}
void nFormateAI::Initialize(){
    nAI::Initialize();
}
void nFormateAI::InitVars(){
    nAI::InitVars();
    pos.Connect( ent, "pos" );
    parentlegion.Connect( ent, "parentlegion");
    parentlegion.DefaultRef("");
    formationPos.Connect( ent, "formationpos" );
    formationPos.DefaultV( 0,0,0 );
    formationRot.Connect( ent, "formationrot" );
    formationRot.DefaultQ( 0,0,0,1 );
    formationTightness.Connect( ent, "formationtightness" );
    formationTightness.DefaultF( .05f );
    formationBearing.Connect( ent, "formationbearing" );
    formationBearing.DefaultF( 0.0f );
    //this->AddToDisplayList();
    arbiter = ent->ChildPath("arbiter");
}

nFormateAI::~nFormateAI(){
}
//------------------------------------------------------------------------------
/**
*/

void nFormateAI::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
    if( arbiter.isvalid() && parentlegion.isvalid() ) {
        //this->DrawLine( pos.GetV(), formationpos.GetV(), white );
        vector3 p = pos.GetV();
        vector3 d = formationPos.GetV();
        quaternion q = formationRot.GetQ();
        vector3 forward( 0,0,1 );
        forward = q.rotate( forward );
        float bearing = atan2( q.x, q.z );
        vector3 dx = d - p;
        float l = dx.len();
        if( l > 4 ) {
            dx.norm();
            arbiter->VoteVelocity( dx, 	0, l * formationTightness.GetF() );
            arbiter->VoteBearing( bearing, 	0, l * formationTightness.GetF() );
        }
    } else {
        //n_printf("arbiter invalid e:%s\n", ent->fn);
        //arbiter = ent->Find("arbiter");
    }
}
