#define N_IMPLEMENTS nHoverMelee
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nhovermelee.h"

nNebulaScriptClass(nHoverMelee, "nai");

//------------------------------------------------------------------------------
/**
*/
nHoverMelee::nHoverMelee():
    arbiter( kernelServer, this )
{
    stateNames.Append("approach");
    stateNames.Append("circle");
}

void nHoverMelee::Initialize(){
    nAI::Initialize();
    tbase = randF( 0, 2.0f * N_PI );
    if( roll( .5 ) )
        direction = 1.0f;
    else
        direction = -1.0f;
    this->AddToDisplayList();
}

void nHoverMelee::InitVars(){
    nAI::InitVars();
    pos.Connect( ent, "pos" );
    target.Connect( ent, "target" );
    target.DefaultRef("");
    mytarget.Connect( ent, "mytarget" );
    mytarget.DefaultRef("");
    targetPos.Connect( target, "pos" );
    //velDesired.Connect( ent, "veldesired" );
    arbiter = ent->ChildPath("arbiter");
}

nHoverMelee::~nHoverMelee(){
}
//------------------------------------------------------------------------------
/**
*/

void nHoverMelee::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
}

bool nHoverMelee::States( StateMachineEvent event, uint state, float time, float dtime ){
    BeginStateMachine
        State(Approach)
            OnEnter
	if( mytarget.isvalid() )
	    target.SetRef( mytarget.GetRef()->fn );
	else
	    this->Die();
            OnTick
	if( target.isvalid() ) {
	    vector3 p = pos.GetV();
	    vector3 tp = targetPos.GetV();
	    vector3 dx = tp - p;
	    float tl = dx.len();
	    dx.norm();
	    float theta = atan2( dx.x, dx.z );
	    float offsetMult = cos( theta * 2.0f ) / tl * 30.0f;
	    float offsetAngle = fabs(offsetMult) * 1.2 + .3 * direction;
	    float ntheta = theta + offsetAngle;
	    
	    vector3 veldesired = vector3( sin(ntheta), 0, cos(ntheta) );
	    arbiter->VoteVelocity(veldesired, 10, 0 );
	} else {
	    n_printf("%s->target invalid\n", ent->fn);
	    this->Die();
	}
        State(Circle)
    EndStateMachine
}
