#define N_IMPLEMENTS nMiniMap
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nminimap.h"
#include "aspect/nside.h"
#include "gfx/nscenegraph2.h"

nNebulaScriptClass(nMiniMap, "n3dnode");

//------------------------------------------------------------------------------
/**
*/
nMiniMap::nMiniMap():
    blueSide     ( kernelServer, this ),
    redSide      ( kernelServer, this ),
    nuetralSide      ( kernelServer, this ),
    friendlybox( kernelServer, this ),
    nuetralbox( kernelServer, this ),
    enemybox( kernelServer, this ),
    selectedbox( kernelServer, this )
{
}

void nMiniMap::Initialize(){
    n3DNode::Initialize();
    blueSide 	= "/game/sides/blue/side";
    redSide 	= "/game/sides/red/side";
    nuetralSide = "/game/sides/nuetral/side";
    friendlybox = "/vis/vis/friendlybox";
    nuetralbox 	= "/vis/vis/nuetralbox";
    enemybox 	= "/vis/vis/enemybox";
    selectedbox = "/vis/vis/selectedbox";
}

nMiniMap::~nMiniMap(){
}
//------------------------------------------------------------------------------
/**
*/

bool nMiniMap::Attach( nSceneGraph2* gfx ) {
    if ( gfx->BeginNode()) {
        ifvalid( blueSide )
            ifvalid( friendlybox )
	this->DrawUnits( gfx, blueSide->GetUnits(), friendlybox.get() );
        ifvalid( nuetralSide )
            ifvalid( nuetralbox )
	this->DrawUnits( gfx, nuetralSide->GetUnits(), nuetralbox.get() );
        ifvalid( redSide )
            ifvalid( enemybox )
	this->DrawUnits( gfx, redSide->GetUnits(), enemybox.get() );
        gfx->EndNode();
        return true;
    }
    return false;
}

void nMiniMap::DrawUnits( nSceneGraph2* gfx, const EntArray* const units, n3DNode* v ) {
    float minx = -0.97f;
    float miny = -0.97f;
    float wx = 0.38f;
    float wy = 0.38f;
    float maxx = minx + wx;
    float maxy = miny + wy;
    float size = 5600.0f;
    float perx, pery;

    n3DNode* vis;
    for(  int i = 0; i < units->Size(); i ++ ) {
        vis = v;
        //n_printf("attaching at :%f,%f,%f\n", formationPos[i].x, formationPos[i].z, -10.0f );
        //nRoot* minebuildlocationRoot = kernelServer->Lookup("/game/ents/minebuildlocation");
        //n_assert( minebuildlocationRoot );
        //if( units->Get(i)->GetParent() == minebuildlocationRoot )
            //continue;
        vector3 p = units->Get(i)->GetVarV("pos");
        ifvalid (selectedbox )
            if( units->Get(i)->Selected() ) {
	vis = selectedbox.get();
            }
        vector2 drawloc;

        //Get percentage of location(x,y)/size(x,y)
        //Have to "mirror" X in order to get correct coordinates
        perx = p.x / size;
        pery = p.z / size;

        //Here's the X position
        drawloc.x = -(perx*wx) + maxx;
        //Here's the Y position
        drawloc.y = -(pery*wy) + maxy;

        //Mirror X, something funky with coordinates
        drawloc.x = (minx - drawloc.x + maxx);

        //n_printf("p:%s dl:%s\n", str(p), str(drawloc));
        vis->Txyz( drawloc.x, drawloc.y, -1.0 );
        vis->Sxyz( .007, .007, .007);		    //scale the lil rectangles
        vis->Attach( gfx );		                    //draw
    }
}
