#define N_IMPLEMENTS nPointDamage
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "turret/npointdamage.h"

nNebulaScriptClass(nPointDamage, "ndamage");

//------------------------------------------------------------------------------
nPointDamage::nPointDamage() {
}
//------------------------------------------------------------------------------
void nPointDamage::Initialize(){
    nDamage::Initialize();
    pos.Connect                         ( ent, "pos" );
    type.Connect                        ( ent, "type" );
    parentTurret.Connect                ( ent, "parentTurret" );
    parentTurret.DefaultRef             ("");
}
//------------------------------------------------------------------------------
void nPointDamage::InitVars(){
    nDamage::InitVars();
}
//------------------------------------------------------------------------------
nPointDamage::~nPointDamage(){
}
//------------------------------------------------------------------------------
void nPointDamage::Tick( float time, float dtime ){
    nDamage::Tick( time, dtime );
}

//-----------------------------------------------------------------------------//
bool nPointDamage::BlockDeath( bool urgent ) {
    if( urgent ) return false;                //being deleted - dont do damage
    //n_printf("%s doing damage\n", this->fn );
    if ( parentTurret.isvalid() ) {
        const char* parentEntString     = parentTurret.GetRef()->GetVarRef("mother");
        //n_printf("parentEntString:%s\n", parentEntString);
        nEnt* parentEnt = (nEnt*) kernelServer->Lookup(parentEntString);
        nString t                       = type.GetS();
        int weaponLevel                 = parentEnt->GetVarI((t + "level").Get());
        float weaponPower               = parentEnt->GetVarF((t + "power").Get());

        nMessage* m                     = new nMessage();
        m->from                         = parentEnt->FullNameString();
        m->to                           = parentTurret.GetRef()->GetVarRef("target");
        m->title                        = "damage";
        m->data.PrintF                  ("%s%i", type.GetS().Get(), weaponLevel );
        m->f0                           = weaponPower;
        m->v                            = pos.GetV();
        Send( m );
        //n_printf("message: %s\n", m->toString());
        return false;
    }
    else {
        //n_printf("%s.blocking my parents are invalid\n", this->fn);
        return true;
    }
}
