#define N_IMPLEMENTS nUIButton
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ui/nuibutton.h"
#include "ui/nplannerui.h"

nNebulaScriptClass(nUIButton, "nuielement");

//------------------------------------------------------------------------------
/**
*/
nUIButton::nUIButton()
{
}

void nUIButton::Initialize(){
    nUIElement::Initialize();
}

void nUIButton::InitVars(){
    nUIElement::InitVars();
}

nUIButton::~nUIButton(){
}

//figure out where to place the button - scale / translate it appropriately
void nUIButton::SetBounds( vector2 min, vector2 max ) {
    bounds[0] = min;
    bounds[1] = max;
    //n_printf("nUIButton::SetBounds( %f,%f->%f,%f )\n", min.x, min.y, max.x, max.y );
    vector2 nodeCenter;
    nodeCenter = (min-vector2(.5f,.5f))*2.0f;
    nodeCenter.y *= -1.0f;
    //nodeCenter.y += ((max.y-min.y)-.5f) * 2.0f;
    vector2 s = ( max - min )*2.0f;
    nodeCenter.y -= s.y;
    //n_printf("c:(%f,%f) s:(%f,%f)\n", nodeCenter.x, nodeCenter.y, s.x, s.y );
    node->Txyz( nodeCenter.x, nodeCenter.y, -1.0f );
    node->Sxyz( s.x, s.y, 1.0 );
}
        
bool nUIButton::States( StateMachineEvent event, uint state, float time, float dtime ){
    MouseInfo info = game->GetMouseInfo();
    BeginStateMachine
    State(Waiting)
        OnTick
            if( contained( info.pos, bounds ) )
                this->SetState( MouseOver );
    State(MouseOver)
        OnEnter
            ui->Block();
        OnTick
            if( contained( info.pos, bounds ) == false )
                SetState( Waiting );
            else
                if( info.pressed[0] == 1 ) //left mouse pressed
                    this->SetState( Pressed );
        OnExit
            ui->UnBlock();
    State(Pressed)
        OnEnter
            ui->Block();
        OnTick
            if( info.pressed[0] == 0 ) //left has been released
                if( contained( info.pos, bounds ) ) //relased over me
                    this->SetState( Clicked );
                else                                        //released outside me
                    this->SetState( Waiting );
        OnExit
            ui->UnBlock();
    State(Clicked)
        OnEnter
            this->RunScript();
            this->SetState(MouseOver);
    EndStateMachine
}
