#define N_IMPLEMENTS nUIElement
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ui/nuielement.h"

nNebulaScriptClass(nUIElement, "nfsm");

//------------------------------------------------------------------------------
/**
*/
nUIElement::nUIElement():
    scriptServer    	( kernelServer, this ),
    node            	( kernelServer, this ),
    ui		( kernelServer, this ),
    stateChannelHandle( -1 )
{
}

void nUIElement::Initialize(){
    nFSM::Initialize();
    ui	= "/ui/planner";
    scriptServer = "/sys/servers/script";
}

void nUIElement::InitVars(){
    nFSM::InitVars();
    this->Hide();
}

nUIElement::~nUIElement(){
}

void nUIElement::Tick( float time, float dtime ) {
    if( stateChannelHandle >= 0 ) {
        n_assert( nodeChannels.isvalid() );
        float f = (float) this->GetStateI();
        //if( roll( .1 ) )
        //n_printf("%s->state = %i\n", this->fn, this->GetStateI() );
        nodeChannels->Set( stateChannelHandle, &f, 1 );
    }
    nFSM::Tick( time, dtime );
}
/////////////////////////////////////////////////////////////////////////////////
void nUIElement::SetNode( const char* nodeName ){
    this->node = nodeName;
    if( node.isvalid() ){
        nodeChannels = (nChannelHolder*) node->Find("channelholder");
        if( nodeChannels.isvalid() == false ) {
            kernelServer->PushCwd( node.get() );
            nodeChannels = (nChannelHolder*) kernelServer->New("nchannelholder", "channelholder");
            n_assert( nodeChannels.isvalid() );
            kernelServer->PopCwd();
            //n_printf("%s.channelholder = %s\n", this->fn, nodeChannels->fn );
            float f = 0;
            stateChannelHandle = nodeChannels->Add("state", &f, 1 );
        }
    }
}
/////////////////////////////////////////////////////////////////////////////////
void nUIElement::RunScript(){
    //printf("<RunScript>\n");
    const char* err = 0;
    scriptServer->Run( script.get(), err );
    if( err )
        n_message( "%s", err );
    //printf("</RunScript>\n");
}
