#--------------------------------------------------------------------
#   classtemplates.tcl
#	----------------
#   templates for classbuilder.tcl
#
#   (C)	2002	leaf
#--------------------------------------------------------------------

#--------------------------------------------------------------------
#   nclassname.h
#--------------------------------------------------------------------
set header "#ifndef $N_CLASSNAME_H
#define $N_CLASSNAME_H
//------------------------------------------------------------------------------
/**
    @class $nClassName

    @brief a brief description of the class

    a detailed description of the class

    (C)	$year	$user
*/
#ifndef $N_SUPERCLASSNAME_H
#include \"$superdir/$nsuperclassname.h\"
#endif
#ifndef E_INCLUDES_H
#include \"enkiduo/nincludes.h\"
#endif

#undef N_DEFINES
#define N_DEFINES $nClassName
#include \"kernel/ndefdllclass.h\"

//------------------------------------------------------------------------------
class $nClassName : public $nSuperClassName {
public:
    /// constructor
    $nClassName\();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~$nClassName\();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
};
//------------------------------------------------------------------------------
#endif
"

#--------------------------------------------------------------------
#   nclassname_cmds.cc
#--------------------------------------------------------------------
set cmds "#define N_IMPLEMENTS $nClassName
//------------------------------------------------------------------------------
//  (C) $year	$user
//------------------------------------------------------------------------------
#include \"$subdir/$nclassname.h\"
#include \"kernel/npersistserver.h\"
#ifdef _CLASSNAME
#error shouldnt be compiling to cmds files together
#undef _CLASSNAME
#endif

#define _CLASSNAME $nClassName
#include \"enkiduo/cmdsMacros.h\"
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->EndCmds();
}

bool
$nClassName\::SaveCmds(nPersistServer* ps)
{
    if ($nSuperClassName\::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}
"
#--------------------------------------------------------------------
#   nclassname_main.h
#--------------------------------------------------------------------
set main "#define N_IMPLEMENTS $nClassName
//------------------------------------------------------------------------------
//  (C) $year	$user
//------------------------------------------------------------------------------
#include \"$subdir/$nclassname.h\"

nNebulaScriptClass($nClassName, \"$nsuperclassname\");

//------------------------------------------------------------------------------
$nClassName\::$nClassName\() {
}
//------------------------------------------------------------------------------
void $nClassName\::Initialize(){
    $nSuperClassName\::Initialize();
}
//------------------------------------------------------------------------------
void $nClassName\::InitVars(){
    $nSuperClassName\::InitVars();
}
//------------------------------------------------------------------------------
$nClassName\::~$nClassName\(){
}
//------------------------------------------------------------------------------
void $nClassName\::Tick( float time, float dtime ){
    $nSuperClassName\::Tick( time, dtime );
}
"

#--------------------------------------------------------------------
#   Package File
#--------------------------------------------------------------------
set pakfile "#--------------------------------------------------------------------
#   $npackagename.pak
#   ============
#   Description of your class/package
#
#   $date   $user	created
#--------------------------------------------------------------------

#--------------------------------------------------------------------
beginmodule $nclassname
    setdir $subdir
    setfiles {
        $nclassname\_main $nclassname\_cmds
    }
    setheaders {
        $nclassname
    }
endmodule

#--------------------------------------------------------------------
begintarget $npackagename
    settype $targettype
    setmods {
        $nclassname
    }
    setdepends { $depends }
    setlibs_win32 { $win32libs }
    setlibs_unix  { $unixlibs}
endtarget

#--------------------------------------------------------------------
#   EOF
#--------------------------------------------------------------------
"        

#--------------------------------------------------------------------
#   EOF
#--------------------------------------------------------------------
