global home
global texdir
set texdir $home/data/lib/tex
global meshdir
set meshdir $home/data/lib/mesh

source lib/shaders/shaders.tcl
set ent_types ""
#source lib/particles/particles.tcl
source lib/fonts/fonts.tcl

set types [glob lib/*]
set ignoreList "lib.tcl node CVS"
foreach type $types { 
    set x [lindex [split $type "/"] 1]
    if { [lsearch $ignoreList $x] != -1 } { continue }
    if {[string last "." $x] == -1 } {
        if { $x != "fonts" && $x != "vis" && $x != "meshes" && $x != "tex" && $x != "ui" && $x!="shaders" && $x!="heightmaps" && $x!="terrain" && $x!="particles"} {
            lappend ent_types $x
        }
    }
}

global gfx
if { $gfx } {
    set classes "ent vis node"
} else { 
    set classes "ent" 
}
set classes "ent vis node"
    
foreach type $ent_types {
    foreach class $classes { 
        sn nroot /$class
        set cmd "source lib/$type/$class.tcl"
        if { [catch { eval $cmd } err] } {
            puts "could not load lib for: $type: $err"
        }
    }
}
pushsel
if { 0 } { 
new nthing /vis/vis
sel /vis/vis
    set files [glob lib/vis/*.tcl]
    #puts "files:$files"
    foreach file $files { 
        if { [catch { eval source $file } err] } {
            puts "could not load vis for: $file"
        }
    }
sel ..
popsel
}
