#stati
#unconnected
#connected - no slaves
#booting slaves
#reading
#running
namespace eval GAGui { 
    variable info
    proc log { txt } { 
        logto "all ga" $txt
    }
    proc init { } {
        vars info
        array set info {
            blue.hostnames "chunli.cse.unr.edu enkiduo.cse.unr.edu"
            red.hostnames  "chunli.cse.unr.edu enkiduo.cse.unr.edu"
        }
    }
    proc open { side } {
        vars info
        set info($side.status) "unconnected"
        TL "GA $side"
        pushf [frame $f.f]
            pack $f
            glabel -text "Status:" -width 10
            gentry -textvariable ::GA::info($side.status) -width 20
            packall -side left
        popf
        gbutton -text "Connect to GA" 	-width 30 	-command "GA::connect	$side"
        pushf [PW $f.hostnames "Hostnames"]
            gentry -textvariable ::GA::info($side.hostnames) -width 28
        popf
        
        gbutton -text "Boot GA" 	-width 30	-command "GA::bootGA	$side"
        gbutton -text "Boot Slaves" 	-width 30	-command "GA::bootSlaves	$side"
        gbutton -text "Kill GA" 	-width 30	-command "GA::killGA 	$side"
        gbutton -text "Kill Slaves" 	-width 30	-command "GA::killSlaves 	$side"
        glog ga 30 5
        packall -side top
    }
    proc connect { side } {
        global socket
        vars info
        log "Connecting to GA for side: $side hostnames: $info($side.hostnames)"
        foreach host $info($side.hostnames) {
            log "Trying host: $host"
            set retval [$socket.connect $hostname]
            if { $retval == "true" } {
	log "connected to $host"
	set info($side.status) 	connected
	set info($side.url) 	$host
	set info(blue.player.type) 	"GA"
	set info(blue.player.url) 	$hostname
	log "connected"
	break
            } else {
	log "connection failed - quitting"
	puts "connection failed - quitting"
	exit
            }
        }
        if { $gaserver_connected } {
            $socket.send "strikeserver" "hello"
        } else {
            log "connection failed quitting"
            puts "connection failed quitting"
            exit
        }
    }
}
GAGui::init
