#holds stuff for the ga master
#argh okay..think think
#idea

namespace eval GAMaster {
    variable initialized "false"
    variable gamaster
    variable slaves
    variable toBoot
#****************************************************************************************************************************************************************************************
    proc log { txt } {
        logto "all gamaster" $txt
    }
#****************************************************************************************************************************************************************************************
    proc init { } {
        puts "<GAMaster::open>"
        global socket
        variable initialized
        variable gamaster
        variable slaves
        variable procIDs
        
        Pathfinder::init
        Socket::init "gamaster"
        Socket::openServer
        array set slaves {
            c0-0 1
            c0-1 1
            c0-2 1
            c0-3 1
            c0-4 1
            c0-5 1
            c0-6 1
            c0-7 1
            c0-8 1
            c0-9 1
        }
        variable toBoot 0
        foreach name [array names slaves] {
            set num $slaves($name)
            incr toBoot $num
        }
        if { $initialized == true } { return } else { set initialized true }
        pushsel
        sn nent /ga
            set gamaster [new ngamaster ga]
            ci maxboots 20
            #extract first
            opt injection {
	puts "INJECTION"
	[new ncaseextractor extractor].initvars
	EventCallbackGroup::addcallback "nextgeneration" /ga/extractor.extract
	[new ncaseinjector injector].initvars
	EventCallbackGroup::addcallback "nextgeneration" /ga/injector.inject
            } { 
	puts "NO INJECTION"
            }

            new ngablue problem
            GA::parseParams
            #strike server messages
            $socket.addfromcallback 	strikeserver 	$gamaster 	receivestrikeserver
            $socket.addfromcallback 	situation 	script 	GAMaster::receiveSituation
            $socket.addfromcallback 	plan	$gamaster 	receiverun
            $socket.addcallback 	bootslaves   	script	GAMaster::BootSlaves
            $socket.addcallback 	killslaves   	script	GAMaster::KillSlaves
            #gaslave messages
            $socket.addfromcallback 	slave 	$gamaster 	receiveslave
            $socket.addfromcallback 	slaveready 	$gamaster 	receiveslaveready
            $socket.addfromcallback 	fitness   	$gamaster 	receivefitness
            $socket.addfromcallback 	profiling 	$gamaster 	receiveprofiling
            
            $socket.addconnectiondiedcallback $gamaster connectiondied
            
        sel ..
        popsel
        #reset the casebase at the beginning of every mission
        CaseBase::clear
        GA::updateInfo
    }
#*********************************************************************************************************************************************************************
    proc receiveSituation { from sit } {
        variable gamaster
        #load the casebase
        puts "pre receive situation"
        CaseBase::build
        $gamaster.receivesituation $from $sit
        puts "post receive situation"
    }
#called when a connection dies - hopefully one to my slaves
#this should
#A - reboot the slave
#B - unmark its individual as evaluating
   proc ConnectionDied { handle } {
#to reboot slave - identify its ip..
#reconnect to it
       puts "StrikeServer::ConnectionDied $handle"
#BootSlave $slave $slaves($slave)
}
#****************************************************************************************************************************************************************************************
    proc BootSlaves { s } {
        variable slaves
        variable procIDs
        variable toBoot
        log "GAMaster::BootSlaves $s #=$toBoot"
        set timeoffset 0
        set i 0
        foreach slave [array names slaves] {
            set numprocs $slaves($slave)
            for { set j 0 } { $j < $numprocs } { incr j } {
	if { $i >= $toBoot } { return }
	puts "booting slave #$i out of $toBoot"
	incr i
	after $timeoffset "GAMaster::BootSlave $slave"
	incr timeoffset 100
            }
        }
    }
#****************************************************************************************************************************************************************************************
    proc BootSlave { slave } {
        variable procIDs
        log "GAMaster::BootSlave $slave"
        set cmd {exec ssh -x $slave "go simple remote gaslave" &}
        puts [subst $cmd]
        lappend procIDs [eval $cmd]
    }
#****************************************************************************************************************************************************************************************
    proc KillSlaves { s } {
        variable slaves
        variable procIDs
        log "GAMaster::KillSlaves $s"
        set s violently
        /ga.si maxboots 0
        switch $s {
            nicely {
	foreach procID $procIDs {
	    exec kill $procID
	}
	set procIDs ""
	Socket::killChildren
            }
            violently -
            default {
            	foreach slave [array names slaves] {
	    puts "exec ssh $slave \"killall go\""
	    catch {exec ssh $slave "killall go"}
	}
            }
        }
    }
#****************************************************************************************************************************************************************************************
    proc open { } {
        TL  "GAMaster"
        pack [entry $f.e -width 4 -textvariable ::GAMaster::toBoot]
        pack [button $f.b0 -text "Boot Slaves" -command { GAMaster::BootSlaves interface }]
        pack [button $f.b1 -text "Kill Slaves" -command { GAMaster::KillSlaves violently }]
    }

}
