proc log { tags } {
    Log::log $tags $str
}
proc log { tags str } {
    puts "BAD LOG: $tags $str"
}
proc logto { tags { str "none" } } {
    Log::log $tags $str
}

namespace eval Log {
    variable menubar ""
    variable logs
    variable data
    variable files
    variable prelog ""
    variable logging yes

    proc tags { } {
        variable logs 
        variable data
        puts "open: [array names logs]"
        puts "known: [array names data]"
    }
    proc open { tag } {
        variable logs
        variable data

        set tl [TL log$tag]
        wm title $tl "Log - $tag"
        pack [gLog "$f.log" $tag] -fill both -expand yes
    }
    proc gLog { path tag {width default} {height default} } {
        puts "gLog: $tag $width $height"
        variable logs
        variable data
        set logFrame [frame $path]
        if { $width == "default" } { set width 80 } 
        if { $height == "default" } { set height 20 } 
        pushf $logFrame
            set logWidget [
	text $f.text -wrap word\
	-xscrollcommand "$f.xscroll set" \
	-yscrollcommand "$f.yscroll set" \
	-setgrid 1 -highlightthickness 0 -pady 2 -padx 3 -width $width -height $height
            ]
            lappend logs($tag) $logWidget
            catch { $logWidget insert end $data($tag)}
            variable ::Log::autoscroll_$tag 1
            checkbutton $f.button -variable ::Log::autoscroll_$tag
            scrollbar $f.yscroll -command "$logs($tag) yview" -highlightthickness 0 -orient vertical
            grid rowconfigure $f 1 -weight 1
            grid columnconfigure $f 0 -weight 1
            grid config $f.text -row 0 -column 0 -rowspan 2 -sticky nsew
            grid config $f.button -row 0 -column 1 -sticky nsew
            grid config $f.yscroll -row 1 -column 1 -sticky nsew
        popf
        return $logFrame
    }
    proc log { tags str } {
        variable logs
        variable data 
        variable files
        variable menubar
        variable prelog
        variable logging
        if { !$logging } {
            return
        }
        if { $menubar == "" } {
            lappend prelog "{$tags} {$str}"
            return;
        }
        foreach tag $tags {
            if { [info exists logs($tag) ]} {
	foreach logwidget $logs($tag) {
	    $logs($tag) insert end "$str\n"
	    variable ::Log::autoscroll_$tag
	    set v "Log::autoscroll_$tag"
	    set v [subst $$v]
	    if { $v } { $logs($tag) see end }
	}
            } else {
	if { ![info exists data($tag) ] } {
	    $menubar add command -label $tag -underline 0 -command "Log::open $tag"
	}
	append data($tag) "$str\n"
            }
            if {! [info exists files($tag)] } {
	global home args
	set argsCondensed [string map { " " "" } $args]
	set dir "$home/data/logs/$argsCondensed"
	if { ![file exists $dir] } {
	    puts "directory $dir does not exist creating"
	    file mkdir $dir
	}
	if { [catch {set file [::open $dir/$tag "w"]} err] } { puts "error opening file : $err" } else {
	    set files($tag) $file
	}
            }
            if {[info exists files($tag)]} {
	puts $files($tag) $str
	flush $files($tag)
            }
        }
    }
    proc setLogMenubar { logMenubar } {
        variable menubar $logMenubar
        variable prelog
        variable menubar $logMenubar
        foreach entry $prelog {
#puts "log [lindex $entry 0] [lindex $entry 1]"
            logto "[lindex $entry 0]" "[lindex $entry 1]"
        }
        set prelog ""
    }
    proc setLogging { f } {
        variable logging $f
    }
}
