proc exit { } {
    /sys/servers/game.stop
}
proc releaseall { } {
    sel /
    releaseall_recur
}
proc releaseall_recur { } {
    foreach x [dir] { 
        if { [$x.isa nent] } { 
            delete $x
        } else { 
            sel $x
                releaseall_recur
            sel ..
        }
    }
}
proc sn { object_type object_name } {
    set n [new $object_type $object_name]
    sel $n
    return $n
}
proc find_create { object_type object_name } {
    pushsel
    if { [ catch { sel $object_name } err ] } {
        popsel
        return [new $object_type $object_name]
    } else {
        popsel
        return $object_name
    }
}
set dirstack ""
proc pushsel { } {
    global dirstack
    lappend dirstack [getfullname]
}
proc popsel { } {
    global dirstack
    set l [llength $dirstack]
    set dir [lindex $dirstack [expr $l-1]]
    sel $dir
    set dirstack [lrange $dirstack 0 [expr $l-2]]
}
proc clear { } {
    foreach item [dir] {
        /sys/servers/release.releasenow $item
    }
}
proc e { } {
    sel /game/ents
}
proc g { } {
    sel /game
}
proc s { } {
    sel /game/sides
}
proc ga { } {
    sel /ga/ga
}
proc c { } {
    sel /game/camera
}
proc v { } {
    sel /game/vis
}
proc tree { } { 
#if { ![isa nthing] } { return }
    puts [.getfullname]
#if { [isa nent] } { return }
    foreach x [dir] { 
        if { $x != "vars" && $x != "node"} {
            sel $x
            tree
            sel ..
        }
    }
}
set selected ""
proc select { name } {
    global selected
    set selected [$name.getfullname]
}
proc nodelink { name } {
    sel node
        linkto $name
    sel ..
}
proc linkto { name } { 
    [new nlinknode link].settarget $name
}
proc cat { a b } {
    return [join "$a $b" ""]
}
proc gen_mesh { filename {name "mesh"} } {
    [new nmeshnode $name].setfilename $filename
}
proc gen_tex { texfile {alphafile "none"} {name "tex"} } {
    [new ntexarraynode $name].settexture 0 $texfile $alphafile
}
proc gen_shader { type {name "shader"} } {
    /lib/shaders/$type.clone $name
}
set entCounter() ""
set visCounter() ""
proc gen_ent { type { name default } } {
    return [genent $type default $name]
}
proc genent { type {path default} {name default} } {
    return [/sys/servers/game.genent $type $path $name]
}
#pushsel
#   set unique false
#   if { $name == "unnamed" } {
#       set name $type
#       set unique true
#   } 
#   #create /game/ents/type
#   sel [find_create nthing /game/ents/$type]
#   #find ent name
#   set c 0
#   set fname $name
#   if { $unique } {
#       while { [find $fname] != "null" } {
#           set fname $name$c
#           incr c
#       }
#       set ent [/ent/$type.clone $fname]
#   } else {
#       if { [find $fname] == "null" } {
#           /ent/$type.clone $fname
#       }
#       set ent [$fname.getfullname]
#   }
#   #find vis
#   sel [find_create nvisnode /game/vis/$type]
#   set c 0
#   set fname $name
#   if { $unique } {
#       while { [find $fname] != "null" } {
#           set fname $name$c
#           incr c
#       }
#       set vis [/vis/$type.clone $fname]
#   } else {
#       if { [find $fname] == "null" } {
#           /vis/$type.clone $fname
#       }
#       set vis [$fname.getfullname]
#   }
#   $ent.setvis $vis
#   popsel
#   return $ent
proc gen_unique { type { prefix "unnamed" } } {
    set i 0
    if { $prefix == "unnamed" } { set prefix $type }
    while { 1 } {
        set name [cat $prefix $i]
        set found [.find $name]
        if { $found == "null" } { 
            break 
        } else { 
            incr i 1 
        }
    }
    return [new $type $name]
}
proc file_to_string { filename } {
    return [eval fileToString $filename]
}
proc of { filename } { 
    return [eval fileToString $filename]
}
proc fileToString { filename } {
    set str ""
    if {[catch {
        set file [open $filename "r"]
    } err] } { return "" }
    while { 1 } { 
        gets $file line
        if { $line == "" } { break }
        append str "$line\n"
    }
    close $file
    return $str
}
proc wf args { return [eval stringToFile $args] }
proc stringToFile { filename s } {
    set file [open $filename "w"]
    puts -nonewline $file $s
    close $file
}

proc appendToFile { filename s } {
    set file [open $filename "a"]
    puts -nonewline $file $s
    close $file
}

proc getkeys { } {
    proc getkeyssub { } {
        set info [.getkeyinfo]
        set numkeys 	[lindex $info 0]
        set type	[lindex $info 1]
        for { set i 0 } { $i < $numkeys } { incr i } {
            switch $type {
	1 { puts [.geykey1f $i] }
	2 { puts [.geykey2f $i] }
	3 { puts [.geykey3f $i] }
	4 { puts [.geykey4f $i] } 
            }
        }
    }
    catch { getkeys } err
}
proc multtimescale { coef } {
    set timescale [expr [/sys/servers/trigger.gettimescale] * $coef]
    /sys/servers/trigger.settimescale $timescale
    puts "timescale : $timescale"
}
proc settimescale { timescale } {
    /sys/servers/trigger.settimescale $timescale
}
#proc puts_long { str } {
#    for { set i 0 } { $i < [string length $str]} { incr i 1000 } {
#        puts -nonewline [string range $str $i [expr $i + 999]]
#    }
#}
#load the popup 2 seconds in
proc benchmark { } {
    multtimescale 50.0
    f7
    after 2000 f6 
}
set ent_locked_to "none"
set ent_controlling "none"
set control_mode "control3d"
set control_mode "controloffset"
proc toggle_camera_lock { } {
    global ent_locked_to ent_controlling control_mode
    set lock [/game/camera.gref attachedto]
    puts "lock : $lock"
    if { $lock == "none" } { 
        puts "locking to $ent_locked_to"
        /game/camera.sref attachedto $ent_locked_to
        /ui.ss controlling $ent_controlling
        /ui/interface.setstate $control_mode
    } else {
        set ent_locked_to $lock
        set ent_controlling [/ui.gs controlling]
        set control_mode [/ui/interface.getstate]
        /game/camera.sref attachedto "none"
        /ui.ss controlling /game/camera
        /ui/interface.setstate control3d
        puts "unlocking from $ent_locked_to $ent_controlling control_mode"
    }
}
proc toggle_wireframe_terrain { } {
    set lock [/game/vis/terrain/shader.getwireframe]
    switch $lock {
        true { /game/vis/terrain/shader.setwireframe false }
        false { /game/vis/terrain/shader.setwireframe true }
    }
}
proc toggle_sky_active { } {
    set active [/game/vis/sky.getactive]
    switch $active {
        true { /game/vis/sky.setactive false }
        false { /game/vis/sky.setactive true }
    }
}
proc toggle_octree { } {
    set active [/sys/servers/octree.getvisualize]
    switch $active {
        true { /sys/servers/octree.setvisualize false }
        false { /sys/servers/octree.setvisualize true }
    }
}
proc toggle_terrain_active { } {
    set active [/game/vis/terrain.getactive]
    switch $active {
        true { /game/vis/terrain.setactive false }
        false { /game/vis/terrain.setactive true }
    }
}
proc toggle_grid { } {
    set grid [/sys/servers/game.getdrawgrid ]
    switch $grid {
        true  { /sys/servers/game.setdrawgrid false }
        false { /sys/servers/game.setdrawgrid true }
    }
}
proc toggle_axis { } {
    set axis [/sys/servers/game.getdrawaxis ]
    switch $axis {
        true  { /sys/servers/game.setdrawaxis false }
        false { /sys/servers/game.setdrawaxis true }
    }
}
proc toggle_screengrid { } {
    set grid [/sys/servers/game.getdrawscreengrid ]
    switch $grid {
        true  { /sys/servers/game.setdrawscreengrid false }
        false { /sys/servers/game.setdrawscreengrid true }
    }
}
proc toggle_visualizecollision { } {
	set collisions [/sys/servers/game.getvisualizecollision]
	puts "collisions : $collisions"
    switch $collisions {
        true  { /sys/servers/game.setvisualizecollision false }
        false { /sys/servers/game.setvisualizecollision true }
    }
}
proc toggle_wireframe { } {
	pushsel
	set wireframemode "unknown"
	sel /node
	foreach node [dir] {
		if { $wireframemode == "unknown" } {
			catch { set wireframemode [$node/shader.getwireframe] } err
			catch { set wireframemode [$node/sn.getwireframe] } err
		}
		switch $wireframemode {
			true {	catch { $node/shader.setwireframe false } err
					catch { $node/sn.setwireframe false } err 
			}
			false { catch { $node/shader.setwireframe true } err 
					catch { $node/sn.setwireframe true } err 
			}
		}
	}
	popsel
}
proc watch { nm } {
    set n [$nm.getfullname]
    /game/camera.sref attachedto $n
}
proc control { nm } {
    set n [$nm.getfullname]
    /ui.ss controlling $n
}
global unpaused_timescale
set unpaused_timescale 1.0
proc pause { } {
    holdall
#global unpaused_timescale
#   set unpaused_timescale [/sys/servers/trigger.gettimescale]
#   /sys/servers/trigger.settimestep 	.00001
#/sys/servers/trigger.settimescale	.0001
}
proc unpause { } {
    unholdall
#global unpaused_timescale
#   /sys/servers/trigger.settimestep 	.001
#   /sys/servers/trigger.settimescale	$unpaused_timescale
}
proc set3rdperson { } {
    /game/camera.sv poffset 0 2 3
    /game/camera.sr roffset -15 0 0
}

proc set1stperson { } {
    /game/camera.sv poffset 0 0 -1.1
    /game/camera.sr roffset 0 0 0
}

proc holdall { } {
    /sys/servers/command.starthold
    pushsel
    sel /game/ents
    foreach type [dir] {
        sel $type
        foreach ent [dir] {
            if { [$ent.isa nent ]} {
	if { ![$ent.held] } {
	    $ent.setheld true
	}
            }
        }
        sel ..
    }
}

proc unholdall { } {
    /sys/servers/command.stophold
    pushsel
    sel /game/ents
    foreach type [dir] {
        sel $type
        foreach ent [dir] {
            if { [$ent.isa nent ]} {
	if { [$ent.held] } {
	    $ent.setheld false
	}
            }
        }
        sel ..
    }
}
proc ljust { s l } {
    append s [string repeat " " [expr $l - [string length $s]]]
    return $s
}
proc rjust { s l } {
    set s "[string repeat " " [expr $l - [string length $s]]]$s"
    return $s
}
proc server { type { name unnamed } } {
    switch $type {
        ent { 
            new nserverent server
        }
        var {
            if { [vars.find $name] == "null" } {
	new nvar vars/$name
            }
            vars/$name.setcategory server
        }
        aspect {
        }
    }
}
proc sub { stringName str1 str2 } {
    upvar $stringName str
    for { set i 0 } { $i < [string length $str] } { incr i } {
        if { [string index $str $i] == $str1 } { 
            set str [string replace $str $i [expr $i+1] $str2]
        }
    } 
}
proc lb { } {
    puts "*******************************************************************************"
}

proc replace { type path } {
    catch { delete $path }
    new $type $path
}
proc regdel { path exp } {
    set exp {\w+[0-9]+}
    pushsel
    sel $path
    foreach name [dir] {
        if { [regexp $exp $name] } {
#puts "delete $name"
            delete $name
        }
    }
    popsel
}
proc fasterCamera { } {
    set mass [/game/camera.gf mass]
    set mass [expr $mass * .5]
    /game/camera.sf mass $mass
}
proc slowerCamera { } {
    set mass [/game/camera.gf mass]
    set mass [expr $mass * 2.0]
    /game/camera.sf mass $mass
}
proc opt { optionName trueCmd { falseCmd "" } } {
    global args
    if { [lsearch $args $optionName] != -1 } { 
        uplevel $trueCmd
    } else {
        if { $falseCmd != "" } {
            uplevel $falseCmd
        }
    }
}
proc defaultFilename { type directory prefix } {
    set files ""
    global home
    catch { set files [glob -tails -directory $home/$directory *] } 
    set found no
    for { set i 0 } { !$found  } { incr i } {
        set filename [cat $prefix $i.xml]
        if { $type == "save" } {
            if { [lsearch $files $filename] == -1 } {
	set found true
            }
        }
    }
    return $filename
}
proc str { arrname } {
    upvar $arrname arr
    set s "{"
    set i 0
    foreach elem [array names arr] {
        append s "'$elem': $arr($elem)"
        if { $i != [llength [array names arr]] - 1 } {
            append s ", "
        }
        incr i
    }
    append s "}"
    return $s
}
proc vars args { 
    foreach var $args {
        uplevel variable $var
    }
}
global pendingTransitionAfters
set pendingTransitionAfters ""
proc transition { time poffset roffset ptightness rtightness } {
    global pendingTransitionAfters
    #cleanup any existing transitions
    foreach id $pendingTransitionAfters { after cancel $id }
    set steps 3
    eval /game/camera.sv poffset $poffset
    eval /game/camera.sr roffset $roffset

    set sp .01
    set rp .01
    /game/camera.sf ptightness $sp
    /game/camera.sf rtightness $rp

    for { set i 1 } { $i <= $steps } { incr i } {
        set r [expr $i / $steps.0]
        puts "i: $i time: $time r:$r"
        puts "after [expr $time * $i / $steps]\"/game/camera.sf ptightness [expr $sp * (1-$r) + $ptightness * ($r)];/game/camera.sf rtightness [expr $rp * (1-$r) + $rtightness * ($r)];\""
        after [expr $time * $i / $steps] "puts $i; /game/camera.sf ptightness [expr $sp * (1-$r) + $ptightness * ($r)];/game/camera.sf rtightness [expr $rp * (1-$r) + $rtightness * ($r)];"
    }
}
proc loosenCamera { } {
    set pt [/game/camera.gf ptightness]
    set pt [expr $pt * .1]
    set rt [/game/camera.gf rtightness]
    set rt [expr $rt * .1]
    clamp pt 0 1
    clamp rt 0 1
    /game/camera.sf ptightness $pt
    /game/camera.sf rtightness $rt
}
proc tightenCamera { } {
    set pt [/game/camera.gf ptightness]
    set pt [expr $pt * 10.0]
    set rt [/game/camera.gf rtightness]
    set rt [expr $rt * 10.0]
    clamp pt 0 1
    clamp rt 0 1
    /game/camera.sf ptightness $pt
    /game/camera.sf rtightness $rt
}
proc clamp { valName min max } {
    upvar $valName val 
    if { $val > $max } { set val $max }
    if { $val < $min } { set val $min }
}
proc try args {
    if {[catch {uplevel $args} err]} { puts "error***********\ncommand: $args \nerror:$err" } else { return $err }
}
proc sexec args {
    return [eval try exec $args]
}
proc attachParticles { name } {
    if {[catch { /vis/particles/$name.clone $name } err ]} { puts $err }
}
proc randf { min max } {
    return [expr rand() * ($max-$min) + $min]
}
proc randi { min max } {
    return [expr int([randf $min $max])]
}
proc attachVis { vis } {
    source lib/vis/$vis.tcl
}
proc strfind { txt string } {
    if { [string first $txt $string] != -1 } { return 1 } else { return 0 }
}
proc showlegionn { b } {
    /node/legionn.setactive $b
    pushsel
    catch {
        sel /game/ents/legionn
        foreach e [dir] { $e.setselectable $b }
    }
    popsel
}
proc evalTime { } {
    /sys/servers/trigger.settimestep 0.01
    /sys/servers/trigger.settimescale 1000
    /sys/servers/trigger.setmaxtimesteps 60
}
proc regularTime { } {
    /sys/servers/trigger.settimestep 0.01
    /sys/servers/trigger.settimescale 1.0
    /sys/servers/trigger.setmaxtimesteps 10
}
