#am i running remotely?
global remote
set remote false

global full
set full false
global win
set win false

#should i show graphics
global gfx
set gfx true

global scriptsToRun
set scriptsToRun ""

global home
set home [/sys/share/assigns/home.gets]

global xmldir
set xmldir $home/data/xml
#cd into data subdirectory

global data
set data $home/data
cd $home/data

#load the tk library
source $home/bin/nsh.tcl

#basic script loading functions
global scriptsLoaded
set scriptsLoaded [list]
proc loadscript { script_name } {
    global data
    loadscript_sub $data/scripts/$script_name
}
proc loadscriptdir { dirname } {
    global data home
    cd $data/scripts/$dirname
    set scripts [glob *.tcl]
    cd $data
    foreach script $scripts {
        set filename $data/scripts/$dirname/$script
        if { [file isfile $filename] && $script != "CVS" } {
            loadscript_sub $filename
        }
    }
}
proc loadscript_sub { scriptpath } {
    global scriptsLoaded
    if { [lsearch $scriptsLoaded $scriptpath] != -1} { 
#puts "trying to reload $scriptpath"
    } else {
        lappend scriptsLoaded $scriptpath
        if {[catch {source $scriptpath} err ]} { puts "failed to load $scriptpath err: $err" }
    }
}

#lappend args "car"
#puts "CREATE SERVERS******************************************************"
loadscript init/arg.tcl
loadscript classes/log.tcl
proc open_gfx { } {
    if [catch { new nglserver 	gfx 	} err] {
        new nd3d8server 	gfx 
    }
    sel gfx
        global full win
        set minDist .1
        if { $full } {
            setdisplaymode "w(1900)-h(1440)-type(full)-zbuf(16)"
#setdisplaymode "w(1600)-h(1200)-type(full)-zbuf(16)"
            set width [expr 1900 / 1440 * $minDist]
            setviewvolume -$width +$width -$minDist +$minDist +$minDist +5000
        } else {
            setdisplaymode "w(1024)-h(1024)-type(win)-zbuf(16)"
            setviewvolume -$minDist +$minDist -$minDist +$minDist +$minDist +5000
        }
        setclearcolor 0 0 0 0
        opendisplay
    sel ..  
    new nparticleserver	particle
    new nspecialfxserver	specialfx
    new nshadowserver	shadow
}

new nroot /sys/servers
sel /sys/servers
    #open_gfx if not a slave
    if { !$remote } {
        if { $gfx } { open_gfx }
    }
	
    new ntriggerserver      	trigger
    sel trigger
        .settimestep 	.01
        .settimescale	1.0
        .setmaxtimesteps	10
    sel ..
    new nfileserver2 	file2
    if [catch { new nlxinputserver input } err] {
        new ndi8server 	input 	
    }
    new nscenegraph2	sgraph2
    new nchannelserver	channel
   [new nconserver          	console].watch ""
    new nmathserver	math
   [new noctree              	octree].setvisualize 	false
    new nopcodeserver       	collide
    new nmessageserver      	message
    new nprimitiveserver    	primitive
    new nrcserver           	rc
    new nprofserver         	prof
    new ngameserver         	game
    sel game
        setdrawaxis         			true 
        setdrawgrid         			true 
        setdrawscreengrid   			false
        setvisualizecollision 			false
    sel ..
    new nfxserver	fx
    new nreleaseserver	release
    new nxmlserver	xml
    new ncommandserver	command
    new nvarserver	var
    new nodeserver 	ode    
    new nopenalserver	audio
sel ..

loadscriptdir funcs
#has to be loaded first
loadscript init/tree.tcl
loadscriptdir init
loadscriptdir misc
loadscript classes/xml.tcl
loadscriptdir classes
loadscriptdir parsers
loadscriptdir gui
loadscriptdir gui/unitinfo

opt simple { /sys/servers/game.setsimple true }

Defaults::load
global args
global defaults
puts "known defaults: [array names defaults]"
if { $args == "" } {
    if {[info exists defaults(startupscript)] } {
        lappend args 	$defaults(startupscript) 
        lappend scriptsToRun 	"loadscript startup/$defaults(startupscript).tcl"
        puts "lappend scriptsToRun 	\"loadscript startup/$defaults(startupscript).tcl\""
    } else {
        puts "no default startupscript"
    }
} else {
    set defaults(startupscript) $args
    puts "set defaults(startupscript) $args"
}
foreach script $scriptsToRun {
    puts "script:$script"
    /sys/servers/game.addnonbusyscript $script
}
/sys/servers/console.watch "*"
if { !$remote } {
    Gui::open
} 
#*******************************************************************************
#sel /node/ringbase_fields/shader

