#instead of just using unit list,  which we want to reuse,  include the unit list as a child of me
#okay time to revamp this shit
namespace eval BlueInterface {
    variable plan
    variable wingCounter 0
    variable wingNames {
        alpha
        beta
        gamma
        kappa
        omega
    }
#**************************************************************************
    proc open { } {
        /ui/planner.setstate normal
        variable highlightTargets [/sys/servers/channel.getchannel1f highlighttargets]
        variable tree
        TL "Blue Interface"
        pushf [frame $f.checks]
            pack $f -expand yes -fill both
            checkbutton $f.highlighttargets -text "Highlight Targets" -onvalue 1.0 -offvalue 0.0 -variable ::BlueInterface::highlightThreats -command BlueInterface::SetHighlightTargets
            pack $f.highlighttargets
        popf
        pushf [frame $f.buttons]
            pack $f
            gbutton -text "Clear Plan"		-command BlueInterface::clearplan 	-width 30
            gbutton -text "Asset Allocation" 		-command AssetAllocation::open		-width 30
            gbutton -text "Export to StrikeServer"	-command BlueInterface::export		-width 30
            packall 
        popf
        pushf [PW $f.units Units]
            pack $f
            pack [UnitList::open $f.unitlist blue tree] 
            $tree insert  0 root "null createwing" -text "New Wing" -data "createwing" -open 1 -font {Helvetica 14 bold} 
            UnitList::addDropCallback BlueInterface::treeDropCallback
            UnitList::addSelectCallback BlueInterface::selectCallback
        popf
        import
        new nblueplanner /ui/blueplanner
        /ui/planner.addplanner /ui/blueplanner
    }
#**************************************************************************
    #toggles whether or not targets are highlighted (larger + smoke)
    proc SetHighlightTargets { } {
        variable highlightTargets
        if { $highlightTargets == true } {
            /sys/servers/channel.setchannel1f emphtargets 0.0
        } else {
            /sys/servers/channel.setchannel1f emphtargets 1.0
        }
    }
#**************************************************************************
#convert our waypoints into the xml plan - which can then be converted to ais
#**************************************************************************
    proc export { } {
        variable plan Plan::fromWPS
        StrikeServer::setplan blue BlueInterface [Plan::fromWPS]
    }
#**************************************************************************
#convert from xml plan to waypoints
#**************************************************************************
    proc import { } { 
        variable plan [Plan::from_gamestate yes]
        planToWPS
    }
#**************************************************************************
    proc checkForEmptyAttack { wp pos } { 
        pushsel
        sel /game/ents/target
        foreach target [dir] {
            set tpos [$target.gv pos]
            set dx [expr abs([lindex $pos 0] - [lindex $tpos 0])]
            set dy [expr abs([lindex $pos 1] - [lindex $tpos 1])]
            set dz [expr abs([lindex $pos 2] - [lindex $tpos 2])]
            set d [expr $dx + $dy + $dz]
#puts "$pos -> $tpos = $d---$dx,$dy,$dz"
            if { $d < 1 } {
#puts "found empty attack -> $target"
	$wp.cref attack [$target.getfullname]
	$wp.cf typef 1.0
            }
        }
        popsel
    }
    proc parser_planToWPS { plan } [XML::buildParser {
        init		{ pushsel } { popsel }
        side
        platform	{ set platform /game/ents/platform/$txt } { set platform "" }
        ai		{ regdel $platform/wp "^(\\w+)(\[0-9\]+)" }
        move		{ 
		    set wp [genent wp $platform/wp]	
		    $wp.sv pos [lindex $txt 0] [lindex $txt 1] [lindex $txt 2]
		    checkForEmptyAttack $wp $txt
		} 			  
        attack		{ 
		    $wp.cref attack $txt
		    $wp.cf typef 1.0
		} 
        withasset	{ $wp.cs withasset $txt		}
    }]
#**************************************************************************
    proc planToWPS { } {
        variable plan 
        puts "planToWPS"
        pushsel
        sel /game/ents/platform
        foreach platform [dir] {
            sel $platform/wp
            foreach wp [dir] {
	if {[string match wp* $wp] } {
	    $wp.die
	}
            }
            sel ../..
        }
        parser_planToWPS $plan
    }
#**************************************************************************
#tell who we dragged from
#who we dragged onto
#**************************************************************************
    proc treeDropCallback { from to fromNode toNode } {
        variable tree
        variable wingNames
        if { $to == "createwing" } {
            set wingName [createWing $from ]
            $tree move "wing $wingName" $fromNode end
        } elseif {[lindex $to 0] == "wing" } {
            set wingName [lindex $to 1]
            $tree move "wing $wingName" $fromNode end
        }
    }
#**************************************************************************
    proc createWing { platform } {
        variable tree
        variable wingNames
        variable wingCounter
        if { $wingCounter == 0 } {
#then create the wing node
            $tree insert 1 root "null wings" -text "Wings" -data "wings" -open 1 -font {Arial 12 bold}
        }
        set wingName [lindex $wingNames $wingCounter]
        $tree insert end "null wings" "wing $wingName" -text $wingName -data "wing $wingName" -open 1 -font {Arial 12 bold}
        incr wingCounter
        return $wingName
    }
#**************************************************************************
#what now..well..we need a custom select callback
#if its not recognized
#**************************************************************************
    proc selectCallback { where num tree node } {
        set tag [lindex $node 0]
        set txt [lindex $node 1]
        set text [$tree itemcget $node -text]
        set data [$tree itemcget $node -data]
        switch $tag {
            wing { 
	set children [$tree nodes $node]
	foreach child $children {
	    set entref [$tree itemcget $child -data]
	    lappend selected $entref
	}
	Selection::setSelected $selected
            }
            default {
	puts "selected unused $node"
            }
        }
    }
    proc clearplan { } {
        pushsel
        sel /game/ents/platform
        foreach platform [dir] {
            regdel $platform/wp "^(\\w+)(\[0-9\]+)"
        }
        popsel
    }
}
