namespace eval FogEditor {
    variable fog
    variable mode
    proc setRed { red } {
        variable fog
        set color [$fog.getcolor]
        set r $red
        set g [lindex $color 1]
        set b [lindex $color 2]
        set a [lindex $color 3]
        $fog.setcolor $r $g $b $a
    }
    proc setGreen { green } {
        variable fog
        set color [$fog.getcolor]
        set r [lindex $color 0]
        set g $green
        set b [lindex $color 2]
        set a [lindex $color 3]
        $fog.setcolor $r $g $b $a
    }
    proc setBlue { blue } {
        variable fog
        set color [$fog.getcolor]
        set r [lindex $color 0]
        set g [lindex $color 1]
        set b $blue
        set a [lindex $color 3]
        $fog.setcolor $r $g $b $a
    }
    proc setMin { min } {
        variable fog
        set range [$fog.getrange]
        set min $min
        set max [lindex $range 1]
        setMode linear
        $fog.setrange $min $max
    }
    proc setMax { max } {
        variable fog
        set range [$fog.getrange]
        set min [lindex $range 0]
        set max $max
        setMode linear
        $fog.setrange $min $max
    }
    proc setDensity { density } { 
        variable fog
        setMode exp
        $fog.setdensity [expr $density*$density*$density*$density ]
    }
    proc setMode { _mode } {
        variable fog
        variable mode $_mode
        $fog.setMode $mode
    }
    proc toggleMode { } {
        variable mode
        if { $mode == linear } { setMode exp } else { setMode linear }
    }
    proc open { } {
        global rc_sym red green blue min max mode
        variable fog
        set fog /game/vis/ambient/fog
        toplevel .fog
        wm title .fog "Fog Editor"
        wm resizable .fog 1 1
        set f [frame .fog.f -relief sunken -borderwidth 1]
        pack .fog.f -side top -expand 1

        set color           [$fog.getcolor]
        set range           [$fog.getrange]
        set red             [lindex $color 0]
        set green           [lindex $color 1]
        set blue            [lindex $color 2]
        set min             [lindex $range 0]
        set max             [lindex $range 1]
        set density         [$fog.getdensity]
        set mode            [$fog.getmode]
        
        scale $f.red       -length 400 -orient horizontal -from 0.0 -to 1.0    -resolution .001 -showvalue 1 -label "Red:"    -variable red \
            -command { FogEditor::setRed   }
        scale $f.green     -length 400 -orient horizontal -from 0.0 -to 1.0    -resolution .001 -showvalue 1 -label "Green:"  -variable green\
            -command { FogEditor::setGreen }
        scale $f.blue      -length 400 -orient horizontal -from 0.0 -to 1.0    -resolution .001 -showvalue 1 -label "Blue:"   -variable blue\
            -command { FogEditor::setBlue  }
        scale $f.min       -length 400 -orient horizontal -from 0.0 -to 2000.0 -resolution .001 -showvalue 1 -label "Min:"    -variable min\
            -command { FogEditor::setMin }
        scale $f.max       -length 400 -orient horizontal -from 0.1 -to 2000.0 -resolution .001 -showvalue 1 -label "Max:"    -variable max\
            -command { FogEditor::setMax }
        scale $f.density   -length 400 -orient horizontal -from 1.0 -to .00001 -resolution .000001 -showvalue 1 -label "Density:"    -variable density\
            -command { FogEditor::setDensity }
        frame $f.mode
            label $f.mode.lbl -text "fog mode:"
            button $f.mode.toggle -textvariable ::FogEditor::mode -command { FogEditor::toggleMode }
            
        pack $f $f.red $f.green $f.blue $f.min $f.max $f.density $f.mode -side top
        pack $f.mode.lbl $f.mode.toggle -side left
    }
}
