
namespace eval GFX {
    variable clipMin .1
    variable clipMax 2000
    proc UpdateViewVolume { } {
        variable viewVolume
        /sys/servers/gfx.setviewvolume $viewVolume(x0) $viewVolume(x1) $viewVolume(y0) $viewVolume(y1) $viewVolume(z0) $viewVolume(z1)
    }
    proc SetClipMin { v } {
        variable clipMin $v
        UpdateClip
    }
    proc SetClipMax { v } {
        variable clipMax $v
        UpdateClip
    }
    proc UpdateClip { } {
        variable clipMin
        variable clipMax
        variable viewVolume
        set viewVolume(x0) -$clipMin
        set viewVolume(x1) +$clipMin
        set viewVolume(y0) -$clipMin
        set viewVolume(y1) +$clipMin
        set viewVolume(z0) +$clipMin
        set viewVolume(z1) +$clipMax
        UpdateViewVolume
    }
    proc open { } {
        set tl [toplevel .gfx]
        wm title        $tl "Gfx" 
        wm resizable    $tl 1 1 
        pushf [frame $tl.f]
            pack $f
            grid config [\
	scale $f.clipMin\
	-length 200\
	-orient horizontal\
	-from 0.1 -to 50.0\
	-resolution .1\
	-showvalue 1\
	-label "Clip Min:"\
	-variable ::GFX::clipMin\
	-command { GFX::SetClipMin }\
            ] -column 0 -row 1
            grid config [\
	scale $f.clipMax\
	-length 200\
	-orient horizontal\
	-from .1 -to 5000.0\
	-resolution 1.0\
	-showvalue 1\
	-label "Clip Max:"\
	-variable ::GFX::clipMax\
	-command { GFX::SetClipMax }\
            ] -column 0 -row 2
        popf
    }
}
