#idea
#this controls all the other guis
#has a menubar with options to load the other guis
namespace eval Gui {
    variable script_row
    variable viewVolume
    variable fileMenu
    proc addscript { scriptname { buttonname "default" } } {
        vars fileMenu
        if { $buttonname == "default" } { 
            set buttonname $scriptname
        }
        $fileMenu add command -text $buttonname -command "loadscript startup/$scriptname.tcl" 
    }
    proc open { } {
        variable script_row 0
        variable viewVolume
        vars fileMenu
        array set viewVolume {
            x0 -.1
            x1 .1
            y0 -.1
            y1 .1
            z0 .1
            z1 2000
        }
        global home

        TL "OPS" 
        #MENU BAR
        pushf [frame $f.menu -bd 1 -relief groove]
            grid config $f -column 0 -row 0 -columnspan 1000 -sticky ew
            pushf [frame $f.bar]
	pack $f -side left -expand yes -fill x
	menubutton $f.file				-underline 0 -text "File"		-menu $f.file.menu
	    set m [menu $f.file.menu]
	    $m add command -label "Exit"			-underline 1 -command { exit }
	menubutton $f.startupScripts				-underline 0 -text "Startup Scripts"	-menu $f.startupScripts.menu
	    set m [menu $f.startupScripts.menu]
	    foreach filename [glob -tails -directory scripts/startup *.tcl] {
	        set scriptName [lindex [split $filename \.] 0]
	        $m add command -label $scriptName			-underline 1 -command "loadscript startup/$filename"
	    }
	menubutton $f.interfaces 				-underline 0 -text "Interfaces"		-menu $f.interfaces.menu
	    set m [menu $f.interfaces.menu]
	    $m add command -label "Funcs"			-underline 0 -command { Funcs::open 	}
	    $m add command -label "Fog"				-underline 0 -command { FogEditor::open 	}
	    $m add command -label "Messager"			-underline 0 -command { messager::open 	}
	    $m add command -label "Pathfinder"			-underline 0 -command { pathfinder::open 	}
	    $m add command -label "Gfx"				-underline 0 -command { GFX::open 	}
	    $m add command -label "Scoreboard"			-underline 0 -command { Scoreboard::Open 	}
	    $m add command -label "VarList"			-underline 0 -command { VarList::open 	}
	    $m add command -label "Population"			-underline 0 -command { Population::open 	}
	    $m add command -label "CommandServer"			-underline 0 -command { CommandServer::open 	}
	    $m add command -label "Results"			-underline 0 -command { Results::open 	}
	    $m add command -label "Info"			-underline 0 -command { Info::open 	}
	    $m add command -label "Sounds"			-underline 0 -command { SoundServer::open 	}
	    $m add command -label "Human Parser"			-underline 0 -command { HumanParser::open 	}
	menubutton $f.logs				-underline 0 -text "Logs"		-menu $f.logs.menu
	    set m [menu $f.logs.menu]			
	    Log::setLogMenubar $m
	pack $f.file $f.startupScripts $f.interfaces $f.logs -side left -expand yes -fill both
            popf
        popf

        return
        #PUSHBUTTONS
        pushf [frame $f.scripts -relief sunken -border 1]
            variable drawgrid [/sys/servers/game.getdrawgrid]
            grid config [\
            checkbutton $f.drawgrid					\
	-text 		"Draw Grid"				    \
	-onvalue  	true						\
	-offvalue 	false						\
	-variable 	drawgrid	                \
	-command  	{ /sys/servers/game.setdrawgrid $drawgrid }\
	]	-column 0 -row 0
            variable drawaxis [/sys/servers/game.getdrawaxis]
            grid config [\
            checkbutton $f.drawaxis					\
	-text 		"Draw Axis"				    \
	-onvalue  	true						\
	-offvalue 	false						\
	-variable 	drawaxis	                \
	-command  	{ /sys/servers/game.setdrawaxis $drawaxis }\
	]	-column 1 -row 0
        popf

        pushf [frame $f.selection]
            grid config $f -column 0 -row 4 -sticky ew
            grid config [label $f.overlabel 	-text "Over: "]    		-row 0 -column 0 -sticky nsew
            grid config [label $f.over 	-width 30 	-textvariable ::Selection::over]	-row 0 -column 1 -sticky nsew
            grid config [label $f.selectionlabel 	-text "Selected: "]		-row 1 -column 0 -sticky nsew
            grid config [label $f.selection -width 30 	-textvariable ::Selection::selected]   	-row 1 -column 1 -sticky nsew
        popf

        pushf [frame $f.time]
            grid config $f -column 0 -row 5
            gc 0 0 gentry -textvariable ::Gui::time
            gc 0 1 gentry -textvariable ::Gui::commandtime
        popf
        update
    }

    proc update { } {
        variable time 	[format %.2f [/sys/servers/channel.getchannel1f time]]
        variable commandtime 	[format %.2f [/sys/servers/command.getcommandtime]]
        after 100 Gui::update
    }
}
