#/-----------------------------------------------------------------------------//
#purpoe of this is to provide an interface tot he human parser
#this should tkae a human plan and reverse engineer it into a case which can then be stored into the casebase
#/-----------------------------------------------------------------------------//
namespace eval HumanParser {
    variable info
#/-----------------------------------------------------------------------------//
    proc log { txt } {
        logto "all humanparser" $txt
    }
#/-----------------------------------------------------------------------------//
    proc open { } {
        vars info 
        set info(plan.human) "<PLAN></PLAN>"
        set info(plan.ga) "<PLAN></PLAN>"
        set info(plan.from) "none"
        EventCallbackGroup::addcallback gaFinished HumanParser::gaFinished

        TL "Human Parser"
        pushf [frame $f.info]
            pack $f 
            glabel -text "Human Plan:"
            gentry -textvariable ::HumanParser::info(plan.from)
            packall -side left
        popf
        pushf [frame $f.buttons]
            pack $f 
            gbutton -text "Load From File" -command "HumanParser::loadFromFile" -width 40
            packall -side left
        popf
        pack [gbutton -text "Reverse Engineer" -command "HumanParser::reverseEngineer" -width 40]
        pushf [frame $f.xmlwrapper]
            pack $f -expand yes -fill both
            pushf [PW $f.human "Human Plan" -anchor w -side left]
	set info(xmlFrame.human) $f.xml
            popf
            pushf [PW $f.ga "GA Plan" -anchor w -side left]
	set info(xmlFrame.ga) $f.xml
            popf

        popf
        pack [Log::gLog $f.log humanparser]

        global defaults
        if { [info exists defaults(humanparser.planfilename)] } {
            loadFile $defaults(humanparser.planfilename)
        } else {
            updateXmlFrame
        }

        initGA
#runGA
    }
#/-----------------------------------------------------------------------------//
    proc initGA { } {
        log "HumanParser::initGA"
        sn nent /ga
        variable ga [new nga ga]

        [new ncaseextractor extractor].initvars
        EventCallbackGroup::addcallback "gaFinished" /ga/extractor.extract
        new ngamimicblue problem
        GA::parseParams
    }
#/-----------------------------------------------------------------------------//
    proc loadFromFile { } {
        global xmldir
        vars info
        log "HumanParser::loadFromFile"
        set filename [tk_getOpenFile -initialdir $xmldir/plans/blue -filetypes {{"Xml Files" .xml}} -title "Load Plan"]
        if { $filename == "" } { return }
        loadFile $filename
    }
#/-----------------------------------------------------------------------------//
    proc loadFile { filename } {
        vars info
        log "Load File: $filename"
        set info(plan.human)				[of $filename]
        set info(plan.from) 				[file tail $filename]

        global defaults
        set defaults(humanparser.planfilename) $filename
        updateXmlFrame
    }
#/-----------------------------------------------------------------------------//
    proc updateXmlFrame { } {
        log "HumanParser::updateXmlFrame"
        vars info 
        XMLViewer::open $info(xmlFrame.human) 	$info(plan.human) "side"
        XMLViewer::open $info(xmlFrame.ga) 	$info(plan.ga) "side"
        pack $info(xmlFrame.human) $info(xmlFrame.ga)
    }
#/-----------------------------------------------------------------------------//
    proc reverseEngineer { } {
        log "HumanParser::reverseEngineer"
        runGA
    }
#/-----------------------------------------------------------------------------//
    proc markHumanPlan { } {
        vars info ga
#Plan::clear
#Plan::load $info(plan)
        /ga/problem.markgoalplan
    }
#/-----------------------------------------------------------------------------//
    proc runGA { } {
        log "runGA"
        vars ga info
        puts "<markgoalplan>"
        markHumanPlan
        puts "</markgoalplan>"
        set situation [Plan::from_gamestate]
        Scenario::clear
        Scenario::load $situation
        $ga.setsituation $situation
        $ga.run
    }
#/-----------------------------------------------------------------------------//
    proc gaFinished { args } {
        vars ga info
        log "gaFinished $args"
        set info(plan.ga) [$ga.getbestplan]
        updateXmlFrame
        StrikeServer::setplan blue HumanParser $info(plan.ga)
        StrikeServer::resetGame
    }
}
