#idea - allow editing of general maps
#in particular for turtle
#place game objects from a certain list - mostly blank nodes
#okay..for now..just have buttons to create the major types
#can do a simple xml to create / destroy objects nicely

namespace eval MapEditor {
    variable types "wall tower"
    variable filename "map0.xml"
    proc open { } { 
        variable types
        /ui/planner.setstate normal
        TL "map editor"
        pushf [frame $tl.f]
            pack $f
            pushf [PW $f.create "Create:"]
	pack $f
	foreach type $types {
	    pack [button $f.button_$type -text "$type" -command "gen_ent $type"]
	}
            popf
            pack [entry $f.filename -textvariable ::MapEditor::filename]
            pack [button $f.save -text "Save" -command MapEditor::save]
            pack [button $f.load -text "Load" -command MapEditor::load]
        popf
    }
    proc save { } {
        variable filename
        variable types
        global XML::lines
        XML::clear
        pushsel
        sel /game/ents
        XML::open MAP $filename
        foreach type $types {
            #if type does not exist then skip
            if { [.find $type] == "null" } { continue }
            sel $type
            foreach ent [dir] {
	set name [$ent.getname]
	XML::open ENT $type
	XML::wrap NAME $name
	XML::wrap POS [$ent.gv pos]
	XML::wrap ROT [$ent.gq rot]
	XML::close ENT
            }
            sel ..
        }
        XML::close MAP
        LogWindow .map "Map" $lines
        stringToFile "maps/$filename" $lines 
    }
    proc load { } {
        variable filename
        set map [file_to_string "maps/$filename"]
        LogWindow .map "Map" $map
        parser_mapToEnts $map
    }

    proc parser_mapToEnts { plan } [XML::buildParser {
        ent 		{ sel [gen_ent $txt] } 		{ sel .. }
        name		{ .setname $txt } 
        pos		{ .sv pos [lindex $txt 0] [lindex $txt 1] [lindex $txt 2] }
        rot		{ .sq rot [lindex $txt 0] [lindex $txt 1] [lindex $txt 2] [lindex $txt 3] }
    }]
 
}
