namespace eval Population {
    variable addchildcounter 0
    variable showall yes
    proc open { } {
        #okay so we want a table with population info for now
        #to do this we need a way to fetch pop info from the ga
        variable opened true
        variable genomes ""
        pushsel
        sel /ga/ga
        TL pop
        wm minsize $tl 300 600
        pushf [frame $f.menu -bd 1 -relief groove]
            pack $f -expand yes -fill both  -side top
            pushf [frame $f.bar]
	pack $f -side left -expand yes -fill both
	menubutton $f.commands -underline 0 -text "Show"		-menu $f.commands.menu
	set m [menu $f.commands.menu]
	$m add command -label "GA Population"			-underline 1 -command { Population::load /ga/ga 	}
	$m add command -label "Case Base"			-underline 1 -command { Population::load /casebase/genomes 	}
	pack $f.commands -side left -expand yes -fill both
            popf
        popf

        pushf [frame $tl.pop]
            pack $f -expand yes -fill both -side bottom
#grid config $f -row 1 -column 0 -sticky nsew
            variable sw          [ScrolledWindow $f.sw -relief sunken -borderwidth 2]
            variable treepath $sw.tree
#openTree 
            pack $sw -side top  -expand yes -fill both
        popf
        popsel
    }
#TREEVIEW STUFF
    proc moddir { index tree node } {
#puts "moddir |$index| |$tree| |$node|"
    }
    proc select { where num tree node } {
#puts "select |$where| |$num| |$tree| |$node|"
    }
    proc build { tree path } {
        pushsel
        sel $path
        foreach genome [dir] {
            build_recur $tree root $genome 1
        }
        popsel
    }
    proc build_recur { tree node genome { open 0 } } {
        variable showall
        sel $genome
            set type [.gettype]
            set val ""
            switch $type {
	int 	{ set val " INT:   [.geti]" }
	float 	{ set val " FLOAT: [.getf]" } 
	enum	{ set val " ENUM:  [.gete]" }
            }
            set text [format %-30s%s $genome $val]
            set mynode $node$genome
            $tree insert end $node $mynode -text $text -data $genome -open $open -font {Times 10 bold}
            if { $showall || $open > 0 } {
	AddChild "Fitness:"	[.getfitness]
	AddChild "Evaluated:" 	[.isevaluated]
	AddChild "EvaluationStarted:" 	[.getevaluationstarted]
	AddChild "Rank:" 	[.getrank]
	AddChild "Position:" 	[.getposition]
	AddChild "TimeStarted:" 	[.gettimestarted]
	AddChild "GenModified:" 	[.getgenmodified]
	AddChild "IsCast:"	[.iscast]
	AddChild "InjectedValue:"	[.getinjectedvalue]
	AddChild "InjectedAmount:"	[.getinjectedamount]
	AddChild "BitString:"	[.getbitstringstring]
	switch $type {
    	    int {	
    	        AddChild "MinI:"		[.getmini]
    	        AddChild "MaxI:"		[.getmaxi]
    	    }
    	    float {	
    	        AddChild "MinF:"		[.getminf]
    	        AddChild "MaxF:"		[.getmaxf]
    	    }
	}
            }
            foreach childgenome [dir] {
	build_recur $tree $node$genome $childgenome
            }
        sel ..
    }
    proc AddChild { prefix val } {
        variable addchildcounter
        upvar tree tree
        upvar mynode mynode
        set child child
        $tree insert end $mynode $mynode$child$addchildcounter -text [format "%-30s %-10s" $prefix $val] -open 0 -font {Times 10}
        incr addchildcounter 
    }
    proc load { path } {
        variable treepath
        destroy $treepath
        set tree        [Tree $treepath              		\
            -relief        	 	flat  	  	\
            -borderwidth    	0       			\
            -highlightthickness 	0   		\
            -redraw         	0       			\
            -dropenabled    	0       			\
            -dragenabled    	0       			\
            -height 		30		\
            -width 		30		\
            -opencmd   		"Population::moddir 1 $treepath" 	\
            -closecmd  		"Population::moddir 0 $treepath"	\
            -deltay		18
        ]
        $tree bindText  <ButtonPress-1>        "Population::select tree 1 $tree"
        $tree bindText  <Double-ButtonPress-1> "Population::select tree 2 $tree"

        Population::build $tree $path
        $tree configure -redraw 1
        variable sw
        $sw setwidget $treepath
    }
}
