#idea
#1 init window + connection to rc server
#2 rc server triggers your update when someone sets its target -> which loads your window with vars, etc.
#3 moving those things is bound back to a script call, which is sent to the rcServer which makes the change to the rc.
namespace eval RC {
    variable sym None
    variable filename
    source $home/bin/keyframeed.tcl
    variable target
    variable currentLine
    variable inmin
    variable inmax
    proc open { } {
        variable sym "none"
        global home
        variable tl 
        TL rc
        pushf [frame $f.opts]
            pack $f -expand yes -fill both
            pushf [PW $f.f1 "commands"]
	gbutton -text "smooth" -command { RC::smooth .1 }
	gbutton -text "0 center" -command { RC::zerocenter }
	packall -side left
            popf
            pushf [PW $f.sym "Symettry"]
	gradio -text "none" 	-variable ::RC::sym -value "none" -command RC::updateSym
	gradio -text "odd" 	-variable ::RC::sym -value "odd" -command RC::updateSym
	gradio -text "even" 	-variable ::RC::sym -value "even" -command RC::updateSym
	packall -side left
            popf
            pushf [PW $f.details "Details"]
	gc 0 0 glabel -text "InRange"
	gc 0 1 gentry -textvariable ::RC::inmin
	gc 0 2 gentry -textvariable ::RC::inmax
	gc 1 0 glabel -text "OutRange"
	gc 1 1 gentry -textvariable ::RC::outmin
	gc 1 2 gentry -textvariable ::RC::outmax
            popf
            pushf [PW $f.file "File"]
	glabel -text "File:"
	gentry -textvariable ::RC::filename
	gbutton -text "Save" -command RC::save
	gbutton -text "Load" -command RC::load
	packall -side left
            popf
        popf
        update
        variable canvas [ke_create $f]
        tick
    }
    proc update { } {
        variable bucketedges 	""
        variable server 	"/sys/servers/rc"
        variable count 	[$server.getcount]
        variable edges  
        array set edges ""
        variable target	[$server.gettarget]
        variable tl
        wm title $tl "$target" 
        variable filename 	[nameToFile $target]
        variable inmin 	[$server.getinputmin]
        variable inmax 	[$server.getinputmax]
        variable outmin 	[$server.getmin]
        variable outmax 	[$server.getmax]
        global ke_num_channels ke_chn_array
        for { set i 0 } { $i < $count } { incr i 1 } {
            set edges($i) [$server.getedge $i]
        }

        #update keys
        set ke_num_channels 1
        set ke_chn_array(0,name)        val
        set ke_chn_array(0,color)       white
        set ke_chn_array(0,minval)      $outmin
        set ke_chn_array(0,maxval)      $outmax
        set ke_chn_array(0,callback)    RC::callback
        set ke_chn_array(0,numkeys)     $count
        for { set i 0 } { $i < $count } { incr i 1 } {
            set ke_chn_array(0,$i) $edges($i)
        }
        ke_refresh
    }
    proc updateSym { } {
        variable sym
        puts "sym : $sym"
    }
    proc smooth { amount } {
        variable server
        variable count
        variable edges
        variable outmin
        variable outmax
        set l 0
        set m 0
        set r 0
        for { set i 0 } { $i < [expr $count]} { incr i 1 } {
            set l $m
            set m $r
            set r $edges($i)
            if { $i >= 2 } {
	set a [expr ($l + $r) / 2.0]
	set d [expr $m - $a]
	set n [expr $m + (-1.0 * $d * $amount)]
	setEdge [expr $i - 1] $n
            }
        }
        update
    }
    proc zerocenter { } {
        variable count
        setEdge [expr $count/2] 0
        update 
    }
    proc callback { channel key val } {
        variable server
        variable sym
        variable count
        variable outmin
        variable outmax
        setEdge $key $val
        switch $sym {
            odd { 
	setEdge [expr $count - 1 - $key] [expr (1.0-(($val-$outmin)/($outmax - $outmin)))*($outmax - $outmin) + $outmin] 
            }
            even { 
	setEdge [expr $count - 1 - $key] $val 
            }
        }
        update 
    }
    proc setEdge { key val } {
        variable server
        variable edges
        $server.setedge $key $val
        set edges($key) $val
    }
    proc tick { } {
        vars canvas currentLine outmin outmax server inmin inmax
        if { $outmin != $outmax } { 
            if { [info exists currentLine] } {
	$canvas delete [lindex $currentLine 0]
	$canvas delete [lindex $currentLine 1]
            }
            set currentLine ""
            set last [$server.getlastchecked]
            set x [expr int(($last - $inmin) / ($inmax - $inmin) * 300)]
            set y [$server.getlastresponse]
            set y [expr int(($y - 1.0)/(-1.0 - 1.0) * 120)]
            lappend currentLine [$canvas create line $x 0 $x 120 -fill black]
            lappend currentLine [$canvas create line 0 $y 300 $y -fill black]
        }
        after 50 RC::tick
    }
    proc nameToFile { name } {
        set sects [split $name "/"]
        set entType [lindex $sects 3]
        set varName [lindex $sects end]
        return "lib/$entType/$varName.rc"
    }
    proc save { } {
        vars filename server
        $server.save $filename
    }
    proc load { } {
        vars filename server
        $server.load $filename
    }
}
