#scoreboard
#a gui showing the health/value of all important objects in the game,  split into blue/red
#it also displays the total score for the game
#NAME HPxVALUE=POINTS NAME HPxVALUE=POINTS
#TOTAL DAMAGE=POINTS	POINTS
#SCORE RED = 
#SCORE BLUE = 

namespace eval Scoreboard {
    variable noshows "asset threat missle_explosion"
    proc Update { } {
        variable noshows
        variable b
        variable r
        variable total_red
        variable total_blue 
        set tr 0
        set tb 0
        pushsel
        if { [catch {
            sel /game/ents
            foreach class [dir] {
	if { [ lsearch $noshows $class ] != -1 } { continue }
	sel $class
	foreach ent [dir] { 
	    set side [[$ent.gref side].getname]
	    set hp [$ent.gf hp]
	    set name [$ent.getname]
	    set value [$ent.gf value]
	    variable hp_$name 	[format %.2f [$ent.gf hp]]
	    variable points_$name	[expr [$ent.gf hp]*[$ent.gf value]]
	    switch $side {
	        red {
	            set tr [expr $tr + (1.0-$hp) * $value]
	        }
	        grey -
	        blue {
	            set tb [expr $tb + (1.0-$hp) * $value]
	        }
	        default { puts "didn't recognize $ent $side $hp" }
	    }
#puts "[$ent.getname] -$side -$hp"
#switch $side {
#	        red  { $r.ghp_[$ent.getname] configure -text $hp }
#	        grey	-
#	        blue { $b.ghp_[$ent.getname] configure -text $hp } 
#	    }
	}
	sel ..
            }
        set total_red 	$tr
        set total_blue 	$tb
        } err ] } { puts $err }
        popsel
        after 200 Scoreboard::Update
    }
    proc Open { } {
        variable b
        variable r
        variable name
        variable hp
        variable value
        variable noshows

        destroy .scoreboard
        set tl [toplevel .scoreboard]
        catch { destroy $tl.f } err
        pushf [frame $tl.f]
        pack $f
            set b [frame $f.b]
            set r [frame $f.r]
            frame $f.spacer -relief sunken -borderwidth 5
            grid config $b 		-row 0 -column 0 -sticky nw
            grid config $f.spacer 	-row 0 -column 1 -sticky ns -rowspan 10
            grid config $r 		-row 0 -column 2 -sticky nw
            pack [label $f.spacer.dummy -text ""]

            label $b.lbl -text "BLUE UNITS"
            label $r.lbl -text "RED UNITS"
            grid config $b.lbl -row 0 -column 0 -sticky nw -columnspan 10
            grid config $r.lbl -row 0 -column 0 -sticky nw -columnspan 10
            grid config [label $b.namelbl -text "NAME"] 	-row 1 -column 0 -sticky nw
            grid config [label $b.hplbl   -text "HP"]	-row 1 -column 1 -sticky nw
            grid config [label $b.valuelbl -text "VALUE"]	-row 1 -column 3 -sticky nw
            grid config [label $b.pointslbl -text "POINTS"]	-row 1 -column 5 -sticky nw

            grid config [label $r.namelbl -text "NAME"] 	-row 1 -column 0 -sticky nw
            grid config [label $r.hplbl   -text "HP"]	-row 1 -column 1 -sticky nw
            grid config [label $r.valuelbl -text "VALUE"]	-row 1 -column 3 -sticky nw
            grid config [label $r.pointslbl -text "POINTS"]	-row 1 -column 5 -sticky nw
            set rows_blue 2
            set rows_red 2

            pushsel
            sel /game/ents
            foreach class [dir] {
	if { [ lsearch $noshows $class ] != -1 } { continue }
	sel $class
	foreach ent [dir] {
	    set side [[$ent.gref side].getname]
	    switch $side {
	        red 	{  
		    set sf $r 
		    set row $rows_red
		    incr rows_red
		}
	        grey 	-
	        blue	{  
		    set sf $b 
		    set row $rows_blue
		    incr rows_blue
		}
	        default { puts "didn't recognize $ent - side" }
	    }
	    set name		[$ent.getname]
	    variable nam_$name	$name
	    variable hp_$name	[$ent.gf hp]
	    variable value_$name	[$ent.gf value]
	    variable points_$name	[expr [$ent.gf hp]*[$ent.gf value]]

	    set gname		[entry 	  $sf.gname_$name 	-width 10 -textvariable ::Scoreboard::nam_$name]
	    set ghp		[entry	    $sf.ghp_$name 	-width 6 -textvariable ::Scoreboard::hp_$name]
	    set gx		[label 	     $sf.gx_$name 	-text "x"]
	    set gvalue		[entry	 $sf.gvalue_$name 	-width 6 -textvariable ::Scoreboard::value_$name]
	    set geq		[label	    $sf.geq_$name 	-text "="]
	    set gpoints		[entry 	$sf.gpoints_$name 	-width 6 -textvariable ::Scoreboard::points_$name]

	    grid config $gname	-row $row -column 0 -sticky nw 
	    grid config $ghp	-row $row -column 1 -sticky nw
	    grid config $gx	-row $row -column 2 -sticky nw
	    grid config $gvalue	-row $row -column 3 -sticky nw
	    grid config $geq	-row $row -column 4 -sticky nw
	    grid config $gpoints	-row $row -column 5 -sticky nw
#pack [LabelEntry $b.[$ent.getname] -label [$ent.getname] -text [$ent.gf hp]]
	}
	sel ..
            }
            popsel
            if { $rows_blue < $rows_red } {
	set max_rows $rows_red 
            } else {
	set max_rows $rows_blue
            }
            grid config [label $r.lbltotal	-text "Damage Taken: "] 	-row $max_rows -column 0 -sticky nw
            grid config [label $b.lbltotal	-text "Damage Taken: "] 	-row $max_rows -column 0 -sticky nw 
            grid config [entry $r.total	-textvariable ::Scoreboard::total_red] 	-row $max_rows -column 1 -sticky nw -columnspan 10
            grid config [entry $b.total	-textvariable ::Scoreboard::total_blue] 	-row $max_rows -column 1 -sticky nw -columnspan 10
        popf
        Update
    }
}
