#
# Scenegraph tree navigator for nebula based on bwidget treedemo (required bwidget 1.3.1 
# obtainable for free from http://www.sourceforge.net/projects/tcllib/
#
# copyright ghoust@gmx.de aka. Thomas Miskiewicz
# 
# You may use this script to your need as long as you leave this copyright
# in place (copy left license) 
# No responibility taken for any harm caused by this script
#
#

global leveled_home
set leveled_home scripts/leveled

namespace eval NavTree {
    variable count
    variable dblclick
    variable imgpath
}

proc NavTree::create { nb } {

    set pw    [PanedWindow $nb.pw -side top]

    set pane  [$pw add -weight 1]
    set title [TitleFrame $pane.lf -text "Namespace"]
    set sw    [ScrolledWindow [$title getframe].sw \
                  -relief sunken -borderwidth 2]
    set tree  [Tree $sw.tree \
                   -relief flat -borderwidth 0 -width 15 -highlightthickness 0\
		   -redraw 0 -dropenabled 1 -dragenabled 1 \
                   -opencmd   "NavTree::moddir 1 $sw.tree" \
                   -closecmd  "NavTree::moddir 0 $sw.tree"]
    $sw setwidget $tree

    pack $sw    -side top  -expand yes -fill both
    pack $title -fill both -expand yes

    pack $pw -fill both -expand yes

    $tree bindText  <ButtonPress-1>        "NavTree::select tree 1 $tree "
    $tree bindText  <Double-ButtonPress-1> "NavTree::select tree 2 $tree "
    
    NavTree::init $tree
}


proc NavTree::init { tree args } {
    global   tcl_platform
    variable count
    variable imgpath
    global leveled_home

    set count 0
    set imgpath $leveled_home/bmp/
#set imgpath "[/sys/share/assigns/home.gets]data/default/scripts/leveleditor/bmp/"
    $tree insert end root home -text "/" -data "/" -open 1 \
        -image [Bitmap::get  "$imgpath\general" ]
    getdir $tree home "/"
    NavTree::select tree 1 $tree home
    $tree configure -redraw 1
}


proc NavTree::getdir { tree node path } {
    variable count
    variable imgpath
    set act [psel]
    sel $path
    set lentries [dir]
    set lfiles   {}

    set img " "
    foreach f $lentries {
           if { [file exists "$imgpath[$path/$f.getclass].gif" ] } {
               set img  "$imgpath[$path/$f.getclass].gif" 
           } else {
              set img  "$imgpath\general" 
           }
           
	   $tree insert end $node n:$count \
             -text " $f | [$path/$f.getclass]"  \
             -image     [Bitmap::get $img ] \
             -drawcross allways \
             -data      "$path/$f"
           incr count
    }
    $tree itemconfigure $node -drawcross auto 
    sel $act
}


proc NavTree::moddir { idx tree node } {
  if { $idx && [$tree itemcget $node -drawcross] == "allways" } {
        getdir $tree $node [$tree itemcget $node -data]
  }
  if { !$idx } {
       set desc [$tree nodes $node]
       set val [$tree itemcget $node -data]
       $tree delete $desc
       $tree itemconfigure $node -drawcross allways
    NavTree::select tree 1 $tree $node
    $tree configure -redraw 1
  }
}


proc NavTree::select { where num tree node } {
    variable dblclick

    set dblclick 1
    if { $num == 1 } {
        if { $where == "tree" && [lsearch [$tree selection get] $node] != -1 } {
            unset dblclick
 #           after 500 "NavTree::edit tree $tree $node"
            return
        }
        if { $where == "tree" } {
            select_node $tree $node
        } 
    } 
}


proc NavTree::select_node { tree node } {
	$tree selection set $node
    set_act_selection [$tree itemcget $node -data]
    sel [$tree itemcget $node -data]

	update

	if { [$tree itemcget $node -drawcross] == "allways" } {
		getdir $tree $node [$tree itemcget $node -data]
	}
}


proc NavTree::edit { where tree node } {
    variable dblclick

    if { [info exists dblclick] } {
        return
    }

    if { $where == "tree" && [lsearch [$tree selection get] $node] != -1 } {
        set res [$tree edit $node [$tree itemcget $node -text]]
        if { $res != "" } {
            $tree itemconfigure $node -text $res
            $tree selection set $node
        }
        return
    }
}


proc NavTree::expand { tree but } {
    if { [set cur [$tree selection get]] != "" } {
        if { $but == 0 } {
            $tree opentree $cur
        } else {
            $tree closetree $cur
        }
    }
}


