namespace eval Scenario {
    namespace export clear load
    proc clear { } {
        pushsel
        sel [find_create nthing /scenario]
        ::clear
        popsel
    }
    proc load { str } { 
        global ::XML::type ::XML::tag ::XML::txt
        global lat_top lat_bottom lng_left lng_right
        global heightmap_filename
        global terrain_filename
        global grid_interval
        set creator none
        set side neutral
        pushsel
        XML::parse $str
        while { [XML::next]} {
            switch $type {
                open { 
                    switch $tag {
                        map  		{ }
                        heightmap           	{ 
	                                    set heightmap_filename $txt 
			    set ::Map::heightmap $txt
                        }
                        terrain             	{ 
			    set terrain_filename $txt 
			    set ::Map::terrain_texture $txt
                        }
                        lattop              	{   set ::Map::lat_top $txt }
                        latbottom           	{   set ::Map::lat_bottom $txt }
                        lngleft             	{   set ::Map::lng_left $txt }
                        lngright            	{   set ::Map::lng_right $txt }
                        mapwidth            	{ 
			    set ::Map::map_width $txt 
			}
                        mapheight           	{ 
			    set ::Map::map_height $txt 
			    set grid_interval [expr $::Map::map_height / 369.0]
			}

                        bm 		- 
                        red 		-
                        blue 		-
	        mission 	-
	        description	-
                        PLAYERTYPES         { set creator $tag }
                        side                { set side $txt }

                        platform            { 
                                                sn nent /scenario/blue/platforms/$txt
                                                .cs class $tag
                                                .cs name $txt
                                                .cs creator $creator
                                                .cref side /game/sides/$side
                                            }
                        asset               {
			new nthing assets
			gen_unique nent assets/$txt

			set platformname [.getfullname]
			pushsel
			sn nthing /scenario/blue/assets
                                                set asset [gen_unique nent $txt]
			$asset.cs platform $platformname
			$asset.cs type $txt
			popsel
                                            }
                        threat              {
                                                sn nent /scenario/red/threats/$txt
                                                .cs class $tag
                                                .cs name $txt
                                                .cs creator $creator
                                                .cref side /game/sides/$side
                                            }   
                        target              {
                                                sn nent /scenario/red/targets/$txt
                                                .cs class $tag
                                                .cs name $txt
                                                .cs creator $creator
                                                .cref side /game/sides/$side
                                            }

                        lat                 { 
                                                .cf $tag $txt 
                                                .svz pos [Map::lat_to_z $txt]
                                                .cvz startpos [Map::lat_to_z $txt]
                                            }
                        lng                 {
                                                .cf $tag $txt
                                                .svx pos [Map::lng_to_x $txt]
                                                .cvx startpos [Map::lng_to_x $txt]
                                            }
                        alt                 {
                                                .cf $tag $txt
                                                .svy pos $txt 
                                            }
	        name	            { 	.setname $txt	}
                        value               -
                        lockontime          -
                        hp                  -
	        active		-
                        FLOATVARIABLES      { .cf $tag $txt }
                        detectionrange      -
                        effectiverange      -
                        RADIUSVARIABLES     { .cf $tag $txt }

                        pos                 -
                        startpos            -
                        VECTORVARS          {   .cv $tag [lindex $txt 0] [lindex $txt 1] [lindex $txt 2] }

                        armorclass          -
                        type                -
                        fires               -
                        STRINGVARIABLES     { .cs $tag $txt }

                        ai                  { }
                        move                { 
                                            }
                        default             { 
                                                puts "Scenario::Load unrecognized: <$tag>$txt"
                                            }
                    }
                }
                close { 
                    switch $tag {
                        map                 	- 
                        heightmap           	-
                        terrain             	-
                        lattop              	-
                        latbottom           	-
                        lngleft             	-
                        lngright            	-
                        mapwidth            	-
                        mapheight           	-
	        mission 	-
	        description	-
                        DUMMIES             	{ }

                        bm                  -
                        red                 -
                        blue                -
                        PLAYERTYPES         { set creator "none" }
                        side                { set side neutral }

                        asset               { } 
                        platform            -
                        target              -
                        threat              -
                        ENTTYPES            { sel .. }
	        
                        lat                 -
                        lng                 -    
                        alt                 - 
                        value               -
                        detectionrange      -
                        effectiverange      -
                        lockontime          -
                        hp                  -
	        active		-
                        FLOATVARIABLES      { }

                        pos                 -
                        startpos            -
                        VECTORVARIABLES     { }

                        armorclass          -
                        type                -
                        fires               -
                        STRINGVARIABLES     { }

                        ai                  -
                        move                -
                        AIS                 { }

	        name	            	-
	        MISC		{ } 
                        default             { 
                                                puts "Scenario::Load unrecognized: </$tag>$txt"
                                            }
                    }
                }
            }
        }
        popsel
    }
}
