#********************************************************************************
#Setup the interface
#********************************************************************************
puts "<rtsinterface>"
global xmldir
pushsel

#********************************************************************************
#place the resource text
#********************************************************************************
proc place_resource_textdisplays { } {
    /game/vis/ui/resource1name.setoffset  	12 19 -20
    /game/vis/ui/resource2name.setoffset  	12 18 -20
    /game/vis/ui/resource3name.setoffset  	12 17 -20
    /game/vis/ui/resource1.setoffset 	18 19 -20
    /game/vis/ui/resource2.setoffset 	18 18 -20
    /game/vis/ui/resource3.setoffset 	18 17 -20
}
#********************************************************************************
#Setup buttons
#********************************************************************************
proc updatexy {} {
    upvar x0 x0 y0 y0 x1 x1 y1 y1 dx dx dy dy columns columns column column x00 x00    
    if { $column >= $columns } { 
	set column 0
	set y0 [expr $y0 + $dy]
    }
    if { $column == 0 } {
	set x0 $x00
    } else {
	set x0 [expr $x0 + $dx]	
    }
    incr column
    set x1 [expr $x0 + $dx]
    set y1 [expr $y0 + $dy]
}
proc create_buttons { } { 
    proc generate { type } {
        set ent [gen_ent $type]
        $ent.cref side /game/sides/blue
        after 0 "/ui/planner.placeent $ent"
    }
    sel /ui
        sn nfsmgroup menus
            sn nfsm selected
        		sn nfsmgroup default
        		    addButton plant 		{ generate plant 		} .95 .80 1.0 .85
        		    addButton refinery 		{ generate refinery     		} .95 .85 1.0 .90
        		    addButton factory 		{ generate factory 		} .95 .90 1.0 .95
        		    addButton legion 		{ generate legion 		} .95 .95 1.0 1.0
        		sel ..
        		sn nfsmgroup factory
        		    addButton paquito 		{ for { set i 0 } { $i < 10 } { incr i } { $Selection::selected/ai.build paquito } } .95 .85 1.0 .90
        		    addButton frigate 		{ $Selection::selected/ai.build frigate	} .95 .90 1.0 .95
        		    addButton cruiser		{ $Selection::selected/ai.build cruiser 	} .95 .95 1.0 1.0
        		sel ..
        		sn nfsmgroup legion
        		    addButton row		{ $Selection::selected.si numrowscolumns  1    } .95 .90 1.0 .95
        		    addButton column		{ $Selection::selected.si numrowscolumns -1    } .95 .95 1.0 1.0
        		    set x0 .85
        		    set x00 .85
        		    set y0 .22
        		    set x1 .8
        		    set y1 .43
        		    set dx .05
        		    set dy .05
        		    set columns 3
        		    set column 0
        		    updatexy
        		    foreach type "paquitolegion frigatelegion cruiserlegion" {
#puts "button: $type $x0 $y0 $x1 $y1"
            			addButton $type "puts {pushed $type}" $x0 $y0 $x1 $y1
            			updatexy
        		    }
        
        		    set lvl "level"
        		    foreach category "laser missle armor speed tachyon" {
            			foreach level "1 2 3" {			  
#puts "button: $category$lvl$level $x0 $y0 $x1 $y1"
            			    addButton $category$lvl$level "\$Selection::selected/legion.upgrade $category$lvl $level" $x0 $y0 $x1 $y1
            			    updatexy
            			}
        		    }
        		sel ..
        		sn nfsmgroup minebuildlocation
        		    addButton mine 			{ 
        			    set p [$Selection::selected.gv pos]; 
        			    set mine [gen_ent mine]
        			    $mine.sv pos [lindex $p 0] [lindex $p 1] [lindex $p 2]; 
        			    $mine.sref side /game/sides/blue
        			    set i [randf 0 10]
        			    if { $i < 6 } {
            			    $mine.cf productionrate0 1.0
        			    } elseif { $i < 9 } {
            			    $mine.cf productionrate1 1.0
        			    } else {
            			    $mine.cf productionrate2 1.0
        			    }
        			    $Selection::selected.die
        		    } .95 .95 1.0 1.0
        		sel ..
            sel ..
        sel ..
    sel ..
    sn n3dnode /game/vis/ui/buttonholder
        setviewspace true
        rz 90
        txyz 10.1 -10.1 -10
        sxyz 4.4 1.2 1.0
        gen_mesh lib/meshes/square.n3d
        gen_tex lib/ui/buttonholder.bmp lib/ui/buttonholderalpha.bmp
        gen_shader button
    sel ..
}
#********************************************************************************
#Setup the minimap
#********************************************************************************
proc create_minimap { } {
sel /game/vis/ui
    sn n3dnode minimapholder
        setviewspace true
	txyz -1.03 -1.03 -1.0
	sxyz 0.5 0.5 0.5
        gen_mesh lib/meshes/square.n3d
        gen_tex lib/ui/minimap.bmp lib/ui/minimapalpha.bmp
        gen_shader button
    sel ..
    sn nminimap /game/vis/ui/minimap
    .sxyz .1 .1 .1
    .txyz -9 -9 0
    sn n3dnode /game/vis/ui/minimapbackground
        setviewspace true
        txyz -0.97 -0.97 -1.0
        sxyz 0.38 0.38 1.0
        gen_mesh lib/meshes/square.n3d
        gen_tex lib/terrain/$Map::terrain_texture
        gen_shader button
        shader.setrenderpri 0
    sel ..
}
#********************************************************************************
#Setup the legion window
#********************************************************************************
proc create_legionwindow { } {
    sel /game/vis/ui
        sn n3dnode legionwindow
            setactive false
            tz -1
	    txyz .715 0.56 -1
	    sxyz .28 .28 .28
            setviewspace true
            gen_mesh lib/meshes/square.n3d
            gen_tex lib/ui/legionwindow.bmp lib/ui/legionwindow_alpha.bmp
            gen_shader simplealpha        
            new nlegionwindow legionwindow
        sel ..            
    sel ..
}
#********************************************************************************
#Show / hide all the legions
#********************************************************************************
proc toggle_legionmode { } {
    pushsel
    set active [/node/legion.getactive]
    set unittypes "robot paquito frigate cruiser"
    if { $active } { 
#puts "deactivating legions"
        /node/legion.setactive false
        sel /game/ents/legion
        foreach legion [dir] { $legion.setselectable false }
        foreach type $unittypes {
            sel /game/ents/$type
            foreach unit [dir] { $unit.setselectable true }
            sel ..
        }
    } else {
#puts "activating legions"
        /node/legion.setactive true
        sel /game/ents/legion
        foreach legion [dir] { $legion.setselectable true }
        sel /game/ents
        foreach type $unittypes {
            sel /game/ents/$type
            foreach unit [dir] { $unit.setselectable false }
        }
    }
    popsel
}

place_resource_textdisplays
create_buttons
create_minimap
create_legionwindow
popsel
puts "</rtsinterface>"
