namespace eval ResultServer {
    variable pgroupCounter 0
    variable mapping
    proc init { } {
        variable mapping
        array set mapping { output.always "" }
        variable xml [fileToString xml/misc/resultswanted.xml]
        parseMappings $xml
        parseDesired $xml

        parseHave [fileToString results/results.xml]

        TL ResultServer
        variable desiredFrame $tl.desired
        showDesired

        while [doNext] { 
            parseHave [fileToString results/results.xml]
        } 
    }
    proc t { tag txt } {
        upvar level level
        upvar output output
        upvar input input
        variable mapping
        set $tag $txt
        incr level 
        if { $level > 1 } {
            puts "lappend mapping($input) $output"
            lappend mapping($input) $output
        } 
    }
    proc parseMappings { plan } [XML::buildParser {
        tagmapping	{ set level 0 } { puts "about to continue"; XML::continueUntilClose "desired"; puts "done continuing" }
        input		{ t $tag $txt } { incr level -1 }
        output		{ t $tag $txt } { incr level -1 }
    }]

    proc openGroup { groupname } {
    }
    proc closeGroup { } {
        proc recur { pgroupsLeft tags } {
            variable pgroups
            variable iterations
            variable desired
            if { [llength $pgroupsLeft] == 0 } {
	set tags [lsort $tags]
	if { [info exists desired($tags)] } {
	    if { $desired($tags) < $iterations } {
	        set desired($tags) $iterations
	        puts "increasing desired($tags) to $iterations"
	    }
	} else {
	    set desired($tags) $iterations
	    puts "set desired($tags) $iterations"
	}
            } else {
	set p [lindex $pgroupsLeft 0]
	set mytags $pgroups($p)
	foreach tag $mytags {
	    set newTags $tags
	    lappend newTags $tag
	    set newTags $newTags
	    recur [lrange $pgroupsLeft 1 end] $newTags
	}
            }
        }
        variable pgroups
        recur [array names pgroups] ""
        array unset pgroups
    }
    proc addOutput { tag } {
        variable pgroups
        variable pgroup
        if { $pgroup == "root" } {
            variable pgroupCounter
            lappend pgroups(pgroup$pgroupCounter) $tag
        } else {
            lappend pgroups($pgroup) $tag
        }
    }
    proc parseDesired { plan } [XML::buildParser {
        init		{
		    variable pgroup
		}
        tagmapping	{ XML::continueUntilClose "tagmapping" }
        iterations	{ variable iterations $txt }
        group		{ 
		    openGroup $txt 
		    set pgroup root
        } { closeGroup }
        pgroup		{ set pgroup $txt } { set pgroup "root" }
        output		{ addOutput $txt }
    }]
    proc parseResultTags { } {
        variable resulttags
        proc recur { left used } {
            variable have
            for { set i 0 } { $i < [llength $left] } { incr i } {
	set newTags $used
	lappend newTags [lindex $left $i]
	set newTags [lsort $newTags]
	if { ![info exists have($newTags)] } {
	    set have($newTags) 0
	}
	incr have($newTags)
	recur [lrange $left [expr $i+1] end] $newTags
            }
        }
        recur $resulttags ""
    }
    proc parseHave { plan } [XML::buildParser {
        init		{
		    variable resulttags
		}
        result		{ set resulttags "" }	{ parseResultTags }
        resulttag	{ lappend resulttags $txt}
    }]

    proc showDesired { } {
        variable desiredFrame
        variable desired
        destroy $desiredFrame
        Table $desiredFrame [lsort [array names desired]] "full desired have" ResultServer::TableEntry
    }
    proc TableEntry { p row col } {
        switch $col {
            full	{ label $p -text $row }
            desired 	{ entry $p -textvariable ::ResultServer::desired($row) 	-width 10	-justify right } 
            have 	{ entry $p -textvariable ::ResultServer::have($row)	-width 10	-justify right }
        }
    }
    proc doNext { } {
        variable desired
        variable have
        foreach d [lsort [array names desired]] {
            if { [info exists have($d)] } {
	set h $have($d)
            } else { 
	set h 0
            }
            if { $h < $desired($d) } {
	set range [expr $desired($d) - $h]
	if {![info exists max] } {
	    set max $range
	    set maxcat $d
	} elseif { $range > $max } {
	    set max $range
	    set maxcat $d
	}
            }
        }
        if { [info exists max] } {
            puts "maximum disparty $max found for category: $maxcat"
            variable mapping
            puts "mappings: [array names mapping]"
            set cmd "go"
            lappend cmd $mapping(output.always)
            foreach tag $maxcat {
	foreach m [array names mapping] {
	    if {[lsearch $mapping($m) $tag] != -1 } {
	        lappend cmd $m
	    }
	}
            }
            run $cmd
            return true
        }
        return false
    }
    proc run cmd {
        puts "run: $cmd"
        #15 minutes for everyone..sinc eit really doesn't work anyways
        variable maxtime [expr 1000 * 60 * 15]
        set executable ssh
        set killProc [exec tclsh ~/kill_later.tcl $executable $maxtime &]
        set executable {ssh "enkiduo.cse.unr.edu $cmd > output"}
        puts "$executable"
        catch { exec $executable } err
        puts "err: |$err|"
        if { [lsearch $err "software"] != -1 } { 
            puts "ran over time" 
        }  else { 
            puts "regular death" 
            catch { exec kill $killProc }
        }
    }
}
ResultServer::init
